//$Id:$
App.AboutLicenseView = Ember.View.extend({
       
    templateName: 'AboutLicense',//No I18N
        didInsertElement: function(){
            jQuery(".modal-title").text(I18N.getMsg("js.webclient.licensedetail"));//No I18N
            App.Settings.getLicenseInfo();
        }
});

App.AboutLicenseController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        }   
    }
});
    
App.SearchViewRoute = Ember.Route.extend({
	renderTemplate: function() {this.render('SearchList',{into: 'application',outlet: 'details'});} //No I18N
});
App.SearchListController = Ember.ObjectController.extend({
    needs : 'AllResourceUsers',//NO I18N
    actions: {
        disassociate:function()
        {
            var app=this.get('controllers.AllResourceUsers');//NO I18N
           App.SettingsCommonController.isSingleCredential=false;
           app.send('disassociate');//NO I18N
        }
    }
});


App.ContactusView = Ember.View.extend({
    templateName: 'Contactus',//No I18N
        didInsertElement: function(){
            $('[data-toggle="popover"]').popover();
            $(".modal-title").text("Get in touch with Key Manager Plus");//No I18N
        }
});

App.ContactusController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        }
    }
});

App.SearchListView = Ember.View.extend({
    templateName: 'SearchList',//No I18N
        didInsertElement: function(){
            var ser_content=$("#global_search").val();
            var ser_type="resource";//NO I18N
            if($("#search_type").val()==2)
            {
                ser_type="users";//NO I18N
            }
            else if($("#search_type").val()==3)
            {
                ser_type="keys";//NO I18N
            }
            else if($("#search_type").val()==4)
            {
                ser_type="certificate";//NO I18N
            }
            else if($("#search_type").val()==5)
            {
                ser_type="san";//NO I18N
            }
            searchListGen(ser_content,ser_type);
        }
});

function searchListGen(ser_content,ser_type)
{
    var data="search_type="+ser_type+"&search_content="+ser_content;//NO I18N
    var ajaxRequestUrl = '/api/pki/Dashboard/search'; //No I18N
    getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
        if(ser_type=="users")
        {
            $("#seartcType").text("("+I18N.getMsg("js.general.sshusername")+")");//NO I18N
            allUsersList(jsonData,"PKISearchList","PKISearchListPager");//NO I18N
        }
        else if(ser_type=="keys")
        {
            $("#seartcType").text("("+I18N.getMsg("js.ssh.sshkeyname")+")");//NO I18N
            getSshKeysList(jsonData,"PKISearchList","PKISearchListPager",false);//NO I18N
        }
        else if(ser_type=="certificate" || ser_type=="san")
        {
            $("#seartcType").text("("+I18N.getMsg("js.commonstr.certificatename")+")");//NO I18N
            getCertificateListWithoutpage(jsonData,"PKISearchList","PKISearchListPager");//NO I18N
//            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true}; //No I18N
//                populateRemoteApiClientGrid('PKIInventoryList',"PKISSLCertificateList", "", "#PKIInventorypager", "certDetails", defaultOptions,ajaxRequestUrl,data); //No I18N
        }
        else
        {
            $("#seartcType").text("("+I18N.getMsg("js.general.resourcename")+")");//NO I18N
            sshResourceList(jsonData,"PKISearchList","PKISearchListPager");//NO I18N
        }
    });    
}

function licenseApply()
{
    var file = $("#filePath").val();
    var isXml = file.match("xml")
    var dotCheck = file.split(".");
    var licenseFile = document.getElementById('filePath'); //No I18N
    if(file === ""){
        showAlert(I18N.getMsg('upgrade.alert3', this));//No I18N
    }else if(dotCheck === file ){
        showAlert(I18N.getMsg('upgrade.alert1', this));//No I18N
    }else if(isXml==null || isXml.toString() !== "xml" ){ //No I18N
        showAlert(I18N.getMsg('upgrade.alert1', this));//No I18N
    }else{
        var data = new FormData();
        data.append("fileUpload",licenseFile.files[0])
        data.append("pmpcp",Get_Cookie('pmpcc'));//No I18N
        var url = "/api/pki/settings/applyLicense"; //No I18N
         getAjaxApiRequestForFile(url,data,null,null,true,function(response){
                $(".modal").click();
                $("#em_modal").modal("hide");//NO I18N
                    if(response.Status === "Success")
                    {
                        location.reload();
                    }
        });
    }
    }

App.InventoryFilterRoute = Ember.Route.extend({
    activate: function() {
        var controller = this.controllerFor('application');//NO I18N
        controller.set('lastFilter', this.routeName);//NO I18N
    }
});

//App.ApplicationRoute = Ember.Route.extend({
//    model: function(params) {
//        if(userRole!=="Administrator")
//        {
//            App.ApplicationController.isAdmin=false;
//        }
//        else
//        {
//            App.ApplicationController.isAdmin=true; 
//        }
//        if(demoUser==="yes")
//        {
//            App.ApplicationController.demo=true;
//        }
//        else
//        {
//            App.ApplicationController.demo=false;
//        }
//        App.ApplicationController.isSSL=isSSL;
//        App.ApplicationController.isSSH=isSSH;
//        App.ApplicationController.isFULL=isFULL;
//    },
//    actions: {
//        openmodal: function(modalName, model) {
//            if(model!=null)
        
//            {
//            this.controllerFor(modalName).set('model', model);//NO I18N
//            }
//            else
//            {
//                this.controllerFor(modalName);
//            }
//            this._super();
//            return this.render(modalName, {
//                into: 'application',//NO I18N
//                outlet: 'modal'//NO I18N
//});
//        },
//
//        closeModal: function() {
//          return this.disconnectOutlet({
//            outlet: 'modal',//NO I18N
//            parentView: 'application'//NO I18N
//          });
//        }
//    }
//});
//
///* Application Controller */
//App.ApplicationController = Ember.Controller.extend({
//    showLogin: false, 
//    userName: "", //No I18N
//    userRole: "",//No I18N
//    isAdmin:true,
//    demo:false,
//    res_id:"",
//    isSSL:false,
//    isSSH:false,
//    isFULL:false,
//    actions: {
//        opendialog: function(modalName,model) {
//            this.send('openmodal',modalName);//No I18N
//        }
//    },
//    currentPathChanged: function () 
//    {
//        var myDiv=document.getElementById('scroll');//NO I18N
//        if(myDiv!==null)
//        {
//            myDiv.scrollIntoView();
//        }
//        return this.send('closeModal');//NO I18N
//    }.observes('currentPath'), //No I18N
//    onPageChange:function(){
//        var path = this.get('currentPath');
//        window.cur_path=path;
//        sideMenuActive(path);
//        //For Loading Bar hide
//        NProgress.done();
//    }.observes('currentPath') //No I18N
//}); 


function Get_Cookie(check_name) {
	var a_all_cookies = document.cookie.split( ';' );
	var a_temp_cookie = '';
	var cookie_name = '';
	var cookie_value = '';
	var b_cookie_found = false;
	for ( i = 0; i < a_all_cookies.length; i++ )
   
	{
		// now we'll split apart each name=value pair
		a_temp_cookie = a_all_cookies[i].split( '=' );
// and trim left/right whitespace while we're at it
		cookie_name = a_temp_cookie[0].replace(/^\s+|\s+$/g, '');

		// if the extracted name matches passed check_name
		if ( cookie_name == check_name )
{
			b_cookie_found = true;

			// we need to handle case where cookie has no value but exists (no = sign, that is):
			if ( a_temp_cookie.length > 1 )
			{
				cookie_value = unescape( a_temp_cookie[1].replace(/^\s+|\s+$/g, '') );
			}
			// note that in cases where cookie is initialized but no value, null is returned
			return cookie_value;
			break;
		}
		a_temp_cookie = null;
		cookie_name = '';
	}
	if ( !b_cookie_found )
	{
		return null;
	}
}

//function sideMenuActive(path)
//{
//        if(document.getElementById("dashboard")!==null)
//        {
//                document.getElementById("settings").className="";
//            document.getElementById("dashboard").className="";
//                document.getElementById("discovery").className="";
//                document.getElementById("ssl_mng").className="";
//                document.getElementById("ssh_mng").className="";
//                document.getElementById("report").className="";
//                document.getElementById("schedule").className="";
//                document.getElementById("auditList").className="";
//            document.getElementById("enc_keys").className="";
////          document.getElementById("inventory").className="";
//            if(path.indexOf('Report')!=-1)
//            {
//                document.getElementById("report").className="sideMenuActive";
//            }
//            else if(path.indexOf('Dashboard')!=-1)
//            {
//
//                document.getElementById("dashboard").className="sideMenuActive";
//            }
//            else if(path.indexOf('Discovery')!=-1)
//            {
//                document.getElementById("discovery").className="sideMenuActive";
//            }
//            else if(path.indexOf('Settings')!=-1)
//            {
//                document.getElementById("settings").className="sideMenuActive";
//            }
//            else if(path.indexOf('SSLMgmt')!=-1 || path.indexOf('LETSMgmt')!=-1)
//            {
//                document.getElementById("ssl_mng").className="sideMenuActive";
//            }
//            else if(path.indexOf('SSHMgmt')!=-1)
//            {
//                document.getElementById("ssh_mng").className="sideMenuActive";
//            }
//            else if(path.indexOf('Schedule')!=-1)
//            {
//                document.getElementById("schedule").className="sideMenuActive";
//            }
//            else if(path.indexOf('Audit')!=-1)
//            {
//                document.getElementById("auditList").className="sideMenuActive";
//            }
//            else if(path.indexOf('EncryptionKeys')!=-1)
//            {
//                document.getElementById("enc_keys").className="sideMenuActive";
//            }
//        }
//}
var topview={};
App.ApplicationView = Ember.View.extend({
	templateName: 'Application', //No I18N
	controllerBinding: "App.ApplicationController", //No I18N
	didInsertElement: function(){
        if (kmpStandAlone)
        {
            var keys = Object.keys(topview);
        for (var i in keys)
        {
            if (keys.hasOwnProperty(i))
            {
                $('[data-pki-menu=\"' + keys[i] + '\"]').attr('style', 'display:block');
            }
        }
        }
		if (checkIfAValIsValid(window.userName, "string"))//No I18N
		{
                    this.get('controller').set("showLogin",false); //No I18N
                this.get('controller').set("userName",cliUser); //No I18N
                    this.get('controller').set("userRole",userRole); //No I18N
                    if(userRole!=="Administrator")
                    {
                        this.get('controller').set("isAdmin",false); //No I18N
                    }
                    if(demoUser==="yes")
                    {
                        this.get('controller').set("demo",true); //No I18N
                }
                }
                App.ApplicationController.isSSH=window.isSSH;
                App.ApplicationController.isSSL=window.isSSL;
                App.ApplicationController.isFULL=window.isFULL;
                App.ApplicationController.kmpStandAlone=kmpStandAlone;
                if(!App.ApplicationController.kmpStandAlone){
                App.ApplicationController.isStandardEdition = isSSLOnlyLicensed;
            }
                //Side menu initial active at refresh time
                var path= window.location.href;
                if(kmpStandAlone)
                {
                sideMenuActive(path);
                
                //License Message Display
                if(window.isAnyMsgToDisplay===true)
                {
                    $("#kmpTopBand").addClass("kmp_topband")
                    $("#license_msg").text(window.MsgToDisplay);
                    $("#license_check").show();
        }
        if(App.ApplicationController.demo)
        {
            $("#license_check").show();
            document.getElementById("kmpTopBand").className="kmp_topband";//NO I18N
        }
            //Global Search
            $("#global_search").keyup(function(event){
                if(event.keyCode == 13){
                    searchSubmit();
                }
            });        
        }
            $('.contentScroll').slimscroll({//NO I18N
                railVisible: true,
                railBorderRadius: 0,
                railOpacity: 0.1
            });        
            $(".slimScrollDiv").css({"overflow":""});//NO I18N
        }
});

                    
App.TextField = Ember.TextField.extend({
	classNames: "form-control" //No I18N
});
App.TextFieldLogin = Ember.TextField.extend({
	classNames: "formInputLogin" //No I18N
});
App.TextFieldHidden = Ember.TextField.extend({
	type: "hidden" //No I18N
});
App.TextFieldWithFocus = Ember.TextField.extend({
	classNames: "formInput", //No I18N
	didInsertElement: function() {
		this.$().focus();
	}
});
App.TextFieldBigWithFocus = Ember.TextField.extend({
	classNames: "formInputBig", //No I18N
	didInsertElement: function() {
		this.$().focus();
	}
});
App.TextFieldLoginWithFocus = Ember.TextField.extend({
	classNames: "formInputLogin", //No I18N
	didInsertElement: function() {
		this.$().focus();
	}
});			
App.TextFieldSmall = Ember.TextField.extend({
	classNames: "formInputSmall" //No I18N
});	
App.CheckBoxField = Ember.Checkbox.extend();

App.TextArea = Ember.TextArea.extend({
	classNames: "formInputArea" //No I18N
});
App.TextAreaWithFocus = Ember.TextArea.extend({
        classNames: "formInputArea", //No I18N
        didInsertElement: function() {
                this.$().focus();
        }
});
App.TextAreaSmall = Ember.TextArea.extend({
	classNames: "formInputAreaSmall" //No I18N
});
App.TextAreaBigWithFocus = Ember.TextArea.extend({
	classNames: "formInputAreaBig", //No I18N
	didInsertElement: function() {
		this.$().focus();
	}
});
App.TextFieldBigWithFocus = Ember.TextField.extend({
	classNames: "formInputBig", //No I18N
	didInsertElement: function() {
		this.$().focus();
	}
});

App.TextAreaSmall = Ember.TextArea.extend({
	classNames: "formInputAreaSmall" //No I18N
});

App.TextFieldForScript = Ember.TextField.extend({
	classNames: "formInputScript" //No I18N
});
App.TextAreaForScript = Ember.TextArea.extend({
	classNames: "formInputScriptArea" //No I18N
});
App.TextAreaBigForScript = Ember.TextArea.extend({
	classNames: "formInputBigScriptArea" //No I18N
});

    //For Browse button
$(document).on('change', '.btn-file :file', function() {
    var input = $(this),
        numFiles = input.get(0).files ? input.get(0).files.length : 1,
        label = input.val().replace(/\\/g, '/').replace(/.*\//, '');
    //input.trigger('fileselect', [numFiles, label]);

    var input = $(this).parents('.input-group').find(':text'),//NO I18N
    log = numFiles > 1 ? numFiles + ' files selected' : label;//NO I18N
        
        if( input.length ) 
        {
            input.val(log);
        }        

});

function vConfirmation(content,func,isCMDB) {
    var $confirm = $("#myModal");
    if(App.InventoryController.cmdb && isCMDB)
    {
        document.getElementById("deleteCMDB").checked=true;
        $("#cmdboption").show();
    }
    else
    {
        document.getElementById("deleteCMDB").checked=false;
        $("#cmdboption").hide();
    }
    if(App.RequestCertController.isDeactivateLetsAccountOption)
    {
        document.getElementById("deactivateAccount").checked=false;
    $("#deactivateAccountoptionLetsEnc").show();
        App.RequestCertController.isDeactivateLetsAccountOption=false;
    }else{
        $("#deactivateAccountoptionLetsEnc").hide();
    }
    if(App.InventoryController.deleteWithoutDisassociationoption)
    {
        document.getElementById("deleteWithoutDisassociation").checked=false;
        $("#deleteWithoutDisassociationoption").show();
        App.InventoryController.deleteWithoutDisassociationoption=false;
    }else{
        $("#deleteWithoutDisassociationoption").hide();
    }
    $confirm.modal('show');//NO I18N
    $("#btnYesConfirmYesNo").off('click').click(function () {
                    func();
        $confirm.modal("hide");//NO I18N
    });
    $("#btnNoConfirmYesNo").off('click').click(function () {
        $confirm.modal("hide");//NO I18N
    });
    if($("#adminDig")!=undefined)
    {
        $("#adminDig").width("450");//NO I18N
    }

    $('#myModal_Dialog').css({"width":"400px"});//NO I18N
    $( "#vConfirmDialog").html( content );//No I18N
    $( "#modal-title").html( I18N.getMsg('js.confirmation.title') );//No I18N
    $( ".modal-footer").show();
}

function vConfirmation1(content,func,title,width) {
    var $confirm = $("#myModal1");
    $confirm.modal('show');//NO I18N
    $("#btnYesConfirmYesNo1").off('click').click(function () {
        func();
        $confirm.modal("hide");//NO I18N
    });
    $("#btnNoConfirmYesNo1").off('click').click(function () {
        $confirm.modal("hide");//NO I18N
    });
    if($("#adminDig")!=undefined)
    {
        $("#adminDig").width("450");//NO I18N
    }
    if(title!=undefined)
    {
        $("#modal-title1").html(title);
    }
    else
    {
        $("#modal-title1").html( I18N.getMsg('js.confirmation.title') );//No I18N
    }
    if(width!=undefined)
    {
        $(".modal-sm").css({width:width+"px"});
    }
    $( "#vConfirmDialog1").html( content );//No I18N
    $( ".modal-footer").show();
}

function showAlert(content)
{
    var $confirm = $("#myModal");//NO I18N
    $confirm.modal('show');//NO I18N
    if($("#adminDig")!=undefined)
    {
        $("#adminDig").width("450");//NO I18N
    }
    $('#myModal_Dialog').css({"width":"400px"});//NO I18N
    $( ".modal-footer").hide();
    $("#cmdboption").hide();
    $("#deleteWithoutDisassociationoption").hide();
    $("#deactivateAccountoptionLetsEnc").hide();
    $( "#vConfirmDialog").html( content );//No I18N
    $( "#modal-title").html( I18N.getMsg('js.keymanager.title') );//No I18N
}

function toggleBtn(elt_name) {
    $('.'+elt_name).toggle();//No I18N
    $(document).click(function() {
        var id = $(this).id;
        if (id != 'elt_name' ) {
            $('.'+elt_name).hide();
}
    });    
}

function changeSearchType(searchType)
{
    $("#search_type").val(searchType);//No I18N
    $(".searchddown").hide();//No I18N
    var ser_type=I18N.getMsg("js.commonstr.search");//NO I18N
    if(searchType==2)
    {
        ser_type=ser_type+" "+I18N.getMsg("js.general.sshusername");;//NO I18N
}
    else if(searchType==3)
    {
        ser_type=ser_type+" "+I18N.getMsg("js.ssh.sshkeyname");;//NO I18N
    }    
    else if(searchType==4)
    {
        ser_type=ser_type+" "+I18N.getMsg("js.commonstr.certificatename");;//NO I18N
    }else if(searchType==5)
    {
        ser_type=ser_type+" "+I18N.getMsg("js.cert.sans");;//NO I18N
    }    
    else
    {
        ser_type=ser_type+" "+I18N.getMsg("js.general.resourcename");//NO I18N
    }
    document.getElementById('global_search').placeholder=ser_type;//NO I18N
}

function searchSubmit() {
    var ser_content=$("#global_search").val();//NO I18N
    if(ser_content.trim()=="")
    {
        showAlert(I18N.getMsg('js.search.giveSearchContent'));//NO I18N
        return;
    }
    var path=window.cur_path;
    $('#searchList').html("<table id='PKISearchList'></table><div id='PKISearchListPager'></div>");//NO I18N
    if(path.indexOf("Search")===-1)
    {
        location.href = window.apiclientUrl+"Search/View";//NO I18N
    }
    else
    {
            var ser_content=$("#global_search").val();
            var ser_type="resource";//NO I18N
            if($("#search_type").val()==2)
            {
                ser_type="users";//NO I18N
            }
            else if($("#search_type").val()==3)
            {
                ser_type="keys";//NO I18N
            }
            else if($("#search_type").val()==4)
            {
                ser_type="certificate";//NO I18N
            }
            else if($("#search_type").val()==5)
            {
                ser_type="san";//NO I18N
            }
            searchListGen(ser_content,ser_type);
    }
}        

function autoReloadGrid(func,params,gridName)
{
    window.setTimeout( refreshGrid, 5000);

    function refreshGrid()
    {
        if($("#"+gridName).length && isAutoRefresh==true)//No I18N
        {
            var grid = jQuery("#"+gridName);//No I18N
            grid.trigger("reloadGrid");//No I18N
            isAutoRefresh=false;
            var pgNumber=$(".ui-pg-input").val();//No I18N
            var pgSel=$(".ui-pg-selbox").val();//No I18N
            func(params,pgNumber,pgSel);
            
            window.setTimeout( refreshGrid, 5000);
        }
    }
}        

function redirectUrl(url)
{
    if(kmpStandAlone)
    {
        location.href="#/"+url;//No I18N
    }
    else
    {
        var currentMainTab="SSHKeysView";//No I18N
        if(localStorage.getItem("homeTab")=="SSHKeysView" || localStorage.getItem("homeTab")=="ReportQuickView" || localStorage.getItem("homeTab")=="SSLCertificatesView" || localStorage.getItem("homeTab")=="admin" || localStorage.getItem("homeTab")=="SSLCertificatesView")//No I18N
        {
            currentMainTab=localStorage.getItem("homeTab");//No I18N
    }
        else if(localStorage.getItem("homeTab")=="PassTrixQuickView")
        {
            currentMainTab=localStorage.getItem("homeTab");//No I18N
            localStorage.setItem("homeTab",currentMainTab);//No I18N
                localStorage.setItem("currentView", url);//NO I18N
        }
        location.href="#/"+currentMainTab+"/"+url;//No I18N
}
}

function redirectPreviousPage()
{
    window.history.back();
}

function getMenusForSideView(sideView)
{
    var promise=Ember.$.getJSON('/api/pki/settings/getClientMenus?viewName='+sideView);//No I18N
            promise.then( function(jsonData) {
            			if(jsonData!=undefined && !jQuery.isEmptyObject(jsonData)){
                            App.ApplicationController.viewMenus = jsonData[sideView];
            			}else{
            				App.ApplicationController.viewMenus = pkiJson[sideView][sideView];
            			}
                        todisplayMenus(App.ApplicationController.viewMenus,sideView);
                        });
                         return promise;
}

function todisplayMenus(json,sideView)
{
		if(json == undefined || jQuery.isEmptyObject(json)){
			json = pkiJson[sideView][sideView];
		}
        var len = json.length;
        for (var i = 0; i < len; i++)
        {
            if(json[i].indexOf('_btn')!=-1 )
            {
            $('[data-pki-menu=\"' + json[i] + '\"]').css('display', 'inline-block');
        }else if( json[i].indexOf('Report')!=-1){
            $('[data-pki-menu=\"' + json[i] + '\"]').css('display', 'inline-table');
        }
            else
            {
                $('[data-pki-menu=\"' + json[i] + '\"]').css('display', 'block');
}
        }
}
