// $Id$
App.Inventory = Ember.Object.extend({});
var informationTabList = App.Inventory.create();
var certEndPoint=App.Inventory.create();
window.cert_ids=null;
window.nav_index=parseInt(0);
App.Inventory.reopenClass({
    listsummary: function(res_type) {
        var data=""; //No I18N
        if(res_type)
        {
            data="res_type="+res_type;//No I18N
        }
        var ajaxRequestUrl = '/api/pki/Inventory/listSummary'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
            var colNamesList = ['Resource_ID',I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.discovery.resourcetype'),'',I18N.getMsg('js.general.creationtime'),'',I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'ResourceID', index: 'ResourceID',hidden:true},//No I18N
                    { name: 'ResourceName', index: 'ResourceName',classes:'pointer'}, //No I18N
                    { name: 'IPAddress', index: 'IPAddress',formatter:'ipcheckFormatter'}, //No I18N
                    { name: 'ResourceType', index: 'ResourceType',hidden:true}, //No I18N
                    { name: 'SSH', index: 'SSH',width:'50px',formatter:'sshEnabledFormatter',classes:'pointer',search:false}, //No I18N
                    { name: 'CreationTime', index: 'CreationTime'}, //No I18N
                    { name: 'Edit', index: 'Edit',title:'Edit Credential',classes:'pointer',formatter:'editCredentialFormatter',width:'50px',search:false}, //No I18N
                    { name: 'search',width:25,sortable: false,search:false}//NO I18N
                ];
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#PKIInventoryList", jsonData.Resources, colNamesList, colModelList, "", "#PKIInventorypager", "AllResources",defaultOptions);//No I18N                    
            });
    },
    listsslsummary: function(controller) {
        
        if(App.ApplicationController.isAdmin===true)
        {
        var ajaxRequestUrl = '/api/pki/settings/isCMDBEnabled'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){                
                if(jsonData.Status=="Success")
                {
                    App.InventoryController.cmdb=true;
                }
                else
                {
                    App.InventoryController.cmdb=false;
                }
            });
        }
        getCertificateList("",'PKIInventoryList',"PKIInventorypager",controller);//No I18N
//        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
//            App.InventoryController.cmdb=jsonData.CMDB;
//        });
    },

    listsshsummary: function(controller) {
        var ajaxRequestUrl = '/api/pki/Inventory/listsshSummary'; //No I18N
        $("#resgroupname").hide();
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
            sshResourceList(jsonData,"PKIInventoryList","PKIInventorypager",defaultOptions);//No I18N
            $("#helpmain").show();
            //openDialogInTable(controller)
            });
    },
    listSSLVulSubSubGrid: function(v_id){
        listSSLVulnSubSubGrid(v_id);
    },

    endPointSummary: function(cert_id) {
        var ajaxRequestUrl = '/api/pki/Inventory/details'; //No I18N
        var params='cert_id='+cert_id;//No I18N
        getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                var jsonend=jsonData.endpoint;
                var jsonissur=jsonData.issuer;
                var jsonissuedto=jsonData.issuedto;
                var jsonInter=jsonData.intermediate;
                App.InventoryListDetailsController.cert_name=jsonend.hostName;
                //$("#common_name").text(jsonissuedto.cname);
                var colModelList = [
                        { name: 'id',width:"0px"},//No I18N
                        { name: 'Key', index: 'Key',sortable: false}, //No I18N
                        { name: 'Value', index: 'Value',sortable: false}, //No I18N
                        { name: 'download',width:50,sortable: false,search:false,fixed:true}//NO I18N
                ];
                    var dataArray = new Array();
                    var colNamesList = ['',jsonend.hostName,'','<div onclick="downLoadCertificate('+cert_id+')"><span id="grid_download" class="icon-export" style="color:#000;font-size:16px;"></span></div>']; //No I18N
                    dataArray.push({"Key":I18N.getMsg('js.commonstr.certificatename'), "Value":jsonend.hostName});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.discovery.port'), "Value":jsonend.port});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.report.timeline.fromdate'), "Value":jsonend.from_date});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.report.timeline.todate'), "Value":jsonend.expiry_date});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.cert.sans'), "Value":jsonend.Sans});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.sslcertificate.issuer'), "Value":jsonissur.org});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.sslcertificate.issuer')+"(CN)", "Value":jsonissur.cname});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.cert.sigAlgorithm'), "Value":jsonend.certSignAlg});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.ssh.fingerprint'), "Value":jsonend.fingerPrint});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.cert.serialNumber'), "Value":jsonend.serial});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.ssl.certificate.keyalgorithm'), "Value":jsonend.keyalg});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.sslcertificate.keysize'), "Value":jsonend.PublicKeyLength});//No I18N
                    if(jsonend.hasOwnProperty("RequestKeyFromOwner")){
                         dataArray.push({"Key":I18N.getMsg('js.cert.keystore'), "Value":'<a class="hand grant" href="javascript:requestCertPrivatekey('+cert_id+')">'+I18N.getMsg("pki.js.request.keyfromowner")+'</a>'});//No I18N
                    }else{
                    if(jsonend.PrivateKey===true)
                    {
                        dataArray.push({"Key":I18N.getMsg('js.keystore.type'),"Value":jsonend.StoreType});//NO I18N
                        dataArray.push({"Key":I18N.getMsg('js.cert.keystore'), "Value":'<a id="exportprivkeyid" class="pointer" href="javascript:exportprivatekey(\''+jsonend.hostName+'\','+jsonend.isSharedExport+','+cert_id+');">Export</a> &emsp; <a style="vertical-align:text-top;" title=\"'+I18N.getMsg("js.showpassphrase.title")+'\" data-container="body" data-content="" data-toggle="popover" data-trigger="click" data-placement="left" href="javascript:getCerPassword(\''+cert_id+'\',\''+jsonend.hostName+'\')"><div class="icon-showpwd fontIcon-disable" style="cursor:pointer;font-size:16px;" title="Show Passphrase"></div></a>'});
                    }
                    }
                    dataArray.push({"Key":I18N.getMsg('js.discovery.ipaddress'), "Value":jsonData.ipaddress});//No I18N
                    var defaultOptions={multiselect:false,rowNumNeeded:false};
                loadJQgridWithData("#PKIInventoryDetailsList", dataArray, colNamesList, colModelList, "", "", "SSLEndPointSummary",defaultOptions,false);//No I18N

                if(jsonData.isCertInstalledMulipleServers)
                {
                    $("#multipleServers").show();
                }
                var divs="";
                for(var i=1;i<=Object.keys(jsonInter).length;i++)
                {
                    divs=divs+"<div class='pad10t'><table id=div"+i+"></table></div>";
                }
                if(Object.keys(jsonInter).length !== 0 && JSON.stringify(jsonInter) !== JSON.stringify({}))
                {
                    $("#intermediate").show();
                    document.getElementById("AdditionalCerts").innerHTML=divs;
                    var i=1;
                    for (var key in jsonInter) {
                        if (jsonInter.hasOwnProperty(key)) {
                            var jsonCerts=jsonInter[key];
                            dataArray = new Array();
                            for (var key1 in jsonCerts) {
                                if (jsonCerts.hasOwnProperty(key1)) {
                                    if(key1!=="InterID")
                                    {
                                    dataArray.push({"Key":I18N.getMsg(key1), "Value":jsonCerts[key1]});//No I18N
                                }
                            }
                            }
                            colNamesList = ['',jsonCerts.Subject,'','<div onclick="downLoadInterCertificate('+jsonCerts.InterID+')"><span id="grid_download" class="icon-export" style="color:#000;font-size:16px;padding:5px;"></span></div>']; //No I18N
                            loadJQgridWithData("#div"+i, dataArray, colNamesList, colModelList, "", "", "SSLEndPointSummary",defaultOptions,false);//No I18N
                            i++;
                        }
                    }
                }
            certEndPoint.setProperties(jsonData);
        });
        return certEndPoint;
    },
    
    getResourceUsersListView: function()
    {
        if(!kmpStandAlone)
        {
            $(".icon-add-user").hide();
        }
        var reqUrl="/api/pki/ssh/getUsers";//No I18N
        var text1="";
        var params="res_id="+App.ApplicationController.res_id;//No I18N
        getAjaxApiRequest(reqUrl,params,function(jsonData){
            if(jsonData.associated_users.length===0 )
            {
                text1="No Users Found";//NO I18N
                $( "#nousers" ).text( text1 );
            }
            else
            {
                var asso_users=jsonData.associated_users;
                var non_asso_users=jsonData.non_associated_users;
                var colNamesList = ['UserID',I18N.getMsg('js.general.username'),'','','','',I18N.getMsg('js.table.search')]; //No I18N
                var colModelList = [
                        { name: 'UserID', index: 'UserID',hidden:true}, //No I18N
                        { name: 'UserName', index: 'UserName',width:'100'}, //No I18N
                        { name: 'credential', index: 'credential',hidden:true}, //No I18N
                        { name: 'credential', index: 'credential',title:'Edit Credential',classes:'pointer',formatter:'editCredentialFormatter',width:'50px',search:false}, //No I18N
                        { name: 'Connect', index: 'Connect',hidden:true}, //No I18N
                        { name: 'Connect', index: 'Connect',search:false,formatter:"openTerminalFormatter",classes:"pointer",width:'50'}, //No I18N
                        { name: 'search',width:30,sortable: false,search:false,fixed:true}//NO I18N
                ];                   
                var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                loadJQgridWithData("#ListResourceUsers", jsonData.associated_users, colNamesList, colModelList, "", "", "ResourceUsersTerminal",defaultOptions,"#associateListUsers");//No I18N
                var DataGrid = $('#ListResourceUsers');//No I18N
                DataGrid.jqGrid('setGridWidth', '460');//No I18N
                DataGrid.jqGrid('setGridHeight', '250');//No I18N
            }
        });        
    },
    getCertificate: function(hostId) {
        var ajaxRequestUrl = '/api/pki/Inventory/CertificateAsJSON?hostId='+hostId; //No I18N
        var params='hostId='+hostId;//No I18N
        getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                //certEndPoint.setProperties(jsonData);
                var content=jsonData.CERTIFICATE;
                if(document.getElementById('Certificate')!==null)
                {
                    document.getElementById('Certificate').value=content;
                }
                $("#currentCert").html(content);
                App.InventoryListDetailsController.certificate=content;
        });
    },
    getInventoryTabList: function() 
    {
    	var selectedTab = App.InventoryTabListController.selectedTab;
        App.SettingsCommonController.rGroup=false;
        var all = false;
        var ssh = false;
        var ssl = false;
   		
        if (selectedTab === "all") {all= true;} //No I18N
        else if (selectedTab === "ssh") {ssh= true;} //No I18N
        else if (selectedTab === "ssl") {ssl= true;} //No I18N
        
		var baseurl = window.apiclientUrl+"Inventory/Tab/"; //No I18N
        
		var jsonObj =   {"menuLinks":[ //No I18N
					{"Name":"ALL Resources","url":baseurl+"Resources","title":"ALL Resources","isSelected":all}, //No I18N
					{"Name":"SSH Resources","url":baseurl+"SSH","title":"SSH Resources","isSelected":ssh}, //No I18N
                                        {"Name":"SSL Resources","url":baseurl+"SSL","title":"SSL Resources","isSelected":ssl} //No I18N
					]
				}//No I18N
				informationTabList.setProperties(jsonObj);
				return informationTabList;
	},

    getResourceViewList: function() 
    {
        var selectedTab = App.InventoryTabListController.selectedTab;

        var res = false;
        var resG = false;
        var ssl=false;
        if (selectedTab === "res") {res= true;} //No I18N
        else if (selectedTab === "resG") {resG= true;} //No I18N
        else if(selectedTab === "ssl" ){ssl=true;}

        var baseurl = window.apiclientUrl+"Inventory/Tab/"; //No I18N
        var arr=new Array();
        var jsonObj={};
        if(App.ApplicationController.isFULL)
        {
            var object = {"Name":"SSH","url":baseurl+"SSH","title":"Resources","isSelected":res} //No I18N
            arr.push(object);
            object = {"Name":"SSL","url":baseurl+"SSL","title":"Certificates","isSelected":ssl} //No I18N
            arr.push(object);
        }
            
        jsonObj.menuLinks = arr;
        informationTabList.setProperties(jsonObj);
        return informationTabList;
    },

        getCertificateDetailsTabList: function(res_id,res_type) 
        {
    	var selectedTab = App.InventoryListDetailsController.selectedTab;
    	App.InventoryListDetailsController.set("hostId", res_id); //No I18N
   
            var ssl = false;
            var ssh = false;
   		
            if (selectedTab === "SSL") {ssl= true;} //No I18N
            else if (selectedTab === "SSH") {ssh= true;} //No I18N
        
            var baseurl = window.apiclientUrl+"Inventory/DetailedView/"+res_id+"/"+res_type +"/"; //No I18N
        
            var menuLinks = [];
            var ssl_jobj={"Name":"SSL Details","url":baseurl+"SSL","title":"SSL Details","isSelected":ssl}; //No I18N
            var ssh_jobj={"Name":"SSH Details","url":baseurl+"SSH","title":"SSH Details","isSelected":ssh}; //No I18N
            if(res_type==="both")
            {
                menuLinks.push(ssl_jobj);
                menuLinks.push(ssh_jobj);
            }
            else if(res_type==="ssl")
            {
                menuLinks.push(ssl_jobj);
            }
            else
            {
                menuLinks.push(ssh_jobj);
            }
            var jsonObj =   {"menuLinks": menuLinks}//No I18N
				informationTabList.setProperties(jsonObj);
				return informationTabList;
	},        
        getSansDetails: function(res_Id)
        {
            var ajaxRequestUrl = '/api/pki/Inventory/sansdetails?hostId='+res_Id; //No I18N
            var params='hostId='+res_Id;//No I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                    var colNamesList = [I18N.getMsg('js.ssl.sansname'),I18N.getMsg('js.sans.startdate'),I18N.getMsg('js.sans.enddate'),I18N.getMsg('js.table.search')]; //No I18N
                    var colModelList = [
                            { name: 'SansName', index: 'SansName'}, //No I18N
                            { name: 'StartDate', index: 'StartDate'}, //No I18N
                            { name: 'EndDate', index: 'EndDate'}, //No I18N
                            { name: 'search',width:25,sortable: false,search:false}//NO I18N
                    ];                   
                    var defaultOptions={multiselect:false,rowNumNeeded:false};
                    loadJQgridWithData("#PKISans", jsonData.SansDetails, colNamesList, colModelList, " ", "#PKISanspager", "",defaultOptions);//No I18N
            });
        },
        getCertificatesGroupList: function()
        {
            var ajaxRequestUrl = '/api/pki/Inventory/getCeritificatesGroupList'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                    var colNamesList = ['Group Id',I18N.getMsg('js.resource.groupname'),I18N.getMsg('js.commonstr.description'),I18N.getMsg('js.general.createdby'),I18N.getMsg('js.schedule.lastmodifiedby'),'',I18N.getMsg('js.table.search')]; //No I18N
                    var colModelList = [
                            { name: 'GROUP_ID', index: 'GROUP_ID',hidden:true}, //No I18N
                            { name: 'GROUP_NAME', index: 'GROUP_NAME',classes:'pointer'}, //No I18N
                            { name: 'DESCRIPTION', index: 'DESCRIPTION'}, //No I18N
                            { name: 'Created By', index: 'Created By'}, //No I18N
                            { name: 'Last Modified By', index:'Last Modified By'},//NO I18N
                            { name: 'Edit', index: 'Edit',search:false,formatter:'editFormatter',width:'30px'}, //No I18N
                            { name: 'search',width:25,sortable: false,search:false}//NO I18N
                    ];                   
                    var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                    loadJQgridWithData("#PKIResourceGroupList", jsonData.RGList, colNamesList, colModelList, " ", "#PKIResourceGrouppager", "SSLGroup",defaultOptions);//No I18N
            });
        },
        getRootCertificateList: function()
        {
            var ajaxRequestUrl = '/api/pki/Inventory/getRootCertificateList'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,'',function(jsonData){
                    var colNamesList = ['ResourceID',I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.sslcertificate.issuer'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg('js.ssl.certificate.keyalgorithm'),I18N.getMsg('js.cert.sigAlgorithm'),I18N.getMsg('js.sslcertificate.daystoexpire'),'',I18N.getMsg('js.table.search')]; //No I18N
                    var colModelList = [
                            { name: 'ResourceID', index: 'ResourceID',hidden:true}, //No I18N
                            { name: 'Common Name', index: 'Common Name',classes:"pointer"}, //No I18N
                            { name: 'DNS Name/FQDN', index: 'DNS Name/FQDN'}, //No I18N                            
                            { name: 'Organization', index: 'Organization'}, //No I18N
                            { name: 'ExpiryDate', index: 'ExpiryDate',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                            { name: 'KeyStrength', index: 'KeyStrength'}, //No I18N
                            { name: 'keyAlgorithm', index: 'keyAlgorithm',width:'90px',width: '150'}, //No I18N
                            { name: 'signatureAlgorithm', index: 'signatureAlgorithm'}, //No I18N
                            { name: 'DaysToExpiry', index: 'DaysToExpiry'}, //No I18N
                            { name: 'isUsedToSign', index: 'isUsedToSign',width: '40px',formatter:'isUsedToSignFormatter',search:false,fixed:true}, //No I18N
                            { name: 'search',width:25,sortable: false,search:false}//NO I18N
                    ];
                    var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                    loadJQgridWithData("#PKIRootCertificateList", jsonData.InventDetails, colNamesList, colModelList, "", "#PKIRootCertificatepager", "rootCertList",defaultOptions);//No I18N
            });
        },        
        getClientCertificateList: function(root_id)
        {
            var params="root_id="+App.InventoryController.res_Id;//No I18N
            var ajaxRequestUrl = '/api/pki/Inventory/getClientCertificateList'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                    var colNamesList = ['ResourceID',I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.sslcertificate.issuer'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg('js.ssl.certificate.keyalgorithm'),I18N.getMsg('js.cert.sigAlgorithm'),I18N.getMsg('js.sslcertificate.daystoexpire'),I18N.getMsg('js.table.search')]; //No I18N
                    var colModelList = [
                            { name: 'ResourceID', index: 'ResourceID',hidden:true}, //No I18N
                            { name: 'Common Name', index: 'Common Name',classes:"pointer"}, //No I18N
                            { name: 'DNS Name/FQDN', index: 'DNS Name/FQDN'}, //No I18N                            
                            { name: 'Organization', index: 'Organization'}, //No I18N
                            { name: 'ExpiryDate', index: 'ExpiryDate',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                            { name: 'KeyStrength', index: 'KeyStrength'}, //No I18N
                            { name: 'keyAlgorithm', index: 'keyAlgorithm',width:'90px',width: '150'}, //No I18N
                            { name: 'signatureAlgorithm', index: 'signatureAlgorithm'}, //No I18N
                            { name: 'DaysToExpiry', index: 'DaysToExpiry'}, //No I18N
                            { name: 'search',width:25,sortable: false,search:false}//NO I18N
                    ];
                    var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                    loadJQgridWithData("#PKISignedCertificateList", jsonData.InventDetails, colNamesList, colModelList, "", "#PKISignedCertificatepager", "rootCertList",defaultOptions);//No I18N
            });
        },        
        getResourceGroupList: function(res_Id)
        {
            var ajaxRequestUrl = '/api/pki/Inventory/getResourceGroupList'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                    var colNamesList = ['Group Id',I18N.getMsg('js.resource.groupname'),I18N.getMsg('js.commonstr.description'),I18N.getMsg('js.general.createdby'),'','',I18N.getMsg('js.table.search')]; //No I18N
                    var colModelList = [
                            { name: 'GROUP_ID', index: 'GROUP_ID',hidden:true}, //No I18N
                            { name: 'GROUP_NAME', index: 'GROUP_NAME',classes:'pointer'}, //No I18N
                            { name: 'DESCRIPTION', index: 'DESCRIPTION'}, //No I18N
                            { name: 'Created By', index: 'Created By'}, //No I18N
                            { name: 'Edit', index: 'Edit',search:false,formatter:'editFormatter',width:'30px',fixed:true}, //No I18N
                            { name: 'EditPath' ,index: 'EditPath',search:false,formatter:'editPathFormatter',width:'30px',fixed:true},//NO I18N
                            { name: 'search',width:25,sortable: false,search:false,width:'30px',fixed:true}//NO I18N
                    ];                   
                    var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                    loadJQgridWithData("#PKIResourceGroupList", jsonData.RGList, colNamesList, colModelList, " ", "#PKIResourceGrouppager", "ResourceGroup",defaultOptions);//No I18N
            });
        },
        getLandingServersList: function()
        {
            var ajaxRequestUrl = '/api/pki/landingserver/getLandingServersList'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                    var colNamesList = ['Server Id',I18N.getMsg('landingserver.servername'),I18N.getMsg("landingserver.primaryserver"),I18N.getMsg("landingserver.secondaryserver"),I18N.getMsg('js.commonstr.description'),I18N.getMsg('js.general.createdby'),'',I18N.getMsg('js.table.search')]; //No I18N
                    var colModelList = [
                            { name: 'SERVER_ID', index: 'SERVER_ID',hidden:true}, //No I18N
                            { name: 'SERVER_NAME', index: 'SERVER_NAME',classes:'pointer'}, //No I18N
                            { name: 'PRIMARY_SERVER', index: 'PRIMARY_SERVER'},//NO I18N
                            { name: 'SECONDARY_SERVER', index: 'SECONDARY_SERVER'},//NO I18N
                            { name: 'DESCRIPTION', index: 'DESCRIPTION'}, //No I18N
                            { name: 'CREATED_BY', index: 'CREATED_BY'}, //No I18N
                            { name: 'EDIT', index: 'EDIT',formatter:'editLSFormatter',width:"30px",fixed:true},//NO I18N
                            { name: 'search',width:25,sortable: false,search:false,width:'30px',fixed:true}//NO I18N
                    ];                   
                    var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                    loadJQgridWithData("#LandingServersList", jsonData.serversList, colNamesList, colModelList, " ", "#LandingServerspager", "LandingServersList",defaultOptions);//No I18N
            });
        },
        landingServerAssociationView: function()
        {
            var ajaxRequestUrl = '/api/pki/landingserver/getLSAssociationView';//NO I18N
            var params = "id="+App.InventoryController.lsid+"&LSName="+App.InventoryController.lsname;//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                $("#pgtitle").text(I18N.getMsg("landingserver.name",new Array(jsonData.ServerName)));  //NO I18N    
                var colNamesList = ['Resource_ID',I18N.getMsg('js.general.resourcename'),I18N.getMsg("js.commonstr.description"),'',I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.general.creationtime'),I18N.getMsg("landingserver.heading"),'','','',I18N.getMsg('js.table.search')]; //No I18N
                var colModelList = [
                        { name: 'ResourceID', index: 'ResourceID',hidden:true},//No I18N
                        { name: 'ResourceName', index: 'ResourceName',formatter:'resourceLinkFormatter'}, //No I18N
                        { name: 'Description', index: 'Description'},//NO I18N
                        { name: 'resourceLink', index: 'resourceLink',hidden:true}, //No I18N
                        { name: 'IPAddress', index: 'IPAddress',formatter:'ipcheckFormatter'}, //No I18N
                        { name: 'CreationTime', index: 'CreationTime',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                        { name: 'LSName', index: 'LSName',hidden:true},//NO I18N
                        { name: 'LSId', index: 'LSId',hidden:true},//NO I18N
                        { name: 'isLS', index: 'isLS',hidden:true},//NO I18N
                        { name: 'ISLS', index: 'ISLS',formatter:'isLSFormatter',width:'35px',search:false,fixed:true},//NO I18N
                        { name: 'search',width:'40px',sortable: false,search:false,fixed:true}//NO I18N
                                ];
                var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                loadJQgridWithData("#PKIInventoryList", jsonData.Resources, colNamesList, colModelList, "", "#PKIInventorypager", "SSHResources",defaultOptions);//No I18N
            });
        },
        getLandingServerView: function(id)
        {
          var ajaxRequestUrl = '/api/pki/landingserver/getLandingServerView';//NO I18N
          if(id!=undefined)
          {
              ajaxRequestUrl+='?id='+id;//NO I18N
          }
          getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
              
              if(jsonData.servername!==undefined)
              {
                  $("#servername").val(jsonData.servername);
              }
              
              if(jsonData.description!==undefined)
              {
                  $("#description").val(jsonData.description);
              }
              
              var resources = jsonData.resources;
              if(resources.length>0)
              {
                  $("#primaryserver").find('option').remove();
                  for(var i=0;i<resources.length;i++)
                  {
                      var rid = resources.get(i).resourceId;
                      var rName = resources.get(i).resourceName;
                      var option = new Option(rName,rid);   
                      var option2 = new Option(rName,rid);   
                      $("#primaryserver").append(option);
                      $("#secondaryserver").append(option2);
                  }                  
              }
              if(id!==undefined)
              {
                if(jsonData.primaryserver_id!==undefined)
                {
                    $("#primaryserver").val(jsonData.primaryserver_id);
                }

                if(jsonData.primaryuser_id!==undefined)
                {                  
                    getResourceUsers('primaryserver','primaryuser',jsonData.primaryuser_id);//NO I18N
                }

                if(jsonData.secondaryserver_id!==undefined)
                {
                    $("#secondaryserver").val(jsonData.secondaryserver_id);
                }

                if(jsonData.secondaryuser_id!==undefined)
                {
                    getResourceUsers('secondaryserver','secondaryuser',jsonData.secondaryuser_id);//NO I18N
                }
            }
            else
            {
                getResourceUsers('primaryserver','primaryuser');//NO I18N
            }
          });
        },
        getResourceListFromGroup: function(rgid)
        {
            var ajaxRequestUrl = '/api/pki/Inventory/getResourcesFromGroup'; //No I18N
            var data="RGID="+rgid;//No I18N
            $("#resgroupname").show();
            $("#resgroupname").text(sessionStorage.getItem("groupname"));//No I18N
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                sshResourceList(jsonData,"PKIInventoryList","PKIInventorypager",defaultOptions);//NO I18N
            });
        },
        getCertificatesListFromGroup: function(sgid)
        {
            var ajaxRequestUrl = '/api/pki/Inventory/getCertificatesFromGroup'; //No I18N
            var data="SGID="+sgid;//No I18N
            $("#resgroupname").show();
            $("#resgroupname").text(sessionStorage.getItem("groupname"));//No I18N
//            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
//                var controller;
                //getCertificateList(jsonData,'PKIInventoryList',"PKIInventorypager",controller);//No I18N
                var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true}; //No I18N
                populateRemoteApiClientGrid('PKIInventoryList',"PKISSLCertificateList", "", "#PKIInventorypager", "certDetails", defaultOptions,ajaxRequestUrl,data); //No I18N
//            });
        },
        getCertificateVersionHistory: function(controller)
        {
            var ajaxRequestUrl = '/api/pki/Inventory/getCertificateHistoryList'; //No I18N
            var params="cert_id="+App.InventoryListDetailsController.cert_id;//No I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                var colNamesList = ['VersionID',I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.issuer'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg("js.ssl.certificate.keyalgorithm"),I18N.getMsg('js.general.creationtime'),'','','','','','',I18N.getMsg('js.table.search')]; //No I18N
                var colModelList = [
                        { name: 'VersionID', index: 'VersionID',hidden:true}, //No I18N
                        { name: 'CommonName', index: 'CommonName',width: '200'}, //No I18N
                        { name: 'IssuerName', index: 'IssuerName',width: '200'}, //No I18N
                        { name: 'ExpiryDate', index: 'ExpiryDate',width: '200px'}, //No I18N
                        { name: 'KeyStrength', index: 'KeyStrength',width:'90px'}, //No I18N
                        { name: 'KeyAlgorithm', index: 'KeyAlgorithm',width:'90px'}, //No I18N
                        { name: 'CreationTime', index: 'CreationTime',width:'200px'}, //No I18N
                        { name: 'Main', index:'Main',hidden:true},//NO I18N
                        { name: 'SetAsMain', index: 'SetAsMain',width:'30px',formatter:'setAsMainCertFormatter',fixed:true},//NO I18N
                        { name: 'PassPhrase', index: 'PassPhrase', hidden:true,fixed:true},//NO I18N
                        { name: 'showPassPhrase',index: 'showPassPhrase',formatter:'showSSLVerPassPhraseFormatter',width:'30px',search:false,fixed:true},//NO I18N
                        { name: 'deploy', index: 'deploy',width:'30px',formatter:'deployedServersFormatter',fixed:true}, //No I18N
                        { name: 'Export', index: 'Export',width:'30px',fixed:'true',search:'false',formatter:'exportKeyFormatterSSLVer' },//No I18N
                        { name: 'search',width:30,sortable: false,search:false,fixed:true}//NO I18N
                ];
                var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
                loadJQgridWithData("#PKIHistory", jsonData.CertVersion, colNamesList, colModelList, "", "#PKIHistorypager", "certHistory",defaultOptions);//No I18N
                if(controller!==undefined)
                    {
                var dig_arr=new Array('showCertVersionDialog');
                var placeHolder=new Array('.reqsName');
                openDialogInTable(controller,"#PKIHistory",placeHolder,dig_arr);//No I18N    
        }
            });             
        },
        getMultipleInstalledServers: function(controller)
        {
            var reqUrl="/api/pki/Inventory/getMultipleInstalledServers";//No I18N
            var params="cert_id="+App.InventoryListDetailsController.cert_id+"&skipSingleServer="+true;//No I18N
            getAjaxApiRequest(reqUrl,params,function(jsonData){
                var colNamesList = ['MappingID',I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.discovery.port'),I18N.getMsg('js.sslcertificate.expirydate'),'',I18N.getMsg('js.table.search')]; //No I18N
                var colModelList = [
                        { name: 'MappingID', index: 'MappingID',hidden:true}, //No I18N
                        { name: 'DomainName', index: 'DomainName'}, //No I18N
                        { name: 'IPAddress', index: 'IPAddress'}, //No I18N
                        { name: 'Port', index: 'Port'}, //No I18N
                        { name: 'ValidTo', index: 'ValidTo'}, //No I18N
                        { name: 'Credential', index: 'Credential',formatter:'editCertCredentialFormatter'}, //No I18N
                        { name: 'search',width:30,sortable: false,search:false,fixed:true}//NO I18N
                ];                   
                var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                loadJQgridWithData("#wildcardList", jsonData.MultipleServers, colNamesList, colModelList, "", "#wildcardpager", "SSLCertMultipleServers",defaultOptions);//No I18N
                if(controller!==undefined)
                {
                    var dig_arr=new Array('showCertDeployment');
                    var placeHolder=new Array('.icon-key');
                    openDialogInTable(controller,"#wildcardList",placeHolder,dig_arr);//No I18N   
                }
            });
        },
        getCertificatePrivateKeyAccessRequestsList: function()
        {
           var reqUrl = "/api/pki/Inventory/showAllCertsRequiringPrivateKeyAccess";//No I18N
            getAjaxApiRequest(reqUrl, "", function (jsonData) {
                var colNamesList = ['CertId','requesterLoginId',I18N.getMsg('js.commonstr.certificate'),I18N.getMsg('pki.js.UserRequested'),I18N.getMsg('js.request.approve'),I18N.getMsg('pki.js.request.reject'),I18N.getMsg('js.table.search')]; //No I18N
                var colModelList = [
                    { name: 'CertId', index: 'CertId',hidden:true}, //No I18N
                    { name: 'requesterLoginId', index: 'requesterLoginId',hidden:true}, //No I18N
                        { name: 'Certificate', index: 'Certificate',width: '200px !important',fixed:true}, //No I18N
                        { name: 'UserRequested', index: 'UserRequested',width: '200px !important',fixed:true}, //No I18N
                        { name: 'approve',index: 'approve',formatter:'approveOrRejectPrivateKeyRequest',width:'100px',search:false,fixed:true},//NO I18N
                        { name: 'reject',index: 'reject',formatter:'approveOrRejectPrivateKeyRequest',width:'100px',search:false,fixed:true},//NO I18N
                        { name: 'search',width:30,sortable: false,search:false,fixed:true}//NO I18N
                ];
                var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
                loadJQgridWithData("#PKICertRequest", jsonData.KeyAccessRequests, colNamesList, colModelList, "", "#PKICertRequestpager", "",defaultOptions);//No I18N
            });             
        },shareCertorCertGroupswithUserorUserGroupsviewList:function(type,certIdType,cert_id,controller){
            if(type=='cert-users' || type=='certgroup-users'){
            var reqUrl = "/api/pki/settings/getSSLRoleUsersWithShareDetailsForCertOrGroup";//No I18N
            getAjaxApiRequest(reqUrl, certIdType+"="+cert_id+'&shareType='+type, function (jsonData) {
                if( jsonData.Status=="Failure"){
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                    controller.send('closeModal');//No I18N
                }
            else if (jsonData == undefined || Object.keys(jsonData).length === 0 || JSON.stringify(jsonData) == JSON.stringify({}))
            {
                messageNotification("messageNotifyFailure", I18N.getMsg("js.keystore.assignKeystoUser.NoUsersAvailable"));//No I18N
                
            } else {
                var colNamesList = ["UserId",'UserName','',I18N.getMsg('js.table.search')]; //No I18N
                var colModelList = [
                        { name: 'UserId', index: 'UserId',hidden:true,width:'30px'}, //No I18N
                        { name: 'UserName', index: 'UserName'}, //No I18N
                        { name: 'Actions', index: 'Actions',sortable: false,formatter:'grantRevokeCert'}, //No I18N
                        { name: 'search',width:30,sortable: false,search:false,fixed:true}//NO I18N
                ];
                var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                loadJQgridWithData("#PKIShareCertToUserDIV", jsonData.UsersList, colNamesList, colModelList, "", "#PKIShareCertToUserDIVpager", "",defaultOptions);//No I18N
        }        
        },controller);
    }else{
        var reqUrl = "/api/pki/settings/getUserGroupsWithSharePermissionForCertOrGroup";//No I18N
            getAjaxApiRequest(reqUrl, certIdType+"="+cert_id+'&shareType='+type, function (jsonData) {
                 if( jsonData.Status=="Failure"){
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                    controller.send('closeModal');//No I18N
                }
            else if (jsonData == undefined || Object.keys(jsonData).length === 0 || JSON.stringify(jsonData) == JSON.stringify({}))
            {
                messageNotification("messageNotifyFailure", I18N.getMsg("js.keystore.assignKeystoUser.NoUsersAvailable"));//No I18N
            } else {
                var colNamesList = ["UserGroupId",'UserGroupName','',I18N.getMsg('js.table.search')]; //No I18N
                var colModelList = [
                        { name: 'UserGroupId', index: 'UserGroupId',hidden:true}, //No I18N
                        { name: 'UserGroupName', index: 'UserGroupName'}, //No I18N
                        { name: 'Actions', index: 'Actions',sortable: false,formatter:'grantRevokeCert'}, //No I18N
                        { name: 'search',width:30,sortable: false,search:false,fixed:true}//NO I18N
                ];
                var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                loadJQgridWithData("#PKIShareCertToUserDIV", jsonData.UserGroupsList, colNamesList, colModelList, "", "#PKIShareCertToUserDIVpager", "",defaultOptions);//No I18N
            }
        },controller);
    }
        }        
});

function downLoadCertificate(cert_id)
{
    var ajaxRequestUrl = '/api/pki/Inventory/certificate?hostId='+cert_id; //No I18N
    if (!window.location.origin) {
        window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '');
}
    location.href=window.location.origin+ajaxRequestUrl;
}

function downLoadInterCertificate(inetCert_id)
{
    var ajaxRequestUrl = '/api/pki/Inventory/certificate?inetCert_id='+inetCert_id; //No I18N
    if (!window.location.origin) {
        window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '');
}
    location.href = window.location.origin + ajaxRequestUrl;
}

function renewCertificateRequest()
{
    var grid = jQuery("#PKIInventoryList"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length >1) {
        showAlert(I18N.getMsg('letsencrypt.renewrequest.selectonecert')); //No I18N
            return;
    }
    var res_id = grid.jqGrid('getCell', selRowIds, 'ResourceID'); //No I18N
    var issuer = grid.jqGrid('getCell',selRowIds,'Organization');//NO I18N
    if(!issuer.includes("Let's Encrypt"))
    {
        showAlert(I18N.getMsg("certificate.renew.onlyletencrypt"));//NO I18N
        return;
    }
    var ajaxRequestUrl = '/api/pki/Inventory/getAlterNames'; //No I18N
    var params='cert_id='+res_id;//No I18N
    var domains="";
    getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
            if(jsonData.Sans === ""|| jsonData.Sans == undefined)
            {
                domains=jsonData.hostName;
            }
            else
            {
                domains=jsonData.Sans;
            }
            redirectUrl("SSLMgmt/LetsEncryptRequest?"+domains); //No I18N            
    });
}

function AssociateLandingServerView()
{
    var grid = jQuery("#PKIInventoryList"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0) {
        showAlert(I18N.getMsg('js.resource.selectAtleastOneResource')); //No I18N
            return;
    }
    var res_ids="";
    var loopBack=false;
    var lsResource=false;
    $.each(selRowIds, function()
    {
        var id = this;
        var resName = grid.jqGrid('getCell', id, 'ResourceName'); //No I18N
        var ipAddress = grid.jqGrid('getCell',id, 'IPAddress'); //No I18N
        var isLs = grid.jqGrid('getCell',id,'isLS');//NO I18N
        if(resName.toLowerCase()==="localhost"||ipAddress.indexOf('127')===0)
        {           
            loopBack=true;
            return;
        }
        if(isLs!=="-")
        {           
            lsResource=true;
        }
        var res_id = grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
        if(res_ids!=="")
        {
            res_ids=res_ids+","+res_id;
        }
        else
        {
            res_ids=res_id;
        }
    });    
    if(loopBack)
    {
        showAlert(I18N.getMsg("loopback.address.cantadd"));//NO I18N
        return;
    }
    
    if(selRowIds.length>1 && lsResource)
    {
        showAlert(I18N.getMsg("landingserver.associate.multiple.notify"));//NO I18N
        return;
    }    
    App.InventoryController.res_Ids=res_ids;
    document.getElementById("assLS").click();
}

function deleteCert (type,reloadtype)
{
    var grid = $("#PKIInventoryList"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0) {
        showAlert(I18N.getMsg('js.resource.selectAtleastOneCertificate')); //No I18N
            return;
    }
    var arr = new Array();
    var res_ids="";
    $.each(selRowIds, function()
    {
        var id = this;
        var res_id = grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
        if(res_ids!=="")
        {
            res_ids=res_ids+","+res_id;
        }
        else
        {
            res_ids=res_id;
        }
    });
    var data = {

        };
    data.RESOURCEIDS = res_ids;
    data.pmpcp=Get_Cookie('pmpcc');//No I18N
    var ajaxRequestUrl = '/api/pki/Inventory/deleteCerts'; //No I18N
    vConfirmation(I18N.getMsg("js.confirmationMsg.deleteSelectedCertificates"),function(){//NO I18N            
            if(document.getElementById("deleteCMDB").checked)
    {        
                data.CMDB="yes";//NO I18N
            }
            else
            {
                data.CMDB="no";//NO I18N
            }
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
            if(jsonData.status==="Success")//No I18N
            {
                if(reloadtype == 'graph' )
                {
                App.Dashboard.setGraphFilter(App.DashboardDetailsController.gtype,App.DashboardDetailsController.gdata);
                    $('#PKIInventoryList').trigger('reloadGrid'); //No I18N
                }
                else if(reloadtype == 'issuer')
                {
                App.Dashboard.getDashboardIssuer(App.DashboardDetailsController.issuerDec);
                $('#PKIInventoryList').trigger('reloadGrid'); //No I18N
            }else if(reloadtype == 'expire')//No I18N
            {
                App.Dashboard.setExpiredFilter();
                    $('#PKIInventoryList').trigger('reloadGrid'); //No I18N
                }
                else
                {
                {{App.Inventory.listsslsummary();}}
                    $('#PKIInventoryList').trigger('reloadGrid'); //No I18N
                }
                messageNotification("messageNotifySuccess",I18N.getMsg("js.certificate.delete.success"));//No I18N
            }
            else
            {
                messageNotification("messageNotifyFailure",I18N.getMsg("js.certificate.delete.failed"));//No I18N
            }
        });       
        },true);
    }    

function deleteResources (type)
{
    var grid = $("#PKIInventoryList"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0) {
            showAlert(I18N.getMsg('js.resource.selectAtleastOneResource')); //No I18N
            return;
    }
    App.InventoryController.deleteWithoutDisassociationoption=true;
    var val=vConfirmation(I18N.getMsg('js.deleteResource.deleteSelectedResource'),function(){//NO I18N
            var res_ids="";
            var exit = false;
            var lsNames = "";
        $.each(selRowIds, function()
        {
            var id = this;
            var res_id = grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
            if(type==="ssh")
            {
                var isLs = grid.jqGrid('getCell',id,'isLS');//NO I18N
                
                if(isLs!=="-")
                {
                    var rName = grid.jqGrid('getCell',id,'ResourceName');//NO I18N
                    rName = $(rName).text();
                    exit = true;
                    if(lsNames==="")
                    {
                        lsNames=rName;
                    }
                    else
                    {
                        lsNames+=","+rName;//NO I18N
                    }
                }
                else
                {
            if(res_ids!=="")
            {
                res_ids=res_ids+","+res_id;
            }
            else
            {
                res_ids=res_id;
            }
                }
            }           
        });
        if(exit)
        {            
            messageNotification("messageNotifyFailure",I18N.getMsg("sshresource.delete.islandingserver",new Array(lsNames)));//NO I18N
            if(res_ids==="")
            {
                return;
            }
        }
            var data = {

            };
        data.RESOURCEIDS = res_ids;
        data.pmpcp=Get_Cookie('pmpcc');//NO I18N
        data.isdeleteWithoutDisassociation=document.getElementById("deleteWithoutDisassociation").checked;
        var ajaxRequestUrl = '/api/pki/Inventory/deleteResources?res_type='+type; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,data,function(){
        if(!exit)
        {
        messageNotification("messageNotifySuccess","Resource deletion started");//No I18N
        }
        });            
});
}

function getCertificateforResource()
{
    redirectUrl("SSLMgmt/sslcertificate/"+App.InventoryListDetailsController.cert_id);//No I18N
}
function goToPKICertDetailsLink(cert_id)//No I18N
{
    App.InventoryListDetailsController.cert_id=cert_id;
    App.InventoryListDetailsController.cert_nav=false;
    redirectUrl("SSLMgmt/certdetails/"+cert_id);//No I18N
};

function goToCertVulnerabilitiesLink(cert_id)
{
    App.InventoryListDetailsController.cert_id=cert_id;
    App.InventoryListDetailsController.cert_nav=false;
    redirectUrl("SSLMgmt/vulnerabilities/"+cert_id); //No I18N
};

function goToPKISansDetailsLink(res_id)//No I18N
{
    redirectUrl("Inventory/SansDetails/"+res_id); //No I18N
};

function saveTextAsFile(inputelt)
{
    var textToWrite = $('textarea#'+inputelt).val();
    var textFileAsBlob = new Blob([textToWrite], {type:'text/plain'});
    var fileName="cert";//NO I18N
    if(App.InventoryListDetailsController.cert_name!=="")//NO I18N
    {
        fileName=App.InventoryListDetailsController.cert_name;
    }
    var fileNameToSaveAs = fileName+".txt";//No I18N

    var downloadLink = document.createElement("a");
    downloadLink.download = fileNameToSaveAs;
    downloadLink.innerHTML = "Download File";//No I18N
    if (window.webkitURL != null)
    {
            // Chrome allows the link to be clicked
            // without actually adding it to the DOM.
            downloadLink.href = window.webkitURL.createObjectURL(textFileAsBlob);
    }
    else
    {
            // Firefox requires the link to be added to the DOM
            // before it can be clicked.
            downloadLink.href = window.URL.createObjectURL(textFileAsBlob);
            downloadLink.onclick = destroyClickedElement;
            downloadLink.style.display = "none";
            document.body.appendChild(downloadLink);
    }
    downloadLink.click();
}

function downloadAsCertificateFile(content,origFileName)
{
    var textToWrite = content;
    var textFileAsBlob = new Blob([textToWrite], {type:'text/plain'});
    var fileName="cert";//NO I18N
    if(App.InventoryListDetailsController.cert_name!=="")//NO I18N
    {
        fileName=App.InventoryListDetailsController.cert_name;
    }

    var fileNameToSaveAs = "";//No I18N
    if(origFileName!==undefined)
    {
        fileNameToSaveAs = origFileName;
    }
    var downloadLink = document.createElement("a");
    downloadLink.download = fileNameToSaveAs;
    downloadLink.innerHTML = "Download File";//No I18N
    if (window.webkitURL != null)
    {
            // Chrome allows the link to be clicked
            // without actually adding it to the DOM.
            downloadLink.href = window.webkitURL.createObjectURL(textFileAsBlob);
    }
    else
    {
            // Firefox requires the link to be added to the DOM
            // before it can be clicked.
            downloadLink.href = window.URL.createObjectURL(textFileAsBlob);
            downloadLink.onclick = destroyClickedElement;
            downloadLink.style.display = "none";
            document.body.appendChild(downloadLink);
    }
    downloadLink.click();
}

function destroyClickedElement(event)
{
	document.body.removeChild(event.target);
}

function showResourceDetailsView(res_id,res_type,res_name)
{
    App.InventoryListDetailsController.res_name=res_name;
    App.ApplicationController.res_id=res_id;
    if(res_type==="ssl"  || res_type==="both")
    {
        location.href = window.apiclientUrl+"Inventory/DetailedView/"+res_id+"/"+res_type+"/SSL"; //No I18N
    }
    else if(res_type==="ssh")
    {
        location.href = window.apiclientUrl+"SSHMgmt/DetailedView/"+res_id+"/"+res_type+"/SSH"; //No I18N
    }
}

function showResourceUsersDialog(res_Id)
{
    App.ApplicationController.res_id=res_Id;
    document.getElementById("listUsers").click();//NO I18N
    $( "#modalDialog" ).draggable();//NO I18N    
}

function openTerminal(userid,key_id)
{
    var params="?userid="+userid;//No I18N
    if(key_id!==undefined)
    {
        params=params+"&keyid="+key_id;//No I18N
    }
    window.open("/apiclient/jindex.jsp"+params, "_blank");//No I18N
}

function showSSHResourceDetails(res_id)
{
    redirectUrl("SSHMgmt/DetailedView/"+res_id+"/ssh"); //No I18N
}

function refreshMatchingResources() {
	var CRITERIA_LIST = new Array();
	var emptyValue = false;
	$("#critetriaTable").find('tr').each(function (i, el) {
		var id = $(this).attr("id");
		var cri = {
				
		};
		cri.Condition = $("#CONDITION_"+id).val();
		cri.Field = $("#PARAMETER_"+id).val();
		if($("#COMPARATOR_"+id).val() == undefined || $("#COMPARATOR_"+id).val() == "") {
			cri.Comparator = "and"; // No I18N
		} else {
			cri.Comparator = $("#COMPARATOR_"+id).val();
		}
		
		var val = $("#PATTERN_"+id).val();
		if(val == "") {
			emptyValue = true;
		}
		cri.Value = val;
		CRITERIA_LIST.push(cri);
	});
	if(emptyValue == true) {
		showAlert(I18N.getMsg('js.resourceGroup.emptyValuesAlert')); // No I18N
		return;
	}
	$("#matchingResources").show();
	$('#PKIMatchingResourcesList').jqGrid('GridUnload');//No I18N
        var ajaxRequestUrl = '/api/pki/Inventory/matchingResources'; //No I18N
        var data="CRITERIA_LIST="+JSON.stringify(CRITERIA_LIST);//No I18N
        getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
          //sshResourceList(jsonData,"PKIMatchingResourcesList","PKIMatchingResourcesPager",defaultOptions);
          var colNamesList = ['Resource_ID',I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.discovery.resourcetype'),I18N.getMsg('js.general.creationtime'),I18N.getMsg("landingserver.heading"),'','','','',I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'ResourceID', index: 'ResourceID',hidden:true},//No I18N
                { name: 'ResourceName', index: 'ResourceName'}, //No I18N
                    { name: 'IPAddress', index: 'IPAddress',formatter:'ipcheckFormatter'}, //No I18N
                    { name: 'ResourceType', index: 'ResourceType',hidden:true}, //No I18N
                    { name: 'CreationTime', index: 'CreationTime',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                    { name: 'LSName', index: 'LSName'},//NO I18N
                { name: 'Edit', index: 'Edit',hidden:true}, //No I18N
                { name: 'Edit', index: 'Edit',formatter:'editCredentialFormatter',title:'Edit Credential',width:'35px',search:false,fixed:true}, //No I18N
                { name: 'Deploy', index: 'Deploy',width:'35px',formatter:'deployFormatter',search:false,fixed:true}, //No I18N
                { name: 'SSH', index: 'SSH',width:'30px',formatter:'sshEnabledFormatter',search:false,fixed:true}, //No I18N                
                    { name: 'search',width:"35px",sortable: false,search:false,fixed:true}//NO I18N
                ];
        var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
        loadJQgridWithData("#PKIMatchingResourcesList", jsonData.Resources, colNamesList, colModelList, " ", "#PKIMatchingResourcesPager", "",defaultOptions);//No I18N
            });
}

function refreshMatchingCertificates() {
	var CRITERIA_LIST = new Array();
	var emptyValue = false;
        var exit=false;
	$("#critetriaTable").find('tr').each(function (i, el) {
		var id = $(this).attr("id");
		var cri = {
				
		};
		cri.Condition = $("#CONDITION_"+id).val();
		cri.Field = $("#PARAMETER_"+id).val();
		if($("#COMPARATOR_"+id).val() == undefined || $("#COMPARATOR_"+id).val() == "") {
			cri.Comparator = "and"; // No I18N
		} else {
			cri.Comparator = $("#COMPARATOR_"+id).val();
		}
		
		var val = $("#PATTERN_"+id).val();
		if(val == "") {
			emptyValue = true;
		}
		cri.Value = val;
                if(cri.Field==="KEY_STRENGTH")
                {
                    var numbers = /^[0-9]+$/;  
                    if(!val.match(numbers))  
                    {
                        showAlert(I18N.getMsg("keysize.numberinput.alert"));//NO I18N
                        exit=true;
                        return;
                    }
                }  
		CRITERIA_LIST.push(cri);
	});
        if(exit)
        {
            return;
        }
	if(emptyValue == true) {
		showAlert(I18N.getMsg('js.certificateGroup.emptyValuesAlert')); // No I18N
		return;
	}
	$("#matchingResources").show();
	$('#PKIMatchingResourcesList').jqGrid('GridUnload');//No I18N
        var ajaxRequestUrl = '/api/pki/Inventory/matchingCertificates'; //No I18N
        var data="CRITERIA_LIST="+JSON.stringify(CRITERIA_LIST);//No I18N
        getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
          var colNamesList = ['ResourceID',I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.sslcertificate.issuer'),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg('js.ssl.certificate.keyalgorithm'),I18N.getMsg('js.cert.sigAlgorithm'),I18N.getMsg('js.sslcertificate.daystoexpire'),I18N.getMsg("js.commonstr.description"),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'ResourceID', index: 'ResourceID',hidden:true}, //No I18N
                    { name: 'Common Name', index: 'Common Name',width: '250'}, //No I18N
                    { name: 'DNS Name/FQDN', index: 'DNS Name/FQDN',width: '250'}, //No I18N
                    { name: 'Organization', index: 'Organization',width: '200px'}, //No I18N
                    { name: 'FromDate', index:'FromDate',sorttype: 'date',datefmt: 'M d, Y',hidden:true},//NO I18N
                    { name: 'ExpiryDate', index: 'ExpiryDate',sorttype: 'date',datefmt: 'M d, Y',formatter:"expiryFlagFormatter"}, //No I18N
                    { name: 'KeyStrength', index: 'KeyStrength',width:'94px'}, //No I18N
                    { name: 'keyAlgorithm', index: 'keyAlgorithm',width:'90px',width: '150',hidden:true}, //No I18N
                    { name: 'signatureAlgorithm', index: 'signatureAlgorithm',width:'200px'}, //No I18N
                    { name: 'DaysToExpiry', index: 'DaysToExpiry',width:'60px',sorttype: 'int'}, //No I18N
                    { name: 'Description', index: 'Description',width: '200'}, //No I18N
                    { name: 'search',width:30,sortable: false,search:false,fixed:true}//NO I18N
            ];            
        var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
        loadJQgridWithData("#PKIMatchingResourcesList", jsonData.InventDetails, colNamesList, colModelList, " ", "#PKIMatchingResourcesPager", "",defaultOptions);//No I18N
            });
}

function sshResourceList(jsonData,tableName,pagerName,defaultOptions)
{
    if(App.ApplicationController.isAdmin===true)
    {
       var colNamesList;
        if(kmpStandAlone)
            {
        colNamesList = ['Resource_ID','','',I18N.getMsg("js.discovery.port"),'',I18N.getMsg('js.general.resourcename'),I18N.getMsg("js.commonstr.description"),'',I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.discovery.resourcetype'),I18N.getMsg('js.general.creationtime'),I18N.getMsg("landingserver.heading"),'','','','','','',I18N.getMsg('js.table.search')]; //No I18N
            }
            else{
                colNamesList = ['Resource_ID','','',I18N.getMsg("js.discovery.port"),'',I18N.getMsg('js.general.resourcename'),I18N.getMsg("js.commonstr.description"),'',I18N.getMsg('js.discovery.ipaddress')+"/"+I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.discovery.resourcetype'),I18N.getMsg('js.general.creationtime'),I18N.getMsg("landingserver.heading"),'','','','','','',I18N.getMsg('js.table.search')]; //No I18N
            }
        var colModelList = [
                { name: 'ResourceID', index: 'ResourceID',hidden:true},//No I18N
                { name: 'Edit', index: 'Edit',hidden:true}, //No I18N
                { name: 'Edit', index: 'Edit',classes:"pointer",formatter:'editCredentialFormatter',title:'Edit Credential',width:'35px',search:false,fixed:true}, //No I18N
                { name: 'Port', index: 'Port',hidden:true},//NO I18N
                { name: 'Path', index: 'Path',hidden:true},//NO I18N
                { name: 'ResourceName', index: 'ResourceName',formatter:'resourceLinkFormatter'}, //No I18N
                { name: 'Description', index: 'Description'},//NO I18N
                { name: 'resourceLink', index: 'resourceLink',hidden:true}, //No I18N
                { name: 'IPAddress', index: 'IPAddress',formatter:'ipcheckFormatter'}, //No I18N
                { name: 'ResourceType', index: 'ResourceType',hidden:true}, //No I18N
                { name: 'CreationTime', index: 'CreationTime',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                { name: 'LSName', index: 'LSName'},//NO I18N
                { name: 'isLS', index: 'isLS',hidden:true},//NO I18N
                { name: 'LSId', index: 'LSId',hidden:true},//NO I18N
                { name: 'ISLS', index: 'ISLS',formatter:'isLSFormatter',width:'35px',search:false,fixed:true},//NO I18N
                { name: 'Deploy', index: 'Deploy',width:'35px',formatter:'deployFormatter',classes:'pointer',search:false,fixed:true}, //No I18N
                { name: 'SSH', index: 'SSH',width:'30px',formatter:'sshEnabledFormatter',search:false,classes:"pointer",fixed:true}, //No I18N
                { name: 'EditPath', index: 'EditPath',search:false,formatter:'editFormatter',width:'30px',fixed:true}, //No I18N
                { name: 'search',width:'40px',sortable: false,search:false,fixed:true}//NO I18N
                        ];
        defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
        loadJQgridWithData("#"+tableName, jsonData.Resources, colNamesList, colModelList, "", "#"+pagerName, "SSHResources",defaultOptions);//No I18N
    }else
    {
        var colNamesList = ['Resource_ID','','',I18N.getMsg('js.general.resourcename'),I18N.getMsg("js.commonstr.description"),'',I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.discovery.resourcetype'),I18N.getMsg('js.general.creationtime'),I18N.getMsg("landingserver.heading"),'','','','',I18N.getMsg('js.table.search')]; //No I18N
        var colModelList = [
                { name: 'ResourceID', index: 'ResourceID',hidden:true},//No I18N
                { name: 'Edit', index: 'Edit',hidden:true}, //No I18N
                { name: 'Edit', index: 'Edit',classes:"pointer",formatter:'editCredentialFormatter',title:'Edit Credential',width:'20px',search:false,hidden:true}, //No I18N
                { name: 'ResourceName', index: 'ResourceName',formatter:'resourceLinkFormatter'}, //No I18N
                { name: 'Description', index: 'Description'},//NO I18N
                { name: 'resourceLink', index: 'resourceLink',hidden:true}, //No I18N
                { name: 'IPAddress', index: 'IPAddress',formatter:'ipcheckFormatter'}, //No I18N
                { name: 'ResourceType', index: 'ResourceType',hidden:true}, //No I18N
                { name: 'CreationTime', index: 'CreationTime',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                { name: 'LSName', index: 'LSName'},//NO I18N
                { name: 'isLS', index: 'isLS',hidden:true},//NO I18N
                { name: 'ISLS', index: 'ISLS',formatter:'isLSFormatter',width:'35px',search:false,fixed:true,hidden:true},//NO I18N
                { name: 'Deploy', index: 'Deploy',width:'35px',formatter:'deployFormatter',classes:'pointer',search:false,hidden:true,fixed:true}, //No I18N
                { name: 'SSH', index: 'SSH',width:'30px',formatter:'sshEnabledFormatter',search:false,classes:"pointer",fixed:true}, //No I18N                
                { name: 'search',width:"40px",sortable: false,search:false,fixed:true}//NO I18N
                        ];
        defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
        loadJQgridWithData("#"+tableName, jsonData.Resources, colNamesList, colModelList, "", "#"+pagerName, "SSHResources",defaultOptions);//No I18N
}
}
function getCertificateListWithoutpage(jsonData,tableName,pagerName,controller)
{
            var hide=true;
            if(App.ApplicationController.isAdmin===true)
            {
                hide=false;
            }            
            var colNamesList = ['ResourceID','','','',I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.sslcertificate.issuer'),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg('js.ssl.certificate.keyalgorithm'),I18N.getMsg('js.cert.sigAlgorithm'),I18N.getMsg('js.sslcertificate.daystoexpire'),I18N.getMsg("js.commonstr.description"),'','','',I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'ResourceID', index: 'ResourceID',hidden:true}, //No I18N
                    { name: 'Flag',index:'Flag',hidden:true},//NO I18N
                    { name: 'Rows',index:'Rows',hidden:true},//NO I18N
                    { name: 'Exp_Type', index: 'Exp_Type',formatter:'expiryFormatter',width:"25px",fixed:true,search:false}, //No I18N
                    { name: 'Common Name', index: 'Common Name', formatter:"pipeFormatter",classes:"pointer",width: '250'}, //No I18N
                    { name: 'DNS Name/FQDN', index: 'DNS Name/FQDN',width: '250'}, //No I18N
                    { name: 'Organization', index: 'Organization',width: '200px'}, //No I18N
                    { name: 'FromDate', index:'FromDate',sorttype: 'date',datefmt: 'M d, Y',hidden:true},//NO I18N
                    { name: 'ExpiryDate', index: 'ExpiryDate',sorttype: 'date',datefmt: 'M d, Y',formatter:"expiryFlagFormatter"}, //No I18N
                    { name: 'KeyStrength', index: 'KeyStrength',width:'94px'}, //No I18N
                    { name: 'keyAlgorithm', index: 'keyAlgorithm',width:'90px',width: '150',hidden:true}, //No I18N
                    { name: 'signatureAlgorithm', index: 'signatureAlgorithm',width:'200px'}, //No I18N
                    { name: 'DaysToExpiry', index: 'DaysToExpiry',width:'60px',sorttype: 'int'}, //No I18N
                    { name: 'Description', index: 'Description',width: '200'}, //No I18N
                    { name: 'IsKeyStore', index: 'IsKeyStore',width: '40px',formatter:'isKeyStoreFormatter',search:false,fixed:true}, //No I18N
                    { name: 'DeployedServers', index: 'DeployedServers',width: '40px',formatter:'deployedServersFormatter',search:false,fixed:true}, //No I18N
                    { name: 'History', index: 'History',search:false,formatter:'certHistoryFormatter',width:'40px',hidden:hide,fixed:true}, //No I18N       
                    { name: 'search',width:30,sortable: false,search:false,fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true,sortName:"DaysToExpiry"};//No I18N
            loadJQgridWithData("#"+tableName, jsonData.InventDetails, colNamesList, colModelList, "", "#"+pagerName, "certDetails",defaultOptions);//No I18N
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true}; //No I18N
            if(controller!==undefined)
            {
                var dig_arr=new Array('showDeployedServersDialog');
                        var placeHolder=new Array('.reqsName');
                        openDialogInTable(controller,"#"+tableName,placeHolder,dig_arr);//No I18N   
            }
}
function getCertificateList(jsonData,tableName,pagerName,controller)
{
            var hide=true;
            if(App.ApplicationController.isAdmin===true)
            {
                hide=false;
            }            
//            var colNamesList = ['ResourceID','','','',I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.sslcertificate.issuer'),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg('js.ssl.certificate.keyalgorithm'),I18N.getMsg('js.cert.sigAlgorithm'),I18N.getMsg('js.sslcertificate.daystoexpire'),I18N.getMsg("js.commonstr.description"),'','','',I18N.getMsg('js.table.search')]; //No I18N
//            var colModelList = [
//                    { name: 'ResourceID', index: 'ResourceID',hidden:true}, //No I18N
//                    { name: 'Flag',index:'Flag',hidden:true},//NO I18N
//                    { name: 'Rows',index:'Rows',hidden:true},//NO I18N
//                    { name: 'Exp_Type', index: 'Exp_Type',formatter:'expiryFormatter',width:"25px",fixed:true,search:false}, //No I18N
//                    { name: 'Common Name', index: 'Common Name', formatter:"pipeFormatter",classes:"pointer",width: '250'}, //No I18N
//                    { name: 'DNS Name/FQDN', index: 'DNS Name/FQDN',width: '250'}, //No I18N
//                    { name: 'Organization', index: 'Organization',width: '200px'}, //No I18N
//                    { name: 'FromDate', index:'FromDate',sorttype: 'date',datefmt: 'M d, Y',hidden:true},//NO I18N
//                    { name: 'ExpiryDate', index: 'ExpiryDate',sorttype: 'date',datefmt: 'M d, Y',formatter:"expiryFlagFormatter"}, //No I18N
//                    { name: 'KeyStrength', index: 'KeyStrength',width:'94px'}, //No I18N
//                    { name: 'keyAlgorithm', index: 'keyAlgorithm',width:'90px',width: '150',hidden:true}, //No I18N
//                    { name: 'signatureAlgorithm', index: 'signatureAlgorithm',width:'200px'}, //No I18N
//                    { name: 'DaysToExpiry', index: 'DaysToExpiry',width:'60px',sorttype: 'int'}, //No I18N
//                    { name: 'Description', index: 'Description',width: '200'}, //No I18N
//                    { name: 'IsKeyStore', index: 'IsKeyStore',width: '40px',formatter:'isKeyStoreFormatter',search:false,fixed:true}, //No I18N
//                    { name: 'DeployedServers', index: 'DeployedServers',width: '40px',formatter:'deployedServersFormatter',search:false,fixed:true}, //No I18N
//                    { name: 'History', index: 'History',search:false,formatter:'certHistoryFormatter',width:'40px',hidden:hide,fixed:true}, //No I18N       
//                    { name: 'search',width:30,sortable: false,search:false,fixed:true}//NO I18N
//            ];
//            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true,sortName:"DaysToExpiry"};//No I18N
//            loadJQgridWithData("#"+tableName, jsonData.InventDetails, colNamesList, colModelList, "", "#"+pagerName, "certDetails",defaultOptions);//No I18N
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true}; //No I18N
            populateRemoteApiClientGrid(tableName,"PKISSLCertificateList", "", "#"+pagerName, "certDetails", defaultOptions); //No I18N
//            if(controller!==undefined)
//            {
//                var dig_arr=new Array('showDeployedServersDialog');
//                        var placeHolder=new Array('.reqsName');
//                        openDialogInTable(controller,"#"+tableName,placeHolder,dig_arr);//No I18N   
//            }
}
function openDialogInTable(controller,gridId,placeHolder,dialogFunctionName)
{
    var callBack = function(place,controllString) {
        $(place).click(function(){controller.send(controllString);});//NO I18N
    };
    
    //For Dialog open
    for(var i=0;i<placeHolder.length;i++)
    {
        var controllString=dialogFunctionName[i];
        callBack(placeHolder[i],controllString);
    }
    $(gridId).jqGrid('setGridParam',{//NO I18N
        gridComplete:function(){
            showPopover();
            for(var i=0;i<placeHolder.length;i++)
            {
                var controllString=dialogFunctionName[i];
                callBack(placeHolder[i],controllString);
            }
        }
    });
}


function enablePathField(userid)
{   userid="text"+userid;//NO I18N
    if(document.getElementById(userid).disabled)
    {
        document.getElementById(userid).disabled=false;
    }
    else
    {
        document.getElementById(userid).disabled=true;
    }
    if($('#userpaths tbody tr td input[type="checkbox"]').not(':checked').length > 0)
    {
        document.getElementById("checkall").checked=false;
    }
    else
    {
        document.getElementById("checkall").checked=true;
    }
    
}

function checkallboxes()
{
    
    $('#userpaths tbody tr td input[type="checkbox"]').prop('checked', document.getElementById("checkall").checked);
    $('#userpaths tbody tr td input[type="text"]').prop('disabled',!document.getElementById("checkall").checked);
            
}

var listusers=true;
function showusers()
{
    if(document.getElementById("showusersvisible").className==="glyphicon glyphicon-plus pointer")
    {
        document.getElementById("showusersvisible").className="glyphicon glyphicon-minus pointer";//NO I18N
        document.getElementById("showusers").checked=true;
        $('#container').css('display','block');
        if(listusers)
        {
            var ajaxRequestUrl='/api/pki/ssh/getResourceUsers'; //No I18N
            var reqParams = "resourceid="+App.InventoryController.res_Id;//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                var array = jsonData.AllResourceUsers;
                for(i=0;i<array.length;i++)
                {
                    var dir_path="";
                    if(array.get(i).Dir_Path != undefined)
                    {
                        dir_path= array.get(i).Dir_Path;
                    }
                    var element = '<tr><td><input type="checkbox" onchange="enablePathField('+array.get(i).UserID+')" name="usercheckbox" value="'+array.get(i).UserID+'"></label></td>'+
                                    '<td>'+'<span id="user'+array.get(i).UserID+'">'+array.get(i).UserName+'</span>'+'</td>'+'<td><input class="form-control " type="text" value="'+dir_path+'" id="text'+array.get(i).UserID+'"disabled></td></tr>';//NO I18N
                            $('#userpaths tbody').append(element);
                }

            });
            listusers=false;
        
            
            
            
        $("#searchuser").keyup(function () {
            var username = $('#searchuser').val();
                 if (username.length>0){
                        $("#userpaths tr").each(function (index) 
                        {
                            if (index != 0) 
                            {
                                $row = $(this);
                                $row.find("td:nth-child(2)").each(function () 
                                {
                                    var cell = $(this).text();
                                    if (cell.indexOf(username) < 0) 
                                    {
                                        $row.hide();
                                    } 
                                    else 
                                    {
                                        $row.show();
                                        return false; 
                                    }
                                });
                            }
                        });
                    }
                    else
                    {
                        $("#userpaths tr").show();
                    }
                });    
            }
    }
    else
    {
        document.getElementById("showusersvisible").className="glyphicon glyphicon-plus pointer";//NO I18N
        document.getElementById("showusers").checked=false;
        $('#container').css('display','none');
    }
}


function getCerPassword(cer_id,hostname)
{
    var ajaxRequestUrl = '/api/pki/request/getCerPassword'; //No I18N
    var data="cer_id="+cer_id+"&hostname="+hostname;//No I18N
    getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
        $(".popover-content").html(jsonData.password)//No I18N
        $(".arrow").hide();
        document.querySelector('.popover').style.maxWidth = "400px" ;//No I18N
        setTimeout(function () {
            $('.popover').popover('hide');
        }, 5000);
    }); 
}

function exportprivatekey(hostName,isSharedExport,cert_id)
{
    var url='/api/pki/Inventory/exportCertPrivateKey?certId=' +cert_id+'&hostName='+hostName;//No I18N
    window.location.href=url;
    if(isSharedExport){
        $('#exportprivkeyid').attr("href", "javascript:requestCertPrivatekey(" + cert_id + ")");
        $('#exportprivkeyid').text(I18N.getMsg("pki.js.request.keyfromowner"));//No I18N
        $('#exportprivkeyid').addClass('hand grant');//No I18N
    }
}

function getResourceUsers(server,user,user_id)
{
    var rid = document.getElementById(server).value;
    var selectMsg = I18N.getMsg("landingserver.selectaccount");//NO I18N
    if(rid!=="-1")
    {    
        var ajaxRequestUrl = '/api/pki/ssh/getResUsersWithCredentials';//NO I18N
        var data='res_id='+rid;//NO I18N
        getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
           var users = jsonData.ResUsersCred;
           if(users.length>0)
           {
                $("#"+user).find('option').remove();
                for(var i=0;i<users.length;i++)
                {
                    var userid = users.get(i).id;
                    var userName = users.get(i).UserName;
                    var option = new Option(userName,userid);
                    $("#"+user).append(option);
                }
           }
           else
           {
                $("#"+user).find('option').remove();
                var option = new Option(selectMsg,"-1");
                $("#"+user).append(option);
           }
           if(user_id!==undefined)
           {
               $("#"+user).val(user_id);
           }
        });
    }
    else
    {
        $("#"+user).find('option').remove();
        var option = new Option(selectMsg,"-1");
        $("#"+user).append(option);
    }
}

function changeLandingServerGridView()
{
    var view = $("#GridView").val();
    var grid = jQuery("#PKIInventoryList");//NO I18N
    var lsid = App.InventoryController.lsid;
    var lsname = $("#serverName").text();
    var ajaxRequestUrl = '/api/pki/landingserver/lsAssociationGridView';//NO I18N
    var params = "LSId="+lsid+"&LSName="+lsname+"&view="+view;//NO I18N
    getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
       var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
        sshResourceList(jsonData,"PKIInventoryList","PKIInventorypager",defaultOptions);//No I18N
        grid.hideCol('EditPath');//NO I18N
        grid.hideCol('SSH');//NO I18N
        grid.hideCol('Edit');//NO I18N
        grid.hideCol('Deploy'); //NO I18N
    });
    if(view==="associated")
    {
        $("#lsAssociate").hide();
        $("#lsDissociate").show();
        grid.hideCol('LSName'); //NO I18N
    }
    else if(view === "notassociated")
    {
        $("#lsAssociate").show();
        $("#lsDissociate").hide();
        grid.showCol('LSName');//NO I18N
    }
    else
    {
        $("#lsAssociate").show();
        $("#lsDissociate").show();
        grid.showCol('LSName');//NO I18N
    }
}

function loadSSHFileText(evt) {
    var f = evt.target.files[0];
    if (f) {
    var r = new FileReader();
    var check=true;
    r.onload = function(e) { 
        var discoverDomains = e.target.result;
        var lines=discoverDomains.split("\n");//No I18N
        var temp="";
        for (var i=0; i < lines.length; i++)
        {
            var line=lines[i].trim();
            temp=temp+line;
            if(i!==lines.length-1)
            {
                temp=temp+"\n";//No I18N
            }
            var words=line.split(" ");
            if(words.length>4 || words.length<2)
            {
                check=false;
                break;
            }
            if(words.length>2)
            {               
                var isnum = (/^[0-9]+$/).test(words[2].trim());//Check the PORT value is digits
                if(!isnum){check=false;break;}                
            }
        }
        if(check){
            window.FILE_CONTENT=temp;
            $('#discoverDomains').val(discoverDomains);//No I18N
        }
        else
        {
            showAlert(I18N.getMsg('js.file.selectaFileWithProperFormat')); //NO I18N
            var browse=$('#importCsv');
            var textfile=document.getElementById('textfile');
            clearfileElt(browse,textfile);
        }
    }
    r.readAsText(f);
    } 
    else { 
        showAlert(I18N.getMsg('js.file.failedToLoadFile'));//NO I18N
    }
}

function selectAddType(type)
{
    if(type=='single')
    {
        $("#FromFile").hide();
        $("#SingleResource").show();
    }
    else
    {
        $("#FromFile").show();
        $("#SingleResource").hide();
    }
}

function DiscoveryLSCheckToggle()
{
    if(document.getElementById("lsCheckBox").checked===true)
    {
        $("#lslist").show();
    }
    else
    {
        $("#lslist").hide();
    }
}

function setAsMainCert(verId)
{
    $('.popover').popover('hide');//NO I18N
    var ajaxRequestUrl = '/api/pki/Inventory/setAsMainCert?certVersionId=' +verId ; //No I18N
    getAjaxApiRequest(ajaxRequestUrl,"pmpcp="+Get_Cookie('pmpcc'),function(jsonData){ //No I18N
        if(jsonData.Status === "Success")
        {
           messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N  
           App.Inventory.getCertificateVersionHistory();
        }
        else
        {
            messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N 
        }  
    });
}

function manageVersionCertificate(verId)
{
    $('.popover').popover('hide');//NO I18N
    var ajaxRequestUrl = '/api/pki/Inventory/manageVersionCertificate?certVersionId=' +verId ; //No I18N
    getAjaxApiRequest(ajaxRequestUrl,"pmpcp="+Get_Cookie('pmpcc'),function(jsonData){ //No I18N
        if(jsonData.Status === "Success")
        {
           messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N  
           App.Inventory.getCertificateVersionHistory();
        }
        else
        {
            messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N 
        }  
    });
}

function getSSLVerPassPhrase(ver_id)
{
    var ajaxRequestUrl = '/api/pki/Inventory/showSSLVerPassPhrase'; //No I18N
    var data="ver_id="+ver_id;//No I18N
    getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
        $(".popover-content").html(jsonData.passphrase)//No I18N
        $(".arrow").hide();//No I18N
        document.querySelector('.popover').style.maxWidth = "400px" ;//No I18N
        setTimeout(function () {
            $('.popover').popover('hide');//NO I18N
        }, 5000);
    }); 
}

function exportSSLverkey(ver_id)
{
    var element = '<ul class="dropdown-menu1" id="dropdownmenu" style="list-style: none;padding-left:0px;"><li><a href="javascript:exportSSLVerCert(\''+//NO I18N
            ver_id+'\');">'+I18N.getMsg('js.commonstr.certificate')+'</a></li><li><a href="javascript:exportSSLVerKey(\''+//NO I18N
            ver_id+'\');">'+I18N.getMsg('js.cert.keystore')+'</a></li></ul>'; //NO I18N
    
    $(".popover-content").html(element)//No I18N
    $(".popover-content").css("cssText", "padding:0px !important;");
    $(".arrow").hide();//No I18N
    $(".popover-title").hide();//No I18N
    document.querySelector('.popover').style.maxWidth = "400px" ;//No I18N
    setTimeout(function () {
        $('.popover').popover('hide');//NO I18N
    }, 3000);
}

function exportSSLVerCert(ver_id)
{
    var ajaxRequestUrl = '/api/pki/Inventory/exportCertVersion?certVersionId=' +ver_id ; //No I18N
    exportCert(ajaxRequestUrl);
}

function exportSSLVerKey(ver_id)
{
    var ajaxRequestUrl = '/api/pki/Inventory/exportCertVersionKey?certVersionId=' +ver_id ; //No I18N
    exportCert(ajaxRequestUrl);
}
var timoutFunction;
function listSSLVulnSubSubGrid(v_id)
{
    var ajaxRequestUrl = '/api/pki/Inventory/sslcertvulsubgridreportview?v_id='+v_id; //No I18N
    getAjaxApiRequest(ajaxRequestUrl, "", function (data) {                                    
        var lines=0;
        $(".modal-title").text(I18N.getMsg("vulnerabilities.popup.title",new Array(data.CommonName)));//NO I18N
        //$('#rightcolumn').slimscroll({railVisible: true,railBorderRadius: 0,railOpacity: 0.1,alwaysVisible: true,disableFadeOut:true});
        $("#ipAddress").text(data.IpAddress);
        $("#port").text(data.Port);
        if(data.OCSPStatus === undefined)
            {
                if(data.Status==="Inprogress")
                {
                $("#ocspRevocation").html("<img src=\"/pki/images/ajax-loader.gif\" alt=\"Inprogress\" height=\"17\" width=\"17\">");//No I18N
                }
                else
                {
                $("#ocspRevocation").text("NA");//No I18N
                }
            }
            else
            {
            $("#ocspRevocation").html(data.OCSPStatus);//No I18N
            }
        if(data.CRLStatus === undefined)
            {
                if(data.Status==="Inprogress")
                {
                $("#crlRevocation").html("<img src=\"/pki/images/ajax-loader.gif\" alt=\"Inprogress\" height=\"17\" width=\"17\">");//No I18N
                }
                else
                {
                $("#crlRevocation").text("NA");//No I18N
                }
            }
            else
            {
            $("#crlRevocation").html(data.CRLStatus);//No I18N
            }
        if(data.PoodleSSL === undefined && data.Status==="Inprogress")
            {
            $("#poodleSSL").html("<img src=\"/pki/images/ajax-loader.gif\" alt=\"Inprogress\" height=\"17\" width=\"17\">");//No I18N
        }
        else
                {
            $("#poodleSSL").html(data.PoodleSSL);//No I18N
            if(data.PoodleSSL==="Not vulnerable")
            {
                $("#poodlespan").addClass("kmp_icons poodle_ssl");
                }
                else
                {
                $("#poodlespan").addClass("kmp_icons poodle_ssl_vul");
                }
            }
        if(data.HeartBleed === undefined && data.Status==="Inprogress")
        {                        
            $("#heartbleed").html("<img src=\"/pki/images/ajax-loader.gif\" alt=\"Inprogress\" height=\"17\" width=\"17\">");//No I18N
        }
            else
            {
            $("#heartbleed").text(data.HeartBleed);//No I18N
            if(data.HeartBleed==="Not vulnerable")
            {
                $("#heartbleedspan").addClass("kmp_icons heartbleed");
            }
            else
            {
                $("#heartbleedspan").addClass("kmp_icons heartbleed_vul");
            }
        }
        $("#liveCertificate").show();
        if(data.LiveCertificate!==undefined)
        {
            if(data.LiveCertificate==="same")
            {
                $("#currentCert").html('<span>'+I18N.getMsg("vulnerabilities.liveandcurrentcert.same")+'</span>');//NO I18N
        }
            else
            {
                $("#currentCert").html('<span style="color:#f54753">'+I18N.getMsg("vulnerabilities.liveandcurrentcert.different")+'</span>');//NO I18N
            }
        }
        else
        {
            $("#currentCert").html("<img src=\"/pki/images/ajax-loader.gif\" alt=\"Inprogress\" height=\"17\" width=\"17\">");//No I18N
        }
        $("#lastUpdate").text(data.LastUpdated);            
        $("#expiry").html(data.ExpDate);            
        $("#signature").html(data.Signature);            
        if(data.SSLv3 === undefined)
        {
                if(data.Status==="Inprogress")
                {
                $("#sslv3label").html("<img src=\"/pki/images/ajax-loader.gif\" alt=\"Inprogress\" height=\"17\" width=\"17\">");//No I18N
                }
                else
                {
                $("#sslv3label").text("Not Enabled");//No I18N
                }
            }
            else
            {
            var temp = data.SSLv3;
            var test=temp.split("<br>");
            lines=lines+test.length;
            if(temp.indexOf("SSLv3 protocol not")!=-1 && window.userRole==="Administrator")
            {
                if(kmpStandAlone)
                {
                $("#sslv3label").html('<span>'+data.SSLv3+', <a class="pointer" href="#/Settings/SSLVulnerabilities">enable SSLv3</a></span>');//No I18N
            }
            else
            {
                    $("#sslv3label").html('<span>'+data.SSLv3+' ,enable SSLv3 in SSL Vulnerability settings.</span>');//No I18N
                }
            }
            else
            {
                $("#sslv3label").html(data.SSLv3);//NO I18N
            }
        }
        if(data.TLSv1 === undefined)
            {                        
            if(data.Status==="Inprogress")
            {
                $("#tlsv1label").html("<img src=\"/pki/images/ajax-loader.gif\" alt=\"Inprogress\" height=\"17\" width=\"17\">");//No I18N
            }
            else
            {
                $("#tlsv1label").text("Not Enabled");//No I18N
            }
            }
            else
            {
                var temp=data.TLSv1;
                var test=temp.split("<br>");
                lines=lines+test.length;
            $("#tlsv1label").html(data.TLSv1);//No I18N
            }
        if(data.TLSv1_1 === undefined)
            {
                if(data.Status==="Inprogress")
                {
                $("#tlsv11label").html("<img src=\"/pki/images/ajax-loader.gif\" alt=\"Inprogress\" height=\"17\" width=\"17\">");//No I18N
                }
                else
                {
                $("#tlsv11label").text("Not Enabled");//No I18N
                }
            }
            else
            {
                var temp=data.TLSv1_1;
                var test=temp.split("<br>");
                lines=lines+test.length;
            $("#tlsv11label").html(data.TLSv1_1);//No I18N
            }
        if(data.TLSv1_2 === undefined)
            {
                if(data.Status==="Inprogress")
                {
                $("#tlsv12label").html("<img src=\"/pki/images/ajax-loader.gif\" alt=\"Inprogress\" height=\"17\" width=\"17\">");//No I18N
                }
                else
                {
                $("#tlsv12label").text("Not Enabled");//No I18N
                }
            }
            else
            {
                var temp=data.TLSv1_2;
                var test=temp.split("<br>");
                lines=lines+test.length;
            $("#tlsv12label").html(data.TLSv1_2);//No I18N
            }
            $("#middlecolumn").css("height",lines*30+"px");   
            
        if(data.Status==="Inprogress")
            {
            timoutFunction = setTimeout(function () {
                App.Inventory.listSSLVulSubSubGrid(v_id);
            }, 5000)
            }
    });
}

function getSSLVunerabilitiesReload()
            {
    var params='cert_id='+App.InventoryListDetailsController.cert_id;//NO I18N
    getSSLVulnerabilities(params);
    autoReloadGrid(getSSLVulnerabilities,params,'VulnerabilitiesList');//No I18N
            }

function showCertDetailsVul(cert_id)
            {
    var ajaxRequestUrl = '/api/pki/Inventory/details'; //No I18N
    var params='cert_id='+cert_id;//No I18N
    getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
            var jsonend=jsonData.endpoint;
            var jsonissur=jsonData.issuer;
            var colModelList = [
                        { name: 'Key', index: 'Key',sortable: false}, //No I18N
                        { name: 'Value', index: 'Value',sortable: false}, //No I18N
                        { name: 'Key1', index: 'Key1',sortable: false}, //No I18N
                        { name: 'Value1', index: 'Value1',sortable: false}, //No I18N
                        { name: 'download',width:35,sortable: false,search:false,fixed:true}//NO I18N
                ];
                    var dataArray = new Array();
                    var colNamesList = [jsonend.hostName,'','','','<div style="float:right;" onclick="downLoadCertificate('+cert_id+')"><span id="grid_download" class="icon-export" style="color:#000;font-size:16px;padding:5px;"></span></div>']; //No I18N
                    dataArray.push({"Key":I18N.getMsg('js.commonstr.certificatename'), "Value":jsonend.hostName,"Key1":I18N.getMsg('js.discovery.port'), "Value1":jsonend.port});//No I18N
                    //dataArray.push({"Key":I18N.getMsg('js.discovery.port'), "Value":jsonend.port});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.report.timeline.fromdate'), "Value":jsonend.from_date,"Key1":I18N.getMsg('js.report.timeline.todate'), "Value1":jsonend.expiry_date});//No I18N
                    //dataArray.push({"Key":I18N.getMsg('js.report.timeline.todate'), "Value":jsonend.expiry_date});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.cert.sans'), "Value":jsonend.Sans,"Key1":I18N.getMsg('js.sslcertificate.issuer'), "Value1":jsonissur.org});//No I18N
                    //dataArray.push({"Key":I18N.getMsg('js.sslcertificate.issuer'), "Value":jsonissur.org});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.sslcertificate.issuer')+"(CN)", "Value":jsonissur.cname,"Key1":I18N.getMsg('js.cert.sigAlgorithm'), "Value1":jsonend.certSignAlg});//No I18N
                    //dataArray.push({"Key":I18N.getMsg('js.cert.sigAlgorithm'), "Value":jsonend.certSignAlg});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.ssh.fingerprint'), "Value":jsonend.fingerPrint,"Key1":I18N.getMsg('js.cert.serialNumber'), "Value1":jsonend.serial});//No I18N
                    //dataArray.push({"Key":I18N.getMsg('js.cert.serialNumber'), "Value":jsonend.serial});//No I18N
                    dataArray.push({"Key":I18N.getMsg('js.ssl.certificate.keyalgorithm'), "Value":jsonend.keyalg,"Key1":I18N.getMsg('js.sslcertificate.keysize'), "Value1":jsonend.PublicKeyLength});//No I18N
                    //dataArray.push({"Key":I18N.getMsg('js.sslcertificate.keysize'), "Value":jsonend.PublicKeyLength});//No I18N
//                    if(jsonend.PrivateKey===true)
//                    {
//                        dataArray.push({"Key":"Store Type","Value":jsonend.StoreType});//NO I18N
//                        var txt='/api/pki/Inventory/exportCertPrivateKey?certId=' +cert_id+'&hostName='+jsonend.hostName;//No I18N
//                        dataArray.push({"Key":"Private Key", "Value":'<a class="pointer" href='+txt+'>Export</a> &emsp; <a style="vertical-align:text-top;" title=\"'+I18N.getMsg("js.showpassphrase.title")+'\" data-container="body" data-content="" data-toggle="popover" data-trigger="click" data-placement="left" href="javascript:getCerPassword(\''+cert_id+'\',\''+jsonend.hostName+'\')"><span class="icon-showpwd fontIcon-disable" style="cursor:pointer;font-size:16px;" title="Show Passphrase"></span></a>'});
//                    }
                    //dataArray.push({"Key":I18N.getMsg('js.discovery.ipaddress'), "Value":jsonData.ipaddress});//No I18N
                    var defaultOptions={multiselect:false,rowNumNeeded:false};
                loadJQgridWithData("#PKIInventoryDetailsList", dataArray, colNamesList, colModelList, "", "", "SSLEndPointSummaryVulnerability",defaultOptions);//No I18N
    });
}

function getSSLVulnerabilities(params)
{ 
    params='cert_id='+App.InventoryListDetailsController.cert_id;//NO I18N
    var ajaxRequestUrl = '/api/pki/Inventory/sslcertvulreportview'; //No I18N
    getAjaxApiRequest(ajaxRequestUrl,params, function (jsonData) {                                    
        var hide=false;
            if(jsonData.NOData!==undefined)
            {
                hide=true;
            }
            else
            {
                $('#VulnerabilitiesList').showCol("IpAddress");
                $('#VulnerabilitiesList').showCol( 'Reason' );
            }
            var colNamesList = ["ID",'Status',I18N.getMsg('js.commonstr.certificatename'),I18N.getMsg("js.discovery.ipaddress"),I18N.getMsg("js.commonstr.status"),'',I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'ID', index: 'ID',hidden:true},//No I18N
                    { name: 'Status', index:'Status',hidden:true},//NO I18N
                    { name: 'CommonName', index: 'CommonName',formatter:"vulFormatter"}, //No I18N
                    { name: 'IpAddress', index: 'IpAddress',hidden:hide},//NO I18N
                    { name: 'Reason',index:'Reason',formatter:'vulStatusFormatter',hidden:hide},//NO I18N
                    { name: 'Flag', index: 'Flag', hidden:true},//NO I18N
                    { name: 'search',fixed:true,width:35,sortable: false,search:false}//NO I18N
                            ];
                            isAutoRefresh = jsonData.Refresh;
            var defaultOptions = {multiselect: false, rowNumNeeded: false,searchOption:true};
            loadJQgridWithData("#VulnerabilitiesList", jsonData.Vulnerabilities, colNamesList, colModelList, " ", "VulnerabilityPager", "SSLVulnerabilitiesSubGrid", defaultOptions);//No I18N                                    
    });
}

function toggleGrid(grid)
{
    App.InventoryController.toggle=grid;
    $("#div"+grid).toggle();
}

function showMailDiv()
{
    if(document.getElementById("sendmail").checked)
    {
        $("#mail-div").show();
    }
    else
    {
        $("#mail-div").hide();
    }
}

function vulSettingsView()
{
    if(document.getElementById("senable").checked)
    {
        $("#settingsdiv").show();
    }
    else
    {
        $("#settingsdiv").hide();
    }
}