// $Id$
App.Settings = Ember.Object.extend({});
var mailServerInfo = App.Settings.create();
App.Settings.reopenClass({
    listUsers: function() {
        var ajaxRequestUrl = '/api/pki/settings/UserManagement'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var colNamesList = ['User Id',I18N.getMsg('js.general.username'),I18N.getMsg('settings.createuser.firstName'),I18N.getMsg('settings.createuser.lastName'),I18N.getMsg('js.settings.useraccesslevel'),I18N.getMsg('js.webclient.register.mailusto'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'UserId', index: 'UserId',hidden:true}, //No I18N
                    { name: 'UserName', index: 'UserName'}, //No I18N
                    { name: 'FirstName', index: 'FirstName'}, //No I18N
                    { name: 'LastName', index: 'LastName'}, //No I18N
                    { name: 'UserRole', index: 'UserRole'}, //No I18N
                    { name: 'EMail', index: 'EMail'}, //No I18N
                    { name: 'search',width:'20px',sortable: false,search:false}//NO I18N
            ];
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#PKIUserManagement", jsonData.UserList, colNamesList, colModelList, " ", "#PKIUserManagementPager", "",defaultOptions);//No I18N
        });
    },
    getSDPTabList: function() {
//        if(kmpStandAlone){
        var selectedTab = App.SettingsCommonController.selectedCMDBTab;
        var server=false;
        var cmdbcerts=false;
        if(selectedTab === "server")//NO I18N
        {
            server=true;
        }
        else if(selectedTab === "cmdbcerts")//NO I18N
        {
            cmdbcerts=true;
        }
        var jsonObj = {};
        var baseurl = window.apiclientUrl+"Settings/"; //No I18N
        var arr=new Array();
        var jsonObj =   {"SDPMenuLinks":[ //No I18N
                                        {"Name":I18N.getMsg("cmdb.server.config.title"),"url":baseurl+"SDP/SDPServer","title":"SDP Server","isSelected":server,"template":"server"}, //No I18N
					{"Name":I18N.getMsg("cmdb.syncwithcmdb.title"),"url":baseurl+"SDP/CMDB","title":"CMDB Sync Details","isSelected":cmdbcerts,"template":"cmdbcerts"} //No I18N
					]
				}
				informationTabList.setProperties(jsonObj);
				return informationTabList;
//                            }
    },
    getSettingsTabList: function() {
    	var selectedTab = App.SettingsCommonController.selectedTab;
        var availableTopViews= topview.Settings;
        var user = false;
        var mail = false;
        var proxy = false;
        var change_password = false;
   	var ad_auth=false;
        var policy=false;
        var notify_policy=false;
        var notify_audit=false;
        var backupDB=false;
   	var dash=false;
    var apiKey=false;
//    var roles=false;
	var radius=false;
        var vulnerabilities=false;
        var certificate = false;
        var METracker = false;
        var cmdb = false;
        var general=false;
        var PurgeAudit=false;
        var exportreportpassword=false;
        var piidata=false;
        var unmappedmails=false;
        var domainexpiry=false;
        var snmp=false;
        var syslog=false;
   		
        if (selectedTab === "user") {user= true;} //No I18N
        else if (selectedTab === "mail") {mail= true;} //No I18N
        else if (selectedTab === "proxy") {proxy= true;} //No I18N
        else if (selectedTab === "change_password") {change_password= true;} //No I18N
        else if (selectedTab === "ad_auth") {ad_auth= true;} //No I18N
        else if (selectedTab === "radius"){radius=true;}//NO I18N
        else if (selectedTab === "policy") {policy= true;} //No I18N
        else if (selectedTab === "notify_policy") {notify_policy= true;} //No I18N
        else if (selectedTab === "notify_audit") {notify_audit= true;} //No I18N
        else if (selectedTab === "backupDB") {backupDB= true;} //No I18N
        else if (selectedTab === "dash") {dash= true;} //No I18N
        else if (selectedTab === "apiKey") {apiKey= true;} //No I18N
//        else if (selectedTab === "roles") {roles= true;} //No I18N
        else if (selectedTab === "vulnerabilities"){vulnerabilities=true;}//NO I18N
        else if (selectedTab === "generalSettings"){general=true;}//NO I18N
        else if (selectedTab === "certificate"){certificate=true;}//NO I18N
        else if (selectedTab === "METracker"){METracker=true;}//NO I18N
        else if (selectedTab === "PurgeAudit"){PurgeAudit=true;}//NO I18N
        else if (selectedTab === "ReportsPassword"){exportreportpassword=true;}//NO I18N
        else if (selectedTab === "PIIData"){piidata=true;}//NO I18N
        else if (selectedTab === "cmdb"){cmdb=true;}//NO I18N
        else if (selectedTab === "unmappedmails"){unmappedmails=true;}//NO I18N
        else if (selectedTab === "domainexpiry"){domainexpiry=true;}//NO I18N
        else if (selectedTab === "snmp"){snmp=true;}//NO I18N
        else if (selectedTab === "syslog"){syslog=true;}//NO I18N
        var baseurl = window.apiclientUrl+"Settings/"; //No I18N
        var sslarr=new Array();
        var ssharr=new Array();
        var arr=new Array();
        var userarr=new Array();
        var genarr=new Array();
        var privacyarry=new Array();
        var toolsarray=new Array();
        var notifyarray=new Array();
        var jsonObj =   {
                        }
//            if(window.userRole==="Administrator")
//            {
            if (availableTopViews.indexOf("UserManagement") > -1)
            {
                var object = {"Name":"User Management","url":baseurl+"UserManagement","title":I18N.getMsg("js.settings.users"),"isSelected":user};//No I18N
                userarr.push(object);
        }
        if ((availableTopViews.indexOf("ActiveDirectory") > -1) && ((isLinux_pmp === null && window.isLinux.toLowerCase() != "linux") || (window.isLinux === null && isLinux_pmp != true) || App.ApplicationController.demo))
                {
            object = {"Name": "ADAuth", "url": baseurl + "ADAuth", "title": I18N.getMsg("js.settingsTitle5.ActiveDirectory"), "isSelected": ad_auth};//No I18N
                userarr.push(object);
                }
        if (availableTopViews.indexOf("Radius") > -1)
        {
            object = {"Name": "Radius", "url": baseurl + "RadiusServer", "title": I18N.getMsg("js.settingsTitle9.Radius"), "isSelected": radius};//NO I18N
                userarr.push(object);
        }
        if (availableTopViews.indexOf("MailServer") > -1)
        {
            object = {"Name": "Mail Setting", "url": baseurl + "MailServer", "title": I18N.getMsg("js.settingsTitle2.MailServer"), "isSelected": mail};//No I18N
                genarr.push(object);
        }
        
        if (availableTopViews.indexOf("ProxyServer") > -1)
        {
            object = {"Name": "Proxy Server", "url": baseurl + "Proxy", "title": I18N.getMsg("js.settingsTitle3.ProxyServer"), "isSelected": proxy};//No I18N
                genarr.push(object);
        }
        if (availableTopViews.indexOf("SNMPSettings") > -1)
        {
            object = {"Name": "SNMP Setting", "url": baseurl + "SNMP", "title": I18N.getMsg("pki.js.SNMPtrap.title"), "isSelected": snmp};//No I18N
                genarr.push(object);
        }
        if (availableTopViews.indexOf("SyslogSettings") > -1)
        {
            object = {"Name": "Syslog Setting", "url": baseurl + "Syslog", "title": I18N.getMsg("pki.js.syslog.title"), "isSelected": syslog};//No I18N
                genarr.push(object);
        }
        if (availableTopViews.indexOf("ChangePassword") > -1)
        {
            object = {"Name": "Change Password", "url": baseurl + "ChangePassword", "title": I18N.getMsg("js.settingsTitle4.ChangePassword"), "isSelected": change_password};//No I18N
                arr.push(object);                            
        }
        if (availableTopViews.indexOf("PolicyConfiguration") > -1)
        {
            object = {"Name": "Policy", "url": baseurl + "Policy", "title": I18N.getMsg("js.settingsTitle6.PolicyConfiguration"), "isSelected": policy};//No I18N
                ssharr.push(object);
        }
        if (availableTopViews.indexOf("Notification") > -1)
        {
            object = {"Name": "Notify_Policy", "url": baseurl + "Notification/NotificationPolicy", "title": I18N.getMsg("js.expirynotification.title"), "isSelected": notify_policy};//No I18N
                notifyarray.push(object);
            object = {"Name": "Notify_Audit", "url": baseurl + "Notification/NotificationAudit", "title": I18N.getMsg("js.audit.title"), "isSelected": notify_audit};//No I18N
                notifyarray.push(object);
        }
        if (availableTopViews.indexOf("DBBackup") > -1)
        {
            object = {"Name": "BackupDB", "url": baseurl + "BackupDB", "title": I18N.getMsg("js.settingsTitle8.DatabaseBackup"), "isSelected": backupDB};//No I18N
                genarr.push(object);
        }
        if (availableTopViews.indexOf("ApiKey") > -1)
        {
            object = {"Name": "API Key", "url": baseurl + "apiKey", "title": I18N.getMsg("js.api.key"), "isSelected": apiKey};//No I18N
                genarr.push(object);                
            }
        if (availableTopViews.indexOf("DashboardSettings") > -1)
        {
            object = {"Name": "DashboardConfig", "url": baseurl + "clientConfig", "title": I18N.getMsg("js.settingsTitle.dashboardConfig"), "isSelected": dash};//No I18N
                genarr.push(object);     
            }
            if (availableTopViews.indexOf("SSLVulnerabilitySettings") > -1)
            {               
                object = {"Name":"SSL Vulnerabilities","url":baseurl+"SSLVulnerabilities","title":I18N.getMsg("vulnerabilities.title"),"isSelected":vulnerabilities};//No I18N
                sslarr.push(object);    
            }
            if (availableTopViews.indexOf("ServerCertificate") > -1)
            {
                object = {"Name":"Server Certificate","url":baseurl+"ServerCertificate","title":I18N.getMsg("settings.servercertificate.title"),"isSelected":certificate};//No I18N
                genarr.push(object);    
            }
            if (availableTopViews.indexOf("SDP") > -1)
            {
                object = {"Name":"SDP","url":baseurl+"SDP/SDPServer","title":I18N.getMsg("settings.cmdb.title"),"isSelected":cmdb};//No I18N
                arr.push(object); 
            }
            if (availableTopViews.indexOf("METracker") > -1)
            {
                object = {"Name":"ME Tracker","url":baseurl+"METracker","title":I18N.getMsg("settings.metracker.title"),"isSelected":METracker};//No I18N
                genarr.push(object);  
            }
            if (availableTopViews.indexOf("PurgeAudit") > -1)
            {
                object = {"Name":"Purge Audit","url":baseurl+"PurgeAudit","title":I18N.getMsg("auditpurge.title"),"isSelected":PurgeAudit};//No I18N
                privacyarry.push(object);  
            }
            
            if (availableTopViews.indexOf("ExportReportPassword") > -1)
            {
                object = {"Name":"Export Report Password","url":baseurl+"exportsettings","title":I18N.getMsg("settings.exportreportpassword.title"),"isSelected":exportreportpassword};//No I18N
                privacyarry.push(object);  
            }
            
                
            if (availableTopViews.indexOf("PIIData") > -1)
            {
                object = {"Name":"PIIData","url":baseurl+"piidata","title":I18N.getMsg("settings.piidata.title"),"isSelected":piidata};//No I18N
                privacyarry.push(object);  
            }
            if (availableTopViews.indexOf("UnMappedMails") > -1)
            {
                object = {"Name":"UnMapped Mails","url":baseurl+"unmappedmails","title":I18N.getMsg("settings.unmappedmails.title"),"isSelected":unmappedmails};//No I18N
                privacyarry.push(object);  
            }
            if (availableTopViews.indexOf("DomainExpiry") > -1)
            {
                object = {"Name":"Domain Expiry","url":baseurl+"domainexpirydata","title":I18N.getMsg("domainexpiry.domainexpiration.label"),"isSelected":domainexpiry};//No I18N
                arr.push(object);  
            }
                if((availableTopViews.indexOf("MSCAAutoRenewal") > -1) &&((isLinux_pmp === null && window.isLinux.toLowerCase() != "linux") || (window.isLinux === null && isLinux_pmp != true) || App.ApplicationController.demo))
                {
                    object = {"Name":"MSCA Settings","url":baseurl+"MSCASettings","title":I18N.getMsg("js.cert.msca.autorenewal"),"isSelected":general};//No I18N
                    sslarr.push(object);
                }
                jsonObj.usermenuLinks = userarr;
            jsonObj.sslmenuLinks = sslarr;
            jsonObj.sshmenuLinks = ssharr;
            jsonObj.generalmenuLinks = genarr;
            jsonObj.menuLinks = arr;
            jsonObj.privacymenuLinks=privacyarry;
            jsonObj.toolsmenuLinks=toolsarray;
            jsonObj.notifyarray=notifyarray;
        informationTabList.setProperties(jsonObj);
        return informationTabList;
    },
    getSSHMgmtTabList: function() {
        if(kmpStandAlone){
    	var selectedTab = App.SettingsCommonController.selectedTab;
        var availableTopViews= topview.SSH;
        if(selectedTab !== "all_users")
        {
            App.SettingsCommonController.userGroupUsersView=false;
            App.DashboardDetailsController.gtype="AllResourceUsers";//No I18N
        }        
        App.SettingsCommonController.uGroup=false; 
        App.SettingsCommonController.cGroup=false;
        var keys = false;
        var all_users = false;
        var dis_keys=false;
        var devices=false;
        var ls = false;
        //var users_group=false;
        //var keys_group=false;
        if (selectedTab === "devices") {devices= true;} //No I18N
        else if (selectedTab === "keys") {keys= true;} //No I18N
        else if (selectedTab === "all_users") {all_users= true;} //No I18N
        else if (selectedTab === "dis_keys") {dis_keys= true;} //No I18N
        else if (selectedTab ==="ls"){ls=true}//NO I18N
        //else if (selectedTab === "users_group"){users_group=true;}//NO I18N
        //else if (selectedTab === "keys_group"){keys_group=true;}//NO I18N
        
        var baseurl = window.apiclientUrl+"SSHMgmt/"; //No I18N
        var arr=new Array();
        var jsonObj =   {
                        }
        if (availableTopViews.indexOf("SSH_Servers") > -1)
        {
            var object = {"Name": I18N.getMsg("js.ssh.server"), "url": baseurl + "SSH", "title": "SSH Devices", "isSelected": devices};//No I18N
                arr.push(object);
        }
        if (availableTopViews.indexOf("SSH_Keys") > -1)
            {
                var object = {"Name":I18N.getMsg("js.sshmanagement.sshkeys.title"),"url":baseurl+"Keys","title":"SSH Keys","isSelected":keys};//No I18N
                arr.push(object);
            }
            if (availableTopViews.indexOf("SSH_Users") > -1)
            {
                object = {"Name":I18N.getMsg("js.sshmanagement.sshusers.title"),"url":baseurl+"AllUsers","title":"SSH Users","isSelected":all_users};//No I18N
                arr.push(object);
            }
            if(availableTopViews.indexOf("Discovered_Keys") > -1)
            {
                var object = {"Name":I18N.getMsg("js.sshmanagement.discoveredkeys.title"),"url":baseurl+"discoveredKeys","title":"Discovered Keys","isSelected":dis_keys};//No I18N
                arr.push(object);
                var object = {"Name":I18N.getMsg("landingserver.title"),"url":baseurl+"LandingServerConfig","title":"Landing Servers","isSelected":ls};//No I18N
                arr.push(object);
            }
            jsonObj.menuLinks = arr;
            
        informationTabList.setProperties(jsonObj);
    }
        return informationTabList;
    },
    resourceWithUsersTree: function()
    {
        var reqUrl="/api/pki/ssh/getResourceWithUsers";//No I18N
        var params="UserView=Only_Associated";//No I18N
        getAjaxApiRequest(reqUrl,params,function(jsonData){
            generateResourceUserTree(jsonData);
            });
    },
    getallresourceGroup:function()
    {
        var ajaxRequestUrl = '/api/pki/settings/getSelectedResourceGroup';//NO I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                for (var col in jsonData.allResourceGroup) {
                    $('#LISTOFRESOURCEGROUPS').append($('<option value="'+ col +'">'+ jsonData.allResourceGroup[col] +'</option>'));  //No I18N
                    groupContents[col]=jsonData.allResourceGroup[col];
                }
        });        
    },
    getalluserGroup:function()
    {
        var ajaxRequestUrl = '/api/pki/settings/getSelectedUserGroup';//NO I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                for (var col in jsonData.allUserGroup) {
                    $('#LISTOFUSERGROUPS').append($('<option value="'+ col +'">'+ jsonData.allUserGroup[col] +'</option>'));  //No I18N
                    userGroupContents[col]=jsonData.allUserGroup[col];
                }
        });        
    },
    getUserInfo: function(user_id) {
        var ajaxRequestUrl = '/api/pki/settings/getUser?USERID='+user_id+"&UserView=Only_Associated"; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            $("#LoginName").val($("<div>").html(jsonData.loginName).text()); //NO I18N
            if(jsonData.firstName!==undefined && jsonData.firstName!=null)
            {
            $("#firstName").val($("<div>").html(jsonData.firstName).text()); //NO I18N
            $("#lastName").val($("<div>").html(jsonData.lastName).text()); //NO I18N
            }
            if(jsonData.firstName==undefined && jsonData.ADUser!=undefined && jsonData.ADUser!=null)
            {
                $("#firstNameDiv").hide();
                $("#lastNameDiv").hide();
            }
            if(jsonData.eMail===undefined)
            {
                document.getElementById('EMail').value="";//NO I18N
            }
            else{
            $("#EMail").val($("<div>").html(jsonData.eMail).text()); //NO I18N
        }

            document.getElementById('LoginName').disabled=true;
            if(jsonData.loginName==="admin")
            {
                document.getElementById('LoginName').disabled=true;
                document.getElementById('ACC_LEVEL').disabled=true;
            }
            if(window.userRole==="Administrator" && window.userName===jsonData.loginName)
            {
                document.getElementById('ACC_LEVEL').disabled=true;
            }
            if(jsonData.userRole!="Administrator")//NO I18N
            {
                if(jsonData.isssh===true)
                {
                    document.getElementById("isssh").checked=true;
                    isSSH_old=true;
                }
                else
                {
                    isSSH_old=false;
                }
                if(jsonData.isssl===true)
                {
                    document.getElementById("isssl").checked=true;
                    if(jsonData.sslSpecific===true)
                    {
                        document.getElementById("SpecificSelection").checked=true;
                    }
                    else
                    {
                        document.getElementById("SpecificSelection").checked=false;
                    }
                    if(jsonData.sslGroups===true)
                    {
                        document.getElementById("GroupSelection").checked=true;
                    }
                    else
                    {
                        document.getElementById("GroupSelection").checked=false;
                    }
                    isSSL_old=true;
                    changeSSLScheduleSelection();
                }                
                else
                {
                    isSSL_old=false;
                }
                if(jsonData.isRGUSED===true)
                {
                    document.getElementById("RGroup").checked=true;
                    isRGUsed_old=true;
                    isUGUsed_old=false;
                    isSpecific_old=false;
                }
                else if(jsonData.isUGUSED===true)
                {
                    document.getElementById("UGroup").checked=true;
                    isUGUsed_old=true;
                    isRGUsed_old=false;
                    isSpecific_old=false;
                }
                else if(jsonData.isSpecific===true)
                {
                    document.getElementById("single").checked=true;
                    isUGUsed_old=false;
                    isRGUsed_old=false;
                    isSpecific_old=true;
                }
                else
                {
                    isUGUsed_old=false;
                    isRGUsed_old=false;
                    isSpecific_old=false;
                }
                selectResType();
                showSelectView();
                App.SettingsUserController.operator=true;
//                if(document.getElementById('single').checked)
//                {
//                    document.getElementById('ResourceUserSelection').className="";
//                }
                
            }
            else
            {
                App.SettingsUserController.admin=true;
            }
            fillUserDetails(jsonData);
            document.getElementById('ACC_LEVEL').value=jsonData.userRole;//NO I18N
        });
    },
    getMailServer: function(){
        var ajaxRequestUrl = '/api/pki/settings/getMailServer'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            mailServerInfo.setProperties(jsonData);
            if (jsonData.SERVER_NAME === 'NOTAPPLICABLE')
            {
                $("#MAIL_SERVER_NAME").val("smtp");//NO I18N
            } else {
                $("#MAIL_SERVER_NAME").val($("<div>").html(jsonData.SERVER_NAME).text());//NO I18N
            }
            document.getElementById("MAIL_SERVER_PORT").value=jsonData.PORT;//NO I18N
            if(jsonData.USER_NAME!==undefined && jsonData.PASSWORD!==undefined)
            {                        
                document.getElementById("REQ_AUTH").checked=true;//NO I18N
                document.getElementById("MAIL_ACCOUNT_NAME").disabled=false;//NO I18N
                document.getElementById("MAIL_ACCOUNT_PASSWORD").disabled=false;//NO I18N
                $("#MAIL_ACCOUNT_NAME").val($("<div>").html(jsonData.USER_NAME).text());//NO I18N
                document.getElementById("MAIL_ACCOUNT_PASSWORD").placeholder=jsonData.PASSWORD;//NO I18N
            }
            $("#FROM_ADDRESS").val($("<div>").html(jsonData.FROMADDRESS).text());//NO I18N
        });        
        return mailServerInfo;
    },
    getSNMPSyslogSettingsView:function(){
        var reqUrl="/api/pki/settings/getSnmpSyslogServerSettings";//NO I18N
         getAjaxApiRequest(reqUrl,"",function(json){
                if(json.syslog_IP != null ) {
                      $('#syslog_ip').val(json.syslog_IP);
                      $('#syslog_port').val(json.syslog_PORT);
                }
                if(json.RECEIVER_NAME != null ) {
                    $('#snmp_ip').val(json.RECEIVER_NAME);
                    $('#snmp_port').val(json.RECEIVER_PORT);
                    $('#snmp_collector').val(json.COMMUNITY);
                }
            });
    },
    getUnmappedMailsView: function()
    {
        var ajaxRequestUrl = '/api/pki/settings/getUnmappedMails'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var colNamesList = ['','',I18N.getMsg("settings.unmappedmails.email"),I18N.getMsg("settings.unamppedmails.presence"),I18N.getMsg("settings.unmappedmails.reason"),I18N.getMsg('js.table.search')];//NO I18N
                    var colModelList = [
                        {name: 'ID',index:'ID',hidden:true},//NO I18N
                        {name:'TYPE',index:'TYPE',hidden:true},//NO I18N
                        {name: 'MAIL_ID', index:'MAIL_ID',width:"100px"},//NO I18N
                        {name:'MODULE', index:'MODULE',width:"100px"},//NO I18N
                        {name:'REASON',index:'REASON',width:"150px"},//NO I18N
                        { name: 'search',width:"30px",sortable: false,search:false,fixed:true}//NO I18N
                    ];
                    var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                    loadJQgridWithData("#UnMappedList", jsonData.list, colNamesList, colModelList, "", "#UnMappedPager", "UnMappedMails",defaultOptions);//No I18N
        });  
    },
    getSSLVulnerabilitiesSettings: function()
    {
        var ajaxRequestUrl = '/api/pki/settings/getSSLVulnerabilitiesSettings'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var scheduleType=jsonData.scheduleType;
            document.getElementById("daily").style.display='none';
            document.getElementById("weekly").style.display='none';
            if(scheduleType==="daily")
            {
                document.getElementById("daily").style.display='';
                $('#dailyRad').prop("checked",true);//No I18N
                $('#daySchedule').val(jsonData.daySchedule);//No I18N
                }
            else if(scheduleType==="weekly")
            {
                document.getElementById("weekly").style.display='';
                $('#weeklyRad').prop("checked",true);//No I18N
                $('#weeklySchedule').val(jsonData.weeklySchedule);//No I18N
                }                        
            var checksan = jsonData.CheckSan;
            var deployedServers = jsonData.DeployedServers;
            var mailAddress = jsonData.MailAddress;
            var sslv3 = jsonData.SSLv3;
            var schedule = jsonData.Schedule;
            document.getElementById('s'+schedule).checked=true;
            document.getElementById(sslv3).checked=true;
            vulSettingsView();
            if(checksan==="yes")
            {
                document.getElementById("checksan").checked=true;
            }
            else
            {
                document.getElementById("checksan").checked=false;
            }
            if(deployedServers==="yes")
            {
                document.getElementById("checkip").checked=true;
            }
            else
            {
                document.getElementById("checkip").checked=false;
            }
            if(mailAddress!=="")
            {
                document.getElementById("sendmail").checked=true;                
            }
            else
            {
                document.getElementById("sendmail").checked=false;
            }
            document.getElementById("scheduleMail").value=mailAddress;
            showMailDiv();
        });
    },
    getRadiusConfiguration: function()
    {
        var ajaxRequestUrl = '/api/pki/settings/getRadiusConfiguration'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            document.getElementById("server_name").value=jsonData.server;
            document.getElementById("server_port").value=jsonData.port;
            if(jsonData.port==="")
            {
                document.getElementById("server_port").value="1812";//NO I18N                
            }
            else
            {
                $("#enableDisable").css("display","block");
            }
            if(jsonData.server!=="")
            {
                document.getElementById("server_secret").placeholder=jsonData.secret;
            }
            document.getElementById("protocol").value=jsonData.protocol;
            document.getElementById("retries").value=jsonData.retries;
            if(jsonData.status=="enable")
            {
                $("#disableRadius").show();
                $("#enableRadius").hide();
                document.getElementById("radius_status").innerHTML="Enabled";//NO I18N
                $("#radius_status").css("color","#0EB07A");
            }
            else
            {
                $("#enableRadius").show();
                $("#disableRadius").hide();
                document.getElementById("radius_status").innerHTML="Disabled";//NO I18N
                $("#radius_status").css("color","red");
            }
           
        });
    },
    getProxyServer: function(){
        var ajaxRequestUrl = '/api/pki/settings/getProxyServer'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            if(jsonData.DIRECT_CONNECTION===true)
            {
                document.getElementById("radio").checked=true;
            }
            else
            {
                document.getElementById("radio2").checked=true;//NO I18N
                $("#proxyDetails").css('display','block'); //No I18N 
            }
            $("#SERVER_NAME").val($("<div>").html(jsonData.PROXY_HOST).text());//NO I18N
            document.getElementById("PORT").value=jsonData.PROXY_PORT;//NO I18N
            if(jsonData.PROXY_USERNAME!==undefined && jsonData.PROXY_PASSWORD!==undefined)
            {                        
                $("#USER_NAME").val($("<div>").html(jsonData.PROXY_USERNAME).text());//NO I18N
                document.getElementById("PASSWORD").placeholder=jsonData.PROXY_PASSWORD;//NO I18N
            }
        });        
    },
    getDomains: function(){
        var ajaxReqUrl="/api/pki/settings/importUsers";//No I18N
        var params="RequestType=collectDomains";//No I18N
        if($('select#DOMAINNAME option').length==0)
        {
        getAjaxApiRequest(ajaxReqUrl,params+"&pmpcp="+Get_Cookie('pmpcc'),function(jsonData){//NO I18N
                if(jsonData.DOMAINS!==undefined)
                {
                var domains=jsonData.DOMAINS;
                var arr=domains.split(",");
                var sel=document.getElementById("DOMAINNAME");//No I18N
                    for(var i=0;i<arr.length;i++)
                    {
                        if(i===0)
                        {
                            var opt1=document.createElement('option');//No I18N
                            opt1.innerHTML = I18N.getMsg('js.selecct.domain');//No I18N
                            opt1.value = "";
                            sel.appendChild(opt1);
                        }
                        var opt=document.createElement('option');//No I18N
                        opt.innerHTML = arr[i];
                        opt.value = arr[i];
                        sel.appendChild(opt);
                    }
                }
        });
        }
    },
    formADOUGroup: function(app)
    {
        var ajaxReqUrl="/api/pki/settings/importUsers"+App.SettingsCommonController.ouUrl;//NO I18N
        if($("#importLoading")!=undefined)
        {
            $("#importLoading").show();
        }
        var isOUClose=false;
        var isGroupClose=false;
        var call1=getAjaxApiRequest(ajaxReqUrl,"pmpcp="+Get_Cookie('pmpcc'),function(jsonData){//NO I18N
                if(jsonData.Status==="Success")//NO I18N
                {
                    var nodes=jsonData.USEROU;
                    $( "#main_cs").html( nodes );//No I18N
                    //$('#step1_id').hide();//No I18N
                    //$('#step2_id').show();//No I18N
                    if(app==undefined)
                    {
                        $("#aduser_div").hide();
                        $("#ADOulist_Div").show();
                        $("#sign_action").hide();
                        $("#sign_type").prop( "disabled", true );
                    }
                }
                else
                {
                    if(jsonData.Message==undefined || jsonData.Message==="")
                    {
                        messageNotification("messageNotifyFailure",I18N.getMsg("js.ad.adou.load.failed"));//No I18N
                    }
                    else
                    {
                         messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                    }
                    isOUClose=true;
                }
                if($("#importLoading")!=undefined)
                {
                    $("#importLoading").hide();
                }                
        });           

        ajaxReqUrl="/api/pki/settings/importUsers"+App.SettingsCommonController.groupUrl;//NO I18N
        var call2=getAjaxApiRequest(ajaxReqUrl,"pmpcp="+Get_Cookie('pmpcc'),function(jsonData){//NO I18N
                if(jsonData.Status==="Success")//NO I18N
                {
                    var nodes=jsonData.USERGROUP;
                    $( "#main_cs1").html( nodes );//No I18N
                    //$('#step1_id').hide();//No I18N
                    //$('#step2_id').show();//No I18N
                    if(app==undefined)
                    {
                        $("#ADOulist_Div").show();
                        $("#aduser_div").hide();
                        $("#sign_action").hide();
                        $("#sign_type").prop( "disabled", true );
                    }
                }
                else
                {
                    if(jsonData.Message==undefined || jsonData.Message==="")
                    {
                        messageNotification("messageNotifyFailure",I18N.getMsg("js.ad.ADUserGroupLoadFailed"));//No I18N
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                    }                    
                    isGroupClose=true;
                }
                if($("#importLoading")!=undefined)
                {
                    $("#importLoading").hide();
                }                
        });           
        $.when(call2, call1).done(function(jsonData2, jsonData1) {
            if(isOUClose && isGroupClose && app!=undefined )
            {
                var controller = app.get('controller');
                controller.send('close');//NO I18N
            }
        });
    },
    getPolicyConfig:function(){
        var ajaxReqUrl="/api/pki/settings/getPolicyConfig";//No I18N 
        getAjaxApiRequest(ajaxReqUrl,"",function(jsonData){
            if(jsonData.KEYFILE_CONFIG==="overwrite")
                {
                    document.getElementById("overwrite").checked=true;
                    document.getElementById("append").checked=false;
            }
        });                   
    },
    getNotificationConfig:function(){
        var ajaxReqUrl="/api/pki/settings/getNotificationConfig";//No I18N 
        getAjaxApiRequest(ajaxReqUrl,"",function(jsonData){
           var count = Object.keys(jsonData).length 
           if(count!=0)
           {
                if(jsonData.IS_DOMAIN==1)
                {
                     document.getElementById("DOMAIN_NOTIFY").checked=true;
                     document.getElementById("domain_day_count").value=jsonData.DOMAIN_DAYS;                     
                }
                if(jsonData.IS_SSLREQ==1)
                {
                    document.getElementById("SSL_NOTIFY").checked=true;
                    document.getElementById("Exp_day_count").value=jsonData.SSL_DAYS;
                    $("#Exp_Days").show();
                }
                if(jsonData.IS_SSHREQ==1)
                {
                    document.getElementById("SSH_NOTIFY").checked=true;
                    document.getElementById("key_day_count").value=jsonData.SSH_DAYS;
                    $("#Crt_Days").show();
                }
                if(jsonData.NOTIFICATION_TYPE.indexOf("Email")!=-1)
                {
                    document.getElementById("Email").checked=true;
                    $("#to_div").show();
                    if(kmpStandAlone)
                    {
                         $("#fromAddress").val($("<div>").html(jsonData.FROMADDRESS).text());//No I18N
                    }
                    $("#toAddress").val($("<div>").html(jsonData.TOADDRESS).text());//No I18N
                    if(jsonData.EMPTY_NOTIFY_CHECK_ENABLED!=undefined && jsonData.EMPTY_NOTIFY_CHECK_ENABLED!=null&& jsonData.EMPTY_NOTIFY_CHECK_ENABLED== true ){
                        document.getElementById("notify_emptyCertMail").checked=true;
                }
                }else{
                    document.getElementById("Email").checked=false;
                }
                if (kmpStandAlone && (jsonData.IP == undefined || jsonData.IP == null || jsonData.IP == '')) {
                    $("#syslogdiv").val("SyslogNotConfigured");
                }
                if(jsonData.NOTIFICATION_TYPE.indexOf("SysLog")!=-1)
                {
                    document.getElementById("SysLog").checked=true;
                }
                var sch_time=jsonData.SCH_REPEAT.split(":");
                document.getElementById("Hrs").value=sch_time[0];
                document.getElementById("Mins").value=sch_time[1];
           }
        });
    },
    getDBBackup:function(){
        var ajaxReqUrl="/api/pki/settings/getDBBackup";//No I18N 
        getAjaxApiRequest(ajaxReqUrl,"",function(jsonData){
            
            var maintainBackup=jsonData.maintainBackup;
            if(maintainBackup==="true")
            {
                $('#backUpDur').val(jsonData.backUpDur);//No I18N
            }
            else
            {
                $('#backUpDur').val(jsonData.maintainBackup);//No I18N
            }
                $('#timerHours').val(jsonData.timerHours);//No I18N
                $('#timerMinutes').val(jsonData.timerMinutes);//No I18N
                $("#emailRecipients").val($("<div>").html(jsonData.emailRecipients).text());//No I18N
                $("#backupPath_ID").val($("<div>").html(jsonData.backupPath).text());//No I18N
                var scheduleType=jsonData.scheduleType;
                var specificSchedule=jsonData.specificSchedule;
                document.getElementById("daily").style.display='none';
                document.getElementById("monthly").style.display='none';
                document.getElementById("weekly").style.display='none';
                if(scheduleType==="daily")
                {
                    document.getElementById("daily").style.display='';
                    $('#dailyRad').prop("checked",true);//No I18N
                    $('#daySchedule').val(jsonData.daySchedule);//No I18N
                }
                else if(scheduleType==="weekly")
                {
                    document.getElementById("weekly").style.display='';
                    $('#weeklyRad').prop("checked",true);//No I18N
                    $('#weeklySchedule').val(jsonData.weeklySchedule);//No I18N
                }
                else if(scheduleType==="monthly")
                {
                    document.getElementById("monthly").style.display='';
                    $('#monthlyRad').prop("checked",true);//No I18N
                    $('#monthlySchedule').val(jsonData.monthlySchedule);//No I18N
                }
        });                   
    },
    getBackupScheduleAuditList:function(){
        var ajaxRequestUrl = '/api/pki/schedule/backupScheduleAudit';//No I18N 
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                        var colNamesList = ['ScheduleAuditId',I18N.getMsg('js.schedule.name'),I18N.getMsg('js.schedule.starttime'),I18N.getMsg('js.commonstr.status'),I18N.getMsg('js.table.search')]; //No I18N
                        var colModelList = [
                                { name: 'ScheduleAuditId', index: 'ScheduleAuditId',hidden:true}, //No I18N
                                { name: 'ScheduleName', index: 'ScheduleName'}, //No I18N
                                { name: 'StartTime', index: 'StartTime'}, //No I18N
                                { name: 'Status', index: 'Status'}, //No I18N
                                { name: 'search',width:'15px',sortable: false,search:false}//NO I18N
                        ];
                    var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
                    loadJQgridWithData("#BackupScheduleDetails", jsonData.scheduleBackupAudit, colNamesList, colModelList, "", "#BackupSchedulePager", "",defaultOptions);//No I18N
            });
    },
    getLicenseInfo: function(){
        var ajaxRequestUrl = '/api/pki/settings/getLicenseInfo'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            $("#version").text(jsonData.version);
            $("#build").text(jsonData.build);
            $("#lictype").text(jsonData.licenseType);
            $("#licinfo").text(jsonData.licenseInfo);
            $("#licto").text(jsonData.licensedTo);
            $("#expiry").text(jsonData.expiryDate);
        });
    },
    getAPIKey: function(){
        var ajaxRequestUrl = '/api/pki/settings/getAPIKey'; //No I18N
        $("#apilink").html(I18N.getMsg('js.api.key.help.link'));//No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            if(jsonData.apiKey!=undefined || jsonData.apiKey!=null)
            {
                $("#apikeyval").text(jsonData.apiKey);
                $("#nokeyDiv").css("display","none");
                $("#apiKeyGenerate").text(I18N.getMsg('js.api.key.regenerate'));//No I18N
                if(jsonData.RestAPIEnabled==true){
                    $("#enable_restapi").prop('checked', true);
                }else{
                    $("#disable_restapi").prop('checked', true);
                    $("#enabledKeyDiv").hide();
                    $("#apiKeyGenerate").hide();
            }
            }
            else
            {
                $("#keyDiv").css("display","none");
                $("#apiKeyValue").text(I18N.getMsg('js.apikey.notAvailable'));//No I18N
                $("#nokeyDiv").css("display","block");
                $("#apiKeyGenerate").text(I18N.getMsg('js.api.key.generate'));//No I18N
            }
        });
    },
    listsshkeys:function(){
              var ajaxRequestUrl = '/api/pki/ssh/getSSHKeys'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                    getSshKeysList(jsonData,"PKISSHKeys","PKISSHKeysPager",false);//No I18N
            });
    },
    listdefaultsshkeys:function(){
              var ajaxRequestUrl = '/api/pki/ssh/getSSHKeys'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                    getdefaultSshKeysList(jsonData,"PKISSHKeys","PKISSHKeysPager");//No I18N
            });
    },
    listkeysgroup:function(){
        var ajaxRequestUrl = '/api/pki/ssh/getkeysgrouplist';//NO I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var colNamesList = ['Group Id',I18N.getMsg('js.resource.groupname'),I18N.getMsg('js.commonstr.description'),I18N.getMsg('js.general.createdby'),I18N.getMsg('js.schedule.lastmodifiedby'),'',I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                { name: 'GROUP ID', index: 'GROUP ID',hidden:true}, //No I18N
                { name: 'GROUP NAME', index: 'GROUP NAME',classes:'pointer'}, //No I18N
                { name: 'DESCRIPTION', index: 'DESCRIPTION'}, //No I18N
                { name: 'Created By', index: 'Created By'}, //No I18N
                { name: 'Last Modified By', index:'Last Modified By'},//NO I18N
                { name: 'Edit', index: 'Edit',search:false,formatter:'editFormatter',width:'30px'}, //No I18N
                { name: 'search',width:40,sortable: false,search:false,fixed:true}//NO I18N
        ];                   
        var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
        loadJQgridWithData("#PKIKeysGroupList", jsonData.KGList, colNamesList, colModelList, " ", "PKIKeysGrouppager", "KeysGroup",defaultOptions);//No I18N
        });
    },
    listusersgroup:function(){
        var ajaxRequestUrl = '/api/pki/ssh/getusersgrouplist';//NO I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var colNamesList = ['Group Id',I18N.getMsg('js.resource.groupname'),I18N.getMsg('js.commonstr.description'),I18N.getMsg('js.general.createdby'),I18N.getMsg('js.schedule.lastmodifiedby'),'','',I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                { name: 'GROUP ID', index: 'GROUP ID',hidden:true}, //No I18N
                { name: 'GROUP NAME', index: 'GROUP NAME',classes:'pointer'}, //No I18N
                { name: 'DESCRIPTION', index: 'DESCRIPTION'}, //No I18N
                { name: 'Created By', index: 'Created By'}, //No I18N
                { name: 'Last Modified By', index:'Last Modified By'},//NO I18N
                { name: 'Edit', index: 'Edit',search:false,formatter:'editFormatter',width:'30px',fixed:true}, //No I18N
                { name: 'EditPath', index:'EditPath',search:false,formatter:'editPathFormatter',width:'30px',fixed:true},//NO I18N
                { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
        ];                   
        var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
        loadJQgridWithData("#PKIUsersGroupList", jsonData.UGList, colNamesList, colModelList, " ", "PKIUsersGrouppager", "UsersGroup",defaultOptions);//No I18N
        });
    },
    listkeysgroupkeys:function(kgid){
      var ajaxRequestUrl = '/api/pki/ssh/getkeysgroupkeyslist';//NO I18N
      var data='KEYS_GROUP_ID='+App.SettingsUserController.kGroupId;//NO I18N
      getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
          getSshKeysList(jsonData,"PKISSHKeys","PKISSHKeysPager",false);//No I18N          
      });
      
    },
    listusersgroupusers:function(ugid){
      var ajaxRequestUrl = '/api/pki/ssh/getusersgroupuserslist';//NO I18N
      var data='USERS_GROUP_ID='+App.SettingsUserController.kGroupId;//NO I18N
      getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
          allUsersList(jsonData,"PKIAllResourceUsers","PKIAllResourceUsersPager");//No I18N          
      });
      
    },
    getAssociatedUsersForKey:function()
    {
        var ajaxRequestUrl = '/api/pki/ssh/getAssociatedUsersForKey'; //No I18N
        var params='key_id='+App.SettingsUserController.key_id+'&ViewName=Table';//No I18N
        getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
            var colNamesList = ['Key Id',I18N.getMsg('js.general.username'),I18N.getMsg('js.general.resourcename'),'',I18N.getMsg('js.table.search')]; //No I18N
            if(!kmpStandAlone)
            {
                colNamesList = ['Key Id',I18N.getMsg('js.general.username'),I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.table.search')]; //No I18N
            }
            var colModelList = [];
            colModelList.push({ name: 'UserID', index: 'UserID',hidden:true}); //No I18N
            colModelList.push({ name: 'UserName', index: 'UserName'}); //No I18N
            colModelList.push({ name: 'ResourceName', index: 'ResourceName'}); //No I18N
            if(kmpStandAlone){
                colModelList.push({ name: 'Connect', index: 'Connect',width:'70px',formatter:'connectFormatter',classes:"pointer",search:false}); //No I18N
            }
            colModelList.push({ name: 'search',width:'15px',sortable: false,search:false});//NO I18N
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#AssociatedUsersList", jsonData.UserDeatils, colNamesList, colModelList, "", "#AssociatedUsersPager", "SSHUserAssociateToKey",defaultOptions);//No I18N            
        });
    },
    ViewKeyHistoryDetails:function(key_id)
    {
        
        //$("#keyName").html(key_id);
     var reqparams="KEYID="+key_id;//NO I18N  
     var reqUrl="/api/pki/ssh/getKeyHistory";//No I18N
     getAjaxApiRequest(reqUrl,reqparams,function(jsonData){
         $("#keyName").html(jsonData.KEYNAME);
         var colNamesList = ['Version Id',I18N.getMsg('js.encryptionkeys.Version'),I18N.getMsg('js.commonstr.description'),I18N.getMsg('js.ssh.fingerprint'),I18N.getMsg('js.general.type'),I18N.getMsg('js.ssh.keylength'),I18N.getMsg('js.general.username'),I18N.getMsg('js.audit.operationaudittime'),I18N.getMsg('js.table.search')]; //No I18N
          var colModelList = [
                                { name: 'Version_Id', index: 'Version_Id', width:'0px',hidden:true}, //No I18N
                                { name: 'Version', index: 'Version',width:'50px'},//NO I18N
                                { name: 'Description', index: 'Description', width:'120px',search:false}, //No I18N               
                                { name: 'FingerPrint', index: 'FingerPrint', width:'200px'}, //No I18N
                                { name: 'Encryption_Type', index: 'Encryption_Type', width:'65px'}, //No I18N
                                { name: 'Encryption_Bits', index: 'Encryption_Bits', width:'65px'}, //No I18N
                                { name: 'UserName', index: 'UserName', width:'125px'}, //No I18N
                                { name: 'Time', index: 'Time', width:'100px',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                                { name: 'search',width:'25px',sortable: false,search:false}//NO I18N
                        ];     
                        var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
                        loadJQgridWithData("#KeyHistoryDetailsList", jsonData.data, colNamesList, colModelList, " ", "#KeyHistoryDetailsListPager", "",defaultOptions);//No I18N
     });
    
        
    },
    getAssociateMappingGraphView:function()
    {
        var ajaxRequestUrl = '/api/pki/ssh/getResourcesMappings?key_id='+App.SettingsUserController.key_id; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                var arr=jsonData.nodes;
                if(jsonData.message!==undefined)
                {
                    showAlert(I18N.getMsg('js.sshkey.noAssociationFound'));//NO I18N
    }
                else
                {
                    var keyname=jsonData.nodes[0].name;
                    $("#key_name").html(keyname);
                    checkLoginStatus(jsonData);
                    loadSlideMapBar();
                    associationGraphView(jsonData); //No I18N
                }
});
    },
    getUserAssociateMappingGraphView:function()
    {
        var ajaxRequestUrl = '/api/pki/ssh/getUserMappings?user_id='+App.SettingsUserController.key_id; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var arr=jsonData.nodes;
            if(jsonData.message!==undefined)
            {
                showAlert(I18N.getMsg('js.sshkey.noAssociationFound'));//NO I18N
            }
            else
            {
                var username=jsonData.nodes[0].name;
                var resourcename=jsonData.nodes[0].resource_name;
                $("#key_name").html(username+"@"+resourcename);
                checkLoginStatus(jsonData);
                loadSlideMapBar();
                userAssociationGraphView(jsonData); //No I18N
            }
        });
    },
    getAllResourceUsers:function()
    {
        if(App.DashboardDetailsController.gtype==="")
        {
            App.DashboardDetailsController.gtype="AllResourceUsers";//No I18N
        }
        var data="user_type="+App.DashboardDetailsController.gtype;//No I18N
        var ajaxRequestUrl = '/api/pki/ssh/getAllResourceUsers'; //No I18N
        //var controller=this.get('controller');
        getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
            allUsersList(jsonData,"PKIAllResourceUsers","PKIAllResourceUsersPager")//No I18N
            //For open the credential dialog
          /*  $(".editCred").on('click',function(){
                controller.send('dialogCall');//NO I18N
            });        */
        });        
                    },
    getPKIRolesList:function(){
        var ajaxRequestUrl = '/api/pki/settings/getPKIRolesList';//No I18N 
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                        var colNamesList = ['roleId',I18N.getMsg('js.settings.rolename'),I18N.getMsg('js.commonstr.description'),I18N.getMsg('js.settings.rolecreatedBy'),I18N.getMsg('js.table.search')]; //No I18N
                        var colModelList = [
                                { name: 'roleId', index: 'roleId',hidden:true}, //No I18N
                                { name: 'RoleName', index: 'RoleName'}, //No I18N
                                { name: 'RoleDescription', index: 'RoleDescription'}, //No I18N
                                { name: 'CreatedBy', index: 'CreatedBy'}, //No I18N
                                { name: 'search',width:'15px',sortable: false,search:false}//NO I18N
                        ];
                    var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                    loadJQgridWithData("#PKIRoleManagement", jsonData.roles, colNamesList, colModelList, "", "#PKIRoleManagementPager", "roles",defaultOptions);//No I18N
            });
                    },
                    getMSCAAutoRenewalSettingsView:function(){
                        var ajaxRequestUrl = '/api/pki/settings/getMSCAAutoRenewalTask'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            if(jsonData.Status=="Enabled")
            {
                document.getElementById("senable").checked=true;
                $("#Hrs").val(jsonData.Hours);
                $("#Mins").val(jsonData.Minutes);
                $("#settingsdiv").show();
            }
            else
            {
                document.getElementById("sdisable").checked=true;
                $("#settingsdiv").hide();
            }
        });
                    }, getCMDBView: function (modal) {
                        if (!kmpStandAlone)
                        {
                            $("#citype").val("PMP_SSL");
                            $("#parentcitype").val("Password Manager Pro");
                        }
        if (App.SettingsCommonController.selectedCMDBTab === "cmdbcerts") {
            var ajaxRequestUrl = '/api/pki/settings/checkSDPServerDetails'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl, "", function (jsonData) {
                if (jsonData.Status === "no")
                {
                        if(kmpStandAlone){
                    vConfirmation(I18N.getMsg("cmdb.alert.addsdpserver"), function () {//NO I18N
                        location.href = "#/Settings/SDP/SDPServer";//NO I18N
                         });
                    }else{
                        //showAlert(I18N.getMsg("cmdb.alert.addsdpserver.pmp")); //No I18N
                        App.SettingsCommonController.selectedCMDBTab = "server"; //No I18N
                         App.Settings.getSDPTabList();
                         App.Settings.getSDPServerView();		
	               $("#ServertemplatetoDisp").show();		
	               $("#cmdbtemplatetoDisp").hide();	
                    }
                    document.getElementById("disable").checked = true;
                    cmdbview();
                } else
                {
                    ajaxRequestUrl = '/api/pki/settings/getcmdbview'; //No I18N
                    getAjaxApiRequest(ajaxRequestUrl, "", function (jsonData) {
                        document.getElementById(jsonData.Status).checked = true;
                        cmdbview();
                        document.getElementById("citype").value = jsonData.childCi;
                        document.getElementById("parentcitype").value = jsonData.parentCi;
                        if (jsonData.ci === "new")
                        {
                            document.getElementById("showParent").checked = true;
                        } else
                        {
                            document.getElementById("hideParent").checked = true;
                            $("select option[value!='---Select Attribute---']").remove();
                            var attributesArray = jsonData.Attributes;
                            for (var i = 0; i < attributesArray.length; i++)
                            {
                                var value = attributesArray[i];
                                if (value.value !== "---Select Attribute---")
                                {
                                    $("select").append(new Option(value.value, value.type));
                                }
                            }
                            var mapArray = jsonData.AttributesMap
                            for (var i = 0; i < mapArray.length; i++)
                            {
                                var m = mapArray[i];
                                $("#" + m[0] + " option:contains('" + m[1] + "')").attr("selected", "selected");//NO I18N
                            }
                        }
                        hideparent();
                    });
                }
            });
        }
    }, getSDPServerView: function () {
        if (App.SettingsCommonController.selectedCMDBTab === "server") {
            var ajaxRequestUrl = '/api/pki/settings/getSDPserveview'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl, "", function (jsonData) {
                if (jsonData.Url !== undefined)
                {
                    document.getElementById("techniciankey").placeholder = I18N.getMsg("js.sdp.placeholder.KeyAvailable");//NO I18N
                    document.getElementById("sdpserverurl").value = jsonData.Url;
                }
            });
        }
    }
        });

function createNewUser()
{
    location.href = window.apiclientUrl+"Settings/CreateUser/"; //No I18N
}

function deleteUser()
{
    var grid = $("#PKIUserManagement"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0) {
            showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
            return;
    }
    vConfirmation(I18N.getMsg("js.deleteUser.confirmation"),function(){//NO I18N
        var arr = new Array();
        var user_ids="";
        var isfound_admin=false;
        $.each(selRowIds, function()
        {
            var id = this;
            var user_id = grid.jqGrid('getCell', id, 'UserId'); //No I18N
            var userName =grid.jqGrid('getCell', id, 'UserName'); //No I18N
            if(userName==="admin")
            {
                isfound_admin=true;
                return;
            }
            if(user_ids!=="")
            {
                user_ids=user_ids+","+user_id;
            }
            else
            {
                user_ids=user_id;
            }
        });
        if(isfound_admin)
        {
            messageNotification("messageNotifyFailure",I18N.getMsg("js.deleteUser.Cannotdeletedefaultuseradmin"));//NO I18N
            return;
        }
            var data = {

            };
        data.USERIDS = user_ids;
        data.pmpcp=Get_Cookie('pmpcc');//No I18N
        data.DeleteConfirm=false;
        var ajaxRequestUrl = '/api/pki/settings/deleteUser'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                if(jsonData.Status==="Success")//No I18N
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//NO I18N
                    {{App.Settings.listUsers();}}
                }
                else
                {
                    var msg=jsonData.Message;
                    if(msg.indexOf("let&#39;s encrypt account")!=-1)
                    {
                        vConfirmation1(jsonData.Message,function(){
                            data.DeleteConfirm=true;
                            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                                if(jsonData.Status==="Success")//No I18N
                                {
                                    messageNotification("messageNotifySuccess",jsonData.Message);//NO I18N
                                    {{App.Settings.listUsers();}}
                                }
                                else
                                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N
                                }
                            });
                        });
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",msg);//NO I18N
                    }
                }
        });
    });
}

function editUser()
{
    var grid = $("#PKIUserManagement");
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0) {
            showAlert(I18N.getMsg('js.userselection.selectOneUser')); //No I18N
            return;
    }
    var arr = new Array();
    if(selRowIds.length!=1)
    {
        showAlert(I18N.getMsg('js.userEdit.OnlyOneUserAllowedtoEditataTime'));//NO I18N
        return;
    }
    var user_id="";//NO I18N
    var user_name="";
    $.each(selRowIds, function()
    {
        var id = this;
        user_id = grid.jqGrid('getCell', id, 'UserId'); //No I18N
        user_name = grid.jqGrid('getCell', id, 'UserName'); //No I18N
    });
    App.SettingsUserController.user_name=user_name;
    location.href = window.apiclientUrl+"Settings/UpdateUser/"+user_id; //No I18N
}
function keyHistory()
{
    var grid = $("#PKISSHKeys"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    var key_id="";
    if(selRowIds == undefined || selRowIds.length == 0) {
        showAlert(I18N.getMsg('js.sshkey.selectOneKey')); //No I18N
        return;
        }else if(selRowIds.length>1)
        {
                showAlert(I18N.getMsg('js.sshkey.selectOneKey')); //No I18N
               return;                
            }
    key_id=grid.jqGrid('getCell',selRowIds,'KeyID'); //No I18N 
    App.SettingsUserController.key_id=key_id;
    redirectUrl("SSHMgmt/KeyHistory/"+key_id); //No I18N

}


function handleMailAccountDetails(form)
{
	var accStatus=true;
	if(form.REQ_AUTH.checked)
	{
		accStatus=false;
	}
	form.MAIL_ACCOUNT_NAME.disabled=accStatus;
	form.MAIL_ACCOUNT_PASSWORD.disabled=accStatus;
}

function showHideProxyRow(proxysettingsrow,status)
{
	if(status){
            $("#"+proxysettingsrow).css('display','block'); //No I18N 
        }
	else
	{
            $("#"+proxysettingsrow).css('display','none'); //No I18N 
	}
}

function collectDCNamesForKMP(){
    var domainName = document.getElementById('DOMAINNAME').value;//No I18N
    if(domainName==="WORKGROUP")//No I18N
    {
        document.getElementById("DOMAINCONTROLLER").value= "";//No I18N
        document.getElementById("SECDOMAINCONTROLLER").value= "";//No I18N
        document.getElementById("LOGINNAME").value= "";//No I18N
    }
    else
    {
        var ajaxReqUrl="/api/pki/settings/importUsers";//No I18N
        var params="RequestType=collectDCNames&DOMAINNAME="+domainName+"&pmpcp="+Get_Cookie('pmpcc');//No I18N
        getAjaxApiRequest(ajaxReqUrl,params,function(jsonData){
            if(jsonData.Status==="Success")
            {
                document.getElementById("DOMAINCONTROLLER").value= jsonData.DCNAME;//No I18N
                if(jsonData.SECDCNAME!=undefined && jsonData.SECDCNAME!="")
                {
                document.getElementById("SECDOMAINCONTROLLER").value= jsonData.SECDCNAME;//No I18N
                }
                document.getElementById("LOGINNAME").value= jsonData.USERNAME;//No I18N
                document.getElementById("PASSWORD").value="";//No I18N
                document.getElementById("PASSWORD").focus();//No I18N
            }
            else
            {
                document.getElementById("DOMAINCONTROLLER").value= "";//No I18N
                document.getElementById("SECDOMAINCONTROLLER").value= "";//No I18N
                document.getElementById("LOGINNAME").value= "";//No I18N
                document.getElementById("DOMAINCONTROLLER").focus();//No I18N
            }
        });
    }
}

function updatePrivateKeyAssociationView(key_id)
{
    redirectUrl("Settings/SSH/UpdateKeyView/"+key_id); //No I18N
}

function showAssociateMapper(keyName,key_id)
{
    sessionStorage.setItem("keyname",keyName);//NO I18N
    redirectUrl("SSHMgmt/ShowAssociateMapper/"+key_id); //No I18N
}

function showSelectView()
{
    if(document.getElementById("ACC_LEVEL").value !== "Administrator")
    {
        document.getElementById("full_view").className="";
        if(!document.getElementById("isssh").checked && !document.getElementById("isssl").checked)
        {
                document.getElementById("isssh").checked=true;
        }
        isresourceGroup();
        selectResType();
    }
    else
    {
        document.getElementById("operator_view").className="hide";
        document.getElementById("full_view").className="hide";
        document.getElementById("ResourceUserSelection").className="hide";        
        document.getElementById("sslSelection").className="hide";        
        document.getElementById("resourceGroupSelection").className="hide";
        document.getElementById("userGroupSelection").className="hide";
    }
    
}

function isresourceGroup()
{
    if(document.getElementById("RGroup").checked)
    {
        document.getElementById("resourceGroupSelection").className="";
        document.getElementById("userGroupSelection").className="hide";
        document.getElementById("ResourceUserSelection").className="hide";        
        
    }
    else if(document.getElementById("UGroup").checked)
    {
        document.getElementById("userGroupSelection").className="";
        document.getElementById("resourceGroupSelection").className="hide";
        document.getElementById("ResourceUserSelection").className="hide";        
    }
    else
    {
//        if(App.ApplicationController.isFULL)
//        {
//            document.getElementById("full_view").className="";
//        }
//        else if(App.ApplicationController.isSSH)
//        {
//            document.getElementById("ResourceUserSelection").className="";        
//            document.getElementById("isssh").checked=true;
//        }
//        else if(App.ApplicationController.isSSL)
//        {
//            document.getElementById("sslSelection").className="";        
//            document.getElementById("isssl").checked=true;
//        }
//        document.getElementById("resourceGroupSelection").className="hide";
//        document.getElementById("userGroupSelection").className="hide";
//        selectResType();
        document.getElementById("userGroupSelection").className="hide";
        document.getElementById("resourceGroupSelection").className="hide";
            document.getElementById("ResourceUserSelection").className="";        
        }
    
}

function selectResType()
{
    if(document.getElementById("isssl").checked)
    {
        document.getElementById("sslSelection").className="";        
    }
    else
    {
        document.getElementById("sslSelection").className="hide";        
    }
    if(document.getElementById("isssh").checked)
    {
        document.getElementById("operator_view").className="";
        isresourceGroup();
    }
    else
    {
        document.getElementById("ResourceUserSelection").className="hide";        
        document.getElementById("userGroupSelection").className="hide";
        document.getElementById("resourceGroupSelection").className="hide";
        document.getElementById("operator_view").className="hide";
    }
}

function displayKeyRotationAuditStatus(params,pgNumber,pgSel)
 {
    var ajaxRequestUrl = '/api/pki/ssh/getKeyRotationAuditStatus'; //No I18N
                getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                          
                        var colNamesList = ['KEYROTATIONID',I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.general.username'),I18N.getMsg('js.commonstr.status'),I18N.getMsg('js.commonstr.description'),I18N.getMsg('js.table.search')]; //No I18N
                        var colModelList = [
                                {name: 'KEYROTATIONID', index: 'KEYROTATIONID',hidden:true},//No I18N
                                {name: 'RESOURCE NAME', index: 'RESOURCE NAME'}, //No I18N
                                {name: 'USER NAME', index: 'USER NAME'}, //No I18N
                                {name: 'STATUS', index: 'STATUS',formatter:'progressStatusFormatter'}, //No I18N
                                {name: 'DESCRIPTION', index: 'DESCRIPTION'}, //No I18N
                                { name: 'search',width:'40px',sortable: false,search:false,fixed:true}//NO I18N
                        ];
                        var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
                        isAutoRefresh=jsonData.autoRefresh;
                        loadJQgridWithData("#KeyRotationStatusDetailsList", jsonData.detailedKeyRotationAudit, colNamesList, colModelList, "", "#KeyRotationStatusDetailsListPager", "",defaultOptions);//No I18N
                        if(pgNumber!=undefined)
                        {
                            $("#KeyRotationStatusDetailsList").trigger("reloadGrid",[{page:pgNumber,rowNum: pgSel}]);
                        }                        
		});
            if(!kmpStandAlone){
                if(App.SettingsCommonController.keyStateId==1)
                {
                    selectKMPTab("assosiation_audit");//No I18N
                }else{
                    selectKMPTab("rotation_audit");//No I18N
 }
            }                            
 }
 
 function exportSshKey(key_id,user_id)
{
    var requestUrl = '/api/pki/ssh/checkIsAccessControlEnabledForKey?keyId='+key_id; //No I18N
    getAjaxApiRequest(requestUrl,"",function(jsonData){
               if(jsonData.isAccessible===true)
               {
                    var ajaxRequestUrl = '/api/pki/ssh/exportSSHKeys?keyId='+key_id; //No I18N
                    if(user_id!=undefined)
                        {
                            ajaxRequestUrl +='&userId='+user_id;//No I18N
                        }
                    if (!window.location.origin) {
                        window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '');
                    }
                    location.href=window.location.origin+ajaxRequestUrl;
               }
               else
               {
                    messageNotification("messageNotifyFailure",I18N.getMsg('js.sshkeysexport.accesscontrolEnabled'));//No I18N
               }
            });
}

function exportAccountKey(account_id)
{
    var ajaxRequestUrl = '/api/pki/letsencrypt/exportAccountKey?account_id='+account_id; //No I18N
    if (!window.location.origin) {
        window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '');
    }
    location.href=window.location.origin+ajaxRequestUrl;
}

function changeAlgLength()
{
    var keyType=document.getElementById("keyType").value;//NO I18N
    var lengthSelect = $("select[name='length']");//NO I18N
    var lengthOptions = lengthSelect.children('option');//NO I18N
    if(keyType==="SSH2_DSA")
    {
        lengthOptions.filter(function(i){ return i == 0}).appendTo(lengthSelect.empty());
    }
    else
    {
        $("#length").append(new Option("2048", "2048"));//NO I18N
        $("#length").append(new Option("4096", "4096"));//NO I18N
    }
}

function toggleDiv(divName1,divName2)
{
    $("#"+divName1).toggle();
    if(divName2!==undefined || divName2!=="")
    {
        $("#"+divName2).toggle();
    }
}

function changeTimeFilter(sValue)
{
   var selectOptions= new Array('daily','weekly','monthly');
   for(var i=0;i<selectOptions.length;i++)
   {
          if(selectOptions[i]==sValue)
       	  {
                   $("#"+selectOptions[i]).show();
          }
          else
          {
                    $("#"+selectOptions[i]).hide();
          }
   }
}

//function enableMaintainBckUps(checkBox)
//{
//   if(checkBox.checked)
//   {
//       document.getElementById("backUpDur").disabled = false;
//   }
//   else
//   {
//       document.getElementById("backUpDur").disabled = true;
//   }
//}

function keyAssociationProcess(grid,appl)
{
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var isPass=false;
            var app=appl.get('controllers.application');
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.sshkey.selectOneKey')); //No I18N
                return;
            }
            else if(selRowIds.length>1)
            {
                showAlert(I18N.getMsg('js.sshkey.selectOneKey')); //No I18N
                return;                
            }
            $.each(selRowIds, function()
            {
                var id = this;
                isPass = grid.jqGrid('getCell', id, 'isPassphrase'); //No I18N
                App.SettingsUserController.key_id=grid.jqGrid('getCell', id, 'KeyID'); //No I18N
                App.SettingsCommonController.keyName=grid.jqGrid('getCell', id, 'KeyName'); //No I18N
            });
            if(isPass==="true")
            {
                app.send('opendialog','EditPassPhrase');//NO I18N
            }
            else
            {
                app.send('opendialog','AssociateKeyView');//NO I18N
            }
}

function UserToKeyDisassociation(user_id,key_ids)
{
    var reqparams="key_ids="+key_ids+"&user_id="+user_id+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N         
    var reqUrl="/api/pki/ssh/keyDissociationRemotely";//No I18N 
    getAjaxApiRequest(reqUrl,reqparams,function(jsonData){
        if(jsonData.Status=="Success")
        {
            messageNotification("messageNotifySuccess",jsonData.Message);//No I18N  
        }
        else
        {
            messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
        }
        }); 
    
}

function keyDisassociationProcess(grid,appl)
{
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var key_id="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.sshkey.selectOneKey')); //No I18N
                //document.getElementById("Asso_close").click();//NO I18N
                return;
            }
            else if(selRowIds.length>1)
            {
                showAlert(I18N.getMsg('js.sshkey.selectOneKey')); //No I18N
                document.getElementById("Asso_close").click();//NO I18N
                return;                
            }
            key_id=grid.jqGrid('getCell',selRowIds,'KeyID') //No I18N 
            var reqUrl="/api/pki/ssh/getResourceUsersWithKey";//No I18N
            var reqParams="KeyId="+key_id; //No I18N 
            var app=appl.get('controllers.application');
            getAjaxApiRequest(reqUrl,reqParams,function(jsonData){
                if(jsonData.data.length===0)
                {
                    showAlert(I18N.getMsg('js.sshkeydisassociation.noUsersAssociated'));//NO I18N
                }
                else if(jsonData.data.length===1 && jsonData.data.get(0).children.length===1)
                {
                    var resource=jsonData.data.get(0).text;
                    var user=jsonData.data.get(0).children.get(0).text;  
                    var userid=jsonData.data.get(0).children.get(0).id;
                    vConfirmation(I18N.getMsg('js.vconfirmation.userDissociation.DoYoureallywanttodisassociatetheuser',new Array(user,resource)),function(){//NO I18N
                        singleKeyDisassociation(key_id,userid);
                        
                    });
                }
                else
                {
                    app.send('opendialog','DissociateKeyToUserView');//NO I18N
                }
            });
}


function singleKeyDisassociation(key_id,userid)
{
            var reqParams="key_ids="+key_id+"&user_id="+userid+"&pmpcp="+Get_Cookie('pmpcc'); //No I18N
            var reqUrl="/api/pki/ssh/keyDissociationRemotely";//No I18N 
            getAjaxApiRequest(reqUrl,reqParams,function(jsonData){
                if(jsonData.Status=="success"||jsonData.Status=="Success")
                {
                    messageNotification("messageNotifySuccess",I18N.getMsg("js.sshkey.keydissociationstarted"));//No I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg('js.sshkey.keydissociationfailed'));//No I18N
                }          
            
            });
}

function getAssociatedKeyToUser(user_id)
{
    var ajaxRequestUrl = '/api/pki/ssh/getKeyAssociatedToUser'; //No I18N
    var data="user_id="+user_id;//No I18N
    getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
        $(".popover-content").html(jsonData.Keys)//No I18N
        $(".arrow").hide();//No I18N
        document.querySelector('.popover').style.maxWidth = "400px" ;//No I18N
    });    
}

function getKeyPassPhrase(key_id)
{
    var ajaxRequestUrl = '/api/pki/ssh/showPassPhrase'; //No I18N
    var data="key_id="+key_id;//No I18N
    getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
        if(jsonData.passphrase!=undefined)
        {
        $(".popover-content").html(jsonData.passphrase)//No I18N
        $(".arrow").hide();//No I18N
        document.querySelector('.popover').style.maxWidth = "400px" ;//No I18N
        setTimeout(function () {
            $('.popover').popover('hide');//NO I18N
        }, 5000);
        }
        else
        {
            $('.popover').popover('hide');//NO I18N
            if(jsonData.Status=="Failure")
            {
                messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
            }
        }
    }); 
}

function allUsersList(jsonData,tableName,pagerName,onSelection)
{
    if(onSelection==undefined)
    {
        onSelection="AllResourceUsers";//No I18N
    }
    var colNamesList = ['User ID','','',I18N.getMsg('js.general.username'),I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.associated.keys'),'',I18N.getMsg('js.table.search')]; //No I18N
    var defaultOptions;
    if(kmpStandAlone)
    {
        colNamesList = ['User ID','','',I18N.getMsg('js.general.username'),I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.associated.keys'),'','','','','','','','','',I18N.getMsg('js.table.search')]; //No I18N
    if(App.ApplicationController.isAdmin===true)
    {
    var colModelList = [
            { name: 'UserID', index: 'UserID',hidden:true}, //No I18N
            { name: 'isCredAvailable', index: 'isCredAvailable',hidden:true},//No I18N
            { name: 'isCredAvailable', index: 'isCredAvailable',formatter:'AllResourceUserCredentialsFormatter',search:false,width:'30px',classes:"pointer",fixed:true}, //No I18N
            { name: 'UserName', index: 'UserName',formatter:'associationGraphFormatter',width:"100"}, //No I18N
            { name: 'ResourceName', index: 'ResourceName',width:"150"}, //No I18N
            { name: 'asso_keys', index: 'asso_keys',width:"100",formatter:'moreKeyAssoToUserFormatter'}, //No I18N
            { name: 'isAssociate', index: 'isAssociate',hidden:true}, //No I18N
            { name: 'terminal',index:'terminal',hidden:true},//NO I18N
            { name: 'terminal', index: 'terminal',formatter:'openTerminalFormatter',search:false,width:'30px',classes:"pointer",fixed:true}, //No I18N
            { name: 'isDissociate', index: 'isDissociate',hidden:true}, //No I18N
            { name: 'isDissociate', index: 'isDissociate',formatter:'disassociateFormatter',search:false,width:'30px', classes:"pointer",fixed:true,hidden:true},//NO I18N
            { name: 'Dir_Path', index:'Dir_Path',hidden:true},//NO I18N
            { name: 'EditPath', index: 'EditPath',search:false,formatter:'editPathFormatter',width:'30px',fixed:true,hidden:true}, //No I18N
            { name: 'AuthFile', index: 'AuthFile',search:false,formatter:'authFileFormatter',width:'30px',classes:"pointer",fixed:true,hidden:true},//NO I18N
            { name: 'EditAuthFile', index: 'EditAuthFile',search:false,formatter:'editAuthFileFormatter',width:'30px',fixed:true}, //No I18N
            { name: 'search',width:'30px',sortable: false,search:false,fixed:true,fixed:true}//NO I18N
    ];
    defaultOptions={multiselect:true,rowNumNeeded:false,sortName:"isAssociate",sortOrder:"desc",searchOption:true};//No I18N
    }
    else
    {
        var colModelList = [
            { name: 'UserID', index: 'UserID',hidden:true}, //No I18N
            { name: 'isCredAvailable', index: 'isCredAvailable',hidden:true},//No I18N
            { name: 'isCredAvailable', index: 'isCredAvailable',formatter:'AllResourceUserCredentialsFormatter',search:false,width:'30px',classes:"pointer",fixed:true}, //No I18N
            { name: 'UserName', index: 'UserName',formatter:'associationGraphFormatter',width:"100"}, //No I18N
            { name: 'ResourceName', index: 'ResourceName',width:"150"}, //No I18N
            { name: 'asso_keys', index: 'asso_keys',width:"100",formatter:'moreKeyAssoToUserFormatter'}, //No I18N
            { name: 'isAssociate', index: 'isAssociate',hidden:true}, //No I18N
            { name: 'terminal',index:'terminal',hidden:true},//NO I18N
            { name: 'terminal', index: 'terminal',formatter:'openTerminalFormatter',search:false,width:'30px',classes:"pointer",fixed:true}, //No I18N
            { name: 'isDissociate', index: 'isDissociate',hidden:true}, //No I18N
            { name: 'Dir_Path', index:'Dir_Path',hidden:true},//NO I18N
            { name: 'isDissociate', index: 'isDissociate',formatter:'disassociateFormatter',search:false,width:'80px', classes:"pointer",hidden:true},//NO I18N
            { name: 'EditPath', index: 'EditPath',search:false,formatter:'editPathFormatter',width:'30px',fixed:true,hidden:true}, //No I18N
            { name: 'AuthFile', index: 'AuthFile',width:'30px',fixed:true,hidden:true},//NO I18N
            { name: 'EditAuthFile', index: 'EditAuthFile',search:false,formatter:'editAuthFileFormatter',width:'30px',fixed:true,hidden:true}, //No I18N
            { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
    ];
    defaultOptions={multiselect:false,rowNumNeeded:false,sortName:"isAssociate",sortOrder:"desc",searchOption:true};//No I18N
    }
    }else{
        var colModelList = [
            { name: 'UserID', index: 'UserID',hidden:true}, //No I18N
            { name: 'isCredAvailable', index: 'isCredAvailable',hidden:true},//No I18N
            { name: 'isCredAvailable', index: 'isCredAvailable',hidden:true}, //No I18N
            { name: 'UserName', index: 'UserName',formatter:'associationGraphFormatter',width:"100"}, //No I18N
            { name: 'ResourceName', index: 'ResourceName',width:"150"}, //No I18N
            { name: 'asso_keys', index: 'asso_keys',width:"100",formatter:'moreKeyAssoToUserFormatter'}, //No I18N
            { name: 'isAssociate', index: 'isAssociate',hidden:true}, //No I18N
            { name: 'search',width:'30px',sortable: false,search:false,fixed:true,fixed:true}//NO I18N
    ];
    defaultOptions={multiselect:true,rowNumNeeded:false,sortName:"isAssociate",sortOrder:"desc",searchOption:true};//No I18N
    }
    
    loadJQgridWithData("#"+tableName, jsonData.AllResourceUsers, colNamesList, colModelList, "", "#"+pagerName, onSelection,defaultOptions);//No I18N

}

function showPopover()
{
    //For more action popup for All resource Users view
    var isVisible = false;
    
    var hideAllPopovers = function() {
       $('.popover').each(function() {//No I18N
            $(this).popover('hide');//No I18N
        });  
    };    
    $('[data-toggle="popover"]').popover({//No I18N
        html:true,
        trigger: 'manual'//No I18N
    }).on('click', function(e) {//No I18N
        // if any other popovers are visible, hide them
        if(isVisible) {
            hideAllPopovers();
        }

        $(this).popover('show');//No I18N
        
        // handle clicking on the popover itself
        $('.popover').off('click').on('click', function(e) {//No I18N
            e.stopPropagation(); 
        });

        isVisible = true;
        e.stopPropagation();
    });
    $(document).on('click', function(e) {//No I18N
        hideAllPopovers();
        isVisible = false;
    });    
}

function getSshKeysList(jsonData,tableName,pagerName,showpass)
{
        var colNamesList = ['Key Id','',I18N.getMsg('js.ssh.keyname'),'',I18N.getMsg('js.ssh.keyType'),I18N.getMsg('js.ssh.keylength'),I18N.getMsg('js.ssh.fingerprint'),I18N.getMsg('js.general.createdby'),I18N.getMsg('js.ssh.age'),I18N.getMsg('js.ssh.keypassphrase'),'','','','',I18N.getMsg('js.table.search')]; //No I18N
        var colModelList = [
                { name: 'KeyID', index: 'KeyID',hidden:true}, //No I18N
                { name: 'KeyName', index: 'KeyName',hidden:true,search:false}, //No I18N
                { name: 'KeyName', index: 'KeyName',formatter:"keyLinkFormatter",width:'150px'}, //No I18N
                { name: 'keyLink', index: 'keyLink',width:'60px',hidden:true}, //No I18N
                { name: 'KeyType', index: 'KeyType',width:'60px'}, //No I18N
                { name: 'KeyLength', index: 'KeyLength',width:'70px'}, //No I18N
                { name: 'FingerPrint', index: 'FingerPrint',width:'200px'}, //No I18N
                { name: 'CreatedBy', index: 'CreatedBy',width:'100px'}, //No I18N
                { name: 'CreationTime', index: 'CreationTime',width:'50px'}, //No I18N
                { name: 'isPassphrase', index: 'isPassphrase',hidden:true}, //No I18N
                { name: 'PassPhrase', index: 'PassPhrase', hidden:true},//NO I18N
                { name: 'showPassPhrase',index: 'showPassPhrase',formatter:'showPassPhraseFormatter',width:'30px',align:'center',search:false,fixed:true,hidden:showpass},//NO I18N
                { name: 'placeKey', index:'placeKey',formatter:'placeKeyFormatter',width:'30px',align:'center',search:false,fixed:true},//NO I18N
                { name: 'Export', index: 'Export',formatter:'exportKeyFormatter',width:'30px',align:'center',search:false,fixed:true}, //No I18N
                { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
        ];
        var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
        loadJQgridWithData("#"+tableName, jsonData.SSHKeys, colNamesList, colModelList, "", "#"+pagerName, "SSHKeyAssociate",defaultOptions);//No I18N
}

function getdefaultSshKeysList(jsonData,tableName,pagerName)
{
        var colNamesList = ['Key Id','',I18N.getMsg('js.ssh.keyname'),'',I18N.getMsg('js.ssh.keyType'),I18N.getMsg('js.ssh.keylength'),I18N.getMsg('js.ssh.fingerprint'),I18N.getMsg('js.general.createdby'),I18N.getMsg('js.ssh.age'),I18N.getMsg('js.table.search')]; //No I18N
        var colModelList = [
                { name: 'KeyID', index: 'KeyID',hidden:true}, //No I18N
                { name: 'KeyName', index: 'KeyName',hidden:true,search:false}, //No I18N
                { name: 'KeyName', index: 'KeyName',formatter:"keyLinkFormatter",width:'150px'}, //No I18N
                { name: 'keyLink', index: 'keyLink',width:'60px',hidden:true}, //No I18N
                { name: 'KeyType', index: 'KeyType',width:'60px'}, //No I18N
                { name: 'KeyLength', index: 'KeyLength',width:'70px'}, //No I18N
                { name: 'FingerPrint', index: 'FingerPrint',width:'200px'}, //No I18N
                { name: 'CreatedBy', index: 'CreatedBy',width:'100px'}, //No I18N
                { name: 'CreationTime', index: 'CreationTime',width:'50px'}, //No I18N
                { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
        ];
        var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
        loadJQgridWithData("#"+tableName, jsonData.SSHKeys, colNamesList, colModelList, "", "#"+pagerName, "SSHKeyAssociate",defaultOptions);//No I18N
}

function refreshMatchingUsers()
{
    var CRITERIA_LIST = new Array();
	var emptyValue = false;
	$("#critetriaTable").find('tr').each(function (i, el) {
		var id = $(this).attr("id");
		var cri = {
				
		};
		cri.Condition = $("#CONDITION_"+id).val();
		cri.Field = $("#PARAMETER_"+id).val();
		if($("#COMPARATOR_"+id).val() == undefined || $("#COMPARATOR_"+id).val() == "") {
			cri.Comparator = "and"; // No I18N
		} else {
			cri.Comparator = $("#COMPARATOR_"+id).val();
		}
		
		var val = $("#PATTERN_"+id).val();
		if(val == "") {
			emptyValue = true;
		}
		cri.Value = val;
		CRITERIA_LIST.push(cri);
	});
	if(emptyValue == true) {
		showAlert(I18N.getMsg('js.usersGroup.emptyvaluesalert')); // No I18N
		return;
	}
	$("#matchingUsers").show();
	$('#PKIMatchingUsersList').jqGrid('GridUnload');//No I18N
        var ajaxRequestUrl = '/api/pki/ssh/getmatchinguserslist'; //No I18N
        var data="CRITERIA_LIST="+JSON.stringify(CRITERIA_LIST);//No I18N
        getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
            allUsersList(jsonData,"PKIMatchingUsersList","PKIMatchingUsersPager","matchingUsers")//No I18N
            });
}

function refreshMatchingKeys()
{
    var CRITERIA_LIST = new Array();
	var emptyValue = false;
        var exit=false;
	$("#critetriaTable").find('tr').each(function (i, el) {
		var id = $(this).attr("id");
		var cri = {
				
		};
		cri.Condition = $("#CONDITION_"+id).val();
		cri.Field = $("#PARAMETER_"+id).val();
		if($("#COMPARATOR_"+id).val() == undefined || $("#COMPARATOR_"+id).val() == "") {
			cri.Comparator = "and"; // No I18N
		} else {
			cri.Comparator = $("#COMPARATOR_"+id).val();
		}
		
		var val = $("#PATTERN_"+id).val();
		if(val == "") {
			emptyValue = true;
		}
		cri.Value = val;
                if(cri.Field==="ENCRYPTION_BITS")
                {
                    var numbers = /^[0-9]+$/;  
                    if(!val.match(numbers))  
                    {
                        showAlert(I18N.getMsg("keylength.numberinput.alert"));//No I18N
                        exit=true;
                        return;
                    }
                }  
		CRITERIA_LIST.push(cri);
	});
        if(exit)
        {
            return;
        }
	if(emptyValue == true) {
		showAlert(I18N.getMsg('js.keysGroup.criteriaempty')); // No I18N
		return;
	}
	$("#matchingKeys").show();
	$('#PKIMatchingKeysList').jqGrid('GridUnload');//No I18N
        var ajaxRequestUrl = '/api/pki/ssh/getmatchingkeyslist'; //No I18N
        var data="CRITERIA_LIST="+JSON.stringify(CRITERIA_LIST);//No I18N
        getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
            getSshKeysList(jsonData,"PKIMatchingKeysList","PKIMatchingKeysPager",false)//No I18N
            });
}


function fillUserDetails(jsonData)
{
    if(jsonData.selectedResourceGroup!==undefined)
    {
        for (var col in jsonData.selectedResourceGroup) {
            $('#SELECTEDRESOURCEGROUPS').append($('<option value="'+ col +'">'+ jsonData.selectedResourceGroup[col] +'</option>'));  //No I18N
        }
    }else{
        document.getElementById("RGroupLabel").className="hide";//No I18N
    }
    if(jsonData.unSelectedResourceGroup!==undefined)
    {
        for (var col in jsonData.unSelectedResourceGroup) {
            $('#LISTOFRESOURCEGROUPS').append($('<option value="'+ col +'">'+ jsonData.unSelectedResourceGroup[col] +'</option>'));  //No I18N
            groupContents[col]=jsonData.unSelectedResourceGroup[col];
        }
    }
    if(jsonData.selectedUserGroup!==undefined)
    {
        for (var col in jsonData.selectedUserGroup) {
            $('#SELECTEDUSERGROUPS').append($('<option value="'+ col +'">'+ jsonData.selectedUserGroup[col] +'</option>'));  //No I18N
        }
    }else{
        document.getElementById("UGroupLabel").className="hide";//No I18N
    }
    if(jsonData.unSelectedUserGroup!==undefined)
    {
        for (var col in jsonData.unSelectedUserGroup) {
            $('#LISTOFUSERGROUPS').append($('<option value="'+ col +'">'+ jsonData.unSelectedUserGroup[col] +'</option>'));  //No I18N
            userGroupContents[col]=jsonData.unSelectedUserGroup[col];
        }
    }
    if(jsonData.LISTEDDEVICES!==undefined)
    {
        baseContents={};
        res_array=jsonData.LISTEDDEVICES;
        var sel=document.getElementById("LISTOFDEVICES");//No I18N
        for (var i=0; i<res_array.length; i++)
        {
            var opt=document.createElement('option');//No I18N
            opt.innerHTML = res_array[i].res_name;
            opt.value = res_array[i].res_id;
            sel.appendChild(opt);
            baseContents[res_array[i].res_id]=res_array[i].res_name;
        }
    }else{
        document.getElementById("issslLabel").className="hide";//No I18N
    }
    if(jsonData.SELECTEDDEVICES!==undefined)
    {
        //document.getElementById("sslSelection").className="";
        //document.getElementById("isssl").checked=true;
        var res_array=jsonData.SELECTEDDEVICES;
        var sel=document.getElementById("SELECTEDDEVICES");//No I18N
        for (var i=0; i<res_array.length; i++)
        {
            var opt=document.createElement('option');//No I18N
            opt.innerHTML = res_array[i].res_name;
            opt.value = res_array[i].res_id;
            sel.appendChild(opt);
        }                        
    }
     if(jsonData.ROLES!==undefined)
    {
        var res_array=jsonData.ROLES;
        var sel=document.getElementById("ACC_LEVEL");//No I18N
        for (var i=0; i<res_array.length; i++)
        {
            var opt=document.createElement('option');//No I18N
            opt.innerHTML = res_array[i];
            opt.value = res_array[i];
            sel.appendChild(opt);
        }                        
    }
    if(jsonData.LISTEDGROUPS!==undefined)
    {
        sslGroupContents ={};
        res_array=jsonData.LISTEDGROUPS;
        var sel=document.getElementById("LISTOFGROUPS");//No I18N
        for (var i=0; i<res_array.length; i++)
        {
            var opt=document.createElement('option');//No I18N
            opt.innerHTML = res_array[i].res_name;
            opt.value = res_array[i].res_id;
            sel.appendChild(opt);
            sslGroupContents[res_array[i].res_id]=res_array[i].res_name;
        }
    }
    if(jsonData.SELECTEDGROUPS!==undefined)
    {
        var res_array=jsonData.SELECTEDGROUPS;
        var sel=document.getElementById("SELECTEDGROUPS");//No I18N
        for (var i=0; i<res_array.length; i++)
        {
            var opt=document.createElement('option');//No I18N
            opt.innerHTML = res_array[i].res_name;
            opt.value = res_array[i].res_id;
            sel.appendChild(opt);                            
        }                        
    }
    if(jsonData.data!==undefined)
    {
        generateResourceUserTree(jsonData.data);
        //Initial SSH resource Visible check
//        if(jsonData.data.isUser)
//        {
//            document.getElementById("isssh").checked=true;
//            document.getElementById("ResourceUserSelection").className="";   
//        }
        }else{
        document.getElementById("singleLabel").className="hide";//No I18N
        document.getElementById("issshLabel").className="hide";//No I18N
        }
    }

function placeKeyFileChange(id1,id2)
{
   if(document.getElementById(id1).checked)
   {
       document.getElementById(id2).disabled=false;
   }
   else
   {
       document.getElementById(id2).disabled=true;
   }
}

function showoptions()
{
    if(document.getElementById("showusersvisible").className==="icon-plus fontIcon-disable")
    {
        document.getElementById("showusersvisible").className="icon-minus fontIcon-disable";//NO I18N
        document.getElementById("showoptions").checked=true;
        $('#options').css('display','block');        
    }
    else
    {
        document.getElementById("showusersvisible").className="icon-plus fontIcon-disable";//NO I18N
        document.getElementById("showoptions").checked=false;
        $('#options').css('display','none');
    }
}

function radiusEnable(status)
{   
    var url = "/api/pki/settings/enableRadius";//No I18N
    var params = "status="+status+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
    getAjaxApiRequest(url,params,function(jsonData){
        if(jsonData.Status ===  "Success")
        {
            messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
            changeRadiusButtons();
        }
        else
        {
            messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
        }
    });
}

function changeRadiusButtons()
{
   if(document.getElementById("radius_status").innerHTML==="Enabled")
    {
        $("#enableRadius").show();
        $("#disableRadius").hide();
        document.getElementById("radius_status").innerHTML="Disabled";//NO I18N
        $("#radius_status").css("color","red");
    }
    else
    {
        $("#disableRadius").show();
        $("#enableRadius").hide();
        document.getElementById("radius_status").innerHTML="Enabled";//NO I18N
        $("#radius_status").css("color","#0EB07A");        
    }
}

function getKeyAuthFile()
{
    var ajaxRequestUrl='/api/pki/ssh/getKeyAuthFile';//NO I18N
    var params = "userid="+App.SettingsCommonController.user_id;//NO I18N
    getAjaxApiRequest(ajaxRequestUrl,params, function(jsonData){ 
            if(jsonData.Status==="Success")
            {                
                document.getElementById("editAuthFileView").click();
                //$("#contentDiv").text(jsonData.keyFile);
                document.getElementById("contentDiv").innerHTML=jsonData.keyFile;
            }
            else
            {
                messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
            }
    });        
}

function dissociateUserToKey()
{
    var grid = jQuery("#PKIAllResourceUsers"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) 
    {
        showAlert(I18N.getMsg('js.userselection.selectoneuseronly')); //No I18N
        return;
    }
    var check = grid.jqGrid('getCell',selRowIds,'isDissociate');//NO I18N
    if(check === "true")
    {
        var user_id = grid.jqGrid('getCell', selRowIds,'UserID'); //No I18N
        App.SettingsCommonController.user_id=user_id;
        document.getElementById("deAssociate").click();
    }
    else
    {
        showAlert(I18N.getMsg('js.dissociation.nokeysassociated'));//NO I18N
        return;
    }
}

function transferFile()
{
    var grid = jQuery("#PKIAllResourceUsers"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) 
    {
        showAlert(I18N.getMsg('js.userselection.selectoneuseronly')); //No I18N
        return;
    }
    var keyAssociated = grid.jqGrid('getCell',selRowIds,'isAssociate');//NO I18N
    if(keyAssociated=="false")
    {
        showAlert(I18N.getMsg("js.dissociation.nokeysassociated"));//NO I18N
        return;
    }
    var user_id = grid.jqGrid('getCell', selRowIds,'UserID'); //No I18N
    var path = grid.jqGrid('getCell',selRowIds,'Dir_Path');//NO I18N
    App.SettingsCommonController.user_id=user_id;
    App.SettingsCommonController.dir_path=path;
    document.getElementById("transferFile").click();
}

function editPath()
{
    var grid = jQuery("#PKIAllResourceUsers"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) 
    {
        showAlert(I18N.getMsg('js.userselection.selectoneuseronly')); //No I18N
        return;
    }
    var user_id = grid.jqGrid('getCell', selRowIds,'UserID'); //No I18N
    var path = grid.jqGrid('getCell',selRowIds,'Dir_Path');//NO I18N
    App.SettingsCommonController.user_id=user_id;
    App.SettingsCommonController.dir_path=path;
    document.getElementById("editPath").click();
}

function addCommand()
{
    var grid = jQuery("#PKIAllResourceUsers"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) 
    {
        showAlert(I18N.getMsg('js.userselection.selectoneuseronly')); //No I18N
        return;
    }
    var check = grid.jqGrid('getCell',selRowIds,'isDissociate');//NO I18N
    if(check === "true")
    {
        var user_id = grid.jqGrid('getCell', selRowIds,'UserID'); //No I18N
        App.SettingsCommonController.user_id=user_id;
        document.getElementById("editAuthFile").click();
    }
    else
    {
        showAlert(I18N.getMsg('js.dissociation.nokeysassociated'));//NO I18N
        return;
    }
}

function changeKeyFileNames()
{
    var privateKeyFileName;
    var publicKeyFileName;
    if(document.getElementById("filenamekeyname").checked)
    {
        if(App.SettingsCommonController.keyType === "ssh-rsa")
        {
            privateKeyFileName=App.SettingsCommonController.keyName;
            publicKeyFileName=App.SettingsCommonController.keyName+".pub";//NO I18N
        }
        else
        {
            privateKeyFileName=App.SettingsCommonController.keyName;
            publicKeyFileName=App.SettingsCommonController.keyName+".pub";//NO I18N
        }
    }
    else
    {
        if(App.SettingsCommonController.keyType === "ssh-rsa")
        {
            privateKeyFileName="id_rsa";//NO I18N
            publicKeyFileName="id_rsa.pub";//NO I18N
        }
        else
        {
            privateKeyFileName="id_dsa";//NO I18N
            publicKeyFileName="id_dsa.pub";//NO I18N
        }
    }
    document.getElementById("privFileName").value=privateKeyFileName;
    document.getElementById("pubFileName").value=publicKeyFileName;
}

function checkFileExtension(e) {
    var file = e.target.files[0].name;
    var file_check = file.split(".");
    var extension = file_check[file_check.length-1];
    extension = extension.toLowerCase();
    if(extension === "pfx" || extension === "p12" || extension === "pkcs12" || extension==="jks" || extension==="keystore")
    {
        $("#password").show();
        $("#keyandintermediate").hide();
    }
    else if(extension === "cer" || extension === "der" || extension === "crt" || extension === "pem")
    {
        $("#password").hide();
        $("#keyandintermediate").show();
    }
    else
    {
        showAlert(I18N.getMsg("settings.servercertificate.fileformathastobe"));//NO I18N
        var input = $("#uploadCertFile");
        input.replaceWith(input.val('').clone(true));
        document.getElementById("filename").value="";
        return;
    }
}

function checkKeyFile(e)
{
    var file = e.target.files[0].name;
    var file_check = file.split(".");
    var extension = file_check[file_check.length-1];
    extension = extension.toLowerCase();
    if(extension!=="key" && extension!=="pem")
    {
        showAlert(I18N.getMsg("settings.servercertificate.keyfileformat"));//NO I18N
        var input = $("#uploadKeyFile");
        input.replaceWith(input.val('').clone(true));
        document.getElementById("keyname").value="";
        return;
    }
}

function checkIntermediate(e,id)
{
    var file = e.target.files[0].name;
    var file_check = file.split(".");
    var extension = file_check[file_check.length-1];
    extension = extension.toLowerCase();
    if(extension!=="cer" && extension!=="pem" && extension!=="der" && extension!=="crt")
    {
        showAlert(I18N.getMsg("settings.servercertificate.intercertformat"));//NO I18N
        var input = $("#"+id);
        input.replaceWith(input.val('').clone(true));
        document.getElementById(id+"name").value="";
        return;
    }
}
function addIntermediate()
{ 
    var value = document.getElementById("count").value;
    var newValue = parseInt(value)+1;
    var element = '<div id=\"intermediate'+newValue+'div\">'+//NO I18N
                        '<div class="form-group">'+//NO I18N
                            '<label for="inputEmail3" class="col-sm-2 control-label">'+I18N.getMsg('settings.servercertificate.intermediatecertificate')+'</label>'+//NO I18N
                            '<div class="col-sm-4">'+//NO I18N
                                '<div class="input-group"> '+//NO I18N
                                    '<span class="input-group-btn">'+//NO I18N
                                    '<span class="buttn buttn-default btn-file">'+//NO I18N
                                    'Browse <input type="file" id=\"intermediate'+newValue+'\"/>'+//NO I18N
                                    '</span>'+//NO I18N
                                    '</span>'+//NO I18N
                                    '<input class="form-control" type="text" id=\"intermediate'+newValue+'name\" readonly>'+//NO I18N
                                '</div>'+//NO I18N
                            '</div>'+//NO I18N
                            '<label class="col-sm-1 control-label" style="text-align:left"><span id=\"'+newValue+'\" onclick="deleteIntermediate(this.id)" class="glyphicon glyphicon-remove pointer"></span></label>'+//NO I18N
                            '<label class="control-label"><span onclick="addIntermediate()" id=\"'+newValue+'\" class="glyphicon glyphicon-plus pointer"></span></label>'+//NO I18N
                        '</div>'+//NO I18N
                        '<div class="form-group" id="schedule-mail-div">'+//NO I18N
                            '<label class="col-sm-2 control-label"></label>'+//NO I18N
                            '<div class="col-sm-4">'+//NO I18N
                                I18N.getMsg("settings.servercertificate.intercertformat1")+//NO I18N
                            '</div>'+//NO I18N
                        '</div>'+//NO I18N
                    '</div>';//NO I18N
    $("#keyandintermediate").append(element);
    document.getElementById("count").value = newValue;
}

function deleteIntermediate(value)
{
    var element = 'intermediate'+value+'div';//NO I18N
    $("#"+element).remove();
}

function showSelection(selection)
{
    document.getElementById("anywaycheck").checked=false;
    if(selection==="existing")
    {
        $("#existingSelection").show();
        $("#importCertificata").hide();
        document.getElementById("available").checked=true;
    }
    else
    {
        $("#importCertificata").show();
        $("#existingSelection").hide();
        document.getElementById("import").checked=true;
    }
}

function showVulPopUp(id,status)
{
    App.ReportController.id=id;
    document.getElementById("showPopUp").click();
}

function importServerCertificate()
{
    var req_url = '/api/pki/settings/serverCertificate?';//NO I18N
    var params="";   
    var fileData = new FormData();
    var mainFile;
    var onlyport="no";//NO I18N
    var port="6565";//NO I18N
    if(document.getElementById("import").checked)
    {
         var mainFileName = $("#filename").val();
         port=document.getElementById("serverPort").value;
         if(port==="" || validatePort(port))
         {
             showAlert(I18N.getMsg("server.port.validport"));//NO I18N
             return;
         }
         if(mainFileName==="")
         {
//             showAlert(I18N.getMsg("js.file.selectaFile"));//NO I18N
//             return;
                onlyport="yes";//NO I18N
         }
         if(mainFileName!=="")
         {
         var file_check = mainFileName.split(".");
         var extension = file_check[file_check.length-1];
         extension = extension.toLowerCase();
         if(extension === "pfx" || extension === "p12" || extension === "pkcs12" || extension==="jks" || extension==="keystore")
         {
             var password = document.getElementById("storepassword").value;
             if(password==="")
             {
                 showAlert(I18N.getMsg("js.Password.enterPassword"));//NO I18N
                 return;
             }
             var files = document.getElementById("uploadCertFile").files;
             mainFile = files[0];
             fileData.append("File", mainFile);//NO I18N
             var anyway="no";//NO I18N
             if(document.getElementById("anywaycheck").checked)
             {
                 anyway="yes";//NO I18N
             }
                params="Type=import&Cert_Type=store&FileName="+mainFileName+"&Password="+encodeURIComponent(password)+"&AnyWay="+anyway+"&port="+port+"&onlyport="+onlyport;//NO I18N
         }
         else if(extension === "cer" || extension === "der" || extension === "crt" || extension === "pem")
         {
             var keyName = document.getElementById("keyname").value;
             if(keyName==="")
             {
                 showAlert(I18N.getMsg("settings.servercertificate.selectkeyfile"));//NO I18N
                 return;
             }
             var files = document.getElementById("uploadCertFile").files;
             mainFile = files[0];
             fileData.append("File", mainFile);//NO I18N
             files = document.getElementById("uploadKeyFile").files;
             mainFile = files[0];
             fileData.append("File", mainFile);//NO I18N
             if(document.getElementById("intermediate1name").value!=="")
             {
                 var count = document.getElementById("count").value;
                 for(var i=1;i<=count;i++)
                 {
                     var id = "intermediate"+i;//NO I18N
                     if(document.getElementById(id+"name")!=null && document.getElementById(id+"name").value!=="")
                     {
                         var file = document.getElementById(id).files;
                         var f = file[0];
                         fileData.append("File",f);//NO I18N
                     }
                 }
             }
             var anyway="no";//NO I18N
             if(document.getElementById("anywaycheck").checked)
             {
                 anyway="yes";//NO I18N
            }
                params="Type=import&Cert_Type=cert&FileName="+mainFileName+"&AnyWay="+anyway+"&port="+port+"&onlyport="+onlyport;//NO I18N
         }
         }
         else
        {
            params="port="+port+"&onlyport="+onlyport;//NO I18N
        }
         req_url+=params;
         fileData.append("pmpcp",Get_Cookie('pmpcc'));//NO I18N
         getAjaxApiRequestForFile(req_url,fileData,null,null,false,function(jsonData){
                 document.getElementById("anywaycheck").checked=false;
                 if(jsonData.Status==="Success")
                 {
                     $('input').val('');                       
                     $("#serverPort").val(jsonData.Port);
                     messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                 }
                 else
                 {                    
                    if(jsonData.AnyWay==="yes")
                    {
                        vConfirmation(I18N.getMsg(jsonData.Message)+", Install Anyway ?",function(){//NO I18N
                            document.getElementById("anywaycheck").checked=true;
                            importServerCertificate();
                        });
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                    }
                 }
         });                
    }
    else
    {
         var ssl_id = document.getElementById("certificateList").value;
         if(ssl_id==="---select certificate---")
         {
             showAlert(I18N.getMsg("letsencrypt.renewrequest.selectonecert"));//NO I18N
             return;
         }
         var domainName = document.getElementById("certificateList").options[document.getElementById("certificateList").selectedIndex].text;              
         var anyway="no";//NO I18N
         if(document.getElementById("anywaycheck").checked)
         {
             anyway="yes";//NO I18N
         }                    
         port=document.getElementById("serverPort").value;
         if(port==="" || validatePort(port))
         {
             showAlert(I18N.getMsg("server.port.validport"));//NO I18N
             return;
         }
         params="SSL_ID="+ssl_id+"&Type=available&DomainName="+domainName+"&AnyWay="+anyway+"&port="+port+"&onlyport="+onlyport+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
         getAjaxApiRequest(req_url,params,function(jsonData){
         document.getElementById("anywaycheck").checked=false;
         if(jsonData.Status ===  "Success")
             {
                 messageNotification("messageNotifySuccess",jsonData.Message);//No I18N  
             }
             else
             {                
                if(jsonData.AnyWay==="yes")
                {
                    vConfirmation(I18N.getMsg(jsonData.Message)+", Install Anyway ?",function(){//NO I18N
                        document.getElementById("anywaycheck").checked=true;
                        importServerCertificate();
                    });
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
             }
         });    
    } 
}
function showNotificationMailDiv()
{
    if(document.getElementById("Email").checked)
    {
        $("#to_div").show();
    }
    else
    {
        $("#to_div").hide();
    }
}
function validatePort(port)
{
    if(port>=1&&port<=65535)
    {
        return false;
    }
    else
    {
        return true;
    }
}

function cmdbview()
{
    if(document.getElementById("enable").checked)
    {
        $("#sdpserver").show();
    }
    else
    {
        $("#sdpserver").hide();
    }
}

function hideparent()
{
    if(document.getElementById("showParent").checked)
    {
        $("#parent").show();
        $("#fetchAttributes").hide();
        $("#attributes").hide();
    }
    else
    {
        $("#parent").hide();
        $("#fetchAttributes").show();
        $("#attributes").show();
    }
}

function fetchAttributes()
{
    var reqUrl = "/api/pki/settings/fetchAttributes";//NO I18N
    var ciType="";
    ciType = document.getElementById("citype").value;
    if(ciType==="")
    {
        showAlert(I18N.getMsg("cmdb.alert.entercitype"));//NO I18N
        return;
    }
    var params="ci="+ciType;//NO I18N
    getAjaxApiRequest(reqUrl,params,function(jsonData){
       if(jsonData.Status==="Success")
       {           
           $("select option[value!='---Select Attribute---']").remove();
           var attributesArray = jsonData.Attributes;
           for(var i=0;i<attributesArray.length;i++)
           {
               var value = attributesArray[i];
               $("select").append(new Option(value[0],value[1]));
           }
       }
       else
       {
           messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
       }
    });
}

function removeCipher(element)
{
    var parent = element.parentNode;
    var ua = window.navigator.userAgent;
    var msie = ua.indexOf('MSIE ');//IE version <10
    var trident = ua.indexOf('Trident/');//IE version 11
    if (msie > 0 || trident > 0) {
        parent.removeNode(true);
    } else {
    parent.remove();    
}
}

function addCipher()
{
    var cipher = document.getElementById("addCipher").value;
    if(cipher=="")
    {
        showAlert(I18N.getMsg("settings.addcipher.empty"));//NO I18N
        return;
    }
    var ciphers = $.trim($("#contentDiv").text());//NO I18N
    if(ciphers.indexOf(cipher)!==-1)
    {
        showAlert(I18N.getMsg("settings.addcipher.already"));//NO I18N
        return;
    }
    var element = '<span class="cipherhover" style="cursor:pointer">'+cipher+' <span onclick=removeCipher(this) class="glyphicon glyphicon-remove cipherdelete" style="vertical-align:text-top;font-size:12px;color:#4d4d4d;" title="Remove Cipher"></span>\n</span>';//NO I18N
    document.getElementById("contentDiv").innerHTML+=element;
    document.getElementById("addCipher").value="";
    var pre = jQuery("#contentDiv");//NO I18N
    pre.scrollTop( pre.prop("scrollHeight") );//NO I18N
}

function searchCiphers()
{
    var text = document.getElementById("cipherSearch").value;
    text = text.toUpperCase();
    var pre = document.getElementById("contentDiv");
    var spans = pre.getElementsByTagName("span");
    for(var i=0;i<spans.length;i++)
    {
        var cipher = spans[i].innerHTML;
        if(cipher.toUpperCase().indexOf(text)>-1)
        {
            spans[i].style.display="";
        }
        else if(cipher!=="")
        {
            spans[i].style.display="none";//NO I18N
        }
    }
}

function getMatchingSSLCertificates()
{
    var sslvalues = [];
    var sslGroups = [];
    if(!document.getElementById("SpecificSelection").checked && !document.getElementById("GroupSelection").checked)
    {
        showAlert(I18N.getMsg("createuser.selectcertificates.alert"));//NO I18N
        return;
    }  
    if(document.getElementById("SpecificSelection").checked)
    {                        
        var select = document.getElementById('SELECTEDDEVICES');
        var options = select.getElementsByTagName('option');
        for (var i=options.length; i--;) {
        sslvalues.push(options[i].value)
        }
        if(sslvalues.toString()=="")
        {
            showAlert(I18N.getMsg('js.createuser.selectatleast.onsslcertificate'));//No I18N
            return;
        }        
    }
    if(document.getElementById("GroupSelection").checked)
    {                        
        var select = document.getElementById('SELECTEDGROUPS');
        var options = select.getElementsByTagName('option');
        for (var i=options.length; i--;) {
        sslGroups.push(options[i].value)
        }
        if(sslGroups.toString()=="")
        {
            showAlert(I18N.getMsg('js.Group.selectatleastonegroup'));//No I18N
            return;
        }        
    }      
    document.getElementById("ShowCertificatesView").click();
}

function globalPasswordDivShow()
{
    if(document.getElementById("enablePasswordEncryption").checked)
    {
        $("#globalPasswordDiv").show();
        $("#userpasswordoption").show();
        if(document.getElementById("enableUserPassword").checked)
        {
            $("#userPasswordDiv").show();
        }
    }
    else
    {
        $("#globalPasswordDiv").hide();
        $("#userpasswordoption").hide();
        $("#userPasswordDiv").hide();
    }
}

function userPasswordDivShow()
{
    if(document.getElementById("enableUserPassword").checked)
    {
        $("#userPasswordDiv").show();
    }
    else
    {
        $("#userPasswordDiv").hide();
    }
}

function generatePassword(inputID)
{
    var ajaxRequestUrl = '/api/pki/settings/generateRandomPassword'; //No I18N
    getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
       if(jsonData.Status=="Success")
       {
           document.getElementById(inputID).value=jsonData.password;
       }
       else
       {
           messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
       }
    });
}