// $Id$

App.InventoryRoute = Ember.Route.extend({
	model: function(params) {
		App.InventoryTabListController.selectedTab = "res"; //No I18N
        },
	setupController: function(controller,model) {
		controller.set('content', App.Inventory.getResourceViewList());  //No I18N
	},
	renderTemplate: function() {this.render({into: 'application', outlet: 'details'});} //No I18N
});

App.InventoryTabRoute = Ember.Route.extend({
	model: function(params) {
        },
	setupController: function(controller,model) {
	},
	renderTemplate: function() {this.render('Inventory',{into: 'application', outlet: 'details'});} //No I18N
});

App.InventoryTabResourcesRoute = App.InventoryFilterRoute.extend({
        beforeModel: function() {
            if(App.ApplicationController.isSSH || App.ApplicationController.isFULL)
            {
                this.transitionTo('Inventory.Tab.SSH');//No I18N
            }
            else if(App.ApplicationController.isSSL )
            {
                this.transitionTo('Inventory.Tab.SSL');//No I18N
            }
        },
	model: function(params) {
            
        },
	setupController: function(controller) {
            controller.set('content', App.Inventory.getResourceViewList());  //No I18N
	},
	renderTemplate: function() {this.render('InventoryResources',{into: 'Inventory',outlet: 'certInfo'});} //No I18N
});
App.InventoryTabSSHRoute = App.InventoryFilterRoute.extend({
        beforeModel: function() {
            if(!App.ApplicationController.isSSH && !App.ApplicationController.isFULL)
            {
                this.transitionTo('Inventory.Tab.SSL');//No I18N
            }
        },
	model: function(params) {
        },
	setupController: function(controller) {
            if(App.ApplicationController.isFULL)
            {
                App.InventoryTabListController.selectedTab = "res"; //No I18N
                controller.set('content', App.Inventory.getResourceViewList());  //No I18N
            }
	},
	renderTemplate: function() {this.render('SSHResources',{into: 'Inventory',outlet: 'certInfo'});} //No I18N
});
App.InventoryTabSSLRoute = App.InventoryFilterRoute.extend({
        beforeModel: function() {
            if(!App.ApplicationController.isSSL && !App.ApplicationController.isFULL)
            {
                this.transitionTo('Inventory.Tab.SSH');//No I18N
            }
        },
	model: function(params) {
		
        },
	setupController: function(controller) {
            if(App.ApplicationController.isFULL)
            {
            App.InventoryTabListController.selectedTab = "ssl"; //No I18N
            controller.set('content', App.Inventory.getResourceViewList());  //No I18N
            }
	},
	renderTemplate: function() {this.render('InventorySSLResources',{into: 'Inventory',outlet: 'certInfo'});} //No I18N
});

App.InventoryDetailsRoute = Ember.Route.extend({
	model: function(params) {
		App.InventoryListDetailsController.selectedTab = "SSL"; //No I18N
		App.InventoryListDetailsController.hostId = params.res_id; 
                App.InventoryListDetailsController.res_type = params.res_type;
        },
	setupController: function(controller,model) {
		controller.set('content', App.Inventory.getCertificateDetailsTabList(App.InventoryListDetailsController.hostId,App.InventoryListDetailsController.res_type));  //No I18N
	},
	renderTemplate: function() {this.render('InventoryDetails',{into: 'application', outlet: 'details'});} //No I18N
        
});

App.SSLMgmtCertificateHistoryRoute = Ember.Route.extend({
	model: function(params) {
            App.InventoryListDetailsController.cert_id = params.cert_id; 
        },
	setupController: function(controller,model) {
            App.ApplicationController.getBack=localStorage.getItem("prevViewName");//No I18N
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('CertificateHistory',{into: 'sslMgmt', outlet: 'sslmgmt'});//No I18N
            }
            else{
                localStorage.setItem("prevViewName",I18N.getMsg("js.sslmgmt.certificates"));//No I18N
                if(localStorage.getItem("homeTab")!="PassTrixQuickView")
                {
                    this.render('CertificateHistory',{ outlet: 'keyInfo'});//No I18N
                }   
                else
                {
                    this.render('CertificateHistory',{ outlet: 'kmpdashboard'});//No I18N
                } 
            }   
        } 
});

App.SSLMgmtCertDetailsRoute = Ember.Route.extend({
	model: function(params) {
            App.InventoryListDetailsController.cert_nav=false;
            App.InventoryListDetailsController.cert_id = params.cert_id; 
        },
	setupController: function(controller,model) {
                var obj={prevViewName:localStorage.getItem("prevViewName")};//No I18N
                controller.set('content', obj);  //No I18N 
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('InventoryDetailsEndPoint',{into: 'sslMgmt', outlet: 'sslmgmt'}); //No I18N
            }
            else{
                if(localStorage.getItem("homeTab")!="PassTrixQuickView")
                {
                    this.render('InventoryDetailsEndPoint',{ outlet: 'keyInfo'});//No I18N
                }   
                else
                {
                    this.render('InventoryDetailsEndPoint',{ outlet: 'kmpdashboard'});//No I18N
                }   
            }   
         }   
});

App.SSLMgmtVulnerablitiesRoute = Ember.Route.extend({
    model: function(param){
        App.InventoryListDetailsController.cert_nav=false;
        App.InventoryListDetailsController.cert_id = param.cert_id; 
    },
    setupController: function(controller,model) {
    },
    renderTemplate: function() {
        if(kmpStandAlone){
            this.render('VulnerabilitiesView',{into: 'sslMgmt', outlet: 'sslmgmt'}); //No I18N
        }
        else{
                if(localStorage.getItem("homeTab")!="PassTrixQuickView")
                {
            this.render('VulnerabilitiesView',{ outlet: 'keyInfo'});//No I18N
        }   
                else
                {
                    this.render('VulnerabilitiesView',{ outlet: 'kmpdashboard'});//No I18N
    }
        }   
    }
})

App.InventoryDetailsSSLRoute = Ember.Route.extend({
	model: function(params) {
            App.InventoryListDetailsController.selectedTab = "SSL"; //No I18N
                App.InventoryListDetailsController.cert_nav=true;
            return this.modelFor("Inventory.Details"); //No I18N
        },
	setupController: function(controller,model) {
            controller.set('content', App.Inventory.getCertificateDetailsTabList(App.InventoryListDetailsController.hostId,App.InventoryListDetailsController.res_type));  //No I18N
	},
	renderTemplate: function() {this.render('InventoryDetailsEndPoint',{into: 'InventoryDetails',outlet: 'certDetail'});} //No I18N
});

App.SSHMgmtDetailsRoute = Ember.Route.extend({
	model: function(params) {
            //App.InventoryListDetailsController.selectedTab = "SSH"; //No I18N
            App.InventoryListDetailsController.hostId=params.res_id;
            return this.modelFor("Inventory.Details"); //No I18N
        },
	setupController: function(controller,model) {
            //controller.set('content', App.Inventory.getCertificateDetailsTabList(App.InventoryListDetailsController.hostId,App.InventoryListDetailsController.res_type));  //No I18N
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('sshresourcedetails',{into: 'SSHMgmtMainTabs',outlet: 'keyInfo'});//No I18N
            }
            else{
                this.render('sshresourcedetails',{ outlet: 'keyInfo'});//No I18N
            }   
        } //No I18N
});


App.InventorySansDetailsRoute = Ember.Route.extend({
	model: function(params) {
            App.InventoryListDetailsController.hostId=params.id;
        },
	setupController: function(controller,model) {
            
	},
	renderTemplate: function() {this.render({into: 'application', outlet: 'details'});} //No I18N
});

App.SSLMgmtCertificateRoute = Ember.Route.extend({
	model: function(params) {
            App.InventoryListDetailsController.cert_id = params.cert_id; 
            return this.modelFor("Inventory"); //No I18N
        },
	setupController: function(controller,model) {
	},
	renderTemplate: function() {this.render('InventoryDetailsCertificate',{into: 'sslMgmt',outlet: 'sslmgmt'});} //No I18N
});

App.SSLMgmtDeployedServersRoute = Ember.Route.extend({
	model: function(params) {
            App.InventoryListDetailsController.cert_id = params.cert_id; 
            return this.modelFor("Inventory"); //No I18N
        },
	setupController: function(controller,model) {
            App.ApplicationController.getBack=localStorage.getItem("prevViewName");//No I18N
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('SSLMultipleServersToDeployment',{into: 'sslMgmt',outlet: 'sslmgmt'});//No I18N
            }
            else{
                localStorage.setItem("prevViewName",I18N.getMsg("js.sslmgmt.certificates"));//No I18N
                if(localStorage.getItem("homeTab")!="PassTrixQuickView")
                {
                    this.render('SSLMultipleServersToDeployment',{outlet: 'keyInfo'});//No I18N
                }   
                else
                {
                    this.render('SSLMultipleServersToDeployment',{ outlet: 'kmpdashboard'});//No I18N
                }
            }   
            
        } 
});

App.InventoryResUsersListRoute = Ember.Route.extend({
        model: function(params) {
            App.InventoryController.res_Id = params.res_Id;
        },
        setupController: function(controller,model){
        },
        renderTemplate: function() {this.render({into: "application",outlet: "details"});} //No I18N
});

App.SSHMgmtResourceGroupRoute = Ember.Route.extend({
        model: function(params) {
        },
        setupController: function(controller,model){
        },
        renderTemplate: function() {
            if(kmpStandAlone){
                this.render('ResourceGroup',{into: 'SSHMgmtMainTabs',outlet: 'keyInfo'});//No I18N
            }
            else{
                this.render('ResourceGroup',{ outlet: 'keyInfo'});//No I18N
            }   
        } 
});

App.SSLMgmtSSLCertificatesGroupRoute = Ember.Route.extend({
        model: function(params) {
        },
        setupController: function(controller,model){
        },
        renderTemplate: function() {
            if(kmpStandAlone){
                this.render('SSLCertificatesGroup',{into: "sslMgmt",outlet: "sslmgmt"});//No I18N
            }
            else{
                this.render('SSLCertificatesGroup',{ outlet: 'keyInfo'});//No I18N
            }   
        }
});

App.SSLMgmtRootCertificateRoute = Ember.Route.extend({
        model: function(params) {
            localStorage.setItem("prevViewName",I18N.getMsg("js.rootcert.title"));//No I18N
        },
        setupController: function(controller,model){
        },
        renderTemplate: function() {
            if(kmpStandAlone){
                this.render('RootCertificateView',{into: "sslMgmt",outlet: "sslmgmt"});//No I18N
            }
            else{
                this.render('RootCertificateView',{ outlet: 'keyInfo'});//No I18N
            }   
        }
});

App.SSLMgmtSignedCertificateRoute = Ember.Route.extend({
        model: function(params) {
            App.InventoryController.res_Id = params.root_id;
            localStorage.setItem("prevViewName",I18N.getMsg("js.rootcert.title"));//No I18N
        },
        setupController: function(controller,model){
            var obj={prevViewName:localStorage.getItem("prevViewName")};//No I18N
            obj.rootName=App.InventoryListDetailsController.cert_name;
            controller.set('content', obj);  //No I18N 
        },
        renderTemplate: function() {
            if(kmpStandAlone){
                this.render('SignedCertificate',{into: "sslMgmt",outlet: "sslmgmt"});//No I18N
            }
            else{
                this.render('SignedCertificate',{ outlet: 'keyInfo'});//No I18N
            }   
        }
});

App.SSLMgmtCGCertificatesListRoute = Ember.Route.extend({
        model: function(params) {
            App.InventoryListDetailsController.dGroupId=params.dgid;
        },
        setupController: function(controller,model){
        },
        renderTemplate: function() {
            if(kmpStandAlone){
                this.render('CGCertificatesList',{into: "sslMgmt",outlet: "sslmgmt"});//No I18N
            }
            else{
                this.render('CGCertificatesList',{ outlet: 'keyInfo'});//No I18N
            }   
        } 
});

App.SSHMgmtResourceListRoute = Ember.Route.extend({
        model: function(params) {
            App.InventoryListDetailsController.dGroupId=params.rgid;
        },
        setupController: function(controller,model){
        },
        renderTemplate: function() {this.render('RGResourcesList',{into: "SSHMgmtMainTabs",outlet: "keyInfo"});} //No I18N
});

App.SSHMgmtAddResourceGroupRoute = Ember.Route.extend({
        model: function(params) {
            App.InventoryListDetailsController.dGroupId=params.dgid;
        },
        setupController: function(controller,model){
        },
        renderTemplate: function() {this.render('AddResourceGroup',{into: "SSHMgmtMainTabs",outlet: "keyInfo"});} //No I18N
});

App.SSLMgmtAddCertificateGroupRoute = Ember.Route.extend({
        model: function(params) {
            App.InventoryListDetailsController.dGroupId=params.dgid;
        },
        setupController: function(controller,model){
        },
        renderTemplate: function() {
            if(kmpStandAlone){
                this.render('AddCertificateGroup',{into: "sslMgmt",outlet: "sslmgmt"});//No I18N
            }
            else{
                this.render('AddCertificateGroup',{ outlet: 'keyInfo'});//No I18N
            }   
        } 
});

// Basic credential Dialog view
App.ResourceCredentialsView = Ember.View.extend({
    templateName: 'ResourceCredentials',//No I18N
        didInsertElement: function(){
            $('[data-toggle="popover"]').popover();
            $('.modal-dialog').css({"width":"550px"});//NO I18N
            $(".modal-title").text(I18N.getMsg("js.resourceCredential.title"));//No I18N
        }
});

App.ResourceCredentialsController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        submitCredentials: function()
        {
            var close=this;
            var grid = jQuery("#PKIInventoryList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var res_ids="";
            $.each(selRowIds, function()
            {
                var id = this;
                var server=grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
                if(res_ids!=="")
                {
                    res_ids=res_ids+","+server;//No I18N
                }
                else
                {
                    res_ids=server;
                }
            });
            var fileData = saveCredentialFileData();
            fileData.append("res_ids",res_ids);//No I18N
            var browse=$('#uploadKeyFile');
            var textfield=document.getElementById("textfile");
            var reqUrl="/api/pki/ssh/saveResourcesCredential";//No I18N
            getAjaxApiRequestForFile(reqUrl, fileData, browse, textfield, true, function (jsonData)
            {
                if(jsonData.Status==="Success")//NO I18N
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                    close.send('closeModal');//NO I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            });                
        }
    }
});

// Basic credential Dialog view
App.ModalView = Ember.View.extend({
    templateName: 'Modal',//No I18N
        didInsertElement: function(){
            $('[data-toggle="popover"]').popover();
            $('.modal-dialog').css({"width":"550px"});//NO I18N
            $(".modal-title").text(I18N.getMsg("js.resourceCredential.title"));//No I18N
            var reqUrl="/api/pki/ssh/getCredential";//No I18N
            var params="res_id="+App.ApplicationController.res_id;//No I18N
            getAjaxApiRequest(reqUrl,params,function(jsonData){
                    if(jsonData.USER_NAME!==undefined)
                    {
                    $("#rootaccount").val($("<div>").html(jsonData.USER_NAME).text()); //NO I18N
                        if(jsonData.PASSWORD!==undefined)
                        {
                            document.getElementById("rootpassword").placeholder=jsonData.PASSWORD;
                        }
                        if(jsonData.ISADMIN === 1)
                        {
                            document.getElementById("isadmin").checked=true;;
                        }
                    }
            });
        }
});

App.ModalController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        submitCredentials: function()
        {
            var close=this;
            saveResourceCredential("resource",close);//NO I18N
        }
    }
});

function saveResourceCredential(callFrom,close)
{
        var fileData = saveCredentialFileData();
        var browse=$('#uploadKeyFile');
        var textfield=document.getElementById("textfile");
        var reqUrl="/api/pki/ssh/saveResourceCredential";//No I18N
        if(callFrom==="resource")
        {
            fileData.append("res_id",App.ApplicationController.res_id);//NO I18N
        }
        else
        {
            fileData.append("user_id",App.SettingsCommonController.user_id);//NO I18N
        }
        getAjaxApiRequestForFile(reqUrl, fileData, browse, textfield, true, function (jsonData)
        {
            if(jsonData.Status==="Success")//NO I18N
            {
                messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                if(callFrom==="assoUsers")
                {
                    App.Inventory.getResourceUsersListView();
                    $("#usersList").show();
                    $("#basicCredentials").hide();
                }
                else
                {
                    if(callFrom==="resource")
                    {
                        App.Inventory.listsshsummary();
                    }
                    close.send('closeModal');//NO I18N
                }
            }
            else
            {
                messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
            }
        });    
}

function saveCredentialFileData()
{
            var fileData = new FormData();
            var rootaccount=$("#rootaccount").val();
            var rootpassword=$("#rootpassword").val();
            if(rootaccount==="")
                {
                showAlert(I18N.getMsg('js.adAuth.enterUserName')); //No I18N
                    return;
                }
            fileData.append("rootaccount",rootaccount);//No I18N
            if(document.getElementById("CRED_TYPE").checked)
            {
                if(rootpassword==="")
                {
                    showAlert(I18N.getMsg('Enter password')); //No I18N
                    return;
                }
                else
                {
                    fileData.append("rootpassword",rootpassword);//No I18N
                    fileData.append("isPassword",true);//No I18N
                }
            }
            if(document.getElementById("CRED_TYPE1").checked)
            {
                var file = document.getElementById("importPrivateKey").files[0];
                if(file===undefined)
                {
                    showAlert(I18N.getMsg('settings.servercertificate.selectkeyfile')); //No I18N
                    return;
                }
                else if($("#textfile").val()==="")
                {
                    showAlert(I18N.getMsg('js.sshkey.enterkeyname')); //No I18N
                    $("#textfile").focus();
                    return;
                }
                else
                {
                    fileData.append("File", file);//NO I18N
                    fileData.append("passPhrase", $("#key_passphrase").val());//NO I18N
                    fileData.append("isPassword",false);//No I18N
                    fileData.append("keyName",$("#textfile").val());//No I18N
                }
            }
            if(document.getElementById("CRED_TYPE2").checked)
            {
                if($("#listofcredentialkeys").val()==="---select one Key---")
                {
                    showAlert(I18N.getMsg('js.sshkey.selectakey')); //No I18N
                    return;
                }
                fileData.append("key_id", $("#listofcredentialkeys").val());//NO I18N
                fileData.append("isPassword",false);//No I18N
            }
            fileData.append("pmpcp",Get_Cookie('pmpcc'));//No I18N
            var isadmin=document.getElementById("isadmin").checked;
            fileData.append("isadmin",isadmin);//No I18N
            return fileData;
}

App.SignWithRootCertificateView = Ember.View.extend({
    templateName: 'SignWithRootCertificate',//No I18N
        didInsertElement: function(){
            $('.modal-dialog').css({"width":"700px"});//NO I18N
            $(".modal-title").text(I18N.getMsg("js.ssl.sign.certificate"));//NO I18N
            if(((isLinux_pmp==null && window.isLinux.toLowerCase()==="linux")||(window.isLinux==null && isLinux_pmp===true )) && !App.ApplicationController.demo)
            {
                $("#sign_type_div").hide();
                $("#sign_type").val("user");//NO I18N
            }
            if(!kmpStandAlone){
                $('.modal-dialog').css({"width":"800px"});//NO I18N
                $("#isCertDetailsParentDiv").removeClass("col-sm-offset-4 col-sm-5");//NO I18N
                $("#isCertDetailsParentDiv").css('margin-left','310px');//NO I18N
                $("#sign_action_childDiv").removeClass("col-sm-4 col-sm-offset-4");//NO I18N
                $("#sign_action_childDiv").css('margin-left','310px');//NO I18N
                $("#goToDiv").removeClass("col-sm-4 col-sm-offset-4");//NO I18N
//                $("#ouFrontBackDiv").css('margin-left','8.5px');//NO I18N
            }
            getAppUsers();
        }
});

function getADUserJQTreeValues(type)
{
    var params=getADFormDetails();
    params.ADIMPORTTYPE=App.ScheduleDetailsController.adImportType;
    if(App.ScheduleDetailsController.adImportType==='USERGROUPS')
    {
        params._USERGROUPS=App.ScheduleDetailsController.adSelectedValues;
    }
    else if(App.ScheduleDetailsController.adImportType==='OUNITS')
    {
        params.selectedOUs=App.ScheduleDetailsController.adSelectedValues;
    }
    var reqUrl="/api/pki/request/getADUserJQTree";//No I18N
    params.pmpcp=Get_Cookie('pmpcc'); //NO I18N
    getAjaxApiRequest(reqUrl,params,function(jsonData)
    {
        if(jsonData.Status==="Success")
        {
            generateResourceUserTree(jsonData);
            $("#sign_type").prop( "disabled", true );
            $('#enumeratedUsers').show();
            if(type==="usersel")
            {
                $('#next').hide();
                $('#sign_action').hide();
                $('#ADOulist_Div').hide();
                $("#gotoaddeta").hide();
                $("#gotousersel").show();
            }
            else
            {
                $('#next').hide();
                $("#aduser_div").hide();
                $('#sign_action').hide();
                $("#gotoaddeta").show();
                $("#gotousersel").hide();
            }
        }
        else
        {
            messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
        }
    });            
}

App.SignWithRootCertificateController = Ember.ObjectController.extend({
    needs:['Discovery','ADOUList'],//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        getSelectedList: function()
        {
            this.get('controllers.ADOUList').send('getSelectedList','false');//No I18N
            getADUserJQTreeValues("usersel");//No I18N
        },
        ADOUList:function()
        {
            getADOUList();
        },
        importUsersFromAD:function()
        {
            this.get('controllers.Discovery').send('importUsersFromAD');//No I18N
            
        },
        goToADDetailsPage:function()
        {
            $("#aduser_div").show();
            $('#enumeratedUsers').hide();
            $('#sign_action').show();
            $('#sign').hide();
            $('#next').show();
        },
        goToUserSelectionPage:function()
        {
            $('#enumeratedUsers').hide();
            $('#ADOulist_Div').show();
            $('#sign_action').hide();
        },
        goTOSign:function()
        {
            var checked_ids = []; 
            checked_ids=$('#data').jstree(true).get_selected();//NO I18N
            if(checked_ids.length==0)
            {
                showAlert(I18N.getMsg('Select atleast one user'));//NO I18N
                return;
            }
            $('#enumeratedUsers').hide();
            $('#sign_action').show();
            $('#cert_details').show();
            $('#sign').show();
        },        
        goNext:function()
        {
            getADUserJQTreeValues('addetail');//No I18N
        },
        goBack:function()
        {
            $("#aduser_div").show();
            $('#sign').hide();
            $('#next').show();
            $('#cert_details').hide();
            $('#sign_action').show();
            $("#sign_type").prop( "disabled", false );
            $("#ADOulist_Div").hide();
        },
        sign: function()
	{
            var params={};
            var grid = $("#PKIRootCertificateList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var sign_type=$("#sign_type").val();
            var user_id="";//No I18N
            if(sign_type==="user")
            {
                user_id=$("#app_user").val();
                params.user_id=user_id;
            }
            else
            {
                var users="";
                var checked_ids = []; 
                checked_ids=$('#data').jstree(true).get_selected();//NO I18N
                for(var i=0;i<checked_ids.length;i++)
                {
                    if(checked_ids[i].indexOf("par_")===-1 && checked_ids[i].indexOf("root_")===-1)
                    {
                        if(users!=="")
                        {
                            users+=","
                        }
                        users+=checked_ids[i];
                    }
                }
                params.ADUsers=users;
                params.DOMAINNAME=$("#DOMAINNAME").val();
            }
            $.each(selRowIds, function()
            {
                var id = this;
                var cert_id = grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
                params.rootCert_id=cert_id;
            });
            var alt_names=$("#alt_names").val().trim();
            var VALIDITY=$("#validity").val().trim();
            params.sign_type=sign_type;
            if($("#isCertDetais").prop("checked") == false)
            {
                var ORGUNIT=$("#orgunit").val().trim();
                var ORG=$("#org").val().trim();
                var LOCATION=$("#loc").val().trim();
                var STATE=$("#isstate").val().trim();
                var COUNTRY=$("#country").val().trim(); 
               var ALG=$("#ALG_TYPE").val().trim();
                var LEN=$("#ALG_LEN").val().trim();
                var SIGALG=$("#SIG_ALG").val().trim();
                if (ORGUNIT == '') {
                    showAlert(I18N.getMsg('js.certificatecreation.enterOrganizationUnit'));//NO I18N
                    return;
                }
                if (ORG == '') {
                    showAlert(I18N.getMsg('js.certificatecreation.enterOrganizationName'));//NO I18N
                    return;
                }
                if(!validateNumberVal(VALIDITY)){
                    showAlert(I18N.getMsg('js.commonstr.enterValidDays'));//NO I18N
                    return;   
                }
                params.ORGUNIT=ORGUNIT;params.ORG=ORG;params.RootCertDetails=false;params.LOCATION=LOCATION;
                params.STATE=STATE;params.COUNTRY=COUNTRY;params.ALG=ALG;params.LEN=LEN;params.SIGALG=SIGALG;
            }
            else
            {
                params.RootCertDetails=true;
            }
            if(alt_names!='' && !alt_names.match(/^[A-Za-z]/i))
            {
               showAlert(I18N.getMsg('js.pki.certificateCreation.dnsNameCheck'));//NO I18N
                return;
            }
            if(VALIDITY==''){
                showAlert(I18N.getMsg('js.certificatecreation.enterValidityDays'));//NO I18N
                return;                    
            }
            params.VALIDITY=VALIDITY;params.ALT_NAMES=alt_names;
            var reqUrl="/api/pki/request/signWithRoot";//No I18N
            var app=this;
            params.pmpcp=Get_Cookie('pmpcc'); //NO I18N
            getAjaxApiRequest(reqUrl,params,function(jsonData)
            {
                if(jsonData.Status==="Success")
                {
                   messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                   app.send("close");//No I18N 
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            });
        }
    }
});

App.SignUserWithRootCertificateView = Ember.View.extend({
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg("js.ssl.sign.certificate"));//NO I18N
            getRootCertificates();
        }
});

App.SignUserWithRootCertificateController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        sign: function()
	{
            var params={};
            var root_id=$("#root_cert").val();
            var grid = $("#PKIUserManagement"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var user_ids="";
            $.each(selRowIds, function()
            {
                var id = this;
                var user_id = grid.jqGrid('getCell', id, 'UserId'); //No I18N
                if(user_ids!=="")
                {
                    user_ids=user_ids+","+user_id;
                }
                else
                {
                    user_ids=user_id;
                }
            });
            if(root_id===undefined || root_id==="" || root_id==="message")
            {
                showAlert(I18N.getMsg('js.select.root.certificate'));//NO I18N
                return;
            }
            params.rootCert_id=root_id;
            var alt_names=$("#alt_names").val().trim();
            var VALIDITY=$("#validity").val().trim();
            params.user_ids=user_ids;
            if($("#isCertDetais"). prop("checked") == false)
            {
                var ORGUNIT=$("#orgunit").val().trim();
                var ORG=$("#org").val().trim();
                var LOCATION=$("#loc").val().trim();
                var STATE=$("#isstate").val().trim();
                var COUNTRY=$("#country").val().trim();
                var ALG=$("#ALG_TYPE").val().trim();
                var LEN=$("#ALG_LEN").val().trim();
                var SIGALG=$("#SIG_ALG").val().trim();
                if (ORGUNIT == '') {
                    showAlert(I18N.getMsg('js.certificatecreation.enterOrganizationUnit'));//NO I18N
                    return;
                }
                if (ORG == '') {
                    showAlert(I18N.getMsg('js.certificatecreation.enterOrganizationName'));//NO I18N
                    return;
                }
                if(!validateNumberVal(VALIDITY)){
                    showAlert(I18N.getMsg('js.commonstr.enterValidDays'));//NO I18N
                    return;   
                }
                params.ORGUNIT=ORGUNIT;params.ORG=ORG;params.RootCertDetails=false;params.LOCATION=LOCATION;
                params.STATE=STATE;params.COUNTRY=COUNTRY;params.ALG=ALG;params.LEN=LEN;params.SIGALG=SIGALG;
            }
            else
            {
                params.RootCertDetails=true;
            }
            if(alt_names!='' && !alt_names.match(/^[A-Za-z]/i))
            {
               showAlert(I18N.getMsg('js.pki.certificateCreation.dnsNameCheck'));//NO I18N
                return;
            }
            if(VALIDITY==''){
                showAlert(I18N.getMsg('js.certificatecreation.enterValidityDays'));//NO I18N
                return;                    
            }
            params.VALIDITY=VALIDITY;params.ALT_NAMES=alt_names;
            var reqUrl="/api/pki/request/signUsersWithRoot";//No I18N
            var app=this;
            params.pmpcp=Get_Cookie('pmpcc'); //NO I18N
            getAjaxApiRequest(reqUrl,params,function(jsonData)
            {
                if(jsonData.Status==="Success")
                {
                   messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                   app.send("close");//No I18N 
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            });
        }
    }
});

function getAppUsers()
{
    var ajaxRequestUrl = '/api/pki/settings/getUsers'; //No I18N
    getAjaxApiRequest(ajaxRequestUrl, "", function (jsonData) {
        if(jsonData.AppUserList!==undefined && jsonData.AppUserList.length!=0)
        {
            var arr=jsonData.AppUserList;
            for(var i=0;i<arr.length;i++)
            {
                var list=arr[i];
                $("#app_user").append("<option value='"+list[0]+"' >"+list[1]+"</option>");
            }               
        }
    });
}

App.ModalDialogComponent = Ember.Component.extend({
    didInsertElement: function () {
        $("#em_modal").modal({
            backdrop: 'static',//NO I18N
            keyboard: false
        });//NO I18N
        //$('.modal-body').slimscroll({railVisible: true,railBorderRadius: 0,railOpacity: 0.1});
        var controller=this.get('controller');
        $(".modal").click(function(e){
            if(e.target.id==="em_modal")
            {
                controller.send('close');//No I18N
            }
        });
        var widpadHeight=0;
        if(kmpStandAlone){
            widpadHeight=$(".widpad").height()-60; 
        }
        else
        {
            widpadHeight=$(".rtcontent").height(); 
        }
        $(".modal-body").css({"max-height":widpadHeight+"px"});
        $(".modal-body").css({"overflow-y":"auto"});
        $('.modal-body').slimscroll({railVisible: true,railBorderRadius: 0,railOpacity: 0.1});
    },
  actions: {
    close: function() {
        $("#em_modal").modal("hide");//NO I18N
        $(".modal-open").css("padding-right","0");//NO I18N
        var app = this;
        setTimeout(function(){ $('.modal-dialog').css({"width":"300px"}); return app.sendAction(); }, 100);
    },
    }
});

App.MyModalDialogComponent = Ember.Component.extend({
    didInsertElement: function () {
        $("#am_modal").modal({
            backdrop: 'static',//NO I18N
            keyboard: false
        });
        //$('.modal-body').slimscroll({railVisible: true,railBorderRadius: 0,railOpacity: 0.1});
        $('.modal-body').css("overflow","auto");
        var controller=this.get('controller');
        $(".modal").click(function(e){
            if(e.target.id==="am_modal")
            {
                controller.send('close');//No I18N
            }
        });
    },
  actions: {
    close: function() {
        $("#am_modal").modal("hide");//NO I18N
        var app = this;
        setTimeout(function(){ $('.modal-dialog').css({"width":"300px"}); return app.sendAction(); }, 100);
    }
    }
});

App.BasicCredentialComponent = Ember.Component.extend({
    actions:{
        submitCredentials:function()
        {
            this.sendAction("submitCredentials");//No I18N
        },
        close:function()
        {
            this.sendAction("close");//No I18N
        }
    }
});

App.ImportSSLKeysView = Ember.View.extend({
    templateName: 'importSSLKeys',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg("js.ssh.importkeys"));//No I18N
            if(!kmpStandAlone)
            {
                $(".modal-dialog").css('width','600px !important'); 
                $( "div#importsslsave" ).removeClass( "col-sm-offset-4" ).addClass( "col-sm-offset-6" );
            }
            var grid = jQuery("#PKIInventoryList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length != 1) {
                this.get("controller").send("close");//No I18N 
                showAlert(I18N.getMsg('letsencrypt.renewrequest.selectonecert')); //No I18N
            }
        }
});

App.ImportSSLKeysController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        importSSL: function(){
            var grid = jQuery("#PKIInventoryList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length != 1) {
                showAlert(I18N.getMsg('letsencrypt.renewrequest.selectonecert')); //No I18N
                return;
            }
            var cert_id=0;
            $.each(selRowIds, function()
            {
                var id = this;
                cert_id = grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
            });
            var param="?cert_id="+cert_id;//No I18N 
            if ($('#textfile').val() == '') {
                showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                return;
            }
//            if ($('#keyStorePassword').val() == '') {
//                showAlert(I18N.getMsg('js.sshkey.enterKeyStorePassword'));//NO I18N
//                return;
//            }
            
            var fileData = new FormData();
            var file1 = document.getElementById("uploadKeyStoreFile").files[0];
            fileData.append("File", file1);//NO I18N
            var textfield=document.getElementById("textfile");
            var validate=document.getElementById("validateKey").checked;
            fileData.append("pmpcp",Get_Cookie('pmpcc'));//No I18N
            param=param+'&PASSWORD='+encodeURIComponent(document.getElementById("keyStorePassword").value)+'&TYPE=KEYSTORE'+'&Validate='+validate;//NO I18N
            var ajaxRequestUrl = '/api/pki/request/importSSLKey'+param; //No I18N
            var app=this;
            $.ajax({
                url: ajaxRequestUrl,
                type: 'POST',//No I18N
                dataType: 'json',//No I18N
                data: fileData,
                cache:false,
                processData:false,
                contentType:false,
                success: function(jsonData) {

                if(jsonData.Status==="Success")
                {
                   messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                   app.send("close");//No I18N 
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
                },
                error: function(jsonData) {
                    if(jsonData.responseText.indexOf("unauthorized")!=-1)
                    {
                        messageNotification("messageNotifyFailure",I18N.getMsg("pki.js.noauthorization"));//No I18N
                }
                }
            });            
        }
    }
});

App.FilterKeysView = Ember.View.extend({
    templateName: 'FilterKeys',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg("Filter search"));//No I18N
        }
});

App.FilterKeysController = Ember.ObjectController.extend({
    filterssl:{},
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        startSearch: function(){
            var ser_content = $("#sanSearchText").val();
            var ser_type="san";//NO I18N
            this.send('closeModal');//NO I18N
            App.FilterKeysController.filterssl={"filter":[{"name":ser_type,"value":ser_content}]};//No I18N
            redirectUrl("SSLSearch");//No I18N
        }
    }
});

App.SSLSearchRoute = Ember.Route.extend({
    renderTemplate: function () {
        this.render({outlet: "keyInfo"});//No I18N
    } 
});

App.ShareWithSSLRoleUsersView = Ember.View.extend({
    templateName: 'ShareCertToUsers',//No I18N
        didInsertElement: function(){
            $(".modal-dialog" ).draggable();           
            $(".modal-dialog").css('width','800px');
            var certgrid = jQuery("#PKIInventoryList"); //No I18N
            var gridId ="";
            var type=this.get("controller").get("model");
            var certIdType="certId";//NO I18N
            if(type=='cert-users'){//NO I18N
                $(".modal-title").text(I18N.getMsg("pki.shareCerts"));//No I18N
                certgrid = jQuery("#PKIInventoryList"); //No I18N
                gridId ='ResourceID';//NO I18N
                $('#certuserDiv').show();
            }else if(type=='cert-usergroups'){//NO I18N
                 $(".modal-title").text(I18N.getMsg("pki.shareCerts"));//No I18N
                certgrid = jQuery("#PKIInventoryList"); //No I18N
                gridId ='ResourceID';//NO I18N
                $('#certuserGpDiv').show();
            }else if(type=='certgroup-users'){//NO I18N
                 $(".modal-title").text(I18N.getMsg("pki.shareCertGroups"));//No I18N
                certgrid = jQuery("#PKIResourceGroupList"); //No I18N
                gridId ='GROUP_ID';//NO I18N
                certIdType="certGroupId";//NO I18N
                $('#certGpuserDiv').show();
            }else if(type=='certgroup-usergroups'){//NO I18N
                 $(".modal-title").text(I18N.getMsg("pki.shareCertGroups"));//No I18N
                certgrid = jQuery("#PKIResourceGroupList"); //No I18N
                gridId ='GROUP_ID';//NO I18N
                certIdType="certGroupId";//NO I18N
                $('#certGpuserGpDiv').show();
            }
            var selRowIds = certgrid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                this.get("controller").send("close");//No I18N 
                showAlert(I18N.getMsg('pki.js.certshare.selectOneCertificate')); //No I18N
                return;
            }
            if( selRowIds.length != 1) {
                this.get("controller").send("close");//No I18N 
                showAlert(I18N.getMsg('pki.js.certshare.canshareonlyonecertificate')); //No I18N
                return;
            }
           var cert_id=0;
            $.each(selRowIds, function()
            {
                var id = this;
                cert_id = certgrid.jqGrid('getCell', id, gridId); //No I18N
            });    
            var controller=this.get('controller');
            App.Inventory.shareCertorCertGroupswithUserorUserGroupsviewList(type,certIdType,cert_id,controller);
            setTimeout(function(){
                resizeJqGridWidth('#PKIShareCertToUserDIV', '#gbox_PKIShareCertToUserDIV'); //No I18N
            },300);
            }
        });

App.ShareWithSSLRoleUsersController = Ember.ObjectController.extend({
    needs: 'application', //NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        shareCertToUsers: function(type){
            var app = this.get('controllers.application');
            var certuserGrid = jQuery("#PKIShareCertToUserDIV"); //No I18N
            var certgrid = jQuery("#PKIInventoryList");//No I18N
            var userGridId='UserId';//NO I18N
            var certGridId='ResourceID';//NO I18N
            var certType="";
            var certIdType='certId';//NO I18N
            if(type=='cert-users'){//NO I18N
                certgrid = jQuery("#PKIInventoryList"); //No I18N
                certType="CERT_USER_SHARE";//NO I18N
            }else if(type=='cert-usergroups'){//NO I18N
                certgrid = jQuery("#PKIInventoryList"); //No I18N
                userGridId='UserGroupId';//NO I18N
                certType="CERT_USERGROUP_SHARE";//NO I18N
            }else if(type=='certgroup-users'){//NO I18N
                certgrid = jQuery("#PKIResourceGroupList"); //No I18N
                certType="CERTGROUP_USER_SHARE";//NO I18N
                certGridId='GROUP_ID';//NO I18N
                certIdType='certGroupId';//NO I18N
            }else if(type=='certgroup-usergroups'){//NO I18N
                certgrid = jQuery("#PKIResourceGroupList"); //No I18N
                 userGridId='UserGroupId';//NO I18N
                 certGridId='GROUP_ID';//NO I18N
                 certIdType='certGroupId';//NO I18N
                certType="CERTGROUP_USERGROUP_SHARE";//NO I18N
            }
            shareCertOrCGroupsToUsersOrUGroups(app,certgrid,certuserGrid,userGridId,certGridId,certType,type,certIdType);
        },
        revokeCertFromUsers:function(type){
            var app = this.get('controllers.application');
            var certuserGrid = jQuery("#PKIShareCertToUserDIV"); //No I18N
            var certgrid = jQuery("#PKIInventoryList");//No I18N
            var userGridId='UserId';//NO I18N
            var certIdType='certId';//NO I18N
            var certGridId='ResourceID';//NO I18N
            if(type=='cert-users'){//NO I18N
                certgrid = jQuery("#PKIInventoryList"); //No I18N
            }else if(type=='cert-usergroups'){//NO I18N
                certgrid = jQuery("#PKIInventoryList"); //No I18N
                userGridId='UserGroupId';//NO I18N
            }else if(type=='certgroup-users'){//NO I18N
                certgrid = jQuery("#PKIResourceGroupList"); //No I18N
                certGridId='GROUP_ID';//NO I18N
                certIdType='certGroupId';//NO I18N
            }else if(type=='certgroup-usergroups'){//NO I18N
                certgrid = jQuery("#PKIResourceGroupList"); //No I18N
                 userGridId='UserGroupId';//NO I18N
                 certGridId='GROUP_ID';//NO I18N
                 certIdType='certGroupId';//NO I18N
            }
            var user_ids = "";
             var selRowIds = certuserGrid.jqGrid('getGridParam', 'selarrrow'); //No I18N        
             if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                return;
            }
            $.each(selRowIds, function ()
            {
                var id = this;
                var user_id = certuserGrid.jqGrid('getCell', id, userGridId); //No I18N
                if (user_ids !== "")
                {
                    user_ids = user_ids + "," + user_id;
                } else
                {
                    user_ids = user_id;
                }
            });
            var cert_id = "";
             var selRowIds = certgrid.jqGrid('getGridParam', 'selarrrow'); //No I18N             
            $.each(selRowIds, function ()
            {
                var id = this;
                cert_id = certgrid.jqGrid('getCell', id, certGridId); //No I18N
            });
            var ajaxRequestUrl ='';
            var params='';
            if(type=='cert-users' || type=='certgroup-users'){
            ajaxRequestUrl = "/api/pki/Inventory/revokeSharedCertsFromUsers";//No I18N
            params="userIds="+user_ids+"&"+certIdType+"="+cert_id;//NO I18N
            }else{
                ajaxRequestUrl = "/api/pki/Inventory/revokeSharedCertsFromUserGroups";//No I18N
            params="userGroupIds="+user_ids+"&"+certIdType+"="+cert_id;//NO I18N
            }
            getAjaxApiRequest(ajaxRequestUrl, params+"&pmpcp="+Get_Cookie('pmpcc'), function (jsonData) {//NO I18N
                if (jsonData.Status === "Success")//NO I18N
                {
                    messageNotification("messageNotifySuccess", I18N.getMsg(jsonData.Message));//No I18N
                    App.Inventory.shareCertorCertGroupswithUserorUserGroupsviewList(type,certIdType,cert_id);
                } 
                else {
                    messageNotification("messageNotifyFailure", I18N.getMsg(jsonData.Message));//No I18N
                }
            });
        }
    }
});

 function shareCertOrCGroupsToUsersOrUGroups(app,certGrid,certuserGrid,userGridId,certGridId,shareType,type,certIdType){
            var user_ids = "";
             var selRowIds = certuserGrid.jqGrid('getGridParam', 'selarrrow'); //No I18N 
             if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                return;
            }
            $.each(selRowIds, function ()
            {
                var id = this;
                var user_id = certuserGrid.jqGrid('getCell', id, userGridId); //No I18N
                if (user_ids !== "")
                {
                    user_ids = user_ids + "," + user_id;
                } else
                {
                    user_ids = user_id;
                }
            });
             
            var cert_id = "";
             var selRowIds = certGrid.jqGrid('getGridParam', 'selarrrow'); //No I18N             
            $.each(selRowIds, function ()
            {
                var id = this;
                cert_id = certGrid.jqGrid('getCell', id, certGridId); //No I18N
            });
            var ajaxRequestUrl = '/api/pki/Inventory/shareCertToUsers?'+certIdType+'=' + cert_id + '&assignCertToUserIds=' + user_ids+ '&shareType='+shareType;//No I18N
            getAjaxApiRequest(ajaxRequestUrl, "pmpcp="+Get_Cookie('pmpcc'), function (jsonData) {//NO I18N
                if (jsonData.Status === "Success")//NO I18N
                {
                    messageNotification("messageNotifySuccess", I18N.getMsg(jsonData.Message));//No I18N
                    App.Inventory.shareCertorCertGroupswithUserorUserGroupsviewList(type,certIdType,cert_id);
                } 
                else {
                    messageNotification("messageNotifyFailure", I18N.getMsg(jsonData.Message));//No I18N
                }
            });
        }

App.ShareKeyWithRequestedUsersView = Ember.View.extend({
    templateName: 'allowPrivateKeyAccessToUser',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg("js.ssh.sharePrivateKeys"));//No I18N
            $(".modal-dialog").css('width','750px');
            App.Inventory.getCertificatePrivateKeyAccessRequestsList();
        }
});

App.ShareKeyWithRequestedUsersController = Ember.ObjectController.extend({
    needs: 'application', //NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        }
    }
});

App.ShareDetailsView = Ember.View.extend({
    templateName: 'shareDetails',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg("js.ssl.sharedetailsview"));//No I18N
            $(".modal-dialog").css('width','750px');
            $(".modal-dialog" ).draggable();   
            var cert_id = "";
            var certGrid=jQuery("#PKIInventoryList");//No I18N 
             var selRowIds = certGrid.jqGrid('getGridParam', 'selarrrow'); //No I18N  
            if(selRowIds == undefined || selRowIds.length == 0) {
                this.get("controller").send("close");//No I18N 
                showAlert(I18N.getMsg('pki.js.certshare.selectOneCertificate')); //No I18N
                return;
            }
            if( selRowIds.length != 1) {
                this.get("controller").send("close");//No I18N 
                showAlert(I18N.getMsg('pki.js.certshare.canshareonlyonecertificate')); //No I18N
                return;
            }
            $.each(selRowIds, function ()
            {
                var id = this;
                cert_id = certGrid.jqGrid('getCell', id, 'ResourceID'); //No I18N
            });
            var reqUrl = "/api/pki/Inventory/getCertificateShareDetails";//No I18N
            getAjaxApiRequest(reqUrl, "certId="+cert_id, function (jsonData) {//NO I18N
                $("#certName").text(jsonData.CertificateName);
                $("#certOwner").text(jsonData.CertificateOwner);
                fillusersTable(jsonData.Users);
                fillusersGroupTable(jsonData.UserGroups);
                fillCGusersTable(jsonData.CertGroupSharedUsers);
                fillCGusersGroupTable(jsonData.CertGroupSharedUserGroups);
            });
        }
});

function fillCGusersTable(users){
     var colNamesList = [I18N.getMsg('js.certificatesgroup.title'),I18N.getMsg('js.settings.users'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'CertGroupName', index: 'CertGroupName'},//No I18N
                    { name: 'CertGroupSharedUser', index: 'CertGroupSharedUser'},//No I18N
                    { name: 'search',width:25,sortable: false,search:false}//NO I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#PKICGUsersList", users, colNamesList, colModelList, "", "#PKICGUsersListpager", "ShareReport",defaultOptions);//No I18N                    
}

function fillCGusersGroupTable(users){
     var colNamesList = [I18N.getMsg('js.certificatesgroup.title'),I18N.getMsg('js.usersGroup.usergroup'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'CertGroupName', index: 'CertGroupName'},//No I18N
                    { name: 'CertGroupSharedUserGroup', index: 'CertGroupSharedUserGroup'},//No I18N
                    { name: 'search',width:25,sortable: false,search:false}//NO I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#PKICGUserGroupsList", users, colNamesList, colModelList, "", "#PKICGUserGroupsListpager", "ShareReport",defaultOptions);//No I18N                    
}

function fillusersTable(users){
     var colNamesList = [I18N.getMsg('js.settings.users'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'User', index: 'User'},//No I18N
                    { name: 'search',width:25,sortable: false,search:false}//NO I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#PKIUsersList", users, colNamesList, colModelList, "", "#PKIUsersListpager", "ShareReport",defaultOptions);//No I18N                    
}

function fillusersGroupTable(users){
     var colNamesList = [I18N.getMsg('js.usersGroup.usergroup'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'UserGroup', index: 'UserGroup'},//No I18N
                    { name: 'search',width:25,sortable: false,search:false}//NO I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#PKIUserGroupsList", users, colNamesList, colModelList, "", "#PKIUserGroupsListpager", "ShareReport",defaultOptions);//No I18N                    
}

App.ShareDetailsController = Ember.ObjectController.extend({
    needs: 'application', //NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        }
    }
});
var isPass=false;
        
// List the associated users Dialog view
App.ListResourceUsersView = Ember.View.extend({
    templateName: 'ListResourceUsers',//No I18N
        didInsertElement: function(){
            isPass=false;
           // $('[data-toggle="popover"]').popover();
            $(".modal-title").text(I18N.getMsg("js.modaltitle.resourceUsers"));//NO I18N
            $('.modal-dialog').css({"width":"600px"});
            $("#keySelection").hide();
            $("#basicCredentials").hide();
            if(App.ApplicationController.res_id!==0)
            {
                App.Inventory.getResourceUsersListView();
            }
            if(App.ApplicationController.isAdmin===false)
            {
                $("#select_key_option").hide();
            }
            todisplayMenus(App.ApplicationController.viewMenus,"SSH");//No I18N
        }
});

App.ListResourceUsersController = Ember.ObjectController.extend({
    needs: ['application','AssociateUserToKeyView'],//No I18N 
    actions: {
        submitCredentials:function()
        {
            saveResourceCredential("assoUsers");//No I18N
        },
        showCreateKey:function()
        {
            var app=this.get('controllers.AssociateUserToKeyView');//No I18N 
            app.send("showCreateKey");//No I18N 
        },
        associatePublicKeys:function()
        {
            this.send('associateUser');//No I18N 
        },
        back:function()
        {
            var app=this.get('controllers.AssociateUserToKeyView');//No I18N 
            app.send("back");//No I18N 
        },
        backToList:function()
        {
            $("#usersList").show();
            $("#addUserView").hide();                        
            $("#basicCredentials").hide();                        
        },
        createKey:function()
        {
            var app=this.get('controllers.AssociateUserToKeyView');//No I18N 
            app.send("createKey");//No I18N 
        },
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        addNewResourceUser:function(){
            var reqUrl="/api/pki/ssh/addNewResourceUser";//No I18N
            if((document.getElementById("UserName").value).trim()==="")
            {
                showAlert("Please give a valid data");//No I18N
            }
            else
            {
                var isadmin=document.getElementById("isadmin1").checked;
                var reqparams="userName="+document.getElementById("UserName").value+"&res_id="+App.ApplicationController.res_id+"&isadmin="+isadmin;//NO I18N
		ajaxRequestWithCookie(reqUrl,reqparams,false,"",true,function(jsonData){
                    if(jsonData.Status==="Success")
                    {
                        messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                        App.Inventory.getResourceUsersListView();
                        $( "#nousers").text("");
                        $("#usersList").show();
                        $("#addUserView").hide();                        
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                    }
                });//NO I18N                
            }
        },
        showAdduser:function()
        {
            $("#usersList").hide();
            $("#addUserView").show();
        },
        keyMappingtoUser: function()
        {
            var grid = $("#ListResourceUsers"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                return;
            }
            var reqUrl="/api/pki/ssh/getkeyslist";//No I18N
            getAjaxApiRequest(reqUrl,"",function(jsonData){
                    var key_array=jsonData.keyList;
                    if(key_array.length===0)
                    {
                        vConfirmation(I18N.getMsg('js.keymappingToUser.PrivatekeynotavailableCreatenewprivatekey'),function(){//NO I18N
                            $("#usersList").hide();
                            $("#CreateSshKeyForm").show();
                        });
                        return;
                    }
                    $("#usersList").hide();
                    $("#keySelection").show();
                    var sel=document.getElementById("listofkeys");//No I18N
                    for (var i=0; i<key_array.length; i++)
                    {
                        var opt=document.createElement('option');//No I18N
                        opt.innerHTML = key_array[i].KeyName;
                        opt.value = key_array[i].KeyId;
                        sel.appendChild(opt);
    }
});
        },
        associateUser : function()
        {            
            var app=this.get('controllers.application');
            var grid = $("#ListResourceUsers"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                return;
            }            
            var arr = new Array();
            var user_ids="";
            $.each(selRowIds, function()
            {
                var id = this;
                var user_id = grid.jqGrid('getCell', id, 'UserID'); //No I18N
                if(user_ids!=="")
                {
                    user_ids=user_ids+","+user_id;
                }
                else
                {
                    user_ids=user_id;
                }
            });
            var data = {

            };
            data.USERIDS = user_ids;
            data.pmpcp=Get_Cookie('pmpcc');//No I18N
            var key_id=0;
            if(App.SettingsCommonController.asso_flag)
            {
                key_id=App.SettingsUserController.key_id;
            }
            else
            {
                key_id=document.getElementById("listofkeys").value;
                App.SettingsCommonController.keyName=document.getElementById("listofkeys").options[document.getElementById("listofkeys").selectedIndex].text;
            }
            if(key_id==='---select one Key---')
                {
                    showAlert(I18N.getMsg('js.sshkey.selectOneKey')); //No I18N
                    return;
                }
            var ajaxRequestUrl='/api/pki/ssh/checkSshKeyPair';//NO I18N
            var passPhrase=$("#PassPhrase").val();
            if(passPhrase==="" && isPass===false)
            {
                var reqParam='key_id='+key_id;//NO I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParam,function(jsonData){
                    if(jsonData.isPubKeyAvailable)
                    {
                        ajaxRequestUrl = "/api/pki/ssh/singleResourceAssociation?key_id="+key_id; //No I18N
                        getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                            if(jsonData.Status==="Success")//NO I18N
                            {
                                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                                    redirectUrl("SSHMgmt/DetailedKeyRotationAudit/"+jsonData.keyRotationAuditId);//No I18N
                            }   
                            else{
                                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                            }
                        });
                        app.send('closeModal');//NO I18N
                    }
                    else
                    {
                        isPass=true;
                        $("#passphrase").show();
                    }
                });
            }
            else
            {
                if(passPhrase==="")
                {
                    showAlert(I18N.getMsg('js.sshkey.enterValidPassphrase'));//NO I18N
                    return;
                }
                ajaxRequestUrl='/api/pki/ssh/applyPassPhrase';//NO I18N
                var reqParam="key_id="+key_id+"&PassPhrase="+$("#PassPhrase").val();//NO I18N
                ajaxRequestWithCookie(ajaxRequestUrl,reqParam,false,"",true,function(jsonData){
                    if(jsonData.Status==="Success")
                    {
                        ajaxRequestUrl = "/api/pki/ssh/singleResourceAssociation?key_id="+key_id; //No I18N
                        //ajaxapicall(ajaxRequestUrl,data,true,"");//NO I18N
                        ajaxRequestWithCookie(ajaxRequestUrl,data,false,"",true,function(jsonData){
                            if(jsonData.Status==="Success")//NO I18N
                            {
                                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                                    redirectUrl("SSHMgmt/DetailedKeyRotationAudit/"+jsonData.keyRotationAuditId);//No I18N
                            }   
                            else{
                                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                            }
                        });
                        app.send('closeModal');//NO I18N
                        isPass=false;
                    }
                    else
                    {
                        showAlert(I18N.getMsg('js.sshkey.passphraseNotApplied'));//NO I18N
                    }
                })
            }
        }
    }
});

// Add new user Dialog view
App.AddUsersViewView = Ember.View.extend({
    templateName: 'addUsersView',//No I18N
        didInsertElement: function(){
            document.getElementById("UserName").focus();
            $(".modal-title").text("Add New User");//NO I18N
            var grid = $("#PKIInventoryList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) 
            {
                    document.getElementById("closeModal").click();
                    showAlert(I18N.getMsg('js.resource.selectOneResource')); //No I18N
                    return;
            }
            else if(selRowIds.length>1)
            {
                    document.getElementById("closeModal").click();
                    showAlert(I18N.getMsg('js.resource.selectOneResource')); //No I18N
                    return;                
            }
        }
});

App.AddUsersViewController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        addNewResourceUser: function()
        {
            var reqUrl="/api/pki/ssh/addNewResourceUser";//No I18N
            if((document.getElementById("UserName").value).trim()==="")
            {
                messageNotification("messageNotifyFailure","Please give a valid data");//No I18N
            }
            else
            {
                var grid = $("#PKIInventoryList"); //No I18N
                var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
                var res_id=0;
                $.each(selRowIds, function()
                {
                    var id = this;
                    res_id = grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
                });
                var reqparams="userName="+document.getElementById("UserName").value+"&res_id="+res_id;//NO I18N
                ajaxRequestWithCookie(reqUrl,reqparams,true,"",false,"");//NO I18N                
            }
            this.send('closeModal');//NO I18N            
        }
    }
});


// AboutPage Dialog view
App.AboutView = Ember.View.extend({
    templateName: 'About',//No I18N
        didInsertElement: function(){
            document.getElementById("modal_main_dialog").style.width="520px";
            $(".modal-title").text(I18N.getMsg("js.modaltitle.about"));//No I18N 
            App.Settings.getLicenseInfo();
        }
});

App.AboutController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        }
    }
});

App.SSLMultipleServersView = Ember.View.extend({
    templateName: 'SSLMultipleServers',//No I18N
        didInsertElement: function(){
            //document.getElementById("modal_main_dialog").style.width="520px";
            $(".modal-title").text(App.InventoryListDetailsController.cert_name);//No I18N 
            var reqUrl="/api/pki/Inventory/getMultipleInstalledServers";//No I18N
            var params="cert_id="+App.InventoryListDetailsController.cert_id;//No I18N
            getAjaxApiRequest(reqUrl,params,function(jsonData){
                    var colNamesList = ['MappingID',I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.discovery.port'),I18N.getMsg('js.table.search')]; //No I18N
                    var colModelList = [
                            { name: 'MappingID', index: 'MappingID',hidden:true}, //No I18N
                            { name: 'DomainName', index: 'DomainName'}, //No I18N
                            { name: 'IPAddress', index: 'IPAddress'}, //No I18N
                            { name: 'Port', index: 'Port'}, //No I18N
                            { name: 'search',width:30,sortable: false,search:false,fixed:true}//NO I18N
                    ];                   
                    var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                    loadJQgridWithData("#wildcardList", jsonData.MultipleServers, colNamesList, colModelList, "", "", "SSLCertMultipleServers",defaultOptions);//No I18N
                    var DataGrid = $('#wildcardList');
                    DataGrid.jqGrid('setGridWidth', '460');//No I18N
                    DataGrid.jqGrid('setGridHeight', '250');//No I18N

            });                    
        }
});

App.SSLMultipleServersController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        exportCsv:function()
        {     
            App.ReportController.scheduleType="PrivateKeyReport";//No I18N
            var reqParams="&cert_id="+App.InventoryListDetailsController.cert_id+"&cName="+App.InventoryListDetailsController.cert_name;//No I18N
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var ids = jQuery("#wildcardList").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=SSLMultiserverReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }              
        }
    }
});

App.SSLMultipleServersForCertVersionView = Ember.View.extend({
        didInsertElement: function(){
           $(".modal-title").text(App.InventoryListDetailsController.cert_name);//No I18N 
            $('#certserver').slimscroll({railVisible: true,railBorderRadius: 0,railOpacity: 0.1});
            var reqUrl="/api/pki/Inventory/certVerionDeployedServers";//No I18N
            var params="certVersionId="+App.InventoryListDetailsController.certVersionId;//No I18N
            getAjaxApiRequest(reqUrl,params,function(jsonData){
                    var colNamesList = ['MappingID',I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.discovery.port'),I18N.getMsg('js.table.search')]; //No I18N
                    var colModelList = [
                            { name: 'MappingID', index: 'MappingID',hidden:true}, //No I18N
                            { name: 'DomainName', index: 'DomainName'}, //No I18N
                            { name: 'IPAddress', index: 'IPAddress'}, //No I18N
                            { name: 'Port', index: 'Port'}, //No I18N
                            { name: 'search',width:30,sortable: false,search:false,fixed:true}//NO I18N
                    ];                   
                    var defaultOptions={rowNumNeeded:false,searchOption:true};
                    loadJQgridWithData("#wildcardList", jsonData.CertVerionInstalledServers, colNamesList, colModelList, "", "", "",defaultOptions);//No I18N
                    var DataGrid = $('#wildcardList');
                    DataGrid.jqGrid('setGridWidth', '460');//No I18N
                    DataGrid.jqGrid('setGridHeight', '250');//No I18N

            });                    
        }
});

App.SSLMultipleServersForCertVersionController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },exportCsv:function()
        {     
            App.ReportController.scheduleType="SSLMultiserverForCertificateVersionReport";//No I18N
            var reqParams="&certVersionId="+App.InventoryListDetailsController.certVersionId+"&cName="+App.InventoryListDetailsController.cert_name;//No I18N
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var ids = jQuery("#wildcardList").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=SSLMultiserverForCertificateVersionReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
        }
    }
    }
});
    
App.ImportDeploymentInfoView = Ember.View.extend({
    templateName: 'ImportCredential',//No I18N
        didInsertElement: function(){
            //$('[data-toggle="popover"]').popover();//For help Content
            $(".modal-title").text(I18N.getMsg("js.importCredential.title"));//NO I18N
            $("#cert_type").show();
            $("#importCredHelpDiv").show();
            var ajaxRequestUrl = '/api/pki/request/isKeystoreAvailable';//NO I18N
            var params="cert_id="+App.InventoryListDetailsController.cert_id;//NO I18N
            App.RequestCertController.cert_type=true;
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                if(jsonData.isKeystoreAvailable==false)
                {
                    $("#cert_type").hide();
                    App.RequestCertController.cert_type=false;
                }    
            });            
        }
});

App.ImportDeploymentInfoController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        importCred:function(){
            var browse="";
            var textfield="";
            var fileData = new FormData();
            fileData.append("pmpcp",Get_Cookie('pmpcc'));//NO I18N
            var file = document.getElementById("uploadKeyFile").files[0];
            fileData.append("File", file);//NO I18N
            browse=$('#uploadKeyFile');
            textfield=document.getElementById("textfile");
            if ($('#textfile').val() == '') {
                showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                return;
            }
            var isCertificate=document.getElementById("cert").checked;
            var isStore=document.getElementById("store").checked;
            var params="?isCertificate="+isCertificate;//NO I18N
            params+="&isStore="+isStore+"&cert_id="+App.InventoryListDetailsController.cert_id;//NO I18N
            if(!(isStore || isCertificate))
            {
                showAlert(I18N.getMsg("js.deploy.cert.type"));//No I18N
                return;
            }

                var ajaxRequestUrl = '/api/pki/request/importDeploymentInfo'+params; //No I18N
                getAjaxApiRequestForFile(ajaxRequestUrl,fileData,browse,textfield,true,function(jsonData){});
                this.send('closeModal');//NO I18N
        }
    }
});

function hidePassPhrase()
{
    $("#passphrase").hide();
    $("#PassPhrase").val("");
    isPass=false;
}

function clearPassword(password)
{
    document.getElementById(password).placeholder="";
}
