// $Id$

App.ScheduleRoute = Ember.Route.extend({
	setupController: function(controller) {
            localStorage.setItem("prevViewName",I18N.getMsg("js.schedule"));//No I18N
            //getMenusForSideView("Schedule");//No I18N
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render({into:"application", outlet: 'details'});//No I18N
            }
            else{
                localStorage.setItem("currentView","Schedule/All"); //NO I18N
                this.render({ outlet: 'keyInfo'});//No I18N
            } 
    },
    redirect : function(){
        if(!kmpStandAlone){
            this.transitionTo("/admin/Schedule/All");//No I18N
        }
    }
});

App.ScheduleAllRoute = Ember.Route.extend({
	setupController: function(controller) {
            getMenusForSideView("Schedule");//No I18N
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render({into:"application", outlet: 'details'});//No I18N
            }
            else{
                localStorage.setItem("currentView","Schedule/All");	//NO I18N
                this.render({ outlet: 'keyInfo'});//No I18N
            }   
        }
});

App.ScheduleAddscheduleRoute = Ember.Route.extend({
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render({into:"application", outlet: 'details'});//No I18N
            }
            else{
                localStorage.setItem("currentView","Schedule/All");	//NO I18N
                this.render({ outlet: 'keyInfo'});//No I18N
            }   
        }
});

App.ScheduleEditscheduleRoute = Ember.Route.extend({
	model: function(params) {
            App.ScheduleDetailsController.scheduleId=params.scheduleId;
        },
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render({into:"application", outlet: 'details'});//No I18N
            }
            else{
                localStorage.setItem("currentView","Schedule/All");	//NO I18N
                this.render({ outlet: 'keyInfo'});//No I18N
            }   
        }
});

App.ScheduleAuditScheduleRoute = Ember.Route.extend({
	setupController: function(controller) {
            App.ApplicationController.getBack=localStorage.getItem("prevViewName");//No I18N
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render({into:"application", outlet: 'details'});//No I18N
            }
            else{
                localStorage.setItem("currentView","Schedule/All");	//NO I18N
                this.render({ outlet: 'keyInfo'});//No I18N
            }   
        }
});

App.EditReportScheduleView=Ember.View.extend({// from pmp reports
    templateName: 'EditReportSchedule',//No I18N
    didInsertElement: function(){
     //   $('#schedule-recurrence-div').style.overflow="auto";
        var scheduleId=0;
                var reqParams="scheduleName="+App.ReportController.pmpschreportName;//NO I18N
                var ajaxRequestUrl1 = '/api/pki/schedule/scheduleNameCheck'; //No I18N
                getAjaxApiRequest(ajaxRequestUrl1,reqParams,function(jsonData){
                if(jsonData.Message!=undefined && jsonData.Message === "Schedule name already exists")//No I18N
                                    {
                                        scheduleId=jsonData.scheduleId;
                                        App.Schedule.getEditScheduleDetails(scheduleId);
                                        getServerTime();
                                    }else{
        App.Schedule.setscheduleView();
    }
});
                
    }
});
App.EditReportScheduleController = Ember.ObjectController.extend({
    needs:["ScheduleAddschedule","ScheduleEditschedule","application"],//NO I18N
    actions: {
       saveSchedule:function()
        {
            var app=this.get('controllers.ScheduleAddschedule');
            app.send('saveSchedule');//No I18N
        },
        updateSchedule:function()
        {
            var app=this.get('controllers.ScheduleEditschedule');
            app.send('updateSchedule');//No I18N
        },
        cancelOperation:function()
        {
            return this.send("closeModal");//No I18N
        },close:function(){
            return this.send("closeModal");//No I18N
    }
    }
    });

App.ADOUListView = Ember.View.extend({
    templateName: 'ADOUList',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg("js.settingsTitle5.ActiveDirectory"));//NO I18N
            getADOUList(this);
            $('.modal-dialog').css({"width":"700px"});//NO I18N
        }
});

function getADOUList(app)
{
            var domainController = document.getElementById('DOMAINCONTROLLER');//No I18N
            var userName = document.getElementById('LOGINNAME');//No I18N
            var password = document.getElementById('PASSWORD');//No I18N

            if(domainController.value=="" ||userName.value=="" || password.value=="")
            {
                showAlert("Give Domain details");//NO I18N
                var controller = app.get('controller');
                controller.send('close');//NO I18N
                return;
            }
            if(window.cur_path.indexOf("Schedule") > -1)
            {
                $("#getOUListID").show();
                $("#importADUserID").hide();
            }
            
            var domainName = document.getElementById('DOMAINNAME');//No I18N
            var domainController = document.getElementById('DOMAINCONTROLLER');//No I18N
            var userName = document.getElementById('LOGINNAME');//No I18N
            var password = document.getElementById('PASSWORD');//No I18N
            var users = document.getElementById('cusers');//No I18N
            var cusergroups = document.getElementById('cusergroups');//No I18N
            var cous = document.getElementById('cous');//No I18N
                var cousvalue = cous.value;
            var conn_mode_ssl1 = document.getElementById("connection_mode_ssl");//No I18N
            var isSSL1 = "false";//No I18N
            if(conn_mode_ssl1.checked)
            {
                    isSSL1 = "true";//No I18N
            }
            var secDCName = document.getElementById('SECDOMAINCONTROLLER');//No I18N
            var params = "?RequestType="+'OUSINDOMAIN'+"&DOMAINNAME="+domainName.value+"&COUSVALUE="+cousvalue+"&DCNAME="+domainController.value+"&UNAME="+userName.value+"&PWD="+encodeURIComponent(password.value)+"&SECDCNAME="+secDCName.value+"&ISSSL="+isSSL1;; // NO I18N
            var cugvalue = cusergroups.value;
            var ugParams = "?RequestType=USERGROUPSINDOMAIN&DOMAINNAME="+domainName.value+"&DCNAME="+domainController.value+"&CUGVALUE="+cugvalue+"&UNAME="+userName.value+"&PWD="+encodeURIComponent(password.value)+"&SECDCNAME="+secDCName.value+"&ISSSL="+isSSL1; //NO I18N
            App.SettingsCommonController.groupUrl=ugParams;
            App.SettingsCommonController.ouUrl=params;
            App.Settings.formADOUGroup(app);
        }

function getADFormDetails()
{
    var domainController = document.getElementById('DOMAINCONTROLLER');//No I18N
    var userName = document.getElementById('LOGINNAME');//No I18N
    var password = document.getElementById('PASSWORD');//No I18N

    var domainName = document.getElementById('DOMAINNAME');//No I18N
    var domainController = document.getElementById('DOMAINCONTROLLER');//No I18N
    var userName = document.getElementById('LOGINNAME');//No I18N
    var password = document.getElementById('PASSWORD');//No I18N
    var users = document.getElementById('cusers');//No I18N
    var cusergroups = document.getElementById('cusergroups');//No I18N
    var cous = document.getElementById('cous');//No I18N
    var cousvalue = cous.value;
    var conn_mode_ssl1 = document.getElementById("connection_mode_ssl");//No I18N
    var isSSL1 = "false";//No I18N
    if(conn_mode_ssl1.checked)
    {
            isSSL1 = "true";//No I18N
    }
    var secDCName = document.getElementById('SECDOMAINCONTROLLER');//No I18N
    var params={};
    params.DOMAINNAME=domainName.value;params.COUSVALUE=cousvalue;params.DCNAME=domainController.value;
    params.UNAME=userName.value;params.PWD=password.value;params.SECDCNAME=secDCName.value;params.ISSSL=isSSL1;
    params.USERS=users.value;params.CUGVALUE=cusergroups.value;
    return params;
}

App.ADOUListController = Ember.ObjectController.extend({
    needs:"SettingsADAuth",//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        importUsersFromAD: function()
        {
            var app = this.get("controllers.SettingsADAuth");
            app.send('importUsersFromAD');//NO I18N                                    
        },
        getSelectedList: function(isClose)
        {
            var adimportType="";
            var elements = document.getElementsByName('selectedOUs');//No I18N
            var _no_Of_Groups = document.getElementById('_no_of_groups_').value;//No I18N
            var len = elements.length;
            var params = "";//No I18N
            var selectedValues="";
            if(document.getElementById("ounits").checked==true)
            {
                adimportType="OUNITS";//No I18N
                for( var i = 0; i < len; i ++ )
                {
                    if(elements[i].checked)
                    {
                        var id=elements[i].value+"_iis"//No I18N
                        if(selectedValues=="")
                        {
                            selectedValues=selectedValues+$("#"+id).text();//No I18N
                            params = params + elements[i].value
                        }
                        else
                        {
                            selectedValues=selectedValues+","+$("#"+id).text();//No I18N
                            params = params +","+ elements[i].value//No I18N
                        }
                    }
                }
            }
            else
            {
                adimportType="USERGROUPS";//No I18N
                for ( var j = 0; j < _no_Of_Groups; j++ )
                {
                    var ug = document.getElementById('checkbox_'+j);//No I18N
                    if(ug.checked)
                    {
                        if(selectedValues=="")
                        {
                            selectedValues=selectedValues+ug.value;
                            params = params + ug.value;
                        }
                        else
                        {
                            selectedValues=selectedValues+","+ug.value;//No I18N
                            params = params +","+ ug.value;//No I18N
                        }
                    }
                }
            }
            if(params!="")
            {
                $("#UGOUList").show();
                $("#selList").text(selectedValues);
                if(adimportType=="USERGROUPS")
                {
                    $("#sel_OU_List").text("Selected UserGroups List");//No I18N
                }
                else
                {
                    $("#sel_OU_List").text("Selected OU List");//No I18N
                }                
                App.ScheduleDetailsController.adImportType=adimportType;
                App.ScheduleDetailsController.adSelectedValues=params;
                if(isClose==undefined)
                {
                    this.send('closeModal');//NO I18N
                }
            }
            else
            {
                showAlert("Select atleast one OU/UserGroup");//No I18N
                return;
            }
        }
    }
});
