// $Id$
App.InventoryView = Ember.View.extend({
	templateName: 'Inventory',//No I18N
		didInsertElement: function(){
		}
});		//No I18N

App.InventoryTabView = Ember.View.extend({
	templateName: 'Inventory',//No I18N
		didInsertElement: function(){
		}
});		//No I18N

App.InventoryResourcesView = Ember.View.extend({
	templateName: 'InventoryResources',//No I18N
                didInsertElement: function(){
                    App.Inventory.listsummary();                    
		}
});		//No I18N

App.SSHResourcesView = Ember.View.extend({
	templateName: 'SSHResources',//No I18N
			didInsertElement: function(){
                            todisplayMenus(App.ApplicationController.viewMenus,"SSH");//No I18N
                            var controller = this.get('controller');
                            //controller.send('showDialog');//NO I18N
                            App.Inventory.listsshsummary(controller);
        if(!kmpStandAlone){
            $("#resourceGroupDiv").hide();//NO I18N
		}
    }
});		//No I18N

App.InventorySSLResourcesView = Ember.View.extend({
	templateName: 'InventorySSLResources',//No I18N
			didInsertElement: function(){
                            var controller=this.get('controller');
                            App.Inventory.listsslsummary(controller);
                if(!kmpStandAlone){
                    selectKMPTab("ssl_certs");//NO I18N
		}
                            
        }
});		//No I18N

App.CertificateHistoryView = Ember.View.extend({
	templateName: 'CertificateHistory',//No I18N
        didInsertElement: function(){
            var controller=this.get('controller');
            App.Inventory.getCertificateVersionHistory(controller);
            if(!kmpStandAlone){
                selectKMPTab("ssl_certs");//NO I18N
        }
        }
});		

App.DomainExpiryView = Ember.View.extend({
   templateName: 'DomainExpiry',//NO I18N
   didInsertElement: function(){
       $("#contentDiv").hide();
        $(".modal-title").text(I18N.getMsg("domainexpiry.title"));//NO I18N
        var grid = jQuery("#PKIInventoryList"); //No I18N
        var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
        var commonName="";
        var controller = this.get('controller');
        if(selRowIds == undefined || selRowIds.length>1 || selRowIds.length==0) 
           {
            controller.send('closeModal');//NO I18N
            showAlert(I18N.getMsg('letsencrypt.renewrequest.selectonecert')); //No I18N
            return;
           }
        commonName = grid.jqGrid('getCell',selRowIds,5);//NO I18N
           commonName = commonName.split("</span>")[1];           
           if(commonName.indexOf("*.")==0)
               {
                   commonName = commonName.substring(2);
               }
               if(commonName.indexOf("www.")==0 || commonName.indexOf("WWW.")==0)
               {
                   commonName = commonName.substring(4);
               }
        $("#commonName").text(commonName);
        var certId = grid.jqGrid('getCell', selRowIds, 'ResourceID'); //No I18N  
        var ajaxUrl = "/api/pki/Inventory/domainExpiry?domain="+commonName+"&certId="+certId;//NO I18N
          getAjaxApiRequest(ajaxUrl,"",function(jsonData){      
            $("#contentDiv").show();
             $("#contentDiv").text(jsonData.data);
          });      
        }        
});

App.EditCertDetailsView = Ember.View.extend({
	templateName: 'EditCertDetails',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg("js.editssl.title"));//NO I18N
            $("#EditCertDetails .modal-dialog").css('width','700px');
            $("#EditCertDetails .modal-body").css('width','700px');    
            var controller = this.get('controller');
            var grid = jQuery("#PKIInventoryList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length != 1) {
                controller.send('closeModal');//NO I18N
                showAlert(I18N.getMsg('letsencrypt.renewrequest.selectonecert')); //No I18N
            }
            var cert_id=0;
            $.each(selRowIds, function()
            {
                var id = this;
                cert_id = grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
                App.InventoryController.res_Id=cert_id;
            });
            $('[data-toggle="popover"]').popover();
            var params="ssl_id="+cert_id;//No I18N
            var ajaxRequestUrl = '/api/pki/Inventory/getSSLDetails'; //No I18N
            if(!kmpStandAlone){
                $(".modal-dialog").css('width','600px !important'); 
                selectKMPTab("ssl_certs");//NO I18N
                $("#editcertSave").removeClass("col-sm-offset-4 col-sm-5");
                $("#editcertSave").css({"margin-left":"281px"});
		}
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                $("#resourcename").val(jsonData.RESOURCENAME);
                $("#description").val(jsonData.RESOURCE_DESCRIPTION);
                $("#cert_type").val(jsonData.CERT_TYPE);
                $("#templatename").val(jsonData.CERTIFICATE_TEMPLATE);
                $("#msca_name").val(jsonData.MSCA_NAME);
                document.getElementById("isnewkey").checked=jsonData.ISNEWKEY;
                if(jsonData.CERT_TYPE=="MSCA")
                {
                    $("#mscaDetails").show();
		}
            });
            $("#cert_type").change(function() {
                if($("#cert_type").val()=="MSCA")
                {
                    $("#mscaDetails").show();
                }
                else
                {
                    $("#mscaDetails").hide();
                }
            });
        }
});

App.EditSSHDetailsView = Ember.View.extend({
	templateName: 'EditSSHDetails',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg("js.editresource.title"));//NO I18N
            $('[data-toggle="popover"]').popover();
            $(".modal-dialog" ).draggable();           
            $("#resourcename").val($.trim($(App.InventoryListDetailsController.res_name).text()));
            $("#description").val(App.InventoryController.description);
            $("#ipaddress").val(App.InventoryListDetailsController.ip_address);
            $("#port").val(App.InventoryController.port);
            if(App.InventoryController.path==="")
            {
            $('#path').attr("placeholder",I18N.getMsg("js.editpath.usershomedirectory"));
            }
            else
            {
                $("#path").val(App.InventoryController.path);
            }
            var reqUrl = '/api/pki/landingserver/getLSListForAssociation?resId='+App.InventoryController.res_Id;//NO I18N
            getAjaxApiRequest(reqUrl,"",function(jsonData){
                var list = jsonData.LSList;
                if(list.length>0)
                {                   
                    for(var i=0;i<list.length;i++)
                    {                   
                        var id = list.get(i).LSId;
                        var name = list.get(i).LSName;
                        var option = new Option(name,id);
                        $("#LSServer").append(option);
                    }
                }
                if(jsonData.Associated!==undefined)
                {
                    $("#LSServer").val(jsonData.Associated);
                }
            });
//            $("#editsshdetails .modal-dialog").css('width','600px');
//            $("#editsshdetails .modal-dialog").css('minHeight','270px');
//            $("#editsshdetails .modal-dialog").css('maxHeight','800px');
//            $("#editsshdetails .modal-body").css('width','600px');
//            $("#editsshdetails .modal-body").css('minHeight','270px');
//            $("#editsshdetails .modal-body").css('maxHeight','800px');
//            $("#editsshdetails .modal-body").css('overflow-y','auto');          
            
            }
});

App.AddSSHDetailsView = Ember.View.extend({
	templateName: 'AddSSHDetails',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg("js.addresource.title"));//NO I18N
            $('[data-toggle="popover"]').popover();
            $(".modal-dialog" ).draggable();    
            var ajaxUrl = '/api/pki/landingserver/discoveryLServers';//NO I18N
            getAjaxApiRequest(ajaxUrl,"",function(jsonData){
                var list = jsonData.LSList;
                if(list.length>0)
                {                    
                    for(var i=0;i<list.length;i++)
                    {                    
                        var id = list.get(i).LSId;
                        var name = list.get(i).LSName+" ( "+list.get(i).RName+" )";//NO I18N
                        var option = new Option(name,id);
                        $("#LSServer").append(option);
                    }
                }
            });
            }
});

App.InventoryDetailsView = Ember.View.extend({
	templateName: 'InventoryDetails',//No I18N
			didInsertElement: function(){
		}
});		//No I18N

App.VulnerabilitiesViewView=Ember.View.extend({
   templateName: 'VulnerabilitiesView',//NO I18N
   didInsertElement: function(){
        //showCertDetailsVul(App.InventoryListDetailsController.cert_id);
        getSSLVunerabilitiesReload();        
   }
});

App.InventoryDetailsEndPointView = Ember.View.extend({
	templateName: 'InventoryDetailsEndPoint',//No I18N
			didInsertElement: function(){
                    App.Inventory.endPointSummary(App.InventoryListDetailsController.cert_id);
                    if(!kmpStandAlone)
                    {
                        $('#SSLCertDiv').slimscroll({height: $("#Password_View_Div_Id").height(),railVisible: true,railBorderRadius: 0,railOpacity: 0.1});
		}
		}
});		//No I18N

/*App.InventoryDetailsEndPointView = Ember.View.extend({
	templateName: 'InventoryDetailsEndPoint',//No I18N
                didInsertElement: function(){
                        var ajaxRequestUrl = '/api/pki/Inventory/getCertNavigation'; //No I18N
                        var data="res_id="+App.InventoryListDetailsController.hostId;//NO I18N
                        getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                                    if(jsonData.cert_ids!==undefined)
                                    {
                                        if(jsonData.cert_ids.length<=1)
                                        {
                                           $("#Cert_Navigation").hide();
                                        }
                                        window.cert_ids=jsonData.cert_ids;
                                        App.InventoryListDetailsController.cert_id=window.cert_ids[window.nav_index];
                                        App.Inventory.endPointSummary(App.InventoryListDetailsController.cert_id);
									}
                            });
                    }
});		//No I18N
*/
App.ResourceGroupView = Ember.View.extend({
    didInsertElement: function(){
        todisplayMenus(App.ApplicationController.viewMenus,"SSH");//No I18N
        App.Inventory.getResourceGroupList();        
    }
});

App.SSLCertificatesGroupView = Ember.View.extend({
    templateName: 'SSLCertificatesGroup',//NO I18N
    didInsertElement: function(){
        App.Inventory.getCertificatesGroupList();        
    }
});

App.RootCertificateViewView = Ember.View.extend({
    didInsertElement: function(){
        var controller=this.get('controller');
        App.Inventory.getRootCertificateList();
    }
});

App.SignedCertificateView = Ember.View.extend({
    didInsertElement: function(){
        var controller=this.get('controller');
        App.Inventory.getClientCertificateList();        
    }
});

App.LandingServerConfigView = Ember.View.extend({
    didInsertElement: function(){
        App.Inventory.getLandingServersList();     
    }
});

App.LandingServerAssociationView = Ember.View.extend({
    didInsertElement: function(){               
        App.Inventory.landingServerAssociationView();       
    }
});

App.AssociateLandingServerView = Ember.View.extend({
   templateName: 'AssociateLandingServer',//NO I18N
   didInsertElement: function() {
        $(".modal-title").text(I18N.getMsg("landingserver.association"));//NO I18N
        $('[data-toggle="popover"]').popover();
        $(".modal-dialog" ).draggable();  
        var reqUrl = '/api/pki/landingserver/getLSListForAssociation?resId='+App.InventoryController.res_Ids;//NO I18N
        getAjaxApiRequest(reqUrl,"",function(jsonData){
            var list = jsonData.LSList;
            if(list.length>0)
            {    
                $("#LSServer").find('option').remove();
                for(var i=0;i<list.length;i++)
                {                   
                    var id = list.get(i).LSId;
                    var name = list.get(i).LSName;
                    var option = new Option(name,id);
                    $("#LSServer").append(option);
                }
            }
            if(jsonData.Associated!==undefined)
            {
                $("#LSServer").val(jsonData.Associated);
            }
        });
   }
});

App.LandingServerDetailsView = Ember.View.extend({
	templateName: 'LandingServerDetails',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg("landingserver.addserver"));//NO I18N
            $('[data-toggle="popover"]').popover();
            $(".modal-dialog" ).draggable();           
            $("#LandingServerDetails .modal-dialog").css('width','650px');
            App.Inventory.getLandingServerView();
            }
});

App.LandingServerEditView = Ember.View.extend({
	templateName: 'LandingServerDetails',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg("landingserver.modifyserver"));//NO I18N
            $('[data-toggle="popover"]').popover();
            $(".modal-dialog" ).draggable();           
            $("#LandingServerDetails .modal-dialog").css('width','650px');
            App.Inventory.getLandingServerView(App.InventoryController.lsid);
            }
});

App.RGResourcesListView = Ember.View.extend({
    templateName: 'RGResourcesList',//No I18N
    didInsertElement: function(){
        todisplayMenus(App.ApplicationController.viewMenus,"SSH");//No I18N
        App.Inventory.getResourceListFromGroup(App.InventoryListDetailsController.dGroupId);
    }
});

App.CGCertificatesListView = Ember.View.extend({
    templateName: 'CGCertificatesList',//No I18N
    didInsertElement: function(){
        $('#group_name').text(I18N.getMsg("js.commonstr.certsgroupname")+":"+sessionStorage.getItem("groupname"));//No I18N
        App.Inventory.getCertificatesListFromGroup(App.InventoryListDetailsController.dGroupId);
    }
});

App.AddCertificateGroupView = Ember.View.extend({
   didInsertElement: function(){
        var dGroupId = App.InventoryListDetailsController.dGroupId;
        $("#dGroupDesc").val("");//No I18N
        var ajaxRequestUrl = '/api/pki/Inventory/certificateGroupEditPreRender'; //No I18N
        var data='GROUP_ID='+dGroupId;//No I18N
        getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData)
        {
            var parameterMap = jsonData.CriteriaParameters;
            var conditionMap = jsonData.CriteriaConditions;
            var comparatorMap = new Array();
            comparatorMap.push({name: "and", value: "and"});  //No I18N
            comparatorMap.push({name: "or", value: "or"});  //No I18N
            App.InventoryListDetailsController.parameterMap = parameterMap;
            App.InventoryListDetailsController.conditionMap = conditionMap;
            App.InventoryListDetailsController.comparatorMap = comparatorMap;
            App.InventoryListDetailsController.QUERYID = jsonData.QUERYID;   
            if(dGroupId != "new") {
                $(".pgtitle").text(I18N.getMsg("js.commonstr.editCertificateGroup"));//NO I18N
                $("#rGroupName").val(jsonData.GROUP_NAME);
                $("#dGroupDesc").val(jsonData.DESCRIPTION);
                $('#rGroupName').attr('readonly', true);
                if(jsonData.DeviceByCriteria == true) {
                    $("#SpecificDevice-div").css('display','none');//No I18N
                    $("#SpecificCriteria-div").css('display','block');//No I18N
                    $('#DeviceByCriteria').attr("checked", true);
                    var selectQuery = jsonData.SelectQueryContents.CRITERIA_LIST;
                    for (var int1 = 0; int1 < selectQuery.length; int1++) 
                    {
                        var index = int1+1;
                        var cri = selectQuery[int1];
                        $row =  $('<tr id="'+index+'" style="height: 45px;"></tr>');//No I18N
                        $td = $("<td width='100px' align='left'></td>");//No I18N
                        if(int1 == 0) {
                            $select = $('<select name="COMPARATOR_"'+ index + ' disabled="true" style="width: 80px;  display: none;" id="COMPARATOR_'+index+'" class="form-control"></select>');//No I18N
                        } 
                        else {
                            $select = $('<select name="COMPARATOR_"'+ index + ' style="width: 80px;" id="COMPARATOR_'+index+'" class="form-control"></select>');//No I18N
                        }
                        for (var intVal = 0; intVal < comparatorMap.length; intVal++) {
                            $select.append($('<option value="'+ comparatorMap[intVal].value +'">'+ comparatorMap[intVal].name +'</option>'));  //No I18N
                        }
                        $td.append($select);
                        $row.append($td);

                        $parameter = $("<td width='200px' align='left'></td>");//No I18N
                        $selectparameter = $('<select onchange="checkConditions(this)" name="PARAMETER_'+ index + '" style="width: 180px;" id="PARAMETER_'+ index + '" class="form-control"></select>');//No I18N
                        for (var intVal = 0; intVal < parameterMap.length; intVal++) 
                        {
                            $selectparameter.append($('<option value="'+ parameterMap[intVal].Key +'">'+ parameterMap[intVal].Value +'</option>'));  //No I18N
                        }
                        $parameter.append($selectparameter);
                        $row.append($parameter);

                        $comparator = $("<td width='200px' align='left'></td>");//No I18N
                        $selectcondition = $('<select name="CONDITION_'+ index + '" style="width: 180px;" id="CONDITION_'+ index + '" class="form-control"></select>');//No I18N
                        for (var intVal = 0; intVal < conditionMap.length; intVal++) {
                                $selectcondition.append($('<option value="'+ conditionMap[intVal].Key +'">'+ conditionMap[intVal].Value +'</option>'));  //No I18N
                                }
                        $comparator.append($selectcondition);
                        $row.append($comparator);

                        $valueField = $("<td width='200px' align='left'></td>");//No I18N
                        $valueField.append($('<input id="PATTERN_'+ index + '" type="text" style="width:180px !important;" class="form-control">'));//No I18N
                        $row.append($valueField);

                        $closeField = $("<td align='left'></td>");//No I18N
                        if(int1 == 0 ){
                                $closeField.append($('<div><span title="Delete Criteria" style="display: none;" onclick="deleteCriteriaToDeviceGroup('+index+');" class="glyphicon glyphicon-remove pointer"></span></div>'));//No I18N
                        } else {
                                $closeField.append($('<div><span title="Delete Criteria" onclick="deleteCriteriaToDeviceGroup('+index+');" class="glyphicon glyphicon-remove pointer"></span></div>'));//No I18N
                        }
                        $row.append($closeField);
                        $addCriteria = $("<td align='left'></td>");//No I18N
                        $addCriteria.append($('<div><span title="Add Criteria" onclick="addCriteriaToDeviceGroup('+index+');" class="glyphicon glyphicon-plus pointer"></span></div>'));//No I18N
                        $row.append($addCriteria);
                        $("#critetriaTable").append($row);
                        $("#CONDITION_"+index).val(cri.Condition);
                        $("#PARAMETER_"+index).val(cri.Field);
                        if(cri.Field==="KEY_STRENGTH")
                        {
                            checkConditions(document.getElementById("PARAMETER_"+index));
                        }       
                        $("#COMPARATOR_"+index).val(cri.Comparator);
                        $("#PATTERN_"+ index).val(cri.Value);
                    }
                    refreshMatchingCertificates();
                }
                else
                {
                    resourceCriteriaForm(comparatorMap,parameterMap,conditionMap);
                }
            } 
            else {
                resourceCriteriaForm(comparatorMap,parameterMap,conditionMap);
            }
            if(jsonData.Listed!=undefined)
            {
                var key_array=jsonData.Listed;
                var sel=document.getElementById("LISTOFDEVICES");//No I18N
                baseContents ={};
                for (var i=0; i<key_array.length; i++)
                {
                    var opt=document.createElement('option');//No I18N
                    opt.innerHTML = key_array[i].CommonName;
                    opt.value = key_array[i].SSLId;
                    sel.appendChild(opt);
                    baseContents[key_array[i].SSLId]=key_array[i].CommonName;
                }
            }
            if(jsonData.Selected!=undefined)
            {
                var key_array=jsonData.Selected;
                var sel=document.getElementById("SELECTEDDEVICES");//No I18N
                for (var i=0; i<key_array.length; i++)
                {
                    var opt=document.createElement('option');//No I18N
                    opt.innerHTML = key_array[i].CommonName;
                    opt.value = key_array[i].SSLId;
                    sel.appendChild(opt);
                }
            }
            
        });        
   } 
});

App.AddResourceGroupView = Ember.View.extend({
    didInsertElement: function(){
        var dGroupId = App.InventoryListDetailsController.dGroupId;
        $("#dGroupDesc").val("");//No I18N
        if(window.DEVICE_IDS_FOR_GROUP != null && window.DEVICE_IDS_FOR_GROUP != "") {
            App.InventoryListDetailsController.AllUnselectedHostMap = window.DEVICE_IDS_FOR_GROUP;
            $("#selectCriteriaType").css("display", "none");//No I18N
            for (var col in App.InventoryListDetailsController.AllUnselectedHostMap) {
                    $('#SELECTEDDEVICES').append($('<option value="'+ col +'">'+ App.InventoryListDetailsController.AllUnselectedHostMap[col] +'</option>'));  //No I18N
            }
        } 
        else 
        {
            var ajaxRequestUrl = '/api/pki/Inventory/resourceGroupEditPreRender'; //No I18N
            var data='RESOURCE_GROUP_ID='+dGroupId;//No I18N
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData)
            {
                var parameterMap = jsonData.CriteriaParameters;
                var conditionMap = jsonData.CriteriaConditions;
                var comparatorMap = new Array();
                comparatorMap.push({name: "and", value: "and"});  //No I18N
                comparatorMap.push({name: "or", value: "or"});  //No I18N
                App.InventoryListDetailsController.parameterMap = parameterMap;
                App.InventoryListDetailsController.conditionMap = conditionMap;
                App.InventoryListDetailsController.comparatorMap = comparatorMap;
                App.InventoryListDetailsController.QUERYID = jsonData.QUERYID;
                App.InventoryListDetailsController.AllUnselectedHostMap = jsonData.AllUnselectedHostMap;
                if(jsonData.UnselectedHostMap != null) 
                {
                    baseContents = {};
                    for (var col in jsonData.UnselectedHostMap) 
                    {
                        $('#LISTOFDEVICES').append($('<option value="'+ col +'">'+ jsonData.UnselectedHostMap[col] +'</option>'));  //No I18N
                        baseContents[col]=jsonData.UnselectedHostMap[col];
                    }
                }
                if(jsonData.SelectedHostMap != null) {
                    for (var col in jsonData.SelectedHostMap) {
                        $('#SELECTEDDEVICES').append($('<option value="'+ col +'">'+ jsonData.SelectedHostMap[col] +'</option>'));  //No I18N
                    }
                }
                if(dGroupId != "new") {
                    $(".pgtitle").text(I18N.getMsg("js.commonstr.editResourceGroup"));//NO I18N
                    $("#rGroupName").val(jsonData.DEVICE_GROUP_NAME);
                    $("#dGroupDesc").val(jsonData.DG_DESCRIPTION);
                    $('#rGroupName').attr('readonly', true);
                    if(jsonData.DeviceByCriteria == true) {
                        $("#SpecificDevice-div").css('display','none');//No I18N
                        $("#SpecificCriteria-div").css('display','block');//No I18N
                        $('#DeviceByCriteria').attr("checked", true);
                        var selectQuery = jsonData.SelectQueryContents.CRITERIA_LIST;
                        for (var int1 = 0; int1 < selectQuery.length; int1++) 
                        {
                            var index = int1+1;
                            var cri = selectQuery[int1];
                            $row =  $('<tr id="'+index+'" style="height: 45px;"></tr>');//No I18N
                            $td = $("<td width='100px' align='left'></td>");//No I18N
                            if(int1 == 0) {
                                $select = $('<select name="COMPARATOR_"'+ index + ' disabled="true" style="width: 80px;  display: none;" id="COMPARATOR_'+index+'" class="form-control"></select>');//No I18N
                            } 
                            else {
                                $select = $('<select name="COMPARATOR_"'+ index + ' style="width: 80px;" id="COMPARATOR_'+index+'" class="form-control"></select>');//No I18N
                            }
                            for (var i = 0; i < comparatorMap.length; i++) {
                                $select.append($('<option value="'+ comparatorMap[i].value +'">'+ comparatorMap[i].name +'</option>'));  //No I18N
                            }
                            $td.append($select);
                            $row.append($td);

                            $parameter = $("<td width='200px' align='left'></td>");//No I18N
                            $selectparameter = $('<select name="PARAMETER_'+ index + '" style="width: 180px;" id="PARAMETER_'+ index + '" class="form-control"></select>');//No I18N
                            for (var i = 0; i < parameterMap.length; i++) 
                            {
                                $selectparameter.append($('<option value="'+ parameterMap[i].Key +'">'+ parameterMap[i].Value +'</option>'));  //No I18N
                            }
                            $parameter.append($selectparameter);
                            $row.append($parameter);

                            $comparator = $("<td width='200px' align='left'></td>");//No I18N
                            $selectcondition = $('<select name="CONDITION_'+ index + '" style="width: 180px;" id="CONDITION_'+ index + '" class="form-control"></select>');//No I18N
                            for (var i = 0; i < conditionMap.length; i++) {
                                    $selectcondition.append($('<option value="'+ conditionMap[i].Key +'">'+ conditionMap[i].Value +'</option>'));  //No I18N
                                    }
                            $comparator.append($selectcondition);
                            $row.append($comparator);

                            $valueField = $("<td width='200px' align='left'></td>");//No I18N
                            $valueField.append($('<input id="PATTERN_'+ index + '" type="text" style="width:180px !important;" class="form-control">'));//No I18N
                            $row.append($valueField);

                            $closeField = $("<td align='left'></td>");//No I18N
                            if(int1 == 0 ){
                                    $closeField.append($('<div><span title="Delete Criteria" style="display: none;" onclick="deleteCriteriaToDeviceGroup('+index+');" class="glyphicon glyphicon-remove pointer"></span></div>'));//No I18N
                            } else {
                                    $closeField.append($('<div><span title="Delete Criteria" onclick="deleteCriteriaToDeviceGroup('+index+');" class="glyphicon glyphicon-remove pointer"></span></div>'));//No I18N
                            }
                            $row.append($closeField);
                            $addCriteria = $("<td align='left'></td>");//No I18N
                            $addCriteria.append($('<div><span title="Add Criteria" onclick="addCriteriaToDeviceGroup('+index+');" class="glyphicon glyphicon-plus pointer"></span></div>'));//No I18N
                            $row.append($addCriteria);
                            $("#critetriaTable").append($row);
                            $("#CONDITION_"+index).val(cri.Condition);
                            $("#PARAMETER_"+index).val(cri.Field);
                            $("#COMPARATOR_"+index).val(cri.Comparator);
                            $("#PATTERN_"+ index).val(cri.Value);
                        }
                        refreshMatchingResources();
                    }
                    else
                    {
                        resourceCriteriaForm(comparatorMap,parameterMap,conditionMap);
                    }
                } 
                else {
                    resourceCriteriaForm(comparatorMap,parameterMap,conditionMap);
                }
            });
            $('#LISTOFDEVICES').dblclick(function(){
                var sel=this.options[this.selectedIndex];
                if(sel!=undefined)
                {
                    SELECTEDDEVICES.options[SELECTEDDEVICES.options.length] = new Option(sel.text, sel.value, false, false);
                    baseContents[sel.value] = null;
                    this.options[this.selectedIndex]=null;
                }
            });

            $('#SELECTEDDEVICES').dblclick(function(){
                var sel=this.options[this.selectedIndex];
                if(sel!=undefined)
                {
                    LISTOFDEVICES.options[LISTOFDEVICES.options.length] = new Option(sel.text, sel.value, false, false);
                    baseContents[sel.value] = null;
                    baseContents[sel.value] = sel.text;
                    this.options[this.selectedIndex]=null;
                }
            });        
        }
    }
});

App.SshresourcedetailsView = Ember.View.extend({
                didInsertElement: function(){
                    var ajaxRequestUrl = '/api/pki/Inventory/sshResourceDetailView'; //No I18N
                    var data="res_id="+App.InventoryListDetailsController.hostId;//NO I18N
                    getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                        var hide=false;
                        if(App.ApplicationController.isAdmin)
                        {
                            hide=false;
                        }else
                        {
                            hide=true;
                        }
                                checkLoginStatus(jsonData);
                                $("#resname").text(jsonData.res_name);
                                var colNamesList = ['User ID','Key ID',I18N.getMsg('js.general.username'),I18N.getMsg('js.ssh.keyname'),I18N.getMsg('js.general.creationtime'),'','',I18N.getMsg('js.table.search')]; //No I18N
                                var colModelList = [
                                        { name: 'UserID', index: 'UserID',hidden:true}, //No I18N
                                        { name: 'KeyID', index: 'KeyID',hidden:true}, //No I18N
                                        { name: 'UserName', index: 'UserName'}, //No I18N
                                        { name: 'KeyName', index: 'KeyName'}, //No I18N
                                        { name: 'CreatedTime', index: 'CreatedTime'}, //No I18N
                                        { name: 'Terminal', index:'Terminal',formatter:'connectFormatter',width:'50px'},//NO I18N
                                        { name: 'Export', index: 'Export',formatter:'exportKeyFormatter',search:false,width:'50px',hidden:hide}, //No I18N
                                        { name: 'search',width:25,sortable: false,search:false}//NO I18N
                                ];
                                var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
                                loadJQgridWithData("#sshDetailList", jsonData.sshDetails, colNamesList, colModelList, "", "#sshDetailPager", "sshResourceDetails",defaultOptions);//No I18N
                    });
		}
});		//No I18N

App.InventorySansDetailsView = Ember.View.extend({
	templateName: 'InventoryDetailsCertDetails',//No I18N
			didInsertElement: function(){
                            App.Inventory.getSansDetails(App.InventoryListDetailsController.hostId);
		}
});		//No I18N

App.InventoryDetailsCertificateView = Ember.View.extend({
	templateName: 'InventoryDetailsCertificate',//No I18N
			didInsertElement: function(){
                                App.Inventory.getCertificate(App.InventoryListDetailsController.cert_id);
                            }
});		//No I18N

App.SSLMultipleServersToDeploymentView = Ember.View.extend({
	templateName: 'SSLMultipleServersToDeployment',//No I18N
        didInsertElement: function(){
                var controller=this.get('controller');
                App.Inventory.getMultipleInstalledServers(controller);
        }
});		

App.InventoryResUsersListView = Ember.View.extend({
    templateName: 'ResUsersList',//No I18N
        didInsertElement: function(){
                    var res_Id = App.InventoryController.res_Id;
                    var reqParam='res_id='+res_Id;//NO I18N
                var ajaxRequestUrl = '/api/pki/ssh/resUsersList'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,reqParam,function(jsonData){
                      var colNamesList = ['User Id',I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.general.username'),I18N.getMsg('js.discovery.usercredential'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    {name: 'UserID', index: 'UserID',hidden:true}, //No I18N
                    {name: 'ResourceName', index: 'ResourceName'},//No I18N
                    {name: 'userName', index: 'userName'}, //No I18N
                    {name: 'isCredAvailable',index: 'isCredAvailable',formatter:'AllResourceUserCredentialsFormatter',align:'center'},//No I18N
                    { name: 'search',width:25,sortable: false,search:false}//NO I18N
            ];
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#ResUserList", jsonData.ResUsers, colNamesList, colModelList, " ", "#ResUsersListPage", "AllResourceUsers",defaultOptions);//No I18N             
            });
        }
});

App.SSLSearchView = Ember.View.extend({
    templateName: 'SearchList',//No I18N
        didInsertElement: function(){
            var filter = App.FilterKeysController.filterssl;
            var ser_type = filter.filter[0].name;
            var ser_content = filter.filter[0].value;
            searchListGen(ser_content,ser_type);
        }
});

function resourceCriteriaForm(comparatorMap,parameterMap,conditionMap)
{
        $row =  $('<tr id="1" style="height: 45px;"></tr>');
        $td = $("<td width='100px' align='left'></td>");
        $select = $('<select name="COMPARATOR_1" disabled="true" style="width:80px;  display: none;" id="COMPARATOR_1" class="form-control"></select>');
        for (var i = 0; i < comparatorMap.length; i++) {
                $select.append($('<option value="'+ comparatorMap[i].value +'">'+ comparatorMap[i].name +'</option>'));  //No I18N
                }
        $td.append($select);
        $row.append($td);
        $parameter = $("<td width='200px' align='left'></td>");
        $selectparameter = $('<select onchange="checkConditions(this)" name="PARAMETER_1" style="width: 180px;" id="PARAMETER_1" class="form-control"></select>');
        for (var i = 0; i < parameterMap.length; i++) {
                $selectparameter.append($('<option value="'+ parameterMap[i].Key +'">'+ parameterMap[i].Value +'</option>'));  //No I18N
                }
        $parameter.append($selectparameter);
        $row.append($parameter);
        $comparator = $("<td width='200px' align='left'></td>");
        $selectcondition = $('<select name="CONDITION_1" style="width: 180px;" id="CONDITION_1" class="form-control"></select>');
        for (var i = 0; i < conditionMap.length; i++) {
                $selectcondition.append($('<option value="'+ conditionMap[i].Key +'">'+ conditionMap[i].Value +'</option>'));  //No I18N
                }
        $comparator.append($selectcondition);
        $row.append($comparator);
        $valueField = $("<td width='200px' align='left'></td>");
        $valueField.append($('<input id="PATTERN_1" type="text" style="width:180px !important;" class="form-control">'));
        $row.append($valueField);
        $closeField = $("<td align='left'></td>");
        $closeField.append($('<div><span title="Delete Criteria" style="display: none;" onclick="deleteCriteriaToDeviceGroup(1);" class="glyphicon glyphicon-remove pointer"></span></div>'));
        $row.append($closeField);
        $addCriteria = $("<td align='left'></td>");
        $addCriteria.append($('<div><span title="Add Criteria" onclick="addCriteriaToDeviceGroup(1);" class="glyphicon glyphicon-plus pointer"></span></div>'));
        $row.append($addCriteria);
        $("#critetriaTable").append($row);
}

function checkConditions(element)
{
    var ids=element.id;
    var id_s = ids.split("_");
    var index=id_s[1];
    var condition_id="CONDITION_"+index;//NO I18N
    if(element.value==="KEY_STRENGTH" || element.value==="ENCRYPTION_BITS")
    {
        $("#"+condition_id).find('option').remove();
        var option = new Option("equals","EQUAL");//No I18N
        $("#"+condition_id).append(option);
        var option = new Option("not equals","NOT_EQUAL");//No I18N
        $("#"+condition_id).append(option);        
    }
    else
    {
        $("#"+condition_id).find('option').remove();
        var option = new Option("equals","EQUAL");//No I18N
        $("#"+condition_id).append(option);
        var option = new Option("not equals","NOT_EQUAL");//No I18N
        $("#"+condition_id).append(option);       
        var option = new Option("contains","LIKE");//No I18N
        $("#"+condition_id).append(option);       
        var option = new Option("not contains","NOT_LIKE");//No I18N
        $("#"+condition_id).append(option);       
        var option = new Option("starts with","STARTS_WITH");//No I18N
        $("#"+condition_id).append(option);       
        var option = new Option("ends with","ENDS_WITH");//No I18N
        $("#"+condition_id).append(option);       
    }    
}
