// $Id$
App.ReportAllView = Ember.View.extend({
	templateName: 'AllReportView',//No I18N
		didInsertElement: function(){
                    
                    }
});

App.ReportPrivatekeyReportView = Ember.View.extend({
	templateName: 'ReportsView',//No I18N
            didInsertElement: function(){
//                var controller=this.get('controller');
//                $("#FROM_DATE").val("");
//                $("#TO_DATE").datepicker({onSelect:function(){controller.send('go');}});//No I18N
//                $("#TO_DATE").val("");
        var ajaxRequestUrl = '/api/pki/ssh/getSSHKeysReport'; //No I18N
        if(kmpStandAlone  || isKMPLicPropInPMP){
            if(App.ApplicationController.viewMenus === undefined || jQuery.isEmptyObject(App.ApplicationController.viewMenus)){    
                App.ApplicationController.viewMenus=pkiJson.Reports.Reports;            
            }
        var key =App.ApplicationController.viewMenus;
            if (key!=undefined && key.indexOf('Reports_KeyGroup')>-1)
            {
        document.getElementById("ALL_GROUPS").className="form-group";//NO I18N
    }
        }else{
            document.getElementById("keyreportOptionsDiv").style="display:none"
        }
        App.ReportController.scheduleType="PrivateKeyReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var select = document.getElementById("GROUPS");
            select.name="keys";//NO I18N
            var group_array = jsonData.groupList;
            for(var i=0;i<jsonData.groupList.length;i++)
            {
                var opt = document.createElement('option');
                opt.value = group_array[i].GroupId;
                opt.innerHTML = group_array[i].GroupName;
                select.appendChild(opt);
            }
            if(jsonData.group != undefined && jsonData.group != null)
            {
                select.value= jsonData.group;
            }
            if(jsonData.SSHKeys.length===0)
            {
                $("#chart").hide();
            }
            else
            {
                if(kmpStandAlone)
                {
                    $("#chart").show();
                    createStackChart(jsonData);
                }
                else
                {
                    $("#chart").hide();
                }
            }
            var colNamesList = ['Key Id',I18N.getMsg('js.ssh.keyname'),I18N.getMsg('js.ssh.keyType'),I18N.getMsg('js.ssh.keylength'),I18N.getMsg('js.ssh.fingerprint'),I18N.getMsg('js.general.createdby'),I18N.getMsg('js.ssh.age'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'KeyID', index: 'KeyID',hidden:true}, //No I18N
                    { name: 'KeyName', index: 'KeyName'}, //No I18N
                    { name: 'KeyType', index: 'KeyType',width:'60px'}, //No I18N
                    { name: 'KeyLength', index: 'KeyLength',width:'70px'}, //No I18N
                    { name: 'FingerPrint', index: 'FingerPrint',width:'250px'}, //No I18N
                    { name: 'CreatedBy', index: 'CreatedBy'}, //No I18N
                    { name: 'CreationTime', index: 'CreationTime',sorttype: 'datetime',datefmt: 'M d, Y H:i'},//No I18N
                    { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,sortName:"CreationTime",searchOption:true}; //No I18N
            loadJQgridWithData("#reportView", jsonData.SSHKeys, colNamesList, colModelList, " ", "#PKIReportPager", "auditdetailslist",defaultOptions);//No I18N
        });
            }
});

App.ReportKeyDeplotmentView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();
        App.ReportController.scheduleType="PublicKeyDeploymentReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/report/keydepdetail'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData)
        {
            var colNamesList = [I18N.getMsg('js.general.username'),I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.ssh.keyname'),I18N.getMsg('js.ssh.keyType'),I18N.getMsg('js.ssh.keylength'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                        { name: 'UserName', index: 'UserName'}, //No I18N
                        { name: 'ResourceName', index: 'ResourceName'}, //No I18N
                        { name: 'KeyName', index: 'KeyName'}, //No I18N
                        { name: 'KeyType', index: 'KeyType'}, //No I18N
                        { name: 'KeyLength', index: 'KeyLength',width:'50px'}, //No I18N
                        { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true}; //No I18N
            loadJQgridWithData("#reportView", jsonData.keydepdetails, colNamesList, colModelList, " ", "#PKIReportPager", "auditdetailslist",defaultOptions);//No I18N
        });
    }
});

App.ReportKeyStoreReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.creationtime");//NO I18N
        App.ReportController.scheduleType="EncryptionKeysReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/encryptionKey/getEncryptionKeys'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                            var colNamesList = ['EncKeyID',I18N.getMsg("js.ssh.keyname"),I18N.getMsg("js.ssh.keyType"),I18N.getMsg("js.general.instancename"),I18N.getMsg("js.encryptionkey.datacenter"),I18N.getMsg("js.commonstr.description"),I18N.getMsg("js.general.createdby"),I18N.getMsg('js.general.creationtime'),I18N.getMsg('js.table.search')]; //No I18N
                            var colModelList = [
                            {name: 'EncKeyID', index: 'EncKeyID',hidden:true},//No I18N
                            {name: 'Key Name', index: 'Key Name'},//No I18N
                            {name: 'Key Type', index: 'Key Type'}, //No I18N
                            {name: 'Instance Name', index: 'Instance Name'}, //No I18N
                            {name: 'Datacenter', index: 'Datacenter'}, //No I18N
                            {name: 'Description', index: 'Description'}, //No I18N
                            {name: 'Created By', index: 'Created By'}, //No I18N
                            {name: 'Created Time', index: 'Created Time',sorttype: 'datetime',datefmt: 'M d, Y H:i'},//NO I18N
                            { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
                        ];
                        
                        var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true,sortName:'EncKeyID',sortOrder:'desc'};//NO I18N
                        loadJQgridWithData("#reportView", jsonData.data, colNamesList, colModelList, "", "#PKIReportPager", "EncryptionKey",defaultOptions);//No I18N
                });
    }
});

App.ReportAllKeysReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.creationtime");//NO I18N
        App.ReportController.scheduleType="AllKeysReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/Inventory/listallkeys'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var colNamesList = ['Key Id',I18N.getMsg('js.ssh.keyname'),I18N.getMsg('js.general.type'),I18N.getMsg('js.general.createdby'),I18N.getMsg('js.general.creationtime'),I18N.getMsg('js.table.search')];//NO I18N
            var colModelList = [
                {name: 'Key Id',index:'Key Id',hidden:true},//NO I18N
                {name: 'Key Name',index:'Key Name'},//NO I18N
                {name: 'Type',index:'Type'},//NO I18N
                {name: 'Created By',index:'Created By'},//NO I18N
                {name: 'Created Time',index:'Created Time',sorttype: 'datetime',datefmt: 'M d, Y H:i'},//NO I18N
                { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};//NO I18N
            loadJQgridWithData("#reportView", jsonData.allkeyslist, colNamesList, colModelList, "", "#PKIReportPager", "allkeyslist",defaultOptions);//No I18N
        });
    }
});


App.ReportUserAuditReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        document.getElementById("timecriteria").title=I18N.getMsg("js.audit.operationaudittime");//NO I18N
        App.ReportController.scheduleType="UserAuditReport";//No I18N
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true}; //No I18N
            populateRemoteApiClientGrid("reportView","PKIAuditDetailsListReport" ,"", "#PKIReportPager", "userAuditlist", defaultOptions); //No I18N
    }
});

App.ReportKeyRotationReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        document.getElementById("timecriteria").title=I18N.getMsg("js.ssh.keyrotationinvokedon");//NO I18N
        App.ReportController.scheduleType="PrivateKeyRotationReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/ssh/getKeyRotationAudit?keyStateId=2'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                if(kmpStandAlone)
                {
                if(jsonData.keyRotationAudit.length===0)
                {
                    $("#chart").hide();
                }
                else
                {
                    $("#chart").show();
                    createBarChart(jsonData);
                }
                }
                else
                {
                    $("#chart").hide();
                }

                var colNamesList = ['KeyRotationAuditId',I18N.getMsg('js.ssh.keyname'),I18N.getMsg('js.ssh.keyrotationinvokedon'),I18N.getMsg('js.general.finishtime'),I18N.getMsg('js.commonstr.status'),I18N.getMsg('js.table.search')]; //No I18N
                var colModelList = [
                        { name: 'KeyRotationAuditId', index: 'KeyRotationAuditId',hidden:true}, //No I18N
                        { name: 'Key_Name', index: 'Key_Name',classes:"pointer"}, //No I18N
                        { name: 'KeyRotationInvokedOn', index: 'KeyRotationInvokedOn',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                        { name: 'FinishTime', index: 'FinishTime',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                        { name: 'KeyRotation_Status', index: 'KeyRotation_Status'}, //No I18N
                        { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,sortName:"OPERATIONAUDITTIME",searchOption:true,subGrid:true,subGridType:"KeyRotationReport"}; //No I18N
            loadJQgridWithData("#reportView", jsonData.keyRotationAudit, colNamesList, colModelList, " ", "#PKIReportPager", "keyRotationReportlist",defaultOptions);//No I18N
        });                
    }
});

App.ReportServerAccessAuditView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.executedon");//NO I18N
        $("#chart").hide();
        App.ReportController.scheduleType="ServerAccessAuditReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/report/getServerAccessAuditView'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData)
        {
            var colNamesList = ['TERMINAL AUDITID',I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.general.username'),I18N.getMsg('js.general.invokedby'),I18N.getMsg('js.general.executedon'),I18N.getMsg('js.commonstr.status'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                        { name: 'TERMINAL AUDITID', index: 'TERMINAL AUDITID',hidden:true}, //No I18N
                        { name: 'ResourceName', index: 'ResourceName'}, //No I18N
                        { name: 'UserName', index: 'UserName'}, //No I18N
                        { name: 'InvokedBy', index: 'InvokedBy'}, //No I18N
                        { name: 'Executed On', index: 'Executed On',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                        { name: 'Status', index: 'Status',width:'100px',classes:'pointer',formatter:"statusFormatter"}, //No I18N
                        { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true}; //No I18N
            loadJQgridWithData("#reportView", jsonData.termial_status, colNamesList, colModelList, " ", "#PKIReportPager", "terminalAuditlist",defaultOptions);//No I18N
        });
    }
});

App.ReportSSLRequestView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();
        document.getElementById("timecriteria").title=I18N.getMsg("js.schedule.startdate");//NO I18N
        App.ReportController.scheduleType="SSLRequestReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/request/RequestList'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var colNamesList = ['RequestId',I18N.getMsg('js.sslrequest.newdomain'),I18N.getMsg('js.sslrequest.parentdomain'),I18N.getMsg('js.sslrequest.startdate'),I18N.getMsg('js.sslrequest.closeddate'),I18N.getMsg('js.sslrequest.requestername'),I18N.getMsg('js.commonstr.status'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'REQUESTID', index: 'REQUESTID',hidden:true}, //No I18N
                { name: 'SubDomain', index: 'SubDomain'}, //No I18N
                { name: 'ParentDomain', index: 'ParentDomain'}, //No I18N
                { name: 'StartDate', index: 'StartDate',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                { name: 'ClosedDate', index: 'ClosedDate',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                { name: 'Requested By', index: 'Requested By'}, //No I18N
                { name: 'Status', index: 'Status'}, //No I18N
                { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
            ];
        var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
        loadJQgridWithData("#reportView", jsonData.REQ_LIST, colNamesList, colModelList, " ", "#PKIReportPager","sslRequestReport" ,defaultOptions);//No I18N                        
    });

    }
});

App.ReportLetsEncryptRequestsView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.creationtime");//NO I18N
        App.ReportController.scheduleType="LetsRequestReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/letsencrypt/getRequestsReport'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            createLetsEncryptRequestsList(jsonData);
        });
    }
});

App.ReportGoDaddyOrdersReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.creationtime");//NO I18N
        App.ReportController.scheduleType="GoDaddyOrdersReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/godaddy/godaddyOrdersReport'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            createGoDaddyOrderList(jsonData);
        });
    }
});

App.ReportWildcardCertificateView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();
        document.getElementById("timecriteria").title=I18N.getMsg("js.title.expiryperiod");//NO I18N
        App.ReportController.scheduleType="WildcardCertificateReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/report/getWildcardCertificateView?wildcard=wildcard'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            createSSLWildcardCertList(jsonData);
         });
    }
});

App.ReportDeploymentReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();
        document.getElementById("timecriteria").title=I18N.getMsg("js.title.expiryperiod");//NO I18N
        App.ReportController.scheduleType="DeploymentReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/report/getDeploymentReportView'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            createDeploymentReportList(jsonData);
         });
    }
});

App.ReportDeployedServersView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();
        document.getElementById("timecriteria").title=I18N.getMsg("js.title.expiryperiod");//NO I18N
        App.ReportController.scheduleType="DeployedServersReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/report/getWildcardCertificateView'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            createSSLWildcardCertList(jsonData);
         });
    }
});

App.ReportSHA1CertificateView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();
        document.getElementById("timecriteria").title=I18N.getMsg("js.title.expiryperiod");//NO I18N
        App.ReportController.scheduleType="SHA1CertificateReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/Dashboard/Graph?type=certlist&data=sha1'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            createSHA1dCertList(jsonData);
        });
    }
});

App.Report1024CertificateView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();
        document.getElementById("timecriteria").title=I18N.getMsg("js.title.expiryperiod");//NO I18N
        App.ReportController.scheduleType="1024CertificateReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/Dashboard/Graph?type=certlist&data=1024'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            createSHA1dCertList(jsonData);
        });
    }
});

App.ReportSSLExpiryView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();        
        if(window.userRole==="Administrator")
        {
            document.getElementById("ALL_GROUPS").className="form-group";//NO I18N
        }
        document.getElementById("timecriteria").title=I18N.getMsg("js.title.expiryperiod");//NO I18N
        App.ReportController.scheduleType="SSLExpiryReport";//No I18N
        if(App.ReportController.fromdate=== undefined && App.ReportController.todate===undefined)
        {
            App.ReportController.fromdate="";
            App.ReportController.todate="";
        }   
        if(App.ReportController.days===undefined)
        {
            App.ReportController.days="";
        }
        var sday=App.ReportController.fromdate;
        var eday=App.ReportController.todate;
        var daysfilter=App.ReportController.days;
        var reqParams='ESDAY='+sday+'&EEDAY='+eday+'&daysfilter='+daysfilter;//NO I18N
        var ajaxRequestUrl = '/api/pki/Inventory/listsslSummary'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
            if(window.userRole==="Administrator")
            {
                var select = document.getElementById("GROUPS");
                select.name="sslExpiry";//NO I18N
                var group_array = jsonData.groupList;
                for(var i=0;i<jsonData.groupList.length;i++)
                {
                    var opt = document.createElement('option');
                    opt.value = group_array[i].GroupId;
                    opt.innerHTML = group_array[i].GroupName;
                    select.appendChild(opt);
                }
                if(jsonData.group != undefined && jsonData.group != null)
                {
                    select.value= jsonData.group;
                }
            }
            var colNamesList = ['ResourceID',I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.sslcertificate.issuer'),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.sslcertificate.daystoexpire'),I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg("js.commonstr.description"),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'ResourceID', index: 'ResourceID',hidden:true}, //No I18N
                    { name: 'Common Name', index: 'Common Name',width: '200'}, //No I18N                    
                    { name: 'DNS Name/FQDN', index: 'DNS Name/FQDN',width: '200'}, //No I18N
                    { name: 'Organization', index: 'Organization',width: '200px'}, //No I18N
                    { name: 'FromDate', index: 'FromDate',width:'100px',sorttype: 'datetime',datefmt: 'M d, Y H:i'},//NO I18N
                    { name: 'ExpiryDate', index: 'ExpiryDate',width:'100px',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                    { name: 'DaysToExpiry', index: 'DaysToExpiry',width:'80px'}, //No I18N
                    { name: 'KeyStrength', index: 'KeyStrength',width:'80px'}, //No I18N
                    { name: 'Description',index:'Description'},//NO I18N
                    { name: 'search',width:'20px',sortable: false,search:false,width:'30px',fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#reportView", jsonData.InventDetails, colNamesList, colModelList, " ", "#PKIReportPager", "sslCertificateReport",defaultOptions);//No I18N
        });
        
    }
});

App.ReportSSLCertificateView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        if(window.userRole==="Administrator")
        {
            document.getElementById("ALL_GROUPS").className="form-group";//NO I18N
        }
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.creationtime");//NO I18N
        $("#chart").hide();
        App.ReportController.scheduleType="SslCertificateReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/Inventory/listsslSummary'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            if(window.userRole==="Administrator")
            {
                var select = document.getElementById("GROUPS");
                select.name="sslCertificates";//NO I18N
                var group_array = jsonData.groupList;
                for(var i=0;i<jsonData.groupList.length;i++)
                {
                    var opt = document.createElement('option');
                    opt.value = group_array[i].GroupId;
                    opt.innerHTML = group_array[i].GroupName;
                    select.appendChild(opt);
                }
                if(jsonData.group != undefined && jsonData.group != null)
                {
                    select.value= jsonData.group;
                }
            }
            var colNamesList = ['ResourceID',I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.sslcertificate.issuer'),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg('js.ssl.certificate.keyalgorithm'),I18N.getMsg('js.cert.sigAlgorithm'),I18N.getMsg('js.general.creationtime'),I18N.getMsg("js.commonstr.description"),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'ResourceID', index: 'ResourceID',hidden:true}, //No I18N
                    { name: 'Common Name', index: 'Common Name'}, //No I18N                    
                    { name: 'DNS Name/FQDN', index: 'DNS Name/FQDN'}, //No I18N
                    { name: 'Organization', index: 'Organization'}, //No I18N
                    { name: 'FromDate', index: 'FromDate',width:'100px',sorttype: 'datetime',datefmt: 'M d, Y H:i',hidden:true},//NO I18N
                    { name: 'ExpiryDate', index: 'ExpiryDate',width:'100px',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                    { name: 'KeyStrength', index: 'KeyStrength',width:'80px'}, //No I18N
                    { name: 'keyAlgorithm', index: 'keyAlgorithm',width:'100px'}, //No I18N
                    { name: 'signatureAlgorithm', index: 'signatureAlgorithm',width:'120px'}, //No I18N
                    { name: 'CreationTime', index:'CreationTime',width:'120px',sorttype: 'datetime',datefmt: 'M d, Y H:i'},//NO I18N
                    { name: 'Description',index: 'Description'},//NO I18N
                    { name: 'search',width:'20px',sortable: false,search:false,width:'30px',fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#reportView", jsonData.InventDetails, colNamesList, colModelList, " ", "#PKIReportPager", "sslCertificateReport",defaultOptions);//No I18N
        });
    }
});

App.ReportLetsEncryptCertsReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.creationtime");//NO I18N
        App.ReportController.scheduleType="LetsCertificatesReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/Inventory/listsslSummary'; //No I18N
        var params = 'letsEncrypt=yes';//NO I18N
        getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
            var colNamesList = ['ResourceID',I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.sslcertificate.issuer'),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg('js.ssl.certificate.keyalgorithm'),I18N.getMsg('js.cert.sigAlgorithm'),I18N.getMsg('js.general.creationtime'),I18N.getMsg("js.commonstr.description"),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'ResourceID', index: 'ResourceID',hidden:true}, //No I18N
                    { name: 'Common Name', index: 'Common Name'}, //No I18N                    
                    { name: 'DNS Name/FQDN', index: 'DNS Name/FQDN'}, //No I18N
                    { name: 'Organization', index: 'Organization'}, //No I18N
                    { name: 'FromDate', index: 'FromDate',width:'100px',sorttype: 'datetime',datefmt: 'M d, Y H:i',hidden:true},//NO I18N
                    { name: 'ExpiryDate', index: 'ExpiryDate',width:'100px',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                    { name: 'KeyStrength', index: 'KeyStrength',width:'80px'}, //No I18N
                    { name: 'keyAlgorithm', index: 'keyAlgorithm',width:'100px'}, //No I18N
                    { name: 'signatureAlgorithm', index: 'signatureAlgorithm',width:'120px'}, //No I18N
                    { name: 'CreationTime', index:'CreationTime',width:'120px',sorttype: 'datetime',datefmt: 'M d, Y H:i'},//NO I18N
                    { name: 'Description',index: 'Description'},//NO I18N
                    { name: 'search',width:'20px',sortable: false,search:false,width:'30px',fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#reportView", jsonData.InventDetails, colNamesList, colModelList, " ", "#PKIReportPager", "sslCertificateReport",defaultOptions);//No I18N
        });
    }
});

App.ReportAdUserCertificatesView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.creationtime");//NO I18N
        $("#chart").hide();
        App.ReportController.scheduleType="ADSslCertificateReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/Inventory/listadsslSummary'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var colNamesList = [I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.domainname'),I18N.getMsg('js.sslcertificate.domaincontroller'),I18N.getMsg("js.userreport.username"),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.common.daystoexpiry'),I18N.getMsg('js.general.creationtime'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'Common_Name', index: 'Common_Name'}, //No I18N      
                    { name: 'Domain_Name',index:'Domain_Name'},//NO I18N
                    { name: 'Domain_Controller', index: 'Domain_Controller'}, //No I18N
                    { name: 'User_Name', index: 'User_Name'}, //No I18N
                    { name: 'From_Date', index: 'From_Date',width:'100px',sorttype: 'datetime',datefmt: 'M d, Y H:i'},//NO I18N
                    { name: 'To_Date', index: 'To_Date',width:'100px',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                    { name: 'Days_Expiry', index: 'Days_Expiry',width:'80px'}, //No I18N
                    { name: 'Created_Time', index:'Created_Time',width:'120px',sorttype: 'datetime',datefmt: 'M d, Y H:i'},//NO I18N
                    { name: 'search',width:'20px',sortable: false,search:false,width:'30px',fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#reportView", jsonData.InventDetails, colNamesList, colModelList, " ", "#PKIReportPager", "ADsslCertificateReport",defaultOptions);//No I18N
        });
    }
});

App.ReportInventoryReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.creationtime");//NO I18N
        $("#chart").hide();
        App.ReportController.scheduleType="ResourceReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/Inventory/listSummary'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            if(window.userRole==="Administrator")
            {
                var select = document.getElementById("GROUPS");
                select.name="resources";//NO I18N
                var group_array = jsonData.groupList;
                for(var i=0;i<jsonData.groupList.length;i++)
                {
                    var opt = document.createElement('option');
                    opt.value = group_array[i].GroupId;
                    opt.innerHTML = group_array[i].GroupName;
                    select.appendChild(opt);
                }
                if(jsonData.group != undefined && jsonData.group != null)
                {
                    select.value= jsonData.group;
                }
            }
            var colNamesList = ['Resource_ID',I18N.getMsg('js.general.resourcename'),I18N.getMsg("js.commonstr.description"),I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.discovery.resourcetype'),'',I18N.getMsg('js.general.creationtime'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'ResourceID', index: 'ResourceID',hidden:true},//No I18N
                    { name: 'ResourceName', index: 'ResourceName'}, //No I18N
                    { name: 'Description', index: 'Description',hidden:true},//NO I18N
                    { name: 'IPAddress', index: 'IPAddress',formatter:'ipcheckFormatter'}, //No I18N
                    { name: 'ResourceType', index: 'ResourceType'}, //No I18N
                    { name: 'SSH', index: 'SSH',width:'50px',formatter:'sshEnabledFormatter',search:false,hidden:true}, //No I18N
                    { name: 'CreationTime', index: 'CreationTime',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                    { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#reportView", jsonData.Resources, colNamesList, colModelList, "", "#PKIReportPager", "inventoryReport",defaultOptions);//No I18N                    
        });
    }
});

App.ReportLandingServersReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.creationtime");//NO I18N
        $("#chart").hide();
        App.ReportController.scheduleType="LandingServersReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/report/LandingServersReportView'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){          
            var colNamesList = ['ServerId',I18N.getMsg('landingserver.servername'),I18N.getMsg("landingserver.primaryserver"),I18N.getMsg('landingserver.primaryserver.account'),I18N.getMsg('landingserver.secondaryserver'),I18N.getMsg("landingserver.secondaryserver.account"),I18N.getMsg("js.general.createdby"),I18N.getMsg('js.general.creationtime'),I18N.getMsg('js.commonstr.description'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'ServerId', index: 'ServerId',hidden:true},//No I18N
                    { name: 'ServerName', index: 'ServerName',width:'120px',classes:"pointer"}, //No I18N
                    { name: 'PrimaryServer', index: 'PrimaryServer',width:'120px'},//NO I18N
                    { name: 'PrimaryUser', index: 'PrimaryUser',width:'130px'}, //No I18N
                    { name: 'SecondaryServer', index: 'SecondaryServer',width:'120px'},//NO I18N
                    { name: 'SecondaryUser', index: 'SecondaryUser',width:'150px'},//NO I18N
                    { name: 'CreatedBy', index: 'CreatedBy',width:'80px'},//NO I18N
                    { name: 'CreatedTime', index: 'CreatedTime',sorttype: 'datetime',datefmt: 'M d, Y H:i',width:'100px'},//NO I18N
                    { name: 'Description', index: 'Description',width:'100px'},//NO I18N
                    { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true,subGrid:true,subGridType:"LandingServerReport"};//NO I18N
            loadJQgridWithData("#reportView", jsonData.LandingServers, colNamesList, colModelList, "", "#PKIReportPager", "LandignServerReport",defaultOptions);//No I18N     
        });        
    }
});

App.ReportMSCARenewalReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.creationtime");//NO I18N
        $("#chart").hide();
        App.ReportController.scheduleType="MSCARenewalReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        App.Report.getMscaRenewalReportList();
    }
});

App.ReportSignReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.creationtime");//NO I18N
        $("#chart").hide();
        App.ReportController.scheduleType="SignReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        App.Report.getSignedReportList();
    }
});

App.ReportSSLVulnerabilitiesReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.creationtime");//NO I18N
        $("#chart").hide();
        if(window.userRole==="Administrator")
        {
            document.getElementById("ALL_GROUPS").className="form-group";//NO I18N
        }
        $("#csvdownload").attr("style", "display: none !important");
        App.ReportController.scheduleType="SSLVulnerabilitiesReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/Inventory/listsslSummary'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            if(window.userRole==="Administrator")
            {
                var select = document.getElementById("GROUPS");
                select.name="sslVulnerabilities";//NO I18N
                var group_array = jsonData.groupList;
                for(var i=0;i<jsonData.groupList.length;i++)
                {
                    var opt = document.createElement('option');
                    opt.value = group_array[i].GroupId;
                    opt.innerHTML = group_array[i].GroupName;
                    select.appendChild(opt);
                }
                if(jsonData.group != undefined && jsonData.group != null)
                {
                    select.value= jsonData.group;
                }
            }
            var colNamesList = ['ResourceID',I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.sslcertificate.issuer'),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg('js.ssl.certificate.keyalgorithm'),I18N.getMsg('js.cert.sigAlgorithm'),I18N.getMsg('js.general.creationtime'),I18N.getMsg("js.commonstr.description"),'',I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'ResourceID', index: 'ResourceID',hidden:true}, //No I18N
                    { name: 'Common Name', index: 'Common Name',classes:"pointer",formatter:"vulFlagFormatter"}, //No I18N                    
                    { name: 'DNS Name/FQDN', index: 'DNS Name/FQDN'}, //No I18N
                    { name: 'Organization', index: 'Organization'}, //No I18N
                    { name: 'FromDate', index: 'FromDate',width:'100px',sorttype: 'datetime',datefmt: 'M d, Y H:i',hidden:true},//NO I18N
                    { name: 'ExpiryDate', index: 'ExpiryDate',width:'100px',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                    { name: 'KeyStrength', index: 'KeyStrength',width:'80px'}, //No I18N
                    { name: 'keyAlgorithm', index: 'keyAlgorithm',width:'100px'}, //No I18N
                    { name: 'signatureAlgorithm', index: 'signatureAlgorithm',width:'120px'}, //No I18N
                    { name: 'CreationTime', index:'CreationTime',width:'120px',sorttype: 'datetime',datefmt: 'M d, Y H:i'},//NO I18N
                    { name: 'Description',index: 'Description'},//NO I18N
                    { name: 'Flag' , index: 'Flag',hidden:true},//NO I18N
                    { name: 'search',width:'20px',sortable: false,search:false,width:'30px',fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,subGrid:true,searchOption:true,subGridType:"SSLVulnerabilitiesReport"};//NO I18N
            loadJQgridWithData("#reportView", jsonData.InventDetails, colNamesList, colModelList, " ", "#PKIReportPager", "SSLVulnerabilitiesReport",defaultOptions);//No I18N
        });
    }
});

App.VulnerabilitiesPopUpView=Ember.View.extend({
    templateName:'VulnerabilitiesPopUp',//NO I18N
    didInsertElement:function(){
        $("#VulnerabilitiesPopUp .modal-dialog").css({"width":"1050px"});//NO I18N             
        var id=App.ReportController.id;
        App.Inventory.listSSLVulSubSubGrid(id);
    }
});

App.ReportSSHResourceReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
         if(App.ApplicationController.viewMenus === undefined || jQuery.isEmptyObject(App.ApplicationController.viewMenus)){    
                App.ApplicationController.viewMenus=pkiJson.Reports.Reports;            
            }
         var keys = App.ApplicationController.viewMenus;
            if (keys.indexOf('Reports_SSHResourceGroup')>-1)
        {
            document.getElementById("ALL_GROUPS").className="form-group";//NO I18N
        }
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.creationtime");//NO I18N
        $("#chart").hide();
        App.ReportController.scheduleType="SSHResourceReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/Inventory/listsshSummary'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            if(window.userRole==="Administrator")
            {
                var select = document.getElementById("GROUPS");
                select.name="sshResources";//NO I18N
                var group_array = jsonData.groupList;
                for(var i=0;i<jsonData.groupList.length;i++)
                {
                    var opt = document.createElement('option');
                    opt.value = group_array[i].GroupId;
                    opt.innerHTML = group_array[i].GroupName;
                    select.appendChild(opt);
                }
                if(jsonData.group != undefined && jsonData.group != null)
                {
                    select.value= jsonData.group;
                }
            }
            var colNamesList = ['Resource_ID',I18N.getMsg('js.general.resourcename'),I18N.getMsg("js.commonstr.description"),I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.general.creationtime'),I18N.getMsg("landingserver.heading"),I18N.getMsg("landingserver.heading"),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'ResourceID', index: 'ResourceID',hidden:true},//No I18N
                    { name: 'ResourceName', index: 'ResourceName'}, //No I18N
                    { name: 'Description', index: 'Description'},//NO I18N
                    { name: 'IPAddress', index: 'IPAddress',formatter:'ipcheckFormatter'}, //No I18N
                    { name: 'CreationTime', index: 'CreationTime',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                    { name: 'LSName', index: 'LSName'},//NO I18N
                    { name: 'isLS', index: 'isLS',hidden:true},//NO I18N
                    { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#reportView", jsonData.Resources, colNamesList, colModelList, "", "#PKIReportPager", "inventoryReport",defaultOptions);//No I18N     
        });        
    }
});


App.ReportUsersReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
         if(App.ApplicationController.viewMenus === undefined || jQuery.isEmptyObject(App.ApplicationController.viewMenus)){    
                App.ApplicationController.viewMenus=pkiJson.Reports.Reports;            
            }
        var keys = App.ApplicationController.viewMenus;
            if (keys.indexOf('Reports_SSHUserGroup')>-1)
        {
            document.getElementById("ALL_GROUPS").className="form-group";//NO I18N
        }
            $("#timecriteria").hide();
            $("#chart").hide();
        App.ReportController.scheduleType="UsersReport";//No I18N
        var ajaxRequestUrl = '/api/pki/Inventory/listUsers'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            if(window.userRole==="Administrator")
            {
                var select = document.getElementById("GROUPS");
                select.name="users";//NO I18N
                var group_array = jsonData.groupList;
                for(var i=0;i<jsonData.groupList.length;i++)
                {
                    var opt = document.createElement('option');
                    opt.value = group_array[i].GroupId;
                    opt.innerHTML = group_array[i].GroupName;
                    select.appendChild(opt);
                }
                if(jsonData.group != undefined && jsonData.group != null)
                {
                    select.value= jsonData.group;
                }
            }
            var colNamesList = ['User_ID',I18N.getMsg('js.userreport.username'),I18N.getMsg('js.userreport.resourcename'),I18N.getMsg('js.userreport.associatedkeys'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'UserID', index: 'UserID',hidden:true},//No I18N
                    { name: 'UserName', index: 'UserName'}, //No I18N
                    { name: 'ResourceName', index: 'ResourceName'},//NO I18N
                    { name: 'AssociatedKeys', index: 'AssociatedKeys'},//No I18N                    
                    { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#reportView", jsonData.users, colNamesList, colModelList, "", "#PKIReportPager", "userreport",defaultOptions);//No I18N                    
        });
    }
});

App.TimeLineView = Ember.View.extend({
    templateName: 'TimeLine',//No I18N
    didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg("js.modaltitle.timePeriod"));//NO I18N
        $('[data-toggle="popover"]').popover();
        $( "#modalDialog" ).draggable();
        $("#FROM_DATE").datepicker();
        $("#TO_DATE").datepicker();
        $("#FROM_DATE").val(App.ReportController.fromdate);
        $("#TO_DATE").val(App.ReportController.todate);
    }
    });
    
App.ExpiryFilterView = Ember.View.extend({
    templateName: 'ExpiryFilter',//No I18N
    didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg("js.expiry.datefilter"));//NO I18N
        $('[data-toggle="popover"]').popover();
        $( "#modalDialog" ).draggable();
        $("#FROM_DATE").datepicker();
        $("#TO_DATE").datepicker();
        jQuery("#radio5").attr('checked', true);//NO I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        App.ReportController.days="";
    }
    });    
    
    App.ExpiryFilterController = Ember.ObjectController.extend({
        needs:'application',//NO I18N
        actions:{
            close: function() {
          return this.send('closeModal');//NO I18N
            },
        submit: function(){
                var text=$('.nav-tabs .active').text();
                if(text === "Filter By Days")
                {
                    var filterByDays = $("input[name='radiodays']:checked").val();//No I18N
                    if(filterByDays === '0')
                    {
                        App.ReportController.days="";
                    }
                    else
                    {
                        App.ReportController.days=filterByDays;
                    }                    
                }
                else
                {
                    App.ReportController.fromdate=$("#FROM_DATE").val();
                    App.ReportController.todate=$("#TO_DATE").val();  
                    if(!validateCriteria())
                    {
                        return;
                    }                    
                }
                redirectUrl("Report/sslExpiryReport");//No I18N
                return this.send('closeModal');//NO I18N
            }
        }
    });
    
App.TimeLineController = Ember.ObjectController.extend({
   needs:['ReportSSLStoreOrdersReport','ReportGoDaddyOrdersReport','ReportSignReport','ReportSSLVulnerabilitiesReport','ReportLandingServersReport','ReportLetsEncryptCertsReport','ReportLetsEncryptRequests','ReportAllKeysReport','ReportAdUserCertificates','ReportKeyStoreReport','ReportPrivatekeyReport','ReportSSLExpiry','ReportSSLRequest','ReportUserAuditReport','ReportSSLCertificate','ReportKeyDeplotment','ReportSSHResourceReport','ReportKeyRotationReport','ReportServerAccessAudit','ReportInventoryReport','ReportWildcardCertificate','ReportSHA1Certificate','Report1024Certificate','ReportDeployedServers','ReportDeploymentReport','ReportMSCARenewalReport'],//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        submit: function(){
            var scheduleType=App.ReportController.scheduleType;
            App.ReportController.fromdate=$("#FROM_DATE").val();
            App.ReportController.todate=$("#TO_DATE").val();  
            if(!validateCriteria())
            {
                return;
            }
            var controller='';
            if(scheduleType==='PrivateKeyReport')
            {
                controller='controllers.ReportPrivatekeyReport';//No I18N
            }
            else if(scheduleType==='PublicKeyDeploymentReport')
            {
                controller='controllers.ReportKeyDeplotment';//No I18N
            }
            else if(scheduleType==='UserAuditReport')
            {
                controller='controllers.ReportUserAuditReport';//No I18N
            }
            else if(scheduleType==='PrivateKeyRotationReport')
            {
                controller='controllers.ReportKeyRotationReport';//No I18N
            }
            else if(scheduleType==='ServerAccessAuditReport')
            {
                controller='controllers.ReportServerAccessAudit';//No I18N
            }
            else if(scheduleType==='ResourceReport')
            {
                controller='controllers.ReportInventoryReport';//No I18N
            }
            else if(scheduleType==='SSHResourceReport')
            {
                controller = 'controllers.ReportSSHResourceReport';//NO I18N
            }
            else if(scheduleType === 'SslCertificateReport')
            {
                controller ='controllers.ReportSSLCertificate';//NO I18N
            }
            else if(scheduleType === 'ADSslCertificateReport')
            {
                controller ='controllers.ReportAdUserCertificates';//NO I18N
            }
            else if(scheduleType === 'SSLRequestReport')
            {
                controller ='controllers.ReportSSLRequest';//NO I18N
            }
            else if(scheduleType === 'SSLExpiryReport')
            {
                controller ='controllers.ReportSSLExpiry';//NO I18N
            }
            else if(scheduleType === 'EncryptionKeysReport')
            {
                controller = 'controllers.ReportKeyStoreReport';//NO I18N
            }
            else if(scheduleType === 'AllKeysReport')
            {
                controller = 'controllers.ReportAllKeysReport';//NO I18N
            }
            else if(scheduleType === 'WildcardCertificateReport')
            {
                controller = 'controllers.ReportWildcardCertificate';//NO I18N
            }
            else if(scheduleType === 'DeployedServersReport')
            {
                controller = 'controllers.ReportDeployedServers';//NO I18N
            }
            else if(scheduleType === 'SHA1CertificateReport')
            {
                controller = 'controllers.ReportSHA1Certificate';//NO I18N
            }
            else if(scheduleType === '1024CertificateReport')
            {
                controller = 'controllers.Report1024Certificate';//NO I18N
            }
            else if(scheduleType === 'LetsRequestReport')
            {
                controller = 'controllers.ReportLetsEncryptRequests';//NO I18N
            }
            else if(scheduleType === 'LetsCertificatesReport')
            {
                controller = 'controllers.ReportLetsEncryptCertsReport';//NO I18N
            }
            else if(scheduleType === 'DeploymentReport')
            {
                controller = 'controllers.ReportDeploymentReport';//NO I18N
            }
            else if(scheduleType === 'LandingServersReport')
            {
                controller = 'controllers.ReportLandingServersReport';//NO I18N
            }
            else if(scheduleType === 'SSLVulnerabilitiesReport')
            {
                controller = 'controllers.ReportSSLVulnerabilitiesReport';//NO I18N
            }
            else if(scheduleType === 'MSCARenewalReport')
            {
                controller = 'controllers.ReportMSCARenewalReport';//NO I18N
            }
            else if(scheduleType === 'SignReport')
            {
                controller = 'controllers.ReportSignReport';//NO I18N
            }
            else if(scheduleType === 'GoDaddyOrdersReport')
            {
                controller = 'controllers.ReportGoDaddyOrdersReport';//NO I18N
            }
            else if(scheduleType === 'SSLStoreOrdersReport')
            {
                controller = 'controllers.ReportSSLStoreOrdersReport';//NO I18N
            }
            var app=this.get(controller);
            app.send('go');//No I18N
            document.getElementById("close_Dialog").click();//NO I18N
        }
    }
});


function createStackChart(data)
{
    var data_arr=getStackChartData(data);
    var plac_arr=document.getElementById("chart");//NO I18N
    var chartObj = new $ZC.charts(plac_arr,data_arr);
}

function getStackChartData(data)
{
    var colorCode=[
			"#f9575c",//No I18N
			"#f5d16c",//No I18N
			"#28c28f",//No I18N
			"#58595b"//No I18N
		];
    if(!kmpStandAlone)
    {
        colorCode=["#47D1AF","#2B3D51","#27C46B","#F68300"];//No I18N
    }
   
    var data_arr={
	"seriesdata": {//NO I18N
		"categories": [//NO I18N
			I18N.getMsg("js.report.keyreport.keytype.sshrsa"),//NO I18N
                        I18N.getMsg("js.report.keyreport.keytype.sshdss"),//NO I18N
                        I18N.getMsg("js.report.keyreport.keytype.unknown")//NO I18N
		],
		"chartdata": [//NO I18N
			{
				"type": 10,//NO I18N
				"yaxiscolumnorder": [//NO I18N
					0
				],
				"seriesname": "1024 bits",//NO I18N
				"data": [//NO I18N
					[
						[
							"SSH RSA",//NO I18N
							data.Count.get(0).rsa1024Count
						],
						[
							"SSH DSA",//NO I18N
							data.Count.get(0).dss1024Count
						],
						[
							"UNKNOWN",//NO I18N
							0
						]
					]
				]
			},
			{
				"type": 10,//NO I18N
				"yaxiscolumnorder": [//NO I18N
					0
				],
				"seriesname": "2048 bits",//NO I18N
				"data": [//NO I18N
					[
						[
							"SSH RSA",//NO I18N
							data.Count.get(0).rsa2048Count
						],
						[
							"SSH DSA",//NO I18N
							data.Count.get(0).dss2048Count
						],
						[
							"UNKNOWN",//NO I18N
							0
						]
					]
				]
			},
			{
				"type": 10,//NO I18N
				"yaxiscolumnorder": [//NO I18N
					0
				],
				"seriesname": "4096 bits",//NO I18N
				"data": [//NO I18N
					[
						[
							"SSH RSA",//NO I18N
							data.Count.get(0).rsa4096Count
						],
						[
							"SSH DSA",//NO I18N
							data.Count.get(0).dss4096Count
						],
						[
							"UNKNOWN",//NO I18N
							0
						]
					]
				]
			},
                        {
				"type": 10,//NO I18N
				"yaxiscolumnorder": [//NO I18N
					0
				],
				"seriesname": "Unknown",//NO I18N
				"data": [//NO I18N
					[
						[
							"SSH RSA",//NO I18N
							0
						],
						[
							"SSH DSS",//NO I18N
							0
						],
						[
							"UNKNOWN",//NO I18N
							data.Count.get(0).unknownCount
						]
					]
				]
			}
                        
		]
	},
	"metadata": {//NO I18N
		"axes": {//NO I18N
			"x": [//NO I18N
				0
			],
			"y": [//NO I18N
				[
					1
				]
			],
			"clr": [//NO I18N
				2
			],
			"tooltip": [//NO I18N
				0,
				1,
				2
			]
		},
		"columns": [//NO I18N
			{
				"dataindex": 0,//NO I18N
				"columnname": I18N.getMsg("js.report.graph.KeyType"),//NO I18N
				"datatype": "ordinal"//NO I18N
				
			},
			{
				"dataindex": 1,//NO I18N
				"columnname": I18N.getMsg("js.report.graph.Numberofkeys"),//NO I18N
				"datatype": "numeric"//NO I18N
			},
			{
                                "dataindex":2,//NO I18N
				"columnname": I18N.getMsg("js.report.graph.KeyLength"),//NO I18N
                                "datatype":"ordinal"//NO I18N
			}
		]
                
	},
	"chart": {//NO I18N
		"axes": {//NO I18N
			"rotated": "true",//NO I18N
			"xaxis": {//NO I18N
				"label": {//NO I18N
					"text": "KeyType",//NO I18N
					"show": "false"//NO I18N
				},
				"ticklabel": {//NO I18N
					"rotation": "auto",//NO I18N
                                        "fontSize":12//NO I18N
				},
				"show": "true"//NO I18N
			},
			"yaxis": [//NO I18N
				{
					"label": {//NO I18N
						"text": "Number of keys",//NO I18N
						"show": "false"//NO I18N
					},
                                        "show":"false"//NO I18N
					}
			]
		},
		"plot": {//NO I18N
			"plotoptions": {//NO I18N
				"bar": {//NO I18N
					"stacked": {//NO I18N
						"enabled": "false"//NO I18N
					}
				}
			},
			"datalabels": {//NO I18N
				"fontSize": 28,//NO I18N
				"show": "true",//NO I18N
                                "fontColor":"#FFFFFF"//NO I18N
			},
			"animation": {//NO I18N
				"easingType": "linear-in"//NO I18N
			},
                        "events": {//NO I18N
				"cursor": "null"//NO I18N
			}
		},
//		"effects": {//NO I18N
//			"choice": "chalk"//NO I18N
//		}
                
	},
	"legend": {//NO I18N
		"colorPallete": {//NO I18N
			"options": {//NO I18N
				"multicolor": "countries",//NO I18N
				"monochrome": {//NO I18N
					"baseColor": "#8C4444",//NO I18N
					"generatorType": "both"//NO I18N
				}
			}
		},
		"background": {//NO I18N
			"color": "rgba(2,63,174,0)"//NO I18N
                        
		},
                "highlightEffect": {//No I18N
                            "selectedSeries": "illuminate"//No I18N
                        },
            "colors": colorCode,//No I18N
		"enabled": "false",//NO I18N
		"x": "null",//NO I18N
                "fontSize":12//NO I18N
	},
	"canvas": {//NO I18N
		"title": {//NO I18N
			"text": "Multiple series - Stacked",//NO I18N
			"show": "false"//NO I18N
		},
		"subtitle": {//NO I18N
			"show": "false"//NO I18N
		},
		"border": {//NO I18N
			"show": "false"//NO I18N
		},
                "shadow":{//NO I18N
                    "show":"false"//NO I18N
                }
	},
	"tooltip": {//NO I18N
		"enabled": "true"//NO I18N
		
		
	}
}
return data_arr;
}

function createLineChart(data)
{
    var data_arr=getLineChartData(data);
    var plac_arr=document.getElementById("chart");//NO I18N
    var chartObj1 = new $ZC.charts(plac_arr,data_arr);    
}

function getLineChartData(data)
{
    var data_arr={
	"metadata": {//NO I18N
		"axes": {//NO I18N
			"x": [//NO I18N
				0
			],
			"y": [//NO I18N
				[
					1
				]
			],
			"tooltip": [//NO I18N
				0,
				1
			]
		},
		"columns": [//NO I18N
			{
				"dataindex": 0,//NO I18N
				"columnname": "Time",//NO I18N
				"datatype": "ordinal"//NO I18N
			},
			{
				"dataindex": 1,//NO I18N
				"columnname": "Number of Keys",//NO I18N
				"datatype": "numeric"//NO I18N
			}
		]
	},
	"seriesdata": {//NO I18N
		"chartdata": [//NO I18N
			{
				"type": 11,//NO I18N
				"yaxiscolumnorder": [//NO I18N
					0
				],
				"data": [//NO I18N
					[
						[
							"Last 7 Days",//NO I18N
							data.Count.get(0).last7Days
						],
						[
							"Last 15 Days",//NO I18N
							data.Count.get(0).last15Days
						],
						[
							"Last 30 Days",//NO I18N
							data.Count.get(0).last30Days
						],
						[
							"> 30 Days",//NO I18N
							data.Count.get(0).remaining
						]
					]
				]
			}
		]
	},
	"chart": {//NO I18N
		"axes": {//NO I18N
			"rotated": false,//NO I18N
			"xaxis": {//NO I18N
				"label": {//NO I18N
					"text": "Year(Date)",//NO I18N
					"show": "false"//NO I18N
				},
				"ticklabel": {//NO I18N
					"rotation": "auto",//NO I18N
                                        "fontSize":14//NO I18N
				}
			},
			"yaxis": [//NO I18N
				{
					"label": {//NO I18N
						"text": "Sum(Sales)"//NO I18N
					},
					"show": "false"//NO I18N
				}
			]
		},
		"plot": {//NO I18N
			"plotoptions": {//NO I18N
				"line": {//NO I18N
					"animation": {}//NO I18N
				}
			},
			"datalabels": {//NO I18N
                                "fontSize":24,//NO I18N
				"show": "true"//NO I18N                                
			},
                        "background": {//NO I18N
				"color": "rgba(208,208,208,0.4)"//NO I18N
			}
		},
		"effects": {//NO I18N
			"choice": "dropShadow"//NO I18N
		}
	},
	"canvas": {//NO I18N
		"title": {//NO I18N
			"text": "Single series - Vertical",//NO I18N
			"show": "false"//NO I18N
		},
		"subtitle": {//NO I18N
			"show": "false"//NO I18N
		},
		"border": {//NO I18N
			"show": "false"//NO I18N
		},
		"shadow": {//NO I18N
			"show": "false"//NO I18N
		}
	},
	"legend": {//NO I18N
		"colorPallete": {//NO I18N
			"options": {//NO I18N
				"multicolor": "zoho-reports"//NO I18N
			}
		}
	}

}
return data_arr;
}
 
// function showHello(event,data,chartObj)
// {
//     var xdata = data.data[0];
//    var ydata = data.data[1];
//    var zdata = data.data[2];
//    if(xdata.value=="SSH RSA")
//    {
//        $("#gs_KeyType").val("ssh-rsa");
//        $('#reportView').trigger('reloadGrid'); //No I18N
//    }
//    alert(xdata.value);;
// }


function createBarChart(data)
{
    var data_arr=getBarChartData(data);
    var plac_arr=document.getElementById("chart");//NO I18N
    $(plac_arr).width(1000);
    var chartObj1 = new $ZC.charts(plac_arr,data_arr);    
}

function getBarChartData(data)
{
    var data_arr={
	"canvas": {//NO I18N
		"theme": "flatui",//NO I18N
		"title": {	//NO I18N		
			"show": "false"//NO I18N
		},
		"subtitle": {//NO I18N
			"show": "false"//NO I18N
		},
		"border": {//NO I18N
			"show": "false"//NO I18N
		},
		"shadow": {//NO I18N
			"show": "false"//NO I18N
		}
	},
	"seriesdata": {//NO I18N
		"chartdata": [//NO I18N
			{
				"type": 9,//NO I18N
				"yaxiscolumnorder": [//NO I18N
					0
				],
				"data": [//NO I18N
					[
						[
							I18N.getMsg("js.report.chart.lastSevenDays"),//NO I18N
							data.Count.get(0).last7Days
						],
						[
							I18N.getMsg("js.report.chart.last8to15Days"),//NO I18N
							data.Count.get(0).last15Days
						],
						[
							I18N.getMsg("js.report.chart.last16to30Days"),//NO I18N
							data.Count.get(0).last30Days
						],
						[
							I18N.getMsg("js.report.chart.greaterThan30days"),//NO I18N
							data.Count.get(0).remaining
						]
					]
				]
			}
		]
	},
	"metadata": {//NO I18N
		"axes": {//NO I18N
			"x": [//NO I18N
				0
			],
			"y": [//NO I18N
				[
					1
				]
			],
			"tooltip": [//NO I18N
				0,
				1
			]
		},
		"columns": [//NO I18N
			{
				"dataindex": 0,//NO I18N
				"columnname": I18N.getMsg("js.report.chart.time"),//NO I18N
				"datatype": "ordinal"//NO I18N
				
			},
			{
				"dataindex": 1,//NO I18N
				"columnname": I18N.getMsg("js.report.chart.numberOfKeys"),//NO I18N
				"datatype": "numeric"//NO I18N				
			}
		]
	},
        "legend": {//No I18N
                        "highlightEffect": {//No I18N
                            "selectedSeries": "illuminate"//No I18N
                        }
                    },
	"chart": {//NO I18N
		"axes": {//NO I18N
			"xaxis": {//NO I18N
				"label": {//NO I18N
					"text": "Time",//NO I18N
					"show": "false"//NO I18N
				},
				"ticklabel": {//NO I18N
					"rotation": "auto",//NO I18N
                                        "fontColor": "#000000"//NO I18N
				},
				"axisline": {//NO I18N
					"color": "transparent"//NO I18N
				},
				"show": "true"//NO I18N
                                
			},
			"yaxis": [//NO I18N
				{
					"label": {//NO I18N
						"text": "Number Of Keys"//NO I18N
					},
					"show": "false"//NO I18N
				}
			]
		},
		"plot": {//NO I18N
			"plotoptions": {//NO I18N
				"bar": {//NO I18N
					"animation": {},//NO I18N
                                        "maxBandWidth": "100"//NO I18N
				}
			},
			"datalabels": {//NO I18N
				"show": "true",//NO I18N
				"fontSize": 24//NO I18N
			},
                        "events": {//NO I18N
				"cursor": "null"//NO I18N
			}
		},
		"fontSize": 24,//NO I18N
		"fontColor": "#000000",//NO I18N
		"fontWeight": "normal",//NO I18N
		"fontStyle": "normal"//NO I18N
		
		}
	}
return data_arr;
}

App.ReportSSLStoreOrdersReportView = Ember.View.extend({
    templateName: 'ReportsView',//No I18N
    didInsertElement: function(){
        $("#chart").hide();
        document.getElementById("timecriteria").title=I18N.getMsg("js.general.creationtime");//NO I18N
        App.ReportController.scheduleType="SSLStoreOrdersReport";//No I18N
        App.ReportController.fromdate="";
        App.ReportController.todate="";
        var ajaxRequestUrl = '/api/pki/sslstore/sslStoreOrdersReport'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            createSSLStoreOrdersList(jsonData);
        });
    }
});
