// $Id$
App.Audit = Ember.Object.extend({});

App.Audit.reopenClass({
    getAuditList: function() {
        var ajaxRequestUrl = '/api/pki/settings/auditlist'; //No I18N
                var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true}; //No I18N
        populateRemoteApiClientGrid("PKIAuditDetailsList","PKIAuditDetailsList", "", "#PKIAuditPager", "auditdetailslist", defaultOptions); //No I18N
    },getAuditNotify:function(){
        var reqUrl="/api/pki/settings/getauditNotify";//NO I18N
            getAjaxApiRequest(reqUrl,"",function(json){
                 //json.notifyAudit;
                 if(json.OperationType != null ) {
                    var colNamesList = ['id','','','','','']; //No I18N
                    var colModelList = [
                        { name: 'id', index: 'id',hidden:true}, //No I18N
                        { name: 'text', index: 'text'}, //No I18N
                        { name: 'audit_type', index: 'audit_type'}, //No I18N
                        { name: 'ISNOTIFY', index: 'ISNOTIFY',formatter:'checkbox_audit_formatter'}, //No I18N
                        { name: 'IS_SNMP_NOTIFY', index: 'IS_SNMP_NOTIFY',formatter:'checkbox_audit_formatter'}, //No I18N
                        { name: 'IS_SYSLOG_NOTIFY', index: 'IS_SYSLOG_NOTIFY',formatter:'checkbox_audit_formatter'}, //No I18N
                    ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,grouping:true,groupField:['audit_type'],groupCollapse:false,minRowsPerPage:250,height:'300px',groupOrder:['asc'],groupText:'<b class="spanattr">  {0}<td role="gridcell" style="" title="" aria-describedby="PKI_grid_columncheckbox_ISNOTIFY"><input type="checkbox" id="ISNOTIFY_{0}" onclick="selectAllNotifyCheckBox(\'{0}\',this,\'ISNOTIFY\')"></td><td role="gridcell" style="" title="" aria-describedby="PKI_grid_columncheckbox_IS_SNMP_NOTIFY"><input type="checkbox" id="IS_SNMP_NOTIFY_{0}" onclick="selectAllNotifyCheckBox(\'{0}\',this,\'IS_SNMP_NOTIFY\')"></td><td role="gridcell" style="" title="" aria-describedby="PKI_grid_columncheckbox_IS_SYSLOG_NOTIFY"><input type="checkbox" id="IS_SYSLOG_NOTIFY_{0}" onclick="selectAllNotifyCheckBox(\'{0}\',this,\'IS_SYSLOG_NOTIFY\')"></td>  </b>'};//NO I18N
            loadJQgridWithData("#PKI_grid_columncheckbox", json.OperationType.notify.data, colNamesList, colModelList, "", "", "",defaultOptions);//No I18N     
    }
                $(".spanattr").parent().attr('colspan',1);
                var notify=['ISNOTIFY','IS_SNMP_NOTIFY','IS_SYSLOG_NOTIFY'];//NO I18N
                var auditTypes=['SSL','SSH','KEYSTORE','SETTINGS','DISCOVERY'];//NO I18N
                notify.forEach(function(name){
                    auditTypes.forEach(function(type){
                        notifyParentOnAllChildchecked(name,type);
                });
                    notifyParentOnAllAuditTypesChecked(name);
                });
                
                if(json.isAllAdminsNotify != null && json.isAllAdminsNotify == true) {
                     $('#administrators').attr("checked", true);
                }
                if(json.isAllAuditorsNotify != null && json.isAllAuditorsNotify == true) {
                     $('#auditors').attr("checked", true);
                }
                if(json.isOthersChecked != null && json.isOthersChecked == true) {
                     $('#showAllUsers').attr("checked", true);
                     $('#DisplayAllUsersDiv').css('display','block');
                }
                //json.isUserGroup;

                if(json.isSyslogNotify != null && json.isSyslogNotify == true) {
                     $('#syslog').attr("checked", true);
                }
                if(json.isSNMPNotify != null && json.isSNMPNotify == true) {
                     $('#snmp').attr("checked", true);
                }
                if(json.isMailNotify != null && json.isMailNotify == true) {
                     $('#isMailNotify').attr("checked", true);
                }
                if(json.mailIdsTobeNotified != null) {
                     $('#mailIdsTobeNotified').val(json.mailIdsTobeNotified);
                }
                if(json.unNotifiedUsers != null) 
                {
                    baseContents={};
                    for (var col in json.unNotifiedUsers) 
                    {
                        var color = '#febd04';//NO I18N
                        if(col == "Privileged Administrator"){//No I18N
                            color = '#5e4fa2';//NO I18N
                        }else if(col == "Administrator"){//No I18N
                            color = '#f01c4e';//NO I18N
                        }else if(col == "Password Administrator"){//No I18N
                            color = '#ff4005';//NO I18N
                        }else if(col == "Password Auditor"){//No I18N
                            color = '#fd8f24';//NO I18N
                        }
                            for(var index in json.unNotifiedUsers[col]){
                                //[1]-username [0]-loginname index-userid 
                                $('#LISTOFUSERS').append($('<option onmouseover="Tip(\'Login Name : '+json.unNotifiedUsers[col][index][0]+'\',this)" onmouseout="UnTip(this);" style="color: '+color+'" value="'+ index +'">'+ json.unNotifiedUsers[col][index][1] +'</option>'));  //No I18N
                                baseContents[index]=json.unNotifiedUsers[col][index][1];
                            }
                    }
                    
                }
                if(json.notifiedUsers != null) {
                    for (var col in json.notifiedUsers) {
                        var color = '#febd04';//NO I18N
                        if(col == "Privileged Administrator"){//No I18N
                            color = '#5e4fa2';//NO I18N
                        }else if(col == "Administrator"){//No I18N
                            color = '#f01c4e';//NO I18N
                        }else if(col == "Password Administrator"){//No I18N
                            color = '#ff4005';//NO I18N
                        }else if(col == "Password Auditor"){//No I18N
                            color = '#fd8f24';//NO I18N
                        }
                            for(var index in json.notifiedUsers[col]){
                                //[1]-username [0]-loginname index-userid 
                                $('#SELECTEDUSERS').append($('<option onmouseover="Tip(\'Login Name : '+json.notifiedUsers[col][index][0]+'\',this)" onmouseout="UnTip(this);" style="color: '+color+'" value="'+ index +'">'+ json.notifiedUsers[col][index][1] +'</option>'));  //No I18N
                            }
                    }
                }
                if(json.unNotifiedUsergroups != null) 
                {
                     userGroupContents={};
                    for (var col in json.unNotifiedUsergroups) 
                    {
                         if (json.unNotifiedUsergroups.hasOwnProperty(col)) {
                                $('#LISTOFUSERSGROUP').append($('<option value="'+ json.unNotifiedUsergroups[col] +'">'+ json.unNotifiedUsergroups[col] +'</option>'));  //No I18N
                                userGroupContents[col]=json.unNotifiedUsergroups[col];
                        }
                    }
                }
                if(json.notifiedUsergroups != null) {
                    for (var col in json.notifiedUsergroups) {
                        if (json.notifiedUsergroups.hasOwnProperty(col)) {
                            $('#SELECTEDUSERSGROUP').append($('<option value="'+ json.notifiedUsergroups[col] +'">'+ json.notifiedUsergroups[col] +'</option>'));  //No I18N
                        }
                    }
                }
               
});
    }

});

function selectCompleteNotifyCheckBox(ele,name){
    var auditTypes=['SSL','SSH','KEYSTORE','SETTINGS','DISCOVERY'];//NO I18N
    auditTypes.forEach(function(val){
        selectAllNotifyCheckBox(val,ele,name);
        $('#PKI_grid_columncheckbox input:checkbox[id="'+name+'_'+val+'"]').prop("checked", ele.checked);
    });
}

function selectAllNotifyCheckBox(audit_type,ele,name){
    $('#PKI_grid_columncheckbox input:checkbox[name="'+name+'[]"][audit_type="'+audit_type+'"]').each(function() {
            this.checked=ele.checked;       
    });
}

function notifyParentOnAllChildchecked(name,audit_type){
    var check = true;
     $('#PKI_grid_columncheckbox input:checkbox[name="' + name + '[]"][audit_type="' + audit_type + '"]').each(function () {
        if (!this.checked) {
            check = false;
            return check;
        }
    });
    if(check){
              $('#PKI_grid_columncheckbox input:checkbox[id="'+name+'_'+audit_type+'"]').attr("checked", true);
         }
}

function notifyParentOnAllAuditTypesChecked(name){
    var auditTypes=['SSL','SSH','KEYSTORE','SETTINGS','DISCOVERY'];//NO I18N
    var check=true;
    auditTypes.forEach(function(val){
        $('#PKI_grid_columncheckbox input:checkbox[id="'+name+'_'+val+'"]').each(function(){
            if (!this.checked) {
                check = false;
                return check;
            }
     });
    });
    if(check){
        $('input:checkbox[id="'+name+'_ALL"]').prop("checked",true);
}
}
