// $Id$
/* Audit Routes */

App.AuditRoute = Ember.Route.extend({

    setupController: function(controller) {

            //controller.set('content', App.Audit.getAuditList());  //No I18N
	},
	renderTemplate: function() {this.render({into: 'application', outlet: 'details'});} //No I18N
});
App.AuditAllRoute = Ember.Route.extend({

    setupController: function(controller) {
        //getMenusForSideView("Audit");
            //controller.set('content', App.Audit.getAuditList());  //No I18N
	},
	renderTemplate: function() {this.render({into: 'application', outlet: 'details'});} //No I18N
});

// Audit Terminal Dialog view
App.AuditTerminalViewView = Ember.View.extend({
    templateName: 'AuditTerminalView',//No I18N
        didInsertElement: function(){
            var reqParams="audit_id="+App.AuditCommonController.audit_id;//NO I18N
            var reqUrl="/api/pki/settings/getTerminalAuditContent"//NO I18N
            getAjaxApiRequest(reqUrl,reqParams,function(jsonData){
                $("#AuditTerminalViewDiv").val(jsonData.auditContent);
            });
        }
});

App.AuditTerminalViewController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        }
    }
});

//PMP Audit View
App.KmpUserAuditViewComponent = Ember.Component.extend({
    topmpjsp : "toController",//No I18N
    openModalInJsp:"openmodalInJsp",//No I18N
    didInsertElement: function () {
        App.Audit.getAuditList();  //No I18N
    },
    actions: {
        exportPdf: function() {
            var ids = jQuery("#PKIAuditDetailsList").jqGrid('getDataIDs');//NO I18N
            exportPdfReport(ids,"","");
        },exportCsv:function()
        {
            var ids = jQuery("#PKIAuditDetailsList").jqGrid('getDataIDs');//NO I18N
            exportCsvReport(ids,"","");
        },dataCheck:function()
        {
            var ids = jQuery("#PKIAuditDetailsList").jqGrid('getDataIDs');//NO I18N
            App.ReportController.scheduleType="UserAuditReport";//No I18N
            App.ReportController.fromdate="";
            App.ReportController.todate="";
            if(ids.length>0)
            {
                this.sendAction("topmpjsp");//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
    }
    },openmodalInJspPurge: function(modelName, model) {
                    this.sendAction('openModalInJsp', modelName);//NO I18N
    }
    }
});

App.AuditNotifyView = Ember.View.extend({
    templateName: 'AuditNotify',//No I18N
    didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg("pki.js.notifyaudit.title"));//NO I18N
        $(".modal-dialog").width("813px");
           App.Audit.getAuditNotify(); 
    }
});

function showNotifyOperationsDiv(div,active)
{
    $("#mail_notify_div").hide();
    $("#snmp_notify_div").hide();
    $("#syslog_notify_div").hide();
    $("#"+div).show();
    
    if(kmpStandAlone){
        $("#email-a").parent().removeClass("active");
    $("#SNMP-a").parent().removeClass("active");
    $("#syslog-a").parent().removeClass("active");
        $(active).addClass("active");
    }else{
        $("#email-a").removeClass("active");
    $("#SNMP-a").removeClass("active");
    $("#syslog-a").removeClass("active");
    $(active.children).addClass("active");
    }
}

App.AuditNotifyController = Ember.ObjectController.extend({
    needs:"application",//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
          },
          saveAuditNotify:function(){
               var reqUrl="/api/pki/settings/setauditnotify";//NO I18N
               var data={};
                data.notifyAudit=true;
                data.notify_admin= $('#administrators').prop("checked");
                data.notify_auditors=$('#auditors').prop("checked");
               var checked_ids = []; 
               $('#PKI_grid_columncheckbox input:checkbox[name="IS_SYSLOG_NOTIFY[]"]:checked').each(function() {
                    checked_ids.push($(this).val());
                });
                    data.syslog=checked_ids;
                   checked_ids = []; 
                    $('#PKI_grid_columncheckbox input:checkbox[name="IS_SNMP_NOTIFY[]"]:checked').each(function() {
                    checked_ids.push($(this).val());
                });
                    data.snmp=checked_ids;
                    checked_ids = []; 
            $('#PKI_grid_columncheckbox input:checkbox[name="ISNOTIFY[]"]:checked').each(function() {
                    checked_ids.push($(this).val());
                });
            data.Keys_Audit_Notify=checked_ids;
               if($('#isMailNotify').prop("checked")){
                    data.shamailid=$('#mailIdsTobeNotified').val();
               }
               if($('#showAllUsers').prop("checked")){
                   var notifieduser=[];
                   $("#SELECTEDUSERS > option").each(function() {
                            notifieduser.push(this.value);
                    });
                    data.ShaNotifiedUser=notifieduser;
                    var notifiedusergroup=[];
                    $("#SELECTEDUSERSGROUP > option").each(function() {
                            notifiedusergroup.push(this.value);
                    });
                     data.ShaNotifiedUserGrp=notifiedusergroup;
               }
               
                data.pmpcp=Get_Cookie('pmpcc');//No I18N
            ajaxapicall(reqUrl,data,true,"",this);
          }
        }
});

App.KMPPurgeAuditView = Ember.View.extend({
    templateName: 'KMPPurgeAudit',//No I18N
    didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg("auditpurge.title"));//NO I18N
        $(".modal-dialog").width("709px");
        $("#purgeSaveDiv").removeClass("col-sm-offset-1 col-sm-4");
        $("#purgeSaveDiv").css('margin-left','33%');
        kmpStandAlone=false;
    }
});

App.KMPPurgeAuditController = Ember.ObjectController.extend({
    needs:["application","PurgeAudit"],//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
          },
          saveSettings:function(){
              this.get('controllers.PurgeAudit').send('saveSettings');//No I18N
          }
        }
});


function exportPdfReport(ids,sday,eday)
{
    var username=document.getElementById("gs_PKIAudit__USERNAME").value;
    var operationtype=document.getElementById("gs_PKIAudit__OPERATIONTYPE").value;
    var description=document.getElementById("gs_PKIAudit__REASON").value;               
    App.ReportController.scheduleType="UserAuditReport";//No I18N
    var reqParams='&username='+username+'&operationtype='+operationtype+'&description='+description+'&scheduleType='+"UserAuditReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
    if(sday!==""&&eday!==""&&!validateCriteria())
    {
        return;
    }
    if(ids.length>0)
    {
        locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=UserAudit"+reqParams);//NO I18N
    }
    else{
        messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
    }
}

function exportCsvReport(ids,sday,eday)
{
    var username=document.getElementById("gs_PKIAudit__USERNAME").value;
    var operationtype=document.getElementById("gs_PKIAudit__OPERATIONTYPE").value;
    var description=document.getElementById("gs_PKIAudit__REASON").value;               
    App.ReportController.scheduleType="UserAuditReport";//No I18N
    var reqParams='&username='+username+'&operationtype='+operationtype+'&description='+description+'&scheduleType='+"UserAuditReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
    if(sday!==""&&eday!==""&&!validateCriteria())
    {
        return;
    }
    if(ids.length>0)
    {
        locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=UserAudit"+reqParams);//NO I18N
    }else{
        messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
    }
}
