// $Id$
App.SSLMgmtRequestView = Ember.View.extend({
    templateName: 'RequestOpen',//No I18N
        didInsertElement: function(){
            App.Request.getResourceNames();
            if(!kmpStandAlone){
                selectKMPTab("ssl_certRequest");//NO I18N
            }
        }
                    });

App.RequestOpenView = Ember.View.extend({
    templateName: 'RequestOpen',//No I18N
        didInsertElement: function(){
            if(App.RequestCertController.flag)
            {
                App.RequestCertController.requestType="New_Cert_Req";//No I18N    
            App.Request.getResourceNames();
            }
            else
            {
                App.Request.getRequestDetails(App.RequestCertController.req_id);
            }
            if(!kmpStandAlone){
                selectKMPTab("ssl_certRequest");//NO I18N
        }
        }
                    });

App.RequestListView = Ember.View.extend({
    templateName: 'RequestList',//No I18N
        didInsertElement: function(){
            var controller = this.get('controller');
            App.Request.getRequestList(controller);
            if(!kmpStandAlone){
                selectKMPTab("ssl_certRequest");//NO I18N
        }
        }
});

App.CreateFormView = Ember.View.extend({
    templateName: 'CreateForm',//No I18N
        didInsertElement: function(){
             App.RequestCertController.isCSR=false;
            document.getElementById("selfSigned").checked=true;
                $("#cert_type").hide();
                $("#csrhelp").hide();
            $("#Cert_Title").text(I18N.getMsg("js.ssl.createCertificateTitle"));//No I18N    
        }
});

App.LetsEncryptView = Ember.View.extend({
    templateName: 'LetsEncrypt',//NO I18N
    didInsertElement: function(){
        App.Request.listLetsEncryptAccounts();
        if(!kmpStandAlone){
            selectKMPTab("ssl_letsencrypt");//NO I18N
    }
    }
});

App.AssignDefaultDNSView = Ember.View.extend({
   templateName:'AssignDefaultDNS',//NO I18N
   didInsertElement: function(){
       $(".modal-title").text(I18N.getMsg('dns.global.provider'));//NO I18N
   }
});

App.AddDefaultDNSView = Ember.View.extend({
   templateName:'AddDefaultDNS',//NO I18N
   didInsertElement: function(){
       App.RequestCertController.dns_id="";
       $(".modal-title").text(I18N.getMsg('dns.global.provider'));//NO I18N
       $(".modal-dialog").css({"width":"600px"});
       $(".modal-body").css({'max-height':'600px','overflow':'auto'}); 
       getDnsServersList();
   }
});

App.DNSProviderView = Ember.View.extend({
    templateName: 'DNSProvider',//NO I18N
    didInsertElement: function(){
        App.Request.defaultDNSServers();
    }
});

App.AddNewAccountView = Ember.View.extend({
    templateName: 'AddNewAccount',//NO I18N
    didInsertElement: function(){
        if(!kmpStandAlone){
            selectKMPTab("ssl_letsencrypt");//NO I18N
        }            
        
    }
});

App.WAgentsView = Ember.View.extend({
    templateName: 'WAgents',//NO I18N
    didInsertElement: function(){
        App.Request.WAgents();
    }
});

App.LETSMgmtView = Ember.View.extend({
	templateName: 'letsMgmt',//No I18N
		didInsertElement: function(){

                    }
});

App.NewRegistrationView = Ember.View.extend({
    templateName: 'NewRegistration',//NO I18N
    didInsertElement: function(){
        
    }
});

App.LetsEncryptDeployMappingView = Ember.View.extend({
   templateName: 'LetsEncryptDeployMapping',//NO I18N 
   didInsertElement: function(){
    App.Request.letsEncryptDomainMappings(App.RequestCertController.domain);
        if(!kmpStandAlone){
            selectKMPTab("ssl_letsencrypt");//NO I18N
   }
   }
});

App.LetsEncryptRequestView = Ember.View.extend({
    templateName: 'LetsEncryptRequest',//No I18N
        didInsertElement: function(){
            document.getElementById("inner_title").innerHTML='<a href="javascript:redirectPreviousPage()">'+localStorage.getItem("prevViewName")+"&nbsp;&raquo;&nbsp;</a>"+I18N.getMsg("js.sslcert.certificateRequest");//NO I18N            
            var ajaxRequestUrl = '/api/pki/letsencrypt/accountExists?'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
                if(jsonData.account === "false")
                {
                    $("#createRequest").hide();
                    $(":submit").attr("disabled", true);
                    vConfirmation(I18N.getMsg('letsencrypt.addorregister.account'),function(){//NO I18N
                        if(App.ApplicationController.isAdmin===true)
                        {
                            redirectUrl("LETSMgmt/LETSAccount");//NO I18N
                        }
                    });                    
                }                
            if(!kmpStandAlone){
                selectKMPTab("ssl_letsencrypt");//NO I18N
            }            
                
//                var url = window.location.href;
//                if(url.includes('?'))
//                {
//                    var domains = url.split("?");
//                    var domain_names=domains[1];
//                    $("#common_name").val(domain_names);
//                }
            });
        }
});

App.GoDaddyRevokeView = Ember.View.extend({
   templateName:'GoDaddyRevoke',//NO I18N
   didInsertElement: function(){
       $(".modal-title").text(I18N.getMsg('js.letsencrypt.revoke'));//NO I18N
   }
});

App.GoDaddyRenewView = Ember.View.extend({
   templateName:'GoDaddyRenew',//NO I18N
   didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg('js.letsencrypt.renew'));//NO I18N
        $("#GoDaddyRenew .modal-dialog").css('width','800px');
        $("#GoDaddyRenew .modal-body").css('width','800px');    
        var grid = jQuery("#PendingCertList"); //No I18N
        var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
        var order_id = grid.jqGrid('getCell', selRowIds, 'ID'); //No I18N
        var ajaxUrl = '/api/pki/godaddy/renewDetails?order_id='+order_id; //No I18N  
        getAjaxApiRequest(ajaxUrl,"",function(jsonData){
            if(jsonData.Status === "Success")
            {            
                 var rootType = jsonData.rootType;
                 var certType = jsonData.product;
                 var keyOnRenewal = jsonData.keyOnRenewal;
                 var period = jsonData.period;
                 var commonName = jsonData.CommonName;
                 var sanSize = jsonData.sanSize;
                 var san = jsonData.san;                 
                 if(keyOnRenewal==="uploadcsr")
                 {
                     $("#samekeyoption").hide();
                 }
                 var cert_type = certType.split("_");   
                 document.getElementById("common_name").value= commonName;
                 document.getElementById("Cert_Type").value=certType;
                 document.getElementById("san_slot").value=sanSize;
                 document.getElementById("san_slot").disabled=true;
                 document.getElementById("san_name").value=san;
                 document.getElementById("Root_Type").value=rootType;
                 document.getElementById("cert_period").value=period;
                if(cert_type[0]==="UCC")
                {                    
                    $("#sandiv").show();
                }          
            }
            else
            {
                document.getElementById("closeButton").click();
                messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N                 
            }
        });            
   }
});

App.GoDaddyReissueView = Ember.View.extend({
   templateName:'GoDaddyReissue',//NO I18N
   didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg('godaddy.reissuecertificate'));//NO I18N
        $("#GoDaddyReissue .modal-dialog").css('width','800px');
        $("#GoDaddyReissue .modal-body").css('width','800px');    
        var grid = jQuery("#PendingCertList"); //No I18N
        var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
        var order_id = grid.jqGrid('getCell', selRowIds, 'ID'); //No I18N
        var ajaxUrl = '/api/pki/godaddy/renewDetails?order_id='+order_id; //No I18N  
        getAjaxApiRequest(ajaxUrl,"",function(jsonData){
            if(jsonData.Status === "Success")
            {            
                 var rootType = jsonData.rootType;
                 var keyOnRenewal = jsonData.keyOnRenewal;
                 var certType = jsonData.product;
                 var period = jsonData.period;
                 var commonName = jsonData.CommonName;
                 var sanSize = jsonData.sanSize;
                 var san = jsonData.san;                 
                 var cert_type = certType.split("_");   
                 if(keyOnRenewal==="uploadcsr")
                 {
                     $("#samekeyoption").hide();
                 }
                 document.getElementById("common_name").value= commonName;
                 document.getElementById("Cert_Type").value=certType;
                 document.getElementById("san_slot").value=sanSize;
                 document.getElementById("san_slot").disabled=true;
                 document.getElementById("san_name").value=san;
                 document.getElementById("Root_Type").value=rootType;                 
                if(cert_type[0]==="UCC")
                {                    
                    $("#sandiv").show();
                }          
            }
            else
            {
                document.getElementById("closeButton").click();
                messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N                 
            }
        });            
   }
});

App.GoDaddyView = Ember.View.extend({
   templateName:'GoDaddy',//NO I18N
   didInsertElement: function(){
       var ajaxRequestUrl = '/api/pki/godaddy/godaddyAccountExists'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
            if(!jsonData.account)
            {                    
                $('#createOrderButton').hide();
                $("#alertAddAccount").show();
                vConfirmation(I18N.getMsg('godaddy.add.account'),function(){//NO I18N
                    if(App.ApplicationController.isAdmin===true)
                    {
                        document.getElementById("godaddyaccount").click();
                    }
                });                    
            }               
            else
            {
                $('#createOrderButton').show();
                $("#alertAddAccount").hide();
            }
        });                   
        App.Request.godaddyRequestsList();  
   }
});

App.GodaddyAddAccountView = Ember.View.extend({
   templateName:'GodaddyAddAccount',//NO I18N
   didInsertElement: function(){
       $(".modal-title").text(I18N.getMsg('godaddy.add.accounttitle'));//NO I18N
       var ajaxRequestUrl = '/api/pki/godaddy/godaddyAccount'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
            $("#key").val(jsonData.key);
        });
   }
});

App.GoDaddyOrderView = Ember.View.extend({
   templateName:'GoDaddyOrder',//NO I18N
   didInsertElement: function(){
       document.getElementById("inner_title").innerHTML='<a href="javascript:redirectPreviousPage()">'+localStorage.getItem("prevViewName")+"&nbsp;&raquo;&nbsp;</a>"+I18N.getMsg("godaddy.certificateorder");//NO I18N            
       var ajaxRequestUrl = '/api/pki/godaddy/godaddyAccountExists'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
            if(!jsonData.account)
            {                 
                $("#createRequest").hide();
                $(":submit").attr("disabled", true);
                vConfirmation(I18N.getMsg('godaddy.add.account'),function(){//NO I18N
                    if(App.ApplicationController.isAdmin===true)
                    {
                        $("#godaddyaccount").attr("disabled", false);
                        document.getElementById("godaddyaccount").click();
                    }
                });                    
            }
            else
            {
       var ajaxRequestUrl = '/api/pki/godaddy/getLoggedInUserDetails'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
            $("#contact_firstname").val(jsonData.firstName);
            $("#contact_middlename").val(jsonData.middleName);
            $("#contact_lastname").val(jsonData.lastName);
            $("#contact_email").val($("<div>").html(jsonData.email).text());
        });
   }
});
   }
});

App.CreateTxtRecordView = Ember.View.extend({
   templateName:'CreateTxtRecord',//NO I18N
   didInsertElement: function(){
       $(".modal-title").text(I18N.getMsg('godaddy.createtxtrecord'));//NO I18N
       getDnsServersList();
   }
});

App.GoDaddyHistoryView = Ember.View.extend({
   templateName:'GoDaddyHistory',//NO I18N
   didInsertElement: function(){
       var order_id = App.RequestCertController.order_id;
       var ajaxUrl = '/api/pki/godaddy/getHistory?order_id='+order_id; //No I18N  
        getAjaxApiRequest(ajaxUrl,"",function(jsonData){
            var colNamesList = ['VersionId','',I18N.getMsg('js.commonstr.certificatename'),I18N.getMsg("js.cert.sans"),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.report.timeline.todate'),I18N.getMsg("js.revoked.by"),I18N.getMsg("godaddy.revokereason"),I18N.getMsg('js.table.search')];//NO I18N
            var colModelList = [
                {name:'VERSION_ID',index:'VERSION_ID',hidden:true},//NO I18N
                {name: 'PrivateKey',index:'PrivateKey',hidden:true},//NO I18N
                {name:'CommonName',index:'CommonName'},//NO I18N
                {name:'San',index:'San'},//NO I18N
                {name:'VALID_FROM',index:'VALID_FROM'},//NO I18N
                {name:'VALID_TO',index:'VALID_TO'},//NO I18N
                { name: "RevokedBy",index:"RevokedBy"},//NO I18N
                { name: "RevokeReason",index:"RevokeReason"},//NO I18N
                { name: 'search',width:40,sortable: false,search:false,fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#historyList", jsonData.historyList, colNamesList, colModelList, "", "#historyListPager", "GoDaddyHistory",defaultOptions);//No I18N     
        });
   }
});

App.GoDaddyOrderDetailsView = Ember.View.extend({
   templateName:'GoDaddyOrderDetails',//NO I18N
   didInsertElement: function(){
       document.getElementById("inner_title").innerHTML='<a href="javascript:redirectPreviousPage()">'+localStorage.getItem("prevViewName")+"&nbsp;&raquo;&nbsp;</a>"+I18N.getMsg("godaddy.order.details");//NO I18N            
       var order_id = App.RequestCertController.order_id;
       var ajaxUrl = '/api/pki/godaddy/getOrderDetails?order_id='+order_id; //No I18N  
        getAjaxApiRequest(ajaxUrl,"",function(jsonData){
            var colModelList = [
                        { name: 'id',width:"0px"},//No I18N
                        { name: 'Key', index: 'Key',sortable: false}, //No I18N
                        { name: 'Value', index: 'Value',sortable: false}, //No I18N                        
                ];
            var dataArray = new Array();
            var colNamesList = ['',jsonData.CommonName,'']; //No I18N
            dataArray.push({"Key":I18N.getMsg('js.commonstr.certificatename'), "Value":jsonData.CommonName});//No I18N      
            var status = jsonData.Status;
            var cert_status = jsonData.CertStatus;
            if(status==="CERTIFICATE ISSUED" && cert_status==="saved")
            {
                status=I18N.getMsg("godaddy.cert.saved");//NO I18N
            }
            else if(status==="CERTIFICATE ISSUED" && cert_status==="pending")
            {
                status=I18N.getMsg("godaddy.liscence.count");//NO I18N
            }
            dataArray.push({"Key":I18N.getMsg('js.commonstr.status'),"Value":status});//NO I18N
            dataArray.push({"Key":I18N.getMsg('js.ssl.certificatetype'),"Value":jsonData.CertType});//NO I18N
            if(jsonData.San!==undefined)
            {
                dataArray.push({"Key":I18N.getMsg('js.cert.sans'),"Value":jsonData.San});//NO I18N
            }
            dataArray.push({"Key":I18N.getMsg('godaddy.san.period'),"Value":jsonData.Period});//NO I18N
            dataArray.push({"Key":I18N.getMsg('godaddy.san.roottype'),"Value":jsonData.RootType});//NO I18N                
            if(jsonData.ValidFrom!==undefined)
            {
                dataArray.push({"Key":I18N.getMsg('js.report.timeline.fromdate'),"Value":jsonData.ValidFrom});//NO I18N
                dataArray.push({"Key":I18N.getMsg('js.report.timeline.todate'),"Value":jsonData.ValidTo});//NO I18N
            }
            dataArray.push({"Key":I18N.getMsg('godaddy.contactname'),"Value":jsonData.ContactName});//NO I18N
            dataArray.push({"Key":I18N.getMsg('godaddy.contactmail'),"Value":jsonData.ContactEmail});//NO I18N
            dataArray.push({"Key":I18N.getMsg('godaddy.contactphone'),"Value":jsonData.ContactPhone});//NO I18N
            if(jsonData.OrgName!==undefined)
            {
                dataArray.push({"Key":I18N.getMsg('js.cert.org'),"Value":jsonData.OrgName});//NO I18N
            }
            if(jsonData.OrgAddressOne!==undefined)
            {
                dataArray.push({"Key":I18N.getMsg('godaddy.orgaddress1'),"Value":jsonData.OrgAddressOne});//NO I18N
            }
            if(jsonData.OrgAddressTwo!==undefined)
            {
                dataArray.push({"Key":I18N.getMsg('godaddy.orgaddress2'),"Value":jsonData.OrgAddressTwo});//NO I18N
            }
            if(jsonData.OrgPhone!==undefined)
            {
                dataArray.push({"Key":I18N.getMsg('godaddy.orgphone'),"Value":jsonData.OrgPhone});//NO I18N
            }
            if(jsonData.RevokedBy!==undefined)
            {
                dataArray.push({"Key":I18N.getMsg('js.revoked.by'),"Value":jsonData.RevokedBy});//NO I18N
                dataArray.push({"Key":I18N.getMsg('godaddy.revokereason'),"Value":jsonData.RevokeReason});//NO I18N
            }
            if(jsonData.SiteSeal!==undefined)
            {
                var siteSeal =jsonData.SiteSeal;
                siteSeal = siteSeal.replace(/</g,"&lt;");
                siteSeal = siteSeal.replace(/>/g,"&gt;");
                siteSeal = siteSeal.replace(/\"/g,"&quot;");                
                siteSeal = '<div style="white-space:normal;word-wrap:break-word">'+siteSeal+'</div>';//NO I18N
                dataArray.push({"Key":I18N.getMsg('godaddy.siteseal'),"Value":siteSeal});//NO I18N
            }
            var defaultOptions={multiselect:false,rowNumNeeded:false};
            loadJQgridWithData("#PKIInventoryDetailsList", dataArray, colNamesList, colModelList, "", "", "GoDaddyOrderDetails",defaultOptions,false);//No I18N
        });
   }
});

App.LetsEncryptRequestListView = Ember.View.extend({
    templateName: 'LetsEncryptRequestList',//No I18N
        didInsertElement: function(){
             var ajaxRequestUrl = '/api/pki/letsencrypt/accountExists?'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
                if(jsonData.account === "false")
                {                    
                    vConfirmation(I18N.getMsg('letsencrypt.addorregister.account'),function(){//NO I18N
                        if(App.ApplicationController.isAdmin===true)
                        {
                        redirectUrl("LETSMgmt/LETSAccount");//NO I18N
                        }
                    });                    
                }               
            });
            if(!kmpStandAlone){
                selectKMPTab("ssl_letsencrypt");//NO I18N
            }            
            App.Request.letsEncryptRequestsList();            
        }
});

App.LetsEncryptRequestHistoryView = Ember.View.extend({
    templateName: 'LetsEncryptRequestHistory',//NO I18N
    didInsertElement:function(){
        document.getElementById("inner_title").innerHTML='<a href="javascript:redirectPreviousPage()">'+localStorage.getItem("prevViewName")+"&nbsp;&raquo;&nbsp;</a>"+I18N.getMsg("js.ssl.certificate.history");//NO I18N            
        App.Request.letsEncryptRequestsHistory(App.RequestCertController.req_id);            
    }
});

App.AgentView = Ember.View.extend({
   templateName: 'Agent',//NO I18N
   didInsertElement: function(){
       $(".modal-title").text(I18N.getMsg('js.sshkey.deploy'));//NO I18N
       $(".modal-dialog").css({"width":"600px"});
       $(".modal-body").css({'max-height':'600px','overflow':'auto'});
       var ajaxRequestUrl = '/api/pki/letsencrypt/domainAgentView?';//NO I18N
       var params = 'domain='+App.RequestCertController.sdomain+'&agentid='+App.RequestCertController.agentid+"&challengeType="+App.RequestCertController.challengeType+"&dns_server="+App.RequestCertController.dns_server;//NO I18N
        getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
            App.Request.agentsView(jsonData);
        });
   }
});


App.DeployStatusView = Ember.View.extend({
   templateName: 'DeployStatus',//NO I18N
    didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg('challengefile.deply.title'));//NO I18N
    }
   });

App.ShowCertificateView = Ember.View.extend({
   templateName: 'ShowCertificate',//NO I18N
   didInsertElement: function(){
       var params = "req_id="+App.RequestCertController.req_id;//NO I18N
       var reqUrl = '/api/pki/letsencrypt/getCertificate';//NO I18N
        getAjaxApiRequest(reqUrl,params,function(jsonData){
            $(".modal-title").text(I18N.getMsg('letsencrypt.certificate.title'));//NO I18N
            $("#domainName").text(jsonData.domain);
            $("#newCert").html(jsonData.certificate); 
        });
   }
});

App.LetsEncryptChallengesView = Ember.View.extend({
   templateName: 'LetsEncryptChallenges',//NO I18N
   didInsertElement: function(){
       document.getElementById("inner_title").innerHTML='<a href="javascript:redirectPreviousPage()">'+localStorage.getItem("prevViewName")+"&nbsp;&raquo;&nbsp;</a>"+I18N.getMsg("lestencrypt.domaincontrol.challenges");//NO I18N            
       App.Request.letsEncryptRequestsChallenges(App.RequestCertController.req_id);
   }
});

App.CreatedCertListView = Ember.View.extend({
    templateName: 'CreatedCertList',//No I18N
        didInsertElement: function(){
            var controller = this.get('controller');
            App.Request.getGeneratedCerts(controller);
        }
});

App.SSLMgmtCreateCsrView = Ember.View.extend({
    templateName: 'CreateForm',//No I18N
        didInsertElement: function(){
            document.getElementById("cert_req").checked=true;
            $("#cert_type").hide();            
            $("#Cert_Title").text(I18N.getMsg("js.create.csr"));//No I18N    
            $("#forCSROnly").show();
            $("#export_cert_id").text("Export CSR");//No I18N
            $("#save_but").hide();
            $("#certhelp").hide();
            $("#isRootCheck").hide();
            $("#csrhelp").show();
        }
});

App.MailCSRmodalView=Ember.View.extend({
     templateName: 'MailCSRmodal',//No I18N
     didInsertElement: function(){
         $(".modal-title").text(I18N.getMsg("js.modaltitle.mailcsr"));//No I18N 
         if(App.RequestCertController.storeType=="NA")
         {
             $("#sendCSRAndKey").hide();
         }
     }
});

App.SSLStoreView = Ember.View.extend({
   templateName:'SSLStore',//NO I18N
   didInsertElement: function(){
       if(App.RequestCertController.vendorName!=="ALL")
       {
           document.getElementById("inner_title").innerHTML='<a href="#/SSLMgmt/sslstore/ALL"><span><svg style="margin-bottom:-2px" id="Layer_1" data-name="Layer 1" width="20" height="20" viewBox="0 0 52 70">  <path d="M43.14,61.23a24.46,24.46,0,0,1-33.63.15C4.13,62.39.74,63.86.74,65.5c0,3,11.64,5.5,26,5.5s26-2.46,26-5.5C52.74,63.78,49,62.24,43.14,61.23Z" transform="translate(-0.74 -1)" fill="#dfdcdd"/> <path d="M26.24,15A26.44,26.44,0,0,1,44,21.83,17.52,17.52,0,0,0,44.24,19a18,18,0,0,0-36,0,17.52,17.52,0,0,0,.25,2.83A26.41,26.41,0,0,1,26.24,15Z" transform="translate(-0.74 -1)" fill="#64b059"/> <path d="M26.24,17a24.5,24.5,0,1,0,24.5,24.5A24.5,24.5,0,0,0,26.24,17Zm5.5,37h-10l.89-15.1A6.5,6.5,0,1,1,30,38.83Z" transform="translate(-0.74 -1)" fill="#36427f"/></span>&nbsp'+I18N.getMsg("sslstore.title")+'&nbsp;&raquo;&nbsp;</a>'+App.RequestCertController.vendorName;//NO I18N
       }
       else
       {
           document.getElementById("inner_title").innerHTML='<span><svg style="margin-bottom:-2px" id="Layer_1" data-name="Layer 1" width="20" height="20" viewBox="0 0 52 70">  <path d="M43.14,61.23a24.46,24.46,0,0,1-33.63.15C4.13,62.39.74,63.86.74,65.5c0,3,11.64,5.5,26,5.5s26-2.46,26-5.5C52.74,63.78,49,62.24,43.14,61.23Z" transform="translate(-0.74 -1)" fill="#dfdcdd"/> <path d="M26.24,15A26.44,26.44,0,0,1,44,21.83,17.52,17.52,0,0,0,44.24,19a18,18,0,0,0-36,0,17.52,17.52,0,0,0,.25,2.83A26.41,26.41,0,0,1,26.24,15Z" transform="translate(-0.74 -1)" fill="#64b059"/> <path d="M26.24,17a24.5,24.5,0,1,0,24.5,24.5A24.5,24.5,0,0,0,26.24,17Zm5.5,37h-10l.89-15.1A6.5,6.5,0,1,1,30,38.83Z" transform="translate(-0.74 -1)" fill="#36427f"/></span>&nbsp;'+I18N.getMsg("sslstore.title");//NO I18N
       }
       var ajaxRequestUrl = '/api/pki/sslstore/sslStoreAccountExists'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
            if(!jsonData.account)
            {                    
                $('#createOrderButton').hide();
                $("#alertAddAccount").show();
                vConfirmation(I18N.getMsg('sslstore.add.account'),function(){//NO I18N
                    if(App.ApplicationController.isAdmin===true)
                    {
                        document.getElementById("sslstoreaccount").click();
                    }
                });                    
            }               
            else
            {
                $('#createOrderButton').show();
                $("#alertAddAccount").hide();
            }
        });                   
        App.Request.sslStoreRequestsList();  
   }
});
       

App.SSLStoreAccountView = Ember.View.extend({
   templateName:'SSLStoreAccount',//NO I18N
   didInsertElement: function(){
       document.getElementById("NOTE").innerHTML=I18N.getMsg("sslstore.addaccount.note");//NO I18N
       $(".modal-title").text(I18N.getMsg('sslstore.addaccount'));//NO I18N
       var ajaxRequestUrl = '/api/pki/sslstore/getSSLStoreAccountDetails'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
            $("#partnercode").val(jsonData.partnercode);
        });
   }
});

App.SSLStoreOrderDetailsView = Ember.View.extend({
   templateName:'SSLStoreOrderDetails',//NO I18N
   didInsertElement: function(){
       var order_id = App.RequestCertController.order_id;
       var ajaxUrl = '/api/pki/sslstore/getSSLStoreOrderDetails?order_id='+order_id; //No I18N  
        getAjaxApiRequest(ajaxUrl,"",function(jsonData){
            var colModelList = [
                        { name: 'id',width:"0px"},//No I18N
                        { name: 'Key', index: 'Key',sortable: false}, //No I18N
                        { name: 'Value', index: 'Value',sortable: false}, //No I18N                        
                ];
            var dataArray = new Array();
            var details=jsonData.details
            var keys = Object.keys(details);
            var colNamesList;
            for(var i=0;i<keys.length;i++)
            {            
                var key = keys[i];
                var value = details[key];
                if(value==="-")
                {
                    continue;
                }
                dataArray.push({"Key":key, "Value":value});//No I18N  
                if(i==0)
                {
                    colNamesList = ['',value,'']; //No I18N
                }
            }           
            if(jsonData.Imported)
            {
                $("#helpnote").show();
            }//!jsonData.Imported && jsonData.DomainValidatonType!=="email" && (jsonData.Status==="Pending" || jsonData.Status==="pending") //NO I18N
            if(!jsonData.Imported && jsonData.DomainValidatonType!=="email" && (jsonData.Status==="Pending" || jsonData.Status==="pending"))
            {
                $("#domainvalidationcontent").show();
                var list = document.getElementById("domainvalidationlist");
                $("#domainvalidationlist").empty();
                if(jsonData.DomainValidatonType==="dns")
                {
                    var name = jsonData.CNAME_AUTHNAME;
                    var targetValue = jsonData.CNAME_AUTHVALUE;       
                    var li = document.createElement("li");
                    li.appendChild(document.createTextNode(I18N.getMsg("sslstore.domainvalidation.dns.one")));//NO I18N
                    list.appendChild(li);
                    li = document.createElement("li");
                    li.appendChild(document.createTextNode(I18N.getMsg("sslstore.domainvalidation.dns.two")));//NO I18N
                    list.appendChild(li);
                    if(name.toLowerCase().indexOf("dns txt")!=-1)
                    {
                        //dns txt record                        
                        var link = '<li>'+I18N.getMsg("sslstore.domainvalidation.dns.txt",new Array('<b>'+targetValue+'</b>'))+'</li>';//NO I18N                        
                        $("#domainvalidationlist").append(link);                        
                    }
                    else
                    {
                        //dns cname record                        
                        var splitvalue = name.split(".");
                        var link = '<li>'+I18N.getMsg("sslstore.domainvalidation.dns.cname",new Array('<b>'+splitvalue[0]+".&lt;yourdomainname.com&gt;</b>",'<b>'+targetValue+'</b>'))+'</li>';//NO I18N
                        $("#domainvalidationlist").append(link);                        
                    }      
                    li = document.createElement("li");
                    li.appendChild(document.createTextNode(I18N.getMsg("sslstore.domainvalidation.dns.three")));//NO I18N
                    list.appendChild(li);  
                    li = document.createElement("li");
                    li.appendChild(document.createTextNode(I18N.getMsg("sslstore.domainvalidation.dns.four")));//NO I18N
                    list.appendChild(li);
                }
                else
                {
                    //http file challenge
                    var filename = jsonData.AUTHFILE_NAME;
                    var filecontent = jsonData.AUTHFILE_CONTENT;
                    var encodedContent = encodeURIComponent(filecontent);                                        
                    var li = document.createElement("li");
                    var link = '<li>Create the file <b>"yourdomainname.com/.well-known/pki-validation/<a class="pointer" style="cursor:pointer" onclick="exportChallengeFile(\''+filename+'\',\''+encodedContent+'\');">'+filename+'</a></b>" for all the domains in certificate order with content "<b>'+filecontent+'</b>".</li>';//NO I18N
                    $("#domainvalidationlist").append(link);                    
                    li = document.createElement("li");
                    li.appendChild(document.createTextNode(I18N.getMsg("sslstore.domainvalidation.file.two")));//NO I18N
                    list.appendChild(li);
                    li = document.createElement("li");
                    li.appendChild(document.createTextNode(I18N.getMsg("sslstore.domainvalidation.file.three")));//NO I18N
                    list.appendChild(li);
                }
            }
            var defaultOptions={multiselect:false,rowNumNeeded:false,minRowsPerPage:100};
            loadJQgridWithData("#PKIInventoryDetailsList", dataArray, colNamesList, colModelList, "", "", "SSLStoreOrderDetails",defaultOptions);//No I18N
        });
   }
});

var sslStoreProductDetails;

App.SSLStoreOrderView = Ember.View.extend({
   templateName:'SSLStoreOrder',//NO I18N
   didInsertElement: function(){       
        if(App.RequestCertController.sslStoreRenew)
        {
            document.getElementById("inner_title").innerHTML='<a href="javascript:redirectPreviousPage()">'+localStorage.getItem("prevViewName")+"&nbsp;&raquo;&nbsp;</a>"+I18N.getMsg("sslstore.certorder.renew");//NO I18N            
        }
        else
        {
            document.getElementById("inner_title").innerHTML='<a href="javascript:redirectPreviousPage()">'+localStorage.getItem("prevViewName")+"&nbsp;&raquo;&nbsp;</a>"+I18N.getMsg("godaddy.certificateorder");//NO I18N            
        }
       
        var ajaxRequestUrl = '/api/pki/sslstore/SSLStoreOrderView?order_id='+App.RequestCertController.order_id+'&renew='+App.RequestCertController.sslStoreRenew+'&vendor='+App.RequestCertController.vendorName; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
            if(jsonData.Status === "Success")
            {
                fillOrgDetails(jsonData.OrgAddress);
                $('#vendor_name').find('option').remove();//NO I18N
                var vendors = jsonData.vendors;
                for(var i=0;i<vendors.length;i++)
                {
                    if(vendors[i]==="SECTIGO")
                    {
                        $("#vendor_name").append(new Option(vendors[i]+" (formerly COMODO)",vendors[i]));//NO I18N
                    }
                    else
                    {
                    $("#vendor_name").append(new Option(vendors[i],vendors[i]));//NO I18N
                }
                }
                var products = jsonData.products;
                sslStoreProductDetails = jsonData.productDetails;
                $('#product_name').find('option').remove();//NO I18N
                var keys = Object.keys(products);
                for(var i=0;i<keys.length;i++)
                {            
                    var key = keys[i];
                    var value = products[key];
                    $("#product_name").append(new Option(value,key));//NO I18N
                }
                if(App.RequestCertController.vendorName!=="ALL" && App.RequestCertController.vendorName!=="")
                {
                    document.getElementById("vendor_name").value=App.RequestCertController.vendorName;
                }
                if(App.RequestCertController.vendorName==="SYMANTEC" || document.getElementById("vendor_name").value ==="SYMANTEC")
                {
                    sslStoreProductsCriteria(jsonData,"OV");//NO I18N
                }
                else
                {
                sslStoreProductsCriteria(jsonData,"DV");//NO I18N
                }
                if(App.RequestCertController.sslStoreRenew)
                {
                    fillSSLStoreRenewDetails(jsonData.OrderDetails);
            }
                sslStoreProductSepecific();
            }
            else
            {
                messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
            }
            changeDomainValidation();
//            $("#contact_firstname").val(jsonData.firstName);
//            $("#contact_middlename").val(jsonData.middleName);
//            $("#contact_lastname").val(jsonData.lastName);
//            $("#contact_email").val($("<div>").html(jsonData.email).text());
        });
   }
});

App.SSLStoreAgreementView = Ember.View.extend({
   templateName:'SSLStoreAgreement',//NO I18N
   didInsertElement: function(){
       $(".modal-title").text(I18N.getMsg('sslstore.product.agreement'));//NO I18N
       var productcode = document.getElementById("product_name").value; 
       var ajaxRequestUrl = '/api/pki/sslstore/getSSLStoreProductAgreement?product_code='+productcode; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
            $("#productagreement").html(jsonData.agreement);
            $("#SSLStoreAgreement .modal-dialog").css('width','650px');
            $("#SSLStoreAgreement .modal-body").css('width','650px');    
        });
   }
});

var sslStoreReissuePrivateKey=false;

App.SSLStoreReissueView = Ember.View.extend({
   templateName:'SSLStoreReissue',//NO I18N
   didInsertElement: function(){
       document.getElementById("inner_title").innerHTML='<a href="javascript:redirectPreviousPage()">'+localStorage.getItem("prevViewName")+"&nbsp;&raquo;&nbsp;</a>"+I18N.getMsg("sslstore.reissue.title");//NO I18N            
       var order_id = App.RequestCertController.order_id;
       var ajaxUrl = '/api/pki/sslstore/SSLStoreReissueView?order_id='+order_id; //No I18N  
        getAjaxApiRequest(ajaxUrl,"",function(jsonData){
            document.getElementById("common_name").innerHTML = jsonData.CommonName;
            sslStoreProductDetails = jsonData.productDetails;
            if(sslStoreProductDetails.IsSan)
            {
                $("#san_div").show();
                document.getElementById("san").value=jsonData.SAN;
                $("#san_description").text("Free SAN:"+sslStoreProductDetails.MinSan+" & Maximum SAN:"+sslStoreProductDetails.MaxSan);//NO I18N
            }
            else
            {
                $("#san_div").hide();
            }
            document.getElementById("server_type").value=jsonData.ServerType;
            document.getElementById("approver_mail").value=jsonData.ApproverEmail;
            document.getElementById("product_name").value=jsonData.ProductCode;
            document.getElementById("domain_validation").value=jsonData.DomainValidationType;
            document.getElementById("vendor_name").value=jsonData.VendorName;
            changeDomainValidation(jsonData.DefaultDns,jsonData.HTTPS_FILE);
            var keyOnRenewal = jsonData.keyOnRenewal;
            if(keyOnRenewal==="uploadcsr")
            {
                $("#samekeyoption").hide();
            }
//            sslStoreReissuePrivateKey=jsonData.PrivateKey;
//            if(jsonData.PrivateKey)
//            {
//                $("#samekeybutton").show();                
//            }
//            else
//            {
//                $("#samekeybutton").hide();
//                $("#passworddiv").show();
//                $("#password").addClass("importantfield_kmp");
//            }
        });
   }
});

App.SSLStoreMgmtView = Ember.View.extend({
	templateName: 'SSLStoreMgmt',//No I18N
		didInsertElement: function(){

                    }
});

App.SSLStoreAccountsPageView = Ember.View.extend({
    templateName: 'SSLStoreAccountsPage',//NO I18N
    didInsertElement: function(){
        document.getElementById("helpNote").innerHTML=I18N.getMsg("sslstore.addaccount.note");//NO I18N
        var ajaxRequestUrl = '/api/pki/sslstore/getSSLStoreAccountDetails'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
            $("#partnercode").val(jsonData.partnercode);
        });
    }
});

App.OrganizationDetailsView = Ember.View.extend({
    templateName: 'OrganizationDetails',//NO I18N
    didInsertElement: function(){
        var ajaxRequestUrl = '/api/pki/sslstore/sslStoreGetOrgDetails'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
            if(jsonData.Status==="Success")
            {
                $("#deleteButton").show();
                fillOrgDetails(jsonData);
            }
        });
    }
});
