// $Id$
App.SettingsView = Ember.View.extend({
	templateName: 'Settings',//No I18N
		didInsertElement: function(){
                    var ajaxRequestUrl = '/api/pki/settings/isExportPasswordEnabled'; //No I18N
                    getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                        if(!App.ApplicationController.isAdmin)
                        {
                            if(jsonData.isExportPasswordEnabled)
                            {
                                $("#privacysettings").show();
                            }
                            else
                            {
                                $("#privacysettings").hide();
                            }
                        }
                    });    
                    $('.kmp_select').parent().closest('div').parent().closest('div').find(">input").attr('checked',true);//No I18N
                    $('#setMenuDIV').slimScroll({
            railVisible: true,
                railBorderRadius: 0,
                railOpacity: 0.1
        });
		}
});
function arrowChange(obj){
    var id=$('input[type=radio][name=kmpmenu]:checked').attr('id');
    if ($('label[for="' + id + '"] span').hasClass("arrow_rot"))
    {
        $('#'+id).prop( "checked", false );
        $('label[for="' + id + '"] span').attr("class", "icon-rtarrow");
    } 
    else {
        $('label[for="menu1"] span').attr("class", "icon-rtarrow");
        $('label[for="menu2"] span').attr("class", "icon-rtarrow");
        $('label[for="menu3"] span').attr("class", "icon-rtarrow");
        $('label[for="menu4"] span').attr("class", "icon-rtarrow");
        $('label[for="menu5"] span').attr("class", "icon-rtarrow");
        $('label[for="menu6"] span').attr("class", "icon-rtarrow");
        $('label[for="menu7"] span').attr("class", "icon-rtarrow");
        $('label[for="' + id + '"] span').attr("class", "icon-rtarrow arrow_rot");
    }
    window.location=$('label[for="'+obj.id+'"] a').attr("href");
}

function settinghideDiv()
{
    $('label[for="menu1"] span').attr("class", "icon-rtarrow");
        $('label[for="menu2"] span').attr("class", "icon-rtarrow");
        $('label[for="menu3"] span').attr("class", "icon-rtarrow");
        $('label[for="menu4"] span').attr("class", "icon-rtarrow");
        $('label[for="menu5"] span').attr("class", "icon-rtarrow");
        $('label[for="menu6"] span').attr("class", "icon-rtarrow");
    $('input:radio[name=kmpmenu]').attr('checked',false);
}

App.SDPView = Ember.View.extend({
	templateName: 'SDP',//No I18N
		didInsertElement: function(){
		}
});

App.SettingsAllView = Ember.View.extend({
	templateName: 'Settings',//No I18N
		didInsertElement: function(){
		}
});

App.UserManagementView = Ember.View.extend({
	templateName: 'UserManagement',//No I18N
		didInsertElement: function(){
                    App.Settings.listUsers();
		}
});

App.RadiusServerView = Ember.View.extend({
    templateName: 'RadiusServer',//NO I18N
    didInsertElement: function(){
        App.Settings.getRadiusConfiguration();
    }
});

App.CreateUserView = Ember.View.extend({
	templateName: 'CreateUser',//No I18N
        didInsertElement: function(){
        var ajaxRequestUrl = '/api/pki/settings/getUserDetails?&UserView=Only_Associated' //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            fillUserDetails(jsonData);
            });
        }
});

App.UpdateUserView = Ember.View.extend({
	templateName: 'UpdateUser',//No I18N
        didInsertElement: function(){
            App.Settings.getUserInfo(App.SettingsUserController.user_id);
        }
});

App.RolesView = Ember.View.extend({
    templateName: 'roles',//NO I18N
    didInsertElement: function(){
        App.Settings.getPKIRolesList();
    }
});

App.ChangePasswordView = Ember.View.extend({
	templateName: 'ChangePassword',//No I18N
        didInsertElement: function(){
            if((/\\/).test(window.userName)){
                $("#NOPasswdDiv").show();
                $("#changePasswdDiv").hide();
            }else{
                $("#NOPasswdDiv").hide();
                $("#changePasswdDiv").show();
        }
        }
});

App.ProxySettingView = Ember.View.extend({
	templateName: 'ProxySetting',//No I18N
        didInsertElement: function(){
            App.Settings.getProxyServer();
        }
});

App.MailServerView = Ember.View.extend({
    templateName: 'MailServer',//No I18N
        didInsertElement: function(){
            App.Settings.getMailServer();
        }
});

App.SyslogView = Ember.View.extend({
    templateName: 'SnmpSyslogServerSettings',//No I18N
        didInsertElement: function(){
            $('#snmp_server_div').hide();
            $('#syslog_server_div').show();
            App.Settings.getSNMPSyslogSettingsView();
        }
});
App.SNMPView = Ember.View.extend({
    templateName: 'SnmpSyslogServerSettings',//No I18N
        didInsertElement: function(){
            $('#snmp_server_div').show();
            $('#syslog_server_div').hide();
            App.Settings.getSNMPSyslogSettingsView();
        }
});

App.ADAuthenticationView = Ember.View.extend({
    templateName: 'ADAuthentication',//No I18N
        didInsertElement: function(){
            $("#adTitle").show();
            $("#userimp_label").text(I18N.getMsg('js.adauth.wantcertimport'));//No I18N
            App.Settings.getDomains();
        }
});

App.PolicyView = Ember.View.extend({
    templateName: 'Policy',//No I18N
        didInsertElement: function(){
            App.Settings.getPolicyConfig();
        }
});

App.NotificationAuditView = Ember.View.extend({
    templateName: 'NotificationAudit',//No I18N
    didInsertElement: function(){
           App.Audit.getAuditNotify(); 
    }
});

App.NotificationPolicyView = Ember.View.extend({
        didInsertElement: function(){
            App.Settings.getNotificationConfig();
        }
});

App.BackupDBView = Ember.View.extend({
    templateName: 'BackupDB',//No I18N
        didInsertElement: function(){
            App.Settings.getDBBackup();
        }
});

App.ClientConfigView = Ember.View.extend({
        didInsertElement: function(){
            var ajaxRequestUrl='/api/pki/settings/getDashboardType'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl, "", function(jsonData){
                if(jsonData.configType=="full")
                {
                    document.getElementById("both").checked=true;
                }
                else if(jsonData.configType=="ssh")
                {
                    document.getElementById("ssh").checked=true;
                }
                else
                {
                    document.getElementById("ssl").checked=true;
                }
            });            
        }
});

App.ApiKeyGenerationView = Ember.View.extend({
        didInsertElement: function(){
            App.Settings.getAPIKey();
        }
});

App.VulnerabilitiesSettingsView = Ember.View.extend({
        didInsertElement: function(){
            App.Settings.getSSLVulnerabilitiesSettings();
        }
});

App.METrackerView = Ember.View.extend({
    templateName:'METracker',//NO I18N
    didInsertElement: function(){
        var ajaxRequestUrl = '/api/pki/settings/meTrackView'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){                
            document.getElementById(jsonData.Tracking).checked=true;
        });
    }
});

App.PIIDataView = Ember.View.extend({
    templateName:'PIIData',//NO I18N
    didInsertElement: function(){
        var ajaxRequestUrl = '/api/pki/settings/getPIIDataView'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                    var colNamesList = ['Settings Id',I18N.getMsg("settings.piidata.piifield"),I18N.getMsg("settings.piidata.maskinreport"),I18N.getMsg("settings.piidata.maskinschedule"),I18N.getMsg("settings.piidata.hideinreport"),I18N.getMsg("settings.piidata.hideinschedule"),I18N.getMsg('js.table.search')];//NO I18N
                    var colModelList = [
                        { name: 'Settings_Id', index: 'Settings_Id',hidden:true}, //No I18N
                        { name: 'Display_Name', index: 'Display_Name',width:"200px"}, //No I18N
                        { name: 'Mask_In_Report', index: 'Mask_In_Report',formatter:"mask_in_report_formatter",width:"150px"}, //No I18N                        
                        { name: 'Mask_In_Schedule', index: 'Mask_In_Schedule',formatter:"mask_in_schedule_formatter",width:"200px"}, //No I18N                        
                        { name: 'Hide_In_Report', index: 'Hide_In_Report',formatter:"hide_in_report_formatter",widht:"150px"}, //No I18N                        
                        { name: 'Hide_In_Schedule', index: 'Hide_In_Schedule',formatter:"hide_in_schedule_formatter",width:"200px"}, //No I18N                        
                        { name: 'search',width:"30px",sortable: false,search:false,fixed:true}//NO I18N
                    ];
                    var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
                    loadJQgridWithData("#PIIDataList", jsonData.PIIList, colNamesList, colModelList, "", "", "PIIDataList",defaultOptions);//No I18N
            });
    }
});

App.UnMappedMailsView = Ember.View.extend({
    templateName:'UnMappedMails',//NO I18N
    didInsertElement: function(){
            App.Settings.getUnmappedMailsView(); 
        }
    });

App.ReportsPasswordView = Ember.View.extend({
    templateName:'ReportsPassword',//NO I18N
    didInsertElement: function(){
        $("#showhideiconglobal").css("cursor","pointer");
        $('#globalpassword + .glyphicon').on('click', function() {
            $(this).toggleClass('glyphicon-eye-close').toggleClass('glyphicon-eye-open'); 
            var type = $("#globalpassword").attr("type");
            if(type==="password")
            {
                $('#globalpassword').prop("type","text"); //NO I18N
            }
            else
            {
                $('#globalpassword').prop("type","password"); //NO I18N
            }
        });
        $("#showhideiconuser").css("cursor","pointer");
        $('#userpassword + .glyphicon').on('click', function() {
            $(this).toggleClass('glyphicon-eye-close').toggleClass('glyphicon-eye-open'); 
            var type = $("#userpassword").attr("type");
            if(type==="password")
            {
                $('#userpassword').prop("type","text"); //NO I18N
            }
            else
            {
                $('#userpassword').prop("type","password"); //NO I18N
            }
        
        });
        var ajaxRequestUrl = '/api/pki/settings/getExportPasswordSettings'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            if(App.ApplicationController.isAdmin===true)
            {
                $("#globalautogenerate").show();
                $("#SubmitButton").show();
                $("#globalpasswordoption").show();
                if(jsonData.isExportPasswordProtected===true)
                {
                    document.getElementById("enablePasswordEncryption").checked=true;
                    document.getElementById("globalpassword").value=jsonData.globalPassword;
                    $("#globalPasswordDiv").show();                    
                    if(jsonData.isUserPasswordAllowed===true)
                    {
                        document.getElementById("enableUserPassword").checked=true;
                        $("#userPasswordDiv").show();
    }
                    $("#userpasswordoption").show();
                    document.getElementById("userpassword").value=jsonData.userPassword;                    
                }
            }
            else
            {
                $("#globalautogenerate").hide();
                $("#globalpasswordoption").hide();
                if(jsonData.isExportPasswordProtected===true)
                {
                    document.getElementById("globalpassword").value=jsonData.globalPassword;
                    $("#globalPasswordDiv").show();   
                    document.getElementById("globalpassword").disabled=true;
                }
                if(jsonData.isUserPasswordAllowed===true)
                {
                    if(jsonData.userPassword!==undefined)
                    {
                        document.getElementById("userpassword").value=jsonData.userPassword;
                    }
                    $("#userPasswordDiv").show();
                    $("#SubmitButton").show();
                }
                else
                {
                    $("#SubmitButton").hide();
            }
            }
});
    }
});

App.DomainExpiryDataView = Ember.View.extend({
   templateName : 'DomainExpiryData',//NO I18N
   didInsertElement: function(){
       if(kmpStandAlone){
            $("#contentParentDiv").css({'width':'80%','max-height':'600px'});
   }
   }
});

App.DomainExpiryDataController = Ember.ObjectController.extend({
   needs: 'application',//NO I18N
   actions:{       
        submit: function(){                        
           var domain = document.getElementById("commonName").value;
           if(domain==="")
           {
               showAlert(I18N.getMsg("js.sslcertificate.enterDomainName"));//NO I18N
               return;
           }
           var ajaxUrl = "/api/pki/Inventory/domainExpiry?domain="+domain;//NO I18N
           getAjaxApiRequest(ajaxUrl,"",function(jsonData){
              $("#contentDiv").show();
              $("#contentDiv").text(jsonData.data);
           });
        }
   }
});
App.KMPDomainExpiryDataView = Ember.View.extend({
    templateName: 'KMPDomainExpiryData',//No I18N
    didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg("domainexpiry.domainexpiration.label"));//NO I18N
        $(".modal-body").css('width','800px'); //NO I18N
        $(".modal-dialog").css('width','800px');//NO I18N
        $("#domainNamelabelDiv").css('width','200px');//NO I18N
        $("#getdetailsDiv").css('padding-left','20px');//NO I18N
        $("#contentParentDiv").css({'width':'100%','max-height':'500px'});//NO I18N
        kmpStandAlone=false;
    }
});

App.KMPDomainExpiryDataController = Ember.ObjectController.extend({
    needs:["application","DomainExpiryData"],//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
            }
        }
});
App.PurgeAuditView = Ember.View.extend({
    templateName:'PurgeAudit',//NO I18N
    didInsertElement: function(){
        var ajaxRequestUrl = '/api/pki/settings/purgeAuditView'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){                
            document.getElementById("operation").value = jsonData.operationAudit;
            document.getElementById("discoveryaudit").value = jsonData.discoveryAudit;
            document.getElementById("keyassociation").value = jsonData.associationAudit;
            document.getElementById("keyrotation").value = jsonData.rotationAudit;
            document.getElementById("scheduleaudit").value = jsonData.scheduleAudit;
        });
    }
});

App.CMDBView = Ember.View.extend({
    templateName:'CMDB',//NO I18N
    didInsertElement: function(){
        if(kmpStandAlone){
        App.Settings.getCMDBView();
    }else{
	$("label").removeClass("col-sm-2").addClass("col-sm-4");
            $("#saveCMDB").css("margin-left","47%");
            $("#fetchAttributes").removeClass();
            $("#NEW_LINK").css("color","#039be5");
            }
            }
        });

App.SDPServerView = Ember.View.extend({
   templateName: 'SDPServer',//NO I18N
   didInsertElement: function(){
        if(kmpStandAlone){App.Settings.getSDPServerView();
        }else{
            $("label").removeClass("col-sm-2").addClass("col-sm-4");
            $("#saveSDP").css("margin-left", "44.667%");
            }
    }
        });

App.ServerCertificateView = Ember.View.extend({
    templateName:'ServerCertificate',//NO I18N
        didInsertElement: function(){
        var ajaxRequestUrl = '/api/pki/Inventory/listsslSummary'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var list = jsonData.InventDetails;
            if(list.length>0)
            {                
                $("#certificateList option").remove();
                var sel = document.getElementById("certificateList");
                for (var i=0; i<list.length; i++)
                {
                    var item=list[i];
                    if(item.IsOnlyKeyStore)
                    {
                    var opt=document.createElement('option');//No I18N
                    opt.innerHTML = item['Common Name'];
                    opt.value = item.ResourceID;
                    sel.appendChild(opt);
                }
                    
            }
            }
        });
        var url = '/api/pki/settings/getServerPort';//NO I18N
        getAjaxApiRequest(url,"",function(jsonData){
           document.getElementById("serverPort").value=jsonData.Port; 
        });
        }
});

App.GeneralSettingsView = Ember.View.extend({
    templateName:'GeneralSettings',//NO I18N
        didInsertElement: function(){
        App.Settings.getMSCAAutoRenewalSettingsView();
            }
        });

App.BackupScheduleAuditView = Ember.View.extend({
    templateName: 'BackupScheduleAudit',//No I18N
        didInsertElement: function(){
        }
});

App.CreateSSHKeyView = Ember.View.extend({
    templateName: 'CreateSSHKey',//No I18N
        didInsertElement: function(){
            if(!kmpStandAlone){
                selectKMPTab("ssh_keys");//NO I18N
                    }
        }
});

App.SSHMgmtView = Ember.View.extend({
    templateName: 'SSHMgmtMainTabs',//No I18N
        didInsertElement: function(){
                    }
});

App.SSHKeysView = Ember.View.extend({
    templateName: 'SSHKeys',//No I18N
        didInsertElement: function(){
            App.ApplicationController.getBack="SSH Keys";//No I18N
            App.Settings.listsshkeys();
            if(!kmpStandAlone){
                selectKMPTab("ssh_keys");//NO I18N
        }
            todisplayMenus(App.ApplicationController.viewMenus,"SSH");//No I18N
            if(App.ApplicationController.viewMenus === undefined || jQuery.isEmptyObject(App.ApplicationController.viewMenus)){    
                App.ApplicationController.viewMenus=pkiJson.SSH.SSH;            
            }
            if((App.ApplicationController.viewMenus.indexOf("Dissociate_SSHKeys")>-1) || (App.ApplicationController.viewMenus.indexOf("ImportKey")>-1) || (App.ApplicationController.viewMenus.indexOf("DeleteKey_SSHKeys")>-1))
            {
                $("#MoreDiv").show();
            }
        }
});

App.KeysGroupView = Ember.View.extend({
    templateName: 'KeysGroup',//No I18N
        didInsertElement: function(){
            todisplayMenus(App.ApplicationController.viewMenus,"SSH");//No I18N
            App.Settings.listkeysgroup();
            if(!kmpStandAlone){
                selectKMPTab("key_group");//NO I18N
        }
        }
});

App.KeysGroupKeysView = Ember.View.extend({
    templateName: 'KeysGroupKeys',//No I18N
        didInsertElement: function(){
            todisplayMenus(App.ApplicationController.viewMenus,"SSH");//No I18N
            $('#group_name').text(I18N.getMsg("js.commonstr.keysgroupname")+":"+sessionStorage.getItem("groupname"));//No I18N
            App.Settings.listkeysgroupkeys();
            if(!kmpStandAlone){
                selectKMPTab("key_group");//NO I18N
        }
        }
});

App.UsersGroupUsersView = Ember.View.extend({
    templateName: 'UsersGroupUsers',//No I18N
        didInsertElement: function(){
            todisplayMenus(App.ApplicationController.viewMenus,"SSH");//No I18N
            App.SettingsCommonController.userGroupUsersView=true;
            $('#group_name').text(I18N.getMsg("js.usersGroup.usergroupname")+":"+sessionStorage.getItem("groupname"));//No I18N
            App.Settings.listusersgroupusers();
        }
});

App.UsersGroupView = Ember.View.extend({
    templateName: 'UsersGroup',//No I18N
        didInsertElement: function(){
            todisplayMenus(App.ApplicationController.viewMenus,"SSH");//No I18N
        App.SettingsCommonController.userGroupUsersView=false;
        App.Settings.listusersgroup();
        }
});

App.AllResourceUsersView = Ember.View.extend({
    templateName: 'AllResourceUsers',//No I18N
        didInsertElement: function(){
             todisplayMenus(App.ApplicationController.viewMenus,"SSH");//No I18N
            App.SettingsCommonController.userGroupUsersView=false;
            App.Settings.getAllResourceUsers();
        }
});

App.AddCommandView = Ember.View.extend({
    templateName: 'AddCommand',//NO I18N
    didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg("js.add.command"));//NO I18N
        $('[data-toggle="popover"]').popover();
        $( "#modalDialog" ).draggable();
        var data ="userid="+ App.SettingsCommonController.user_id;//NO I18N
        var ajaxRequestUrl='/api/pki/ssh/userKeysWithCommand'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,data, function(jsonData){
            var array = jsonData.keyslist;
            document.getElementById("editcommand").value=jsonData.editcommand;
            for(i=0;i<array.length;i++)
            {
                var value = array.get(i).command.replace(/"/g, '&quot;'); 
                var element= '<div class="form-group"><label class="col-sm-5 ">'+array.get(i).keyname+'</label>'+//NO I18N
                                    '<div class="col-sm-7">'+//NO I18N
                                    '<input type="text" class="form-control" id="'+array.get(i).keyid+'" value="'+value+'">'+//NO I18N
                                '</div>';//NO I18N
                $('#keys').append(element);            
            }
        });
    }
});

App.EditAuthFileView = Ember.View.extend({
   templateName: 'EditAuthFile',//NO I18N
   didInsertElement:function(){
       $(".modal-title").text(I18N.getMsg('js.editauthorizedkeys.file'));//NO I18N       
        $("#EditAuthFile .modal-dialog").css('width','650px');
        $("#EditAuthFile .modal-body").css('width','650px');    
        document.getElementById("NOTE").innerHTML=I18N.getMsg("js.editauthorizedkeys.file.note");//NO I18N
   }
});

App.ShowCertificatesView = Ember.View.extend({
   templateName: 'ShowCertificates',//NO I18N
   didInsertElement:function(){
        $(".modal-title").text(I18N.getMsg('usermanagement.certificates'));//NO I18N       
        $("#ShowCertificates .modal-dialog").css('width','1050px');
        $("#ShowCertificates .modal-body").css('width','1050px');     
        var reqParams="";
        var sslvalues = [];
        var sslGroups = [];
        if(document.getElementById("SpecificSelection").checked)
        {                        
            var select = document.getElementById('SELECTEDDEVICES');
            var options = select.getElementsByTagName('option');
            for (var i=options.length; i--;) {
            sslvalues.push(options[i].value)
            }
            if(sslvalues.toString()=="")
            {
                showAlert(I18N.getMsg('js.createuser.selectatleast.onsslcertificate'));//No I18N
                return;
            }
            reqParams+="&SELECTEDSSLDEVICES="+sslvalues; //No I18N
        }
        if(document.getElementById("GroupSelection").checked)
        {                        
            var select = document.getElementById('SELECTEDGROUPS');
            var options = select.getElementsByTagName('option');
            for (var i=options.length; i--;) {
            sslGroups.push(options[i].value)
            }
            if(sslGroups.toString()=="")
            {
                showAlert(I18N.getMsg('js.Group.selectatleastonegroup'));//No I18N
                return;
            }
            reqParams+="&SELECTEDSSLGOUPS="+sslGroups; //No I18N
        }                    
        if(!document.getElementById("SpecificSelection").checked && !document.getElementById("GroupSelection").checked)
        {
            showAlert(I18N.getMsg("createuser.selectcertificates.alert"));//NO I18N
            return;
        }
        $("#matchingResources").show();
        $("#PKIMatchingResourcesList .ui-jqgrid-bdiv").css('height',"300px");
    //    $("#showCertificates").hide();
    //    $("#hideCertificates").show();
        $('#PKIMatchingResourcesList').jqGrid('GridUnload');//No I18N
        var ajaxRequestUrl = '/api/pki/Inventory/userMatchingCertificates'; //No I18N    
        getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
          var colNamesList = ['ResourceID',I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.sslcertificate.issuer'),I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg('js.ssl.certificate.keyalgorithm'),I18N.getMsg('js.cert.sigAlgorithm'),I18N.getMsg("js.commonstr.description"),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'ResourceID', index: 'ResourceID',hidden:true}, //No I18N
                    { name: 'Common Name', index: 'Common Name',width: '200px'}, //No I18N
                    { name: 'DNS Name/FQDN', index: 'DNS Name/FQDN',width: '200px'}, //No I18N
                    { name: 'Organization', index: 'Organization',width: '200px'}, //No I18N                                        
                    { name: 'KeyStrength', index: 'KeyStrength',width:'100px'}, //No I18N
                    { name: 'keyAlgorithm', index: 'keyAlgorithm',width:'90px'}, //No I18N
                    { name: 'signatureAlgorithm', index: 'signatureAlgorithm',width:'200px'}, //No I18N                    
                    { name: 'Description', index: 'Description',width: '200px'}, //No I18N
                    { name: 'search',width:"30px",sortable: false,search:false,fixed:true,hidden:true}//NO I18N
            ];            
        var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
        loadJQgridWithData("#PKIMatchingResourcesList", jsonData.InventDetails, colNamesList, colModelList, " ", "#PKIMatchingResourcesPager", "",defaultOptions);//No I18N
        });    
   }
});

App.CiphersView = Ember.View.extend({
   templateName: 'Ciphers',//NO I18N
   didInsertElement:function(){
       $(".modal-title").text(I18N.getMsg('vulnerabilities.insecureciphers'));//NO I18N       
        $("#Ciphers .modal-dialog").css('width','550px');
        $("#Ciphers .modal-body").css('width','550px');    
        document.getElementById("NOTE").innerHTML=I18N.getMsg("vulnerabilities.editciphers.note");//NO I18N
        var ajaxRequestUrl = '/api/pki/settings/getCiphersView';//NO I18N
        getAjaxApiRequest(ajaxRequestUrl,"", function(jsonData){ 
            var ciphers = jsonData.Ciphers.split("\n");
            document.getElementById("contentDiv").innerHTML='<input type="text" onkeyup="searchCiphers()" id="cipherSearch" placeholder="Search" style="border: none;border-color: transparent;outline-width: 0;"><br>';//NO I18N
            for(var i=0;i<ciphers.length;i++)
            {
                var element='<span class="cipherhover" style="cursor:pointer">'+$.trim(ciphers[i])+'<span onclick=removeCipher(this) class="glyphicon glyphicon-remove cipherdelete" style="vertical-align:text-top;font-size:12px;color:#4d4d4d;" title="Remove Cipher"></span>';//NO I18N
                if(i!=ciphers.length)
                {
                    element+='\n</span>';//NO I18N
                }
                else
                {
                    element+='</span>';//NO I18N
                }
                document.getElementById("contentDiv").innerHTML+=element;                
            }
        });
   }
});

App.AuthFileView = Ember.View.extend({
   templateName: 'AuthFile',//NO I18N
   didInsertElement: function(){
       
   }
});

App.EditUserPathView = Ember.View.extend({
   templateName: 'EditUserPath',//NO I18N
   didInsertElement:function(){
        $(".modal-title").text(I18N.getMsg("js.editpath.title"));//NO I18N
        $('[data-toggle="popover"]').popover();
        $( "#modalDialog" ).draggable();
        if(!App.SettingsCommonController.uGroup && !App.SettingsCommonController.rGroup)
        {
            
                $('#Path').val(App.SettingsCommonController.dir_path);
            
            }
        else
        {
            $('#Path').attr("placeholder",I18N.getMsg("js.editpath.usershomedirectory"));
        }
   }
});

App.TransferFileView = Ember.View.extend({
   templateName: 'TransferFile',//NO I18N
   didInsertElement:function(){
       $("#Path").val(App.SettingsCommonController.dir_path);
        $(".modal-title").text(I18N.getMsg("transferfile.title"));//NO I18N
        $('[data-toggle="popover"]').popover();
        $( "#modalDialog" ).draggable();        
   }
});


App.CreateGroupView = Ember.View.extend({
    templateName: 'CreateGroup',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg("js.creategroup"));//NO I18N
        }
});

App.AllUsersKeysView = Ember.View.extend({
    templateName: 'AllUsersKeys',//No I18N
    didInsertElement:function(){
        todisplayMenus(App.ApplicationController.viewMenus,"SSH");//No I18N
        var ajaxRequestUrl='/api/pki/ssh/alluserswithkeys'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl, "", function(jsonData){
            var colNamesList ;
            if(kmpStandAlone)
            {
             colNamesList = ['User Id','ResID',I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.general.username'),I18N.getMsg('js.discovery.discoveredkeys'),'credential','','isadmin',I18N.getMsg('js.table.search')]; //No I18N
            }else{
                colNamesList = ['User Id','ResID',I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.general.username'),I18N.getMsg('js.discovery.discoveredkeys'),'credential','','isadmin',I18N.getMsg('js.table.search')]; //No I18N
            }
             var colModelList = [
                 {name: 'UserID',index: 'UserID',hidden:true}, //No I18N
                 {name: 'ResID',index: 'ResID',hidden:true}, //No I18N
                 {name: 'Resource Name', index: 'Resource Name'},//No I18N
                 {name: 'User Name', index: 'User Name'}, //No I18N
                 {name: 'Discovered Keys', index: 'Discovered Keys'}, //No I18N
                 {name: 'isCredAvailable',index: 'isCredAvailable',hidden:true},//No I18N
                 {name: 'isCredAvailable',index: 'isCredAvailable',formatter:'AllResourceUserCredentialsFormatter',search:false},//No I18N
                 {name: 'isadmin',index: 'isadmin',hidden:true},//No I18N
                 { name: 'search',width:40,sortable: false,search:false,fixed:true}//NO I18N
             ];
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#AllUsersKeys", jsonData.AllUsersKeys, colNamesList, colModelList, "", "#AllUsersKeysPage", "AllResourceUsers",defaultOptions);//No I18N             
        });
            if(!kmpStandAlone){
                selectKMPTab("ssh_disKeys");//NO I18N
    }
    }
});

App.PlaceKeyFileView = Ember.View.extend({
    templateName: 'PlaceKeyFile',//No I18N
    didInsertElement:function(){
        var ajaxRequestUrl = '/api/pki/ssh/checkPublicOrPrivate';//NO I18N
        var params ='key_id='+App.SettingsCommonController.key_id;//NO I18N
        var puborprivate;
        var controller = this.get('controller');
        getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){        
        $(".modal-title").text(I18N.getMsg("js.general.copykeyfiletouser"));//NO I18N
        //$("#placekeyfile .modal-dialog").css('width','550px');
                ajaxRequestUrl = '/api/pki/ssh/getAssociatedUsersForKey'; //No I18N
        var privateKeyFileName;
        var publicKeyFileName;
        var id=App.SettingsCommonController.id
        var keytype = $("#PKISSHKeys").jqGrid('getCell',id,'KeyType');//NO I18N
                App.SettingsCommonController.keyType=keytype;
        if(keytype == "ssh-rsa")
        {
            privateKeyFileName="id_rsa";//NO I18N
            publicKeyFileName="id_rsa.pub";//NO I18N
        }
        else
        {
            privateKeyFileName="id_dsa";//NO I18N
            publicKeyFileName="id_dsa.pub";//NO I18N
        }
                if(jsonData.key==="public")
                {
                    document.getElementById("privcheckbox").checked = false;
                    $("#privatecheckbox").hide();
                }
        document.getElementById("privFileName").value=privateKeyFileName;
        document.getElementById("pubFileName").value=publicKeyFileName;
        var key_id= App.SettingsCommonController.key_id;
        params='key_id='+key_id+'&ViewName=List';//No I18N
        //var directoryLabel = I18N.getMsg("js.editpath.title");
        getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
            if(jsonData.Status!=undefined && jsonData.Status=="Failure")
            {
                messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N
                controller.send("close");//NO I18N
            }else{
            var array = jsonData.UserDeatils;
            for(i=0;i<array.length;i++)
            {
                var element=   '<div>'
                                    +'<div class="col-sm-12 checkbox">'
                                        +'<label class=" control-label"><input type="checkbox" value="'+array.get(i).UserID+'" name="users">'+array.get(i).UserName+"@"+array.get(i).ResourceName+'</label>'
                                    +'</div>'
                            +'</div>';//NO I18N
                            
                $('#associatedUsers').append(element);    
            }
        }
        });
        });
    }
});


App.RotateKeyWithFileView = Ember.View.extend({
   templateName: 'RotateKeyWithFile',//NO I18N
   didInsertElement: function(){
       $(".modal-title").text(I18N.getMsg("js.general.pushkeyfileafterrotation"));//NO I18N
   }
});

App.AssociateMapperView = Ember.View.extend({
    templateName: 'AssociateMapper',//No I18N
        didInsertElement: function(){
            $('#key_name').text(I18N.getMsg("js.ssh.keyname")+":"+sessionStorage.getItem("keyname"));//No I18N
            App.Settings.getAssociatedUsersForKey();
            if(!kmpStandAlone && !isKMPLicPropInPMP){
                $('#associationGraphDiv').hide();
            }
                        }
            });

App.MappingGraphView = Ember.View.extend({
    templateName: 'MappingGraph',//No I18N
        didInsertElement: function(){
            if(App.SettingsUserController.type==="user")
            {
                App.Settings.getUserAssociateMappingGraphView();
            }else
            {
                App.Settings.getAssociateMappingGraphView();
            }
        }
});

App.KeyRotationAuditView = Ember.View.extend({
    templateName: 'KeyRotationAudit',//No I18N
        didInsertElement: function(){
            var ajaxRequestUrl = '/api/pki/ssh/getManageKeyRotationAuditView?keyStateId='+App.SettingsCommonController.keyStateId; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                        var colNamesList = ['KeyRotationAuditId',I18N.getMsg('js.ssh.keyname'),I18N.getMsg('js.ssh.keyrotationinvokedon'),I18N.getMsg('js.keyRotationaudit.rotatedBy'),I18N.getMsg('js.general.finishtime'),I18N.getMsg('js.commonstr.status'),I18N.getMsg('js.table.search')]; //No I18N
                        var colModelList = [
                                { name: 'KeyRotationAuditId', index: 'KeyRotationAuditId',hidden:true}, //No I18N
                                { name: 'Key_Name', index: 'Key_Name',classes:"pointer"}, //No I18N
                                { name: 'KeyRotationInvokedOn', index: 'KeyRotationInvokedOn'}, //No I18N
                                { name: 'RotatedBy', index: 'RotatedBy'}, //No I18N
                                { name: 'FinishTime', index: 'FinishTime'}, //No I18N
                                { name: 'KeyRotation_Status', index: 'KeyRotation_Status'}, //No I18N
                                { name: 'search',width:'40px',sortable: false,search:false,fixed:true}//NO I18N
                        ];
                    var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
                    loadJQgridWithData("#KeyRotationAuditDetailsList", jsonData.keyRotationAudit, colNamesList, colModelList, "", "#KeyRotationAuditListPager", "SSHKeyAssociateAudit",defaultOptions);//No I18N
            });
            if(!kmpStandAlone){
                if(App.SettingsCommonController.keyStateId==1)
                {
                    selectKMPTab("assosiation_audit");//No I18N
                }else{
                    selectKMPTab("rotation_audit");//No I18N
        }
            }            
        }
});

App.AddKeysView = Ember.View.extend({
    templateName: 'AddKeys',//No I18N
        didInsertElement: function(){
            //$('[data-toggle="popover"]').popover();//For help Content
            $(".modal-title").text(I18N.getMsg("js.ssh.importkeys"));//NO I18N
                    }
});

App.AddKeysGroupView = Ember.View.extend({
    templateName: 'AddKeysGroup',//No I18N
        didInsertElement: function(){
            var kGroupId = App.SettingsUserController.kGroupId;
            $("#kGroupDesc").val("");//No I18N
            var data='KEYS_GROUP_ID='+kGroupId;//No I18N
            var ajaxRequestUrl = '/api/pki/ssh/keysgroupeditview'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData)
            {
                var parameterMap = jsonData.CriteriaParameters;
                var conditionMap = jsonData.CriteriaConditions;
                var comparatorMap = new Array();
                comparatorMap.push({name: "and", value: "and"});  //No I18N
                comparatorMap.push({name: "or", value: "or"});  //No I18N
                App.InventoryListDetailsController.parameterMap = parameterMap;
                App.InventoryListDetailsController.conditionMap = conditionMap;
                App.InventoryListDetailsController.comparatorMap = comparatorMap; 
                App.SettingsUserController.QUERYID = jsonData.QUERYID;
                if(kGroupId != "new") {
                    $("#kGroupDesc").val(jsonData.GroupDesc);//No I18N
                    if(kmpStandAlone){
                        $("#kGroupName").val(jsonData.GroupName);
                        $('#kGroupName').attr('readonly', true);
                    }else{
                    $("#kGroupName_Label").show();
                    $("#kGroupName_Label").text(jsonData.GroupName);//No I18N
                    $("#kGroupName").val(jsonData.GroupName);//No I18N
                    $('#kGroupName').hide();
                }
                    $('.pgtitle').text(I18N.getMsg('js.commonstr.updateKeysGroup'));//No I18N
                    if(jsonData.KeysByCriteria == true) {
                        $("#keys-div").css('display','none');//No I18N
                        $("#SpecificCriteria-div").css('display','block');//No I18N
                        $('#KeysByCriteria').attr("checked", true);
                        var selectQuery = jsonData.SelectQueryContents.CRITERIA_LIST;
                        for (var int1 = 0; int1 < selectQuery.length; int1++) 
                        {
                            var index = int1+1;
                            var cri = selectQuery[int1];
                            $row =  $('<tr id="'+index+'" style="height: 45px;"></tr>');//No I18N
                            $td = $("<td width='100px' align='left'></td>");//No I18N
                            if(int1 == 0) {
                                $select = $('<select name="COMPARATOR_"'+ index + ' disabled="true" style="width: 80px;  display: none;" id="COMPARATOR_'+index+'" class="form-control"></select>');//No I18N
                            } 
                            else {
                                $select = $('<select name="COMPARATOR_"'+ index + ' style="width: 80px;" id="COMPARATOR_'+index+'" class="form-control"></select>');//No I18N
                            }
                            for (var i = 0; i < comparatorMap.length; i++) {
                                $select.append($('<option value="'+ comparatorMap[i].value +'">'+ comparatorMap[i].name +'</option>'));  //No I18N
                            }
                            $td.append($select);
                            $row.append($td);

                            $parameter = $("<td width='200px' align='left'></td>");//No I18N
                            $selectparameter = $('<select onchange="checkConditions(this)" name="PARAMETER_'+ index + '" style="width: 180px;" id="PARAMETER_'+ index + '" class="form-control"></select>');//No I18N
                            for (var i = 0; i < parameterMap.length; i++) 
                            {
                                $selectparameter.append($('<option value="'+ parameterMap[i].Key +'">'+ parameterMap[i].Value +'</option>'));  //No I18N
                            }
                            $parameter.append($selectparameter);
                            $row.append($parameter);

                            $comparator = $("<td width='200px' align='left'></td>");//No I18N
                            $selectcondition = $('<select name="CONDITION_'+ index + '" style="width: 180px;" id="CONDITION_'+ index + '" class="form-control"></select>');//No I18N
                            for (var i = 0; i < conditionMap.length; i++) {
                                    $selectcondition.append($('<option value="'+ conditionMap[i].Key +'">'+ conditionMap[i].Value +'</option>'));  //No I18N
                                    }
                            $comparator.append($selectcondition);
                            $row.append($comparator);

                            $valueField = $("<td width='200px' align='left'></td>");//No I18N
                            $valueField.append($('<input id="PATTERN_'+ index + '" type="text" style="width:180px !important;" class="form-control">'));//No I18N
                            $row.append($valueField);

                            $closeField = $("<td align='left'></td>");//No I18N
                            if(int1 == 0 ){
                                    $closeField.append($('<div><span title="Delete Criteria" style="display: none;" onclick="deleteCriteriaToDeviceGroup('+index+');" class="glyphicon glyphicon-remove pointer"></span></div>'));//No I18N
                            } else {
                                    $closeField.append($('<div><span title="Delete Criteria" onclick="deleteCriteriaToDeviceGroup('+index+');" class="glyphicon glyphicon-remove pointer"></span></div>'));//No I18N
                            }
                            $row.append($closeField);
                            $addCriteria = $("<td align='left'></td>");//No I18N
                            $addCriteria.append($('<div><span title="Add Criteria" onclick="addCriteriaToDeviceGroup('+index+');" class="glyphicon glyphicon-plus pointer"></span></div>'));//No I18N
                            $row.append($addCriteria);
                            $("#critetriaTable").append($row);
                            $("#CONDITION_"+index).val(cri.Condition);
                            $("#PARAMETER_"+index).val(cri.Field);
                            if(cri.Field==="ENCRYPTION_BITS")
                            {
                                checkConditions(document.getElementById("PARAMETER_"+index));
                            }   
                            $("#COMPARATOR_"+index).val(cri.Comparator);
                            $("#PATTERN_"+ index).val(cri.Value);
                        }
                        refreshMatchingKeys();
                    }
                    else
                    {                        
                        resourceCriteriaForm(comparatorMap,parameterMap,conditionMap);
                    }
                    
                }
                else
                {
                    resourceCriteriaForm(comparatorMap,parameterMap,conditionMap);
                }
                if(jsonData.Listed!=undefined)
                {
                    var key_array=jsonData.Listed;
                    var sel=document.getElementById("LISTOFKEYS");//No I18N
                    keyContents={};
                    for (var i=0; i<key_array.length; i++)
                    {
                        var opt=document.createElement('option');//No I18N
                        opt.innerHTML = key_array[i].KeyName;
                        opt.value = key_array[i].KeyId;
                        sel.appendChild(opt);
                        keyContents[key_array[i].KeyId]=key_array[i].KeyName;
                    }
                }
                if(jsonData.Selected!=undefined)
                {
                    var key_array=jsonData.Selected;
                    var sel=document.getElementById("SELECTEDKEYS");//No I18N
                    for (var i=0; i<key_array.length; i++)
                    {
                        var opt=document.createElement('option');//No I18N
                        opt.innerHTML = key_array[i].KeyName;
                        opt.value = key_array[i].KeyId;
                        sel.appendChild(opt);
                    }
                }
            });     
            
           
        }
});

App.AddUsersGroupView = Ember.View.extend({
    templateName: 'AddUsersGroup',//No I18N
        didInsertElement: function(){
            var uGroupId = App.SettingsUserController.kGroupId;
            $("#uGroupDesc").val("");//No I18N
            var ajaxRequestUrl = '/api/pki/ssh/usersGroupEditPreRender'; //No I18N
            var data={};
            data.USERS_GROUP_ID=uGroupId;
            data.UserView="Only_Associated";//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData)
            {
                var parameterMap = jsonData.CriteriaParameters;
                var conditionMap = jsonData.CriteriaConditions;
                var comparatorMap = new Array();
                comparatorMap.push({name: "and", value: "and"});  //No I18N
                comparatorMap.push({name: "or", value: "or"});  //No I18N
                App.InventoryListDetailsController.parameterMap = parameterMap;
                App.InventoryListDetailsController.conditionMap = conditionMap;
                App.InventoryListDetailsController.comparatorMap = comparatorMap; 
                App.SettingsUserController.QUERYID = jsonData.QUERYID;
                if(uGroupId != "new") {
                    $('.pgtitle').text(I18N.getMsg('js.usersGroup.update'));//No I18N
                    $("#uGroupName").val(jsonData.USERS_GROUP_NAME);
                    $("#uGroupDesc").val(jsonData.DESCRIPTION);
                    $('#uGroupName').attr('readonly', true);
                    if(jsonData.UsersByCriteria == true) {
                        $("#ResourceUserSelection").css('display','none');//No I18N
                        $("#SpecificCriteria-div").css('display','block');//No I18N
                        $('#UsersByCriteria').attr("checked", true);
                        var selectQuery = jsonData.SelectQueryContents.CRITERIA_LIST;
                        for (var int1 = 0; int1 < selectQuery.length; int1++) 
                        {
                            var index = int1+1;
                            var cri = selectQuery[int1];
                            $row =  $('<tr id="'+index+'" style="height: 45px;"></tr>');//No I18N
                            $td = $("<td width='100px' align='left'></td>");//No I18N
                            if(int1 == 0) {
                                $select = $('<select name="COMPARATOR_"'+ index + ' disabled="true" style="width: 80px;  display: none;" id="COMPARATOR_'+index+'" class="form-control"></select>');//No I18N
                            } 
                            else {
                                $select = $('<select name="COMPARATOR_"'+ index + ' style="width: 80px;" id="COMPARATOR_'+index+'" class="form-control"></select>');//No I18N
                            }
                            for (var i = 0; i < comparatorMap.length; i++) {
                                $select.append($('<option value="'+ comparatorMap[i].value +'">'+ comparatorMap[i].name +'</option>'));  //No I18N
                            }
                            $td.append($select);
                            $row.append($td);

                            $parameter = $("<td width='200px' align='left'></td>");//No I18N
                            $selectparameter = $('<select name="PARAMETER_'+ index + '" style="width: 180px;" id="PARAMETER_'+ index + '" class="form-control"></select>');//No I18N
                            for (var i = 0; i < parameterMap.length; i++) 
                            {
                                $selectparameter.append($('<option value="'+ parameterMap[i].Key +'">'+ parameterMap[i].Value +'</option>'));  //No I18N
                            }
                            $parameter.append($selectparameter);
                            $row.append($parameter);

                            $comparator = $("<td width='200px' align='left'></td>");//No I18N
                            $selectcondition = $('<select name="CONDITION_'+ index + '" style="width: 180px;" id="CONDITION_'+ index + '" class="form-control"></select>');//No I18N
                            for (var i = 0; i < conditionMap.length; i++) {
                                    $selectcondition.append($('<option value="'+ conditionMap[i].Key +'">'+ conditionMap[i].Value +'</option>'));  //No I18N
                                    }
                            $comparator.append($selectcondition);
                            $row.append($comparator);

                            $valueField = $("<td width='200px' align='left'></td>");//No I18N
                            $valueField.append($('<input id="PATTERN_'+ index + '" type="text" style="width:180px !important;" class="form-control">'));//No I18N
                            $row.append($valueField);

                            $closeField = $("<td align='left'></td>");//No I18N
                            if(int1 == 0 ){
                                    $closeField.append($('<div><span title="Delete Criteria" style="display: none;" onclick="deleteCriteriaToDeviceGroup('+index+');" class="glyphicon glyphicon-remove pointer"></span></div>'));//No I18N
                            } else {
                                    $closeField.append($('<div><span title="Delete Criteria" onclick="deleteCriteriaToDeviceGroup('+index+');" class="glyphicon glyphicon-remove pointer"></span></div>'));//No I18N
                            }
                            $row.append($closeField);
                            $addCriteria = $("<td align='left'></td>");//No I18N
                            $addCriteria.append($('<div><span title="Add Criteria" onclick="addCriteriaToDeviceGroup('+index+');" class="glyphicon glyphicon-plus pointer"></span></div>'));//No I18N
                            $row.append($addCriteria);
                            $("#critetriaTable").append($row);
                            $("#CONDITION_"+index).val(cri.Condition);
                            $("#PARAMETER_"+index).val(cri.Field);
                            $("#COMPARATOR_"+index).val(cri.Comparator);
                            $("#PATTERN_"+ index).val(cri.Value);
                        }
                        refreshMatchingUsers();
                    }
                    else
                    {
                        resourceCriteriaForm(comparatorMap,parameterMap,conditionMap);
                    }
                }
                else
                {
                    resourceCriteriaForm(comparatorMap,parameterMap,conditionMap);
                }
                generateResourceUserTree(jsonData.selected);
            });
            
            
        }
    });

App.ImportCredentialView = Ember.View.extend({
    templateName: 'ImportCredential',//No I18N
        didInsertElement: function(){
            //$('[data-toggle="popover"]').popover();//For help Content
            $(".modal-title").text(I18N.getMsg("js.modaltitle.ImportCredentialFromFile"));//NO I18N
                    }
});

App.KeyHistoryAuditView = Ember.View.extend({
    templateName: 'KeyHistoryAudit',//No I18N
        didInsertElement: function(){
                   App.Settings.ViewKeyHistoryDetails(App.SettingsUserController.key_id);
                    }
});

App.AddRolesView = Ember.View.extend({
    templateName: 'AddRoles',//No I18N
        didInsertElement: function(){
             $('.modal-dialog').css({"width":"870px"});
            $(".modal-title").text(I18N.getMsg("js.pki.addroles"));//NO I18N
        var params = "";
        var ajaxRequestUrl = '/api/pki/settings/getRolesForUI'; //No I18N
        if (App.SettingsUserController.roleId != undefined && App.SettingsUserController.roleId != "")
        {
            $('#save').hide();
            $('#update').show();
            $(".modal-title").text(I18N.getMsg("js.pki.editroles"));//NO I18N
            params = 'roleid=' + App.SettingsUserController.roleId;//No I18N
            ajaxRequestUrl = '/api/pki/settings/getRoleDetails'; //No I18N
        }else{
            $('#update').hide();
            $('#save').show();       
        }
        roleTopLayerList();
        roleSecondLayerList("SSH");//No I18N
                 $("#role-top-layer-list li" ).click(function() {
                    var topLayer=$(this).text();
                    roleSecondLayerList(topLayer);
                     $("#role-second-layer-list li" ).click(function() {
                     var secondLayer=$(this).text();
                    showHideDivClient(secondLayer);
                });
                });
                $("#role-second-layer-list li" ).click(function() {
                     var secondLayer=$(this).text();
                    showHideDivClient(secondLayer);
                });
        getAjaxApiRequest(ajaxRequestUrl, params, function (jsonData) {
            if (App.SettingsUserController.roleId != undefined && App.SettingsUserController.roleId != "")
            {
                $('#rolename').val(jsonData.RoleName);
                $('#rolename').attr("disabled", "disabled");
                $('#roleDescription').val(jsonData.RoleDescription);
               
            }
            var dependentJSON=jsonData.DependentCategories;
            roleListDisplay(jsonData);
           $('input[type=checkbox]').change(function () {
               dependencySelection(dependentJSON, this);
                tocheckParentChild(this);
                });
                $('[role-display-id=\"Resources\"]').attr('style', 'display:block');
        });
    }
});

function roleListDisplay(jsonData)
{
    for (var key in jsonData) {
        if (key !== 'categoryName' && key !== 'categoryID' && key !== 'parentIndex' && key !== 'selected' && key !== 'RoleName' && key !== 'RoleDescription' && key !== 'DependentCategories')
        {
            if (jsonData.hasOwnProperty(key)) {
                var value = jsonData[key];
                var roleDisp=roleDisplayDiv(value.categoryName);
                if (value.selected === true)
                {
                    $('#constructTree').append('<li role-display-id='+roleDisp+' style=\'display:none\' id=li_' + value.categoryName + '><input checked class="CategorySelection" id=' + value.categoryID + ' type="checkbox"><label for='+value.categoryID+'>' + I18N.getMsg('js.rolename.'+key) + '</label></li>');
                } else {
                    $('#constructTree').append('<li role-display-id='+roleDisp+' style=\'display:none\'  id=li_' + value.categoryName + '><input class="CategorySelection" id=' + value.categoryID + ' type="checkbox"><label for='+value.categoryID+'>' +  I18N.getMsg('js.rolename.'+key) + '</label></li>');
                }
                rec_role(value,roleDisp);
            }
        }
    }
}

function rec_role(innerLayer,roleDisp)
{
    $('#li_' + innerLayer.categoryName + '').append('<ul role-display-id='+roleDisp+' id=ul_' + innerLayer.categoryName + '></ul>');
    for (var pos in innerLayer) {
        if (pos !== 'categoryName' && pos !== 'categoryID' && pos !== 'parentIndex' && pos !== 'selected')
        {
            var value = innerLayer[pos];
            if (value.selected === true)
            {
                $('#li_' + innerLayer.categoryName + ' #ul_' + innerLayer.categoryName).append('<li id=li_' + value.categoryName + '><input checked class="CategorySelection" id=' + value.categoryID + ' type="checkbox"><label for='+value.categoryID+'>' + I18N.getMsg('js.rolename.'+value.categoryName) + '</label></li>');
            } else {
                $('#li_' + innerLayer.categoryName + ' #ul_' + innerLayer.categoryName).append('<li id=li_' + value.categoryName + '><input class="CategorySelection" id=' + value.categoryID + ' type="checkbox"><label for='+value.categoryID+'>' + I18N.getMsg('js.rolename.'+value.categoryName) + '</label></li>');
            }
            if (Object.keys(value).length > 4)
            {
                rec_role(value,roleDisp);
            }
        }
    }
}

function roleDisplayDiv(categName)
{
    var roleDispDiv='Resources';//No I18N
    if(categName ==='KMP_SSHKEY_MANAGEMENT' || categName ==='KMP_SSHKEY_ADDITIONALFEATURES' || categName === 'KMP_SSHKEY_CREATEANDDEPLOY')//No I18N
    {
        roleDispDiv='Keys';//No I18N
    }else if(categName ==='KMP_SSL_MANAGEMENT' || categName ==='SSL_CERTIFICATES_DISCOVERY'){//No I18N
         roleDispDiv='Certificates';//No I18N
    }else if(categName ==='KMP_ENCRYPTIONKEYS_MANAGEMENT'){//No I18N
         roleDispDiv='KeyStore';//No I18N
    }else if(categName ==='REPORTS'){//No I18N
         roleDispDiv='Reports';//No I18N
    }else if(categName ==='SCHEDULE_OPERATIONS'){//No I18N
         roleDispDiv='Schedule';//No I18N
    }else if(categName ==='SETTINGS'){//No I18N
         roleDispDiv='Settings';//No I18N
    }
    return roleDispDiv;
}

function showHideDivClient(secondLayer)
{   
    var dispDivs = ["Resources", "Keys", "Certificates", "KeyStore", "Reports", "Schedule", "Settings"];//No I18N
    $.each(dispDivs, function (index, value) {
        $("[role-display-id=\'" + value + "\']").attr('style', 'display:none');
    });
    $('[role-display-id=\"'+secondLayer+'\"]').attr('style', 'display:block');
}

function roleTopLayerList()
{
    var topLayer=["SSH","SSL","KeyStore","Report","Schedule","Settings"];//No I18N
    var topLevelHTML = "";
    $.each(topLayer, function( index, value ) { 
        topLevelHTML+="<li name=\"topLayer\">"+value+"</li>";
    }); 
    $('#role-top-layer-list').html(topLevelHTML);
    return roleTopLayerList;
}

function getSecondLayer(topLayer)
{
    var secondLayer = [];
    if (topLayer === "SSH")
    {
        secondLayer = ["Resources", "Keys"];//No I18N
    } else if (topLayer === "SSL")
    {
        secondLayer = ["Certificates"];
    } else if (topLayer === "KeyStore")
    {
        secondLayer = ["KeyStore"];
    } else if (topLayer === "Report")
    {
        secondLayer = ["Reports"];
    } else if (topLayer === "Schedule")
    {
        secondLayer = ["Schedule"];
    } else if (topLayer === "Settings")
    {
        secondLayer = ["Settings"];
    }
    return secondLayer;
}
function roleSecondLayerList(layer)
{
    var secondLayer=getSecondLayer(layer);
    var topLevelHTML="";
    var frstVal="";
    $.each(secondLayer, function( index, value ) {
        topLevelHTML+="<li name=\"second-layer\" >"+value+"</li>";//NO I18N
        if(frstVal===""){
            frstVal=value;
        }
    });
    $('#role-second-layer-list').html(topLevelHTML);//NO I18N
    showHideDivClient(frstVal);
}
function dependencySelection(dependentJson,curid)
{
        var checkCheckList=dependentJson.SELECT_SELECT;
    var checkUncheckList=dependentJson.SELECT_DESELECT;
    var uncheckCheckList=dependentJson.DESELECT_SELECT;
    var uncheckUncheckList=dependentJson.DESELECT_DESELECT;
    if($(curid). prop("checked") == true)
    {
    toDoOperationOnCheck(checkCheckList,checkUncheckList,curid.id);
    }
    else{
    toDoOperationOnUncheck(uncheckCheckList,uncheckUncheckList,curid.id);
    }
}

function toDoOperationOnCheck(checkCheckList,checkUncheckList,curid){
    var ischeck=curid in checkCheckList;
    if(ischeck)
    {
        var toselect=JSON.parse(checkCheckList[curid]);
        var len=toselect.length;
        for (var i = 0; i < len; i++) {
            $('#'+toselect[i]). prop("checked",true);//SELECT_SELECT
            tocheckParentChild('#'+toselect[i]);
        }
   }
    var isUncheck=curid in checkUncheckList;
    if(isUncheck)
    {
        var tounselect=JSON.parse(checkUncheckList[curid]);
        var len=tounselect.length;
        for (var i = 0; i < len; i++) {
            $('#'+tounselect[i]). prop("checked",false);//SELECT_DESELECT
            tocheckParentChild('#'+tounselect[i]);
        }
    }
}

function toDoOperationOnUncheck(uncheckCheckList,uncheckUncheckList,curid){
    var ischeck=curid in uncheckCheckList;
    if(ischeck)
    {
        var toselect=JSON.parse(uncheckCheckList[curid]);
        var len=toselect.length;
        for (var i = 0; i < len; i++) {
            $('#'+toselect[i]). prop("checked",true);//DESELECT_SELECT
            tocheckParentChild('#'+toselect[i]);
        }
   }
    var isUncheck=curid in uncheckUncheckList;
    if(isUncheck)
    {
        var tounselect=JSON.parse(uncheckUncheckList[curid]);
        var len=tounselect.length;
        for (var i = 0; i < len; i++) {
            $('#'+tounselect[i]). prop("checked",false);//DESELECT_DESELECT
            tocheckParentChild('#'+tounselect[i]);
        }
    }
}

function tocheckParentChild(ele)
{
    $(ele).parent().find('li input[type=checkbox]').prop('checked', $(ele).is(':checked'));//No I18N
                    var sibs = false;
                    $(ele).closest('ul').children('li').each(function () {
                        if ($('input[type=checkbox]', this).is(':checked')){
                            sibs = true;
                        }
                    });
                    $(ele).parents('ul').prev().prev().prop('checked', sibs);//No I18N
}

App.DeleteRolesView = Ember.View.extend({
    templateName: 'DeleteRoles', //No I18N
    didInsertElement: function () {
        $('.modal-dialog').css({"width": "500px"});
        $(".modal-title").text(I18N.getMsg("js.pki.deleteroles"));//NO I18N
        var params = "";
        var ajaxRequestUrl = ''; //No I18N
        var roleToBeDeleted = App.SettingsUserController.roleName;
        $('#roleToBeDeleted').text(roleToBeDeleted);
        if (App.SettingsUserController.roleId != undefined && App.SettingsUserController.roleId != "")
        {
            params = 'roleid=' + App.SettingsUserController.roleId;//No I18N
            ajaxRequestUrl = '/api/pki/settings/getAvailableRolesToUpdateOnDelete'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl, params, function (jsonData) {
                if(jsonData !== undefined)
                {
                var sel=document.getElementById("newRoleId");//No I18N
                var keys=Object.keys(jsonData);
                    for (var i in keys)
                    {
                        if (keys.hasOwnProperty(i))
                        {
                            var key = keys[i];
                            if (key !== roleToBeDeleted)
                            {
                                var val = jsonData[key];
                                var opt = document.createElement('option');//No I18N
                                opt.innerHTML = key;
                                opt.value = val;
                                sel.appendChild(opt);
                            }
                        }
                    }
                }
            });
        }
    }
});
